'use strict';

define(function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('DoorInfoBatchEditDlg',
        ['$scope', 'Const', 'API', 'Util', 'DoorAgent', 'MessageProperties', 'MessageService',
            function ($scope, Const, API, Util, DoorAgent, MessageProperties, MessageService) {

                $scope.EDIT_ITEMS = {
                    OpenTime: false,
                    OpenBy: false,
                    DoubleMode: false,
                    APBType: false,
                    APBResetTime: false,
                    APBWhenDisconnected: false,
                    DoubleModeSchedule: false,
                    DoubleModeAuthGroup: false
                };

//        $scope.RELAY_OPEN_CONDITION = Const.RELAY_OPEN_CONDITION;
                $scope.APB_TYPE = Const.APB_TYPE;
                $scope.ACTION_WHEN_FAILED = Const.ACTION_WHEN_FAILED;


                $scope.doEditItem = function (key) {
                    $scope.EDIT_ITEMS[key] = !$scope.EDIT_ITEMS[key];
                };

                $scope.editAllDoor = {};
                $scope.editAllDoor.door_anti_passback = {};

                $scope.editAllDoor.open_duration = Const.DEFAULT_DOOR_OPEN_DURATION;

                $scope.doDoorInfoBatchEdit = function () {

                    if (!$scope.EDIT_ITEMS.OpenTime) {
                        delete $scope.editAllDoor.open_duration;
                    }
//            if(!$scope.EDIT_ITEMS.OpenBy) {
//                delete $scope.editAllDoor.relay_open_condition;
//            }
//            if(!$scope.EDIT_ITEMS.DoubleModeSchedule) {
//                delete $scope.editAllDoor.door_double_mode.double_mode_schedule_id;
//            }
//            if(!$scope.EDIT_ITEMS.DoubleModeAuthGroup) {
//                delete $scope.editAllDoor.door_double_mode.double_mode_access_groups;
//            }
//            if(!$scope.EDIT_ITEMS.APBType) {
//                delete $scope.editAllDoor.door_anti_passback.apb_type;
//            }
//            if(!$scope.EDIT_ITEMS.APBResetTime) {
//                delete $scope.editAllDoor.door_anti_passback.reset_time;
//            }
//            if(!$scope.EDIT_ITEMS.APBWhenDisconnected) {
//                delete $scope.editAllDoor.door_anti_passback.open_when_disconnected;
//            }

                    if (Object.keys($scope.editAllDoor).length > 0) {
                        MessageService.displayConfirmMessage(MessageProperties.get('common.modifyAllSelectedDoors'), function (confirmYn) {
                            if (confirmYn) {
                                // $scope.checkItemArray 는 this Dlg 를 embed 하고 있는 UserController의 Scope 변수입니다.
                                var param = $scope.checkItemArray;
                                // $scope.SelectAllYN 는 this Dlg 를 embed 하고 있는 UserController의 Scope 변수입니다.
                                if ($scope.SelectAllYN) {
                                    param = 'ALL';
                                }

                                DoorAgent.putDoors({
                                    "doorIDs": param, "door": $scope.editAllDoor, "query": $scope.doorListQueryStrings
                                }).then(function success(data) {
                                    $scope.$emit('ReloadDoorsDataGrid');
                                    $scope.$emit('InitDoorInfoBatchEditDlgUrl');
                                }, function error(reason, status) {
                                    $scope.$emit('ReloadDoorsDataGrid');
                                    $scope.$emit('InitDoorInfoBatchEditDlgUrl');
                                });
                            }
                        })
                    } else {
                        MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                            if (confirmYn) {
                                var options = angular.element("#userInfoBatchEditDlg").dialog('options');
                                options.onClose();
                            }
                        });
                    }


                };

                $scope.doInfoBatchEditCancel = function () {
                    $scope.$emit('InitDoorInfoBatchEditDlgUrl');
                };

            }]);
});
