define(['modules/common/services/access-control-agent', 'modules/common/services/user-agent'], function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('DoorOutputSignalAddDlgController',
        ['$scope','$document','API','Const','MessageService','MessageProperties',
        function ($scope, $document, API, Const, MessageService, MessageProperties) {
            var currSignalInfo = window.sessionStorage.getItem('currSelectSignalItem');

            window.sessionStorage.removeItem('currSelectSignalItem');

            var OutputSignal = function () {
                this.name = undefined;
                this.delay = undefined;
                this.count = undefined;
                this.on_duration = undefined;
                this.off_duration = undefined;

                return this;
            };

            $scope.OutputSignal = new OutputSignal();

            if(currSignalInfo) {
                currSignalInfo = angular.fromJson(currSignalInfo);
                $scope.OutputSignal = angular.copy(currSignalInfo);
            }

            $scope.doApplyNewOutputSignal = function () {


                var id = '',
                    httpRequestType = API.post;

                if (!$scope.OutputSignal.name) {
                    MessageService.displayWarningMessage(MessageProperties.get('validate.pleaseInputName'));
                    return false;
                }

                if (!$scope.OutputSignal.delay) {
                    $scope.OutputSignal.delay = 0;
                }
                if (!$scope.OutputSignal.on_duration) {
                    $scope.OutputSignal.on_duration = 0;
                }
                if (!$scope.OutputSignal.off_duration) {
                    $scope.OutputSignal.off_duration = 0;
                }
                if (!$scope.OutputSignal.count) {
                    $scope.OutputSignal.count = 0;
                }

                if(currSignalInfo) {
                    httpRequestType = API.put;
                    id = '/' + currSignalInfo.id;
                }

                httpRequestType('setting/output_signals' + id, 'setting_output_signals', {"OutputSignal": $scope.OutputSignal}).then(function(data) {
                    $scope.$emit('CloseOutputSignalEditDlg');
                });

            };

            $scope.doCancelNewOutputSignal = function () {
                $scope.$emit('CloseOutputSignalEditDlg');
            };
        }]);
});