'use strict';

define(function () {

    var app = angular.module('biostarWebApp');

    app.service('AlertListService', ['$rootScope', 'API', 'Const', 'MessageProperties', function ($rootScope, API, Const, MessageProperties) {

        var getGridQueryFunction;
        var dataList = [];

        return {
            getGridQueryFunction: function (paramGetGridQueryFunction) {
                getGridQueryFunction = paramGetGridQueryFunction;
            },
            getDataList: function () {
                return dataList;
            },
            openDialog: function () {
                var options = {};
                options.iconCls = 'icon-save';
                options.modal = true;
                options.shadow = false;
                options.border = false;
                options.title = MessageProperties.get('common.alertList');
                options.width = 1100;
                options.height = 'auto';
//                options.top = 100;
                options.position = {
                    my: "center top",
                    at: "center top",
                    of: window
                };
                options.onClose = function () {
                    $rootScope.$apply(function () {
                        $rootScope.alertListDialog.url = '';
                        angular.element('#alertListPopupDiv').dialog('destroy');
                    });
                };

                angular.element("#alertListPopupDiv").dialog(options);

                $rootScope.alertListDialog = {};
                $rootScope.alertListDialog.url = 'modules/common/alert/alertList.html';
            },
            closeDialog: function () {
                $rootScope.alertListDialog.url = '';
                angular.element('#alertListPopupDiv').dialog('destroy');
            },
            search: function (callbackFunction, gridId) {
                var query = getGridQueryFunction();
                gridId = gridId || 'AlertListGrid';
                if (query.offset >= query.total && query.total >= query.limit) {
                    query.offset = query.total - query.limit;
                }
//                var conditionsObject = new Array();
//            if ($scope.userListQueryStrings.query){
//                conditionsObject.push({operator: 'contains', values:[$scope.userListQueryStrings.query] });
//            }
//            if ($scope.userListQueryStrings.group_id){
//                conditionsObject.push({column: 'group_id', operator: 'eq', values:[$scope.userListQueryStrings.group_id] });
//            }
//                conditionsObject.push({column: 'status', operator: 'eq', values: Const.ALERT_STATUS.PENDING });
//                query.conditions = conditionsObject;
                var searchParam = {};
                searchParam.Query = query;
//                console.log('alertListService::alert search ::' + searchParam.Query);
                API.post('alerts/search', gridId + 'AlertSerch', searchParam).then(function (data) {
                    if (data && data.AlertCollection && data.AlertCollection.rows) {
                        dataList = data.AlertCollection.rows || [];
                        angular.element('#' + gridId).datagrid('loadData', dataList);
                        query.total = data.AlertCollection.total || 0;
                    } else {
                        query.total = 0;
                        angular.element('#' + gridId).datagrid('loadData', []);
                    }
                    if (angular.isDefined(callbackFunction)) {
                        callbackFunction(dataList, query);
                    }
                });
            }
        };
    }]);
});
