'use strict';

define(['modules/common/services/device-agent', 'modules/common/services/user-agent','modules/common/alert/alertService'], function () {

    var app = angular.module('biostarWebApp');
    app.controller('AlertPopupController', ['$scope', '$rootScope', '$timeout', '$filter', 'Const', 'DeviceAgent', 'UserAgent', 'AlertService', function ($scope, $rootScope, $timeout, $filter, Const, DeviceAgent, UserAgent, AlertService) {


        $scope.initPopup = function () {
            var alertObject = AlertService.getAlert();
            $scope.alertObject = alertObject;
            $scope.alertObject.datetimeFormatted = $filter('BssDatetimeLongTerm')(new Date(alertObject.event_id.datetime));
            $scope.descriptionHtml = '';
            if (alertObject.event_id != undefined) {
                if (alertObject.event_id.device_id != undefined) {
                    $scope.descriptionHtml += alertObject.event_id.device_id.name;
                }
                if (alertObject.event_id.door_id != undefined) {
                    $scope.descriptionHtml += alertObject.event_id.door_id.name;
                }
                if (alertObject.event_id.user_id != undefined) {
                    $scope.descriptionHtml += alertObject.event_id.user_id.name;
                }
                $scope.descriptionHtml += '<br><br>' + alertObject.event_id.event_type_id.name;
                $scope.descriptionHtml += '<br><br>' + alertObject.datetimeFormatted;
                $scope.descriptionHtml += '<br><br>';
            }
        };

        function ackSuccessful(){
            AlertService.closeDialog();
        }

        $scope.doAck = function () {
            AlertService.ack(ackSuccessful, $scope.alertObject.event_id, $scope.alertObject.comment);

        };

        $scope.doIgnore = function () {
            AlertService.closeDialog();
        };

    }]);
});


