'use strict';

define([
    'modules/common/commonModule'
], function () {

    var app = angular.module('commonModule');

    app.directive('ngMenu', ['$rootScope', function ($rootScope) {
        return {
            templateUrl: 'modules/common/directives/ng-menu.html',
            restrict: 'A',
            replace: true,
            controller: ['$scope', '$location', '$timeout', 'API', 'Const', 'Util', function MenuCtrl($scope, $location, $timeout, API, Const, Util) {
                //API Service를 통해 데이터 받아오기
                var sideMenuTimer = false;

                $scope.menuNames = [];
                for (var key in Const.GNB_MENU_ITEMS) {
                    if (Const.GNB_MENU_ITEMS.hasOwnProperty(key)) {
                        $scope.menuNames.push(key);
                    }
                }
                $scope.menus = Const.GNB_MENU_ITEMS;
                $scope.menuLabels = Const.GNB_MENU_ITEMS_NAME;
                $scope.sideRightPos = -10.3;

                $scope.sideMenus = [
                    {
                        menuText: 'Door',
                        url: '/access-control/ac-doors',
                        id: '31'
                    },
                    {
                        menuText: 'Access Group',
                        url: '/access-control/ac-groups',
                        id: '32'
//                    },
//                    {
//                        menuText: 'Zone',
//                        url: '/access-control/ac-zones',
//                        id: '33'
                    }
                ];
                $scope.selectedMenuIdx = Const.GNB_MENU_ITEMS.DASHBOARD;
                $scope.selectedSideMenuIdx = -1;
                $scope.sideMenuViewOK = false;

                if (window.sessionStorage.getItem('SelectedMenuIndex')) {
                    $scope.selectedMenuIdx = parseInt(window.sessionStorage.getItem('SelectedMenuIndex'));
                }
                if (window.sessionStorage.getItem('SelectedSideMenuIndex')) {
                    $scope.selectedSideMenuIdx = parseInt(window.sessionStorage.getItem('SelectedSideMenuIndex'));
                }

//                $rootScope.$on('$locationChangeSuccess', function (a, b, c, d, e) {
//                    Util.debug('$locationChangeSuccess')
//                });
//                $rootScope.$on('$locationChangeStart', function (a, b, c, d, e) {
//                    Util.debug('$locationChangeStart')
//                });
                $rootScope.$on('$routeChangeSuccess', function (event, location) {
                    var i, key, item, url;

                    window.sessionStorage.setItem('SelectedMenuIndex', 0);
                    $scope.selectedMenuIdx = 0;
                    $scope.selectedSideMenuIdx = -1;

                    for (i = $scope.sideMenus.length; i--;) {
                        url = $scope.sideMenus[i].url;

                        if ($location.url().indexOf(url) == 0) {
                            window.sessionStorage.setItem('SelectedSideMenuIndex', i);
                            $scope.selectedSideMenuIdx = i;
                        }
                    }

                    if ($location.url().indexOf(Const.MODULE_URL.SETTING) > -1) {
                        window.sessionStorage.setItem('SelectedMenuIndex', -1);
                        $scope.selectedMenuIdx = -1;
                        return false;

                    } else {
                        for (key in Const.GNB_MENU_ITEMS) {
                            if (Const.GNB_MENU_ITEMS.hasOwnProperty(key)) {
                                item = Const.GNB_MENU_ITEMS[key];
                                url = item.url;

                                if ($location.url().indexOf(url) == 0 || (item.url2 != undefined && $location.url().indexOf(item.url2) == 0)) {
                                    window.sessionStorage.setItem('SelectedMenuIndex', item.id);
                                    $scope.selectedMenuIdx = item.id;

                                    return false;
                                }
                            }
                        }
                    }
                });
//                $rootScope.$on('$routeChangeStart', function (a, b, c, d, e) {
//                    Util.debug('$routeChangeStart')
//                });

                $scope.doMenuClick = function ($index, url) {
                    $scope.selectedMenuIdx = $index;
//                    console.log($index);
                    window.sessionStorage.setItem('SelectedMenuIndex', $index);

                    $location.path(url);

                    $rootScope.$emit('ClickMenuInit');

                    angular.element('#acSubMenu').removeClass('open');
                    sideMenuTimer = false;
                };


                $scope.fnMouseOverAction = function ($index) {
                    if ($index && $index == Const.GNB_MENU_ITEMS.ACCESS_CONTROL.id) {//Access Control submenu
                        angular.element('#acSubMenu').addClass('open');
                        sideMenuTimer = true;
                    } else if ($index && $index != Const.GNB_MENU_ITEMS.ACCESS_CONTROL.id) {
                        angular.element('#acSubMenu').removeClass('open');
                        sideMenuTimer = false;
                    }
                };

                $scope.fnMouseOutAction = function ($index) {
                    sideMenuTimer = false;
                    $timeout(function () {
                        if (!sideMenuTimer) {
                            angular.element('#acSubMenu').removeClass('open');
                        }
                    }, 50);

                };

                $scope.doOpenSideMenu = function () {
                    angular.element('#acSubMenu').addClass('open');
                    sideMenuTimer = true;
                };

                $scope.doCloseSideMenu = function () {
                    angular.element('#acSubMenu').removeClass('open');
                    sideMenuTimer = false;
                };


//                $rootScope.$on('menuUrlChange', function ($event, data) {
//                    console.log('menuUrlChange');
//                    var item = '', i = 0;
//                    $scope.selectedMenuIdx = -1;
//
//                    for (i = 0; i < $scope.menus.length; i++) {
//                        item = $scope.menus[i];
//                        if ($location.url().split("/")[1] === item.url.split("/")[1]) {
//                            $scope.selectedMenuIdx = i;
//                        }
//                    }
//
//                    $scope.selectedSideMenuIdx = -1;
//                    for (i = 0; i < $scope.sideMenus.length; i++) {
//                        item = $scope.sideMenus[i];
//                        if ($location.url().split("/")[2] === item.url.split("/")[2]) {
//                            $scope.selectedSideMenuIdx = i;
//                        }
//                    }
//                });
            }]
        };
    }]);
});