'use strict';
/**
 * <div ngbss-board-search data-ng-model="Parameters.Parameters.query" data-search-function="SearchCallback"></div>
 *
 *   written by mphong 2014.07.24
 *
 *   directive name : ngbss-board-search
 *   type : attribute
 *   ng-model object : { query(String, optional), offset(Integer, optional), limit(Integer, optional) }
 *
 *   data-search-function object : { fn(Function, required) }
 *
 */
define(function () {
    var app = angular.module('commonModule');
    app.directive('ngbssBoardSearch', ['$window', '$timeout', function ($window, $timeout) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                Parameters: '=ngModel',
                listName: '=',
                SearchCallback: '=searchFunction'
            },
            template: '<div class="boardSearch" ng-class="{\'open\': openSearchHistoryBoxYN === true, \'typeClear\':Parameters.query.length > 0}" tabindex="-1"><!-- addClass : open --> ' +
                '<input type="text" class="inputSearch" id="boardSearchInput" ng-model="Parameters.query"> ' +
                '<a href="javascript:void(null);" class="inputAct" ng-click="openSearchHistoryBox();" style="outline: none; border: 0 !important;" tabindex="-1"></a> ' +
                '<a href="javascript:void(null);" class="btnClose" ng-click="closeSearchBox()">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a> ' +
                '<a href="javascript:void(null);" class="btnText btnColorPoint" ng-click="doSearchBoard()" ng-label="button.go"></a> ' +

                '<ul class="autoComplete" tabindex="-1"> ' +
                '<li ng-repeat="item in searchHistory" ng-click="doSearchBoard(item)"><a href="javascript:void(null);"><span>{{item}}</span></a></li> ' +
                '<li ng-show="searchHistory.length <= 0"><a href="javascript:void(null);" ng-label="common.noRecentSearches"></a></li> ' +
                '</ul> ' +
                '</div>',
            controller: ['$scope', '$element', function ($scope, $element) {

                var historyName = '', timeout = undefined;

                if (!$scope.listName) {
                    $scope.listName = 'general';
                }

                historyName = angular.uppercase($scope.listName) + ('_SEARCH_HISTORY');

                $scope.searchHistory = angular.fromJson(window.localStorage.getItem(historyName));
                if (!$scope.searchHistory) {
                    $scope.searchHistory = [];
                }
                $scope.openSearchHistoryBoxYN = false;
                $scope.openSearchHistoryBox = function () {
                    $scope.openSearchHistoryBoxYN = !$scope.openSearchHistoryBoxYN;
                };


                $element.on('mouseleave', function ($event) {
                    var event = $event || $window.event,
                        target = event.target || (event.srcElement || document);

                    $scope.$apply(function () {
                        timeout = $timeout(function () {
                            $scope.openSearchHistoryBoxYN = false;
                        }, 500);
                    });
                });
                $element.on('mouseenter', function ($event) {
                    var event = $event || $window.event,
                        target = event.target || (event.srcElement || document);

                    $timeout.cancel(timeout);
                });
//
//              $element.on('focusin', function($event) {
//                  var event = $event || $window.event,
//                    target = event.target;
//
//                  $scope.$apply(function() {
//                      $scope.openSearchHistoryBoxYN = true;
//                  });
//              });

                $scope.doSearchBoard = function (query) {
                    var idx;

                    if (query) {
                        $scope.Parameters.query = query;
                    }

                    if ($scope.Parameters.query) {

                        idx = $scope.searchHistory.indexOf($scope.Parameters.query);

                        if (idx > -1) {
                            $scope.searchHistory.splice(idx, 1);
                        }
                        $scope.searchHistory = $scope.searchHistory.reverse();

                        $scope.searchHistory.push($scope.Parameters.query);
//
                        $scope.searchHistory = $scope.searchHistory.reverse();

                        if ($scope.searchHistory.length > 5) {
                            $scope.searchHistory.splice(5, $scope.searchHistory.length - 5);
                        }

                        window.localStorage.setItem(historyName, angular.toJson($scope.searchHistory));
                    }

                    $scope.Parameters.offset = 0;
                    $scope.SearchCallback.fn();
                    $scope.openSearchHistoryBoxYN = false;
                };


                $element.find('#boardSearchInput').on('keypress', function ($event) {
                    var event = $event || $window.event,
                        target = event.target || (event.srcElement || document);

                    if (event.keyCode == 13) {
                        $scope.$apply(function () {
                            $scope.Parameters.query = angular.element('#boardSearchInput').val();
                            console.log(event.keyCode, $scope.Parameters.query);
                            $scope.doSearchBoard();
                        });

                        if (!$scope.Parameters.query)
                            $scope.Parameters.query = '';

                        if (target.setSelectionRange) {
                            target.setSelectionRange(0, $scope.Parameters.query.length);
                        } else if (target.createTextRange) {
                            console.log(target.createTextRange);
                        }

                        if (event.preventDefault) event.preventDefault();
                        if (event.returnValue) event.returnValue = false;
                        return false;
                    }
                });


            }],
            link: function ($scope, $element, $attrs) {
                $scope.closeSearchBox = function () {
                    $scope.Parameters.query = undefined;
                };
            }
        }
    }]);
})