'use strict';

define([
    'modules/common/alert/alertListController',
    'modules/common/alert/alertListService',
    'modules/common/alert/alertPopupController',
    'modules/common/alert/alertService'
], function () {

    var app = angular.module('commonModule');

    app.directive('ngbssAlarmTicker', ['Util', 'Const', 'API', 'AlertListService', 'AlertService', function (Util, Const, API, AlertListService, AlertService) {
        return {
            templateUrl: 'modules/common/directives/ngbssAlarmTicker.html',
            restrict: 'A',
            replace: true,
            controller: ['$scope', '$element', function ($scope, $element) {

                var query = {};
                query.offset = 0;
                query.limit = 1;
                query.total = 0;
                var conditionsObject = new Array();
                conditionsObject.push({column: 'status', operator: Const.QUERY_OPERATOR.EQUAL, values: [Const.ALERT_STATUS.PENDING] });
                query.conditions = conditionsObject;
                if (API.isLoggedIn()) {
                    API.post('alerts/search', 'alerts_search', {"Query": query}).then(function (data) {
                        if (data && data.AlertCollection) {
                            AlertService.setPendingCount(data.AlertCollection.total);
                        }
                    });
                }
                $scope.$on('AlertReceived', function (event, alertObject) {
                    AlertService.setAlert(alertObject);
                    if (angular.element("#alertPopupDialogDiv").length < 1) {
                        $scope.openAlertPopup($scope);
                    }
                    AlertService.increasePendingCount();
                });


                $scope.openAlertListPopup = AlertListService.openDialog;
                $scope.openAlertPopup = AlertService.openDialog;
            }]
        };
    }]);
});