'use strict';

define(['modules/common/services/scheduleAgent'], function () {
    var app = angular.module('biostarWebApp');
    app.register.directive('ngbssAuthModeList', function () {
        return {
            templateUrl: 'modules/common/directives/ngbssAuthModeList.html',
            restrict: 'A',
            require: '?ngModel',
            scope: {
                select: '&',
                ngModel: '=',
                fingerEditable: '=',
                cardEditable: '=',
                pinIdEditable: '=',
                scheduleListData: '=',
                disabledYn: '='
            },
            replace: false,
            controller: ['$scope', '$rootScope', '$log', 'API', 'Const', 'Util', 'ScheduleAgent', 'MessageProperties', 'MessageService', function ngbssAuthModeList($scope, $rootScope, $log, API, Const, Util, ScheduleAgent, MessageProperties, MessageService) {

                $scope.safeApply = function (fn) {
                    var phase = this.$root.$$phase;
                    if (phase == '$apply' || phase == '$digest') {
                        if (fn && (typeof(fn) === 'function')) {
                            fn();
                        }
                    } else {
                        this.$apply(fn);
                    }
                };

                if (angular.isUndefined($scope.ngModel)) {
                    $scope.ngModel = [];
                }

                $scope.hasMultiAuth = function (auth_mode) {
                    if ((auth_mode.first && auth_mode.first.length == 2)
                        || (auth_mode.second && auth_mode.second.length == 2)
                        || (auth_mode.third && auth_mode.third.length == 2)) {
                        return 'A';
                    }
                    return '';
                };
                $scope.isSingle = function (arr_auth_mode) {
                    return arr_auth_mode && arr_auth_mode.length == 1;
                };
                $scope.hasSecond = function (auth_mode) {
                    return auth_mode.second && auth_mode.second.length > 0;
                };
                $scope.hasThird = function (auth_mode) {
                    return auth_mode.third && auth_mode.third.length > 0;
                };

                $scope.editAuthModeRow = undefined;
                $scope.editAuthMode = function (auth_mode) {
                    if ($scope.disabledYn) {
                        return false;
                    }
                    $scope.auth_item_list = {};
                    $scope.auth_item_list.part_one = [];
                    $scope.auth_item_list.part_two = [];
                    $scope.auth_item_list.part_three = [];
                    $scope.auth_item = [];

                    $scope.editAuthModeRow = auth_mode;
                    $scope.doOpenAddAuthModeDlg();
                };
                $scope.delAuthMode = function ($index) {
                    if ($scope.disabledYn) {
                        return false;
                    }
                    MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (dialogResult) {
                        if (dialogResult) {
                            $scope.safeApply(function () {
                                $scope.ngModel.splice($index, 1);
                            });
                        } else {
                            return false;
                        }
                    });
                };
                /**
                 // TODO: �시 text 변�수 (publish 검�� �정)
                 * @param schedule_name
                 * @param auth_mode
                 */
                $scope.getText = function (schedule_name, auth_mode) {
                    if (schedule_name) {
                        return schedule_name;
                    } else {
                        var str = auth_mode.first.join('/');
                        str += (auth_mode.second ? ' + ' + auth_mode.second.join('/') : '');
                        str += (auth_mode.third ? ' + ' + auth_mode.third.join('/') : '');
                        return str;
                    }
                };


                var AUTH_MODE_SAME_TYPE = {
                    '0': 'BIOMETRIC',
                    '1': 'BIOMETRIC',

                    '2': 'CARD',
                    '3': 'CARD',
                    '4': 'CARD',
                    '5': 'CARD',
                    '6': 'CARD',

                    '7': 'ID',
                    '8': 'ID',
                    '9': 'ID',
                    '10': 'ID',
                    '11': 'NUM'
                };
                var AUTH_MODE_TYPE_TEXT = {
                    '0': 'fingerprint',
                    '1': 'fingerprint',

                    '2': 'card',
                    '3': 'card',
                    '4': 'card',
                    '5': 'card',
                    '6': 'card',

                    '7': 'ID',
                    '8': 'ID',
                    '9': 'ID',
                    '10': 'ID',
                    '11': 'PIN'
                };

                var authModePreset = [
//          'AUTH_MODE_NONE',
                    'AUTH_MODE_BIOMETRIC_ONLY',
                    'AUTH_MODE_BIOMETRIC_PIN',

                    'AUTH_MODE_CARD_ONLY',
                    'AUTH_MODE_CARD_BIOMETRIC',
                    'AUTH_MODE_CARD_PIN',
                    'AUTH_MODE_CARD_BIOMETRIC_OR_PIN',
                    'AUTH_MODE_CARD_BIOMETRIC_PIN',

                    'AUTH_MODE_ID_BIOMETRIC',
                    'AUTH_MODE_ID_PIN',
                    'AUTH_MODE_ID_BIOMETRIC_OR_PIN',
                    'AUTH_MODE_ID_BIOMETRIC_PIN',
                    'NUM_OF_AUTH_MODE'
                ];

                authModePreset.isHasAuthItem = function (authItemContainer) {
                    var authItemContainerHasOR = authItemContainer.indexOf('OR') > -1;

                    for (var i = 0; i < this.length; i++) {
                        var auth_item_cnt = 0;
                        if (this[i].indexOf('OR') > -1 && !authItemContainerHasOR) {
                            continue;
                        }
                        for (var j = authItemContainer.length; j--;) {
                            if (this[i].indexOf(authItemContainer[j]) > -1) {
                                auth_item_cnt++;
                            } else {
                                auth_item_cnt--;
                            }
                        }
                        if (auth_item_cnt == authItemContainer.length && authItemContainer.length > 1) {
                            return i;
                        }
                    }
                    return 255;
                };

                $scope.makeAuthModeList = function (mode) {
                    var regExp = /AUTH_MODE_([A-Z_]+)/g;
                    regExp.exec();

                    authModePreset[mode].match(regExp);
                    var result = RegExp.$1.split('_');

                    var _html = [];
                    _html.push('<div class="authModeType');
                    if (result.length > 2) {
                        _html.push('A');
                    }
                    _html.push('">');

                    for (var i = 0, len = result.length; i < len; i++) {
                        var _auth_item = result[i].toLowerCase();
                        if (_auth_item == 'only') {
                            continue;
                        } else if (_auth_item == 'or') {
                            continue;
                        } else if (_auth_item == 'biometric') {
                            _auth_item = 'finger';
                        } else if (_auth_item == 'pin') {
                            _auth_item = 'password';
                        }
                        if (i == 1) {
                            _html.push('<span class="plusA"></span>');
                            if (result.indexOf('OR') > -1) {
                                _html.push('<div>');
                            }
                        } else if (i == 2) {
                            _html.push('<span class="plusB"></span>');
                        }

                        _html.push('<span class="' + _auth_item + '"></span>');

                        if (i == 3) {
                            _html.push('</div>');
                        }
                    }
                    _html.push('</div>');
                    return _html.join('');
                };


                ScheduleAgent.getScheduleList().then(function success(data) {
                    $scope.scheduleListData = data.ScheduleCollection.rows;
                    $scope.scheduleItem = {};
                    ScheduleAgent.getScheduleMap().then(function success(data) {
                        $scope.scheduleItem = data;
                    });

                });

//                if ($scope.scheduleListData == undefined || $scope.scheduleListData.length == 0) {
//                    ScheduleAgent.getScheduleList().then(function (data) {
//                        $scope.scheduleListData = data.ScheduleCollection.rows;
//                        for (var i = 0; i < $scope.scheduleListData.length; i++ ) {
//                            var item = $scope.scheduleListData[i];
//                            $scope.scheduleItem[item.id] = item;
//                        }
//                    });
//                } else {
//                    for (var i = 0; i < $scope.scheduleListData.length; i++ ) {
//                        var item = $scope.scheduleListData[i];
//                        $scope.scheduleItem[item.id] = item;
//                    }
//                }

                $scope.doLoadSchedule = function ($event) {
                    /**
                     * 스케쥴 목록 정보 조회
                     */
                    ScheduleAgent.getScheduleList().then(function (data) {
                        $scope.scheduleListData = data.ScheduleCollection.rows;
                        angular.element($event.target.parentElement).addClass('open');
                    })
                };

                $scope.doSelectSchedule = function (schedule) {
                    $scope.selectedScheduleItem = schedule;
                    //angular.element('.select.selectTypeA.sizeM').removeClass('open');
                };

                $scope.checkIn24Time = function (time) {
                    var t24s = [];
                    for (var i = 0; i < 24; i++) {
                        t24s.push(false);
                    }
                    if (time != undefined && item.time_segments != undefined) {
                        for (var i = 0; i < time.time_segments.length; i++) {
                            var item = time.time_segments[i], start_time = Math.floor(item.start_time / 60), end_time = Math.floor(item.end_time / 60);
                            for (var j = start_time; j < end_time; j++) {
                                t24s[j] = true;
                            }
                        }
                    }
                    return t24s;
                };

                /*Add New Auth Mode Dialog Logic*/

                $scope.auth_item_list = {};
                $scope.auth_item_list.part_one = [];
                $scope.auth_item_list.part_two = [];
                $scope.auth_item_list.part_three = [];
                $scope.auth_item = [];

                var auth_edit_mode = Const.PAGE_MODE.CREATE;    // 'create';
                $scope.doOpenAddAuthModeDlg = function ($event) {
                    if ($scope.disabledYn) {
                        return false;
                    }
                    var addAuthModeDlg = {};
                    addAuthModeDlg.url = 'addAuthModeTemplate';
                    $scope.addAuthModeDlg = addAuthModeDlg;

                    $scope.auth_item_list = {};
                    $scope.auth_item_list.part_one = [];
                    $scope.auth_item_list.part_two = [];
                    $scope.auth_item_list.part_three = [];
                    $scope.auth_item = [];

                    $scope.selectedScheduleItem = undefined;

                    auth_edit_mode = Const.PAGE_MODE.CREATE;    // 'create';
                };

                var loadAuthModeInfo = function (auth_mode_string) {
                    var auth_mode_arr = auth_mode_string.replace('auth_mode_', '').split('_');

                    for (var i = 0, len = auth_mode_arr.length; i < len; i++) {
                        var item = auth_mode_arr[i].replace('biometric', 'finger'), part_el, containerHtml,
                            elImg = angular.element('<img/>')
//                                .attr('src', 'images/contents/icon_auth_' + item + '_drag.png')
                                .attr('src', 'images/contents/icon_auth_' + item + '.png')
                                .attr('alt', item)
                                .on('mousedown', function (event) {
                                    return false;
                                }),
                            delete_div = angular.element('<div/>').addClass('delete').on('click', deleteAuthItem),
                            deleteImg = angular.element('<img/>', {
                                'data-item-type': item
                            }).addClass('delete').on('click', deleteAuthItem).attr('src', 'images/contents/btn_close_select_door.png');

                        if (i == 0) {
                            $scope.auth_item_list.part_one.push(item);
                            part_el = angular.element('#part_one_0');
                        } else if (i == 1 && item != 'only') {
                            $scope.auth_item_list.part_two.push(item);
                            part_el = angular.element('#part_two_0');
                        } else if (i == 2 && item != 'or') {
                            $scope.auth_item_list.part_three.push(item);
                            part_el = angular.element('#part_three_0');
                        } else if (i == 3) {
                            $scope.auth_item_list.part_two.push(item);
                            part_el = angular.element('#part_two_1');
                        }
                        if (item == 'only' || item == 'or') {
                            continue;
                        }
//                        part_el.prepend(elImg).append(delete_div);
                        containerHtml = angular.element('<div/>', {
                                class: 'authModeDragPannel'
                            }
                        ).append(elImg).append('<span ng-label="user.authMode.' + item + '">' + MessageProperties.get('user.authMode.' + item) + '</span>');
                        part_el.prepend(containerHtml).append(deleteImg);
                        $scope.auth_item.push(item);
                    }
                };

                var deleteAuthItem = function (event) {
                    var target = event.target || (event.srcElement || document);

                    var itemType = angular.element(target).attr('data-item-type');

                    var auth_mode_string = $scope.AuthModeCombinationResult.toLowerCase(),
                        orExists = auth_mode_string.indexOf('or') > -1;

                    auth_mode_string = auth_mode_string.replace('_only', '').replace('_or', '').replace('biometric', 'finger');

                    var auth_mode_array = auth_mode_string.split(Const.OPERATION_MODE_SPLITTER);

                    var orIdx = auth_mode_array.indexOf('or');

                    if (orIdx > -1) {
                      auth_mode_array.splice(orIdx, 1);
                    }

                    var idx = auth_mode_array.indexOf(itemType);

                    auth_mode_array.splice(idx, 1);

                    auth_mode_string = auth_mode_array.join(Const.OPERATION_MODE_SPLITTER);

                    var nestedIdx = -1;
                    for (var i = 0; i < Const.OPERATION_MODE.length; i++) {
                        if (Const.OPERATION_MODE[i].indexOf(auth_mode_string.toUpperCase()) == 0) {
                            nestedIdx = i;
                        }
                    }

                    $scope.auth_item = [];
                    $scope.auth_item_list.part_one = [];
                    $scope.auth_item_list.part_two = [];
                    $scope.auth_item_list.part_three = [];
                    angular.element('.part_one > div.item').html('');
                    angular.element('.part_two > div.item').html('');
                    angular.element('.part_three > div.item').html('');

                    if (auth_mode_array.length > 0 && nestedIdx > -1) {

                        if (auth_mode_array.length == 1) {
                            auth_mode_array.push('only');
                        }

                        auth_mode_string = auth_mode_array.join(Const.OPERATION_MODE_SPLITTER);

                        loadAuthModeInfo(auth_mode_string);
                    } else {

                    }

                    if (!$scope.$root.$$phase) $scope.$apply();
                };

                $scope.doAfterOpenAddAuthModeDlg = function () {
                    var options = {};
                    options.modal = true;
                    options.shadow = false;
                    options.title = MessageProperties.get('device.addNewAuthMode');
//          options.width = 754;
                    options.top = 80;
                    options.width = 624;
                    options.height = 530;

                    options.onClose = function () {
                        $scope.addAuthModeDlg = {};
                        $scope.editAuthModeRow = undefined;

                        $scope.safeApply(function () {
                            angular.element('#addAuthModeDlg').dialog('destroy');
                        });
                    };
                    options.onOpen = function () {
                        if ($scope.editAuthModeRow) {
                            var auth_mode = $scope.editAuthModeRow,
                                auth_mode_string = authModePreset[auth_mode.mode].toLowerCase();
                            $scope.selectedScheduleItem = auth_mode.schedule_id;
                            loadAuthModeInfo(auth_mode_string);

                            auth_edit_mode = Const.PAGE_MODE.UPDATE;    // 'update';
                        }
                    };

                    $scope.AuthModeCombinationResult = '';

                    angular.element('#addAuthModeDlg').dialog(options);


//          $scope.selectedScheduleItem = {'id':0, 'name':'Always'};

                    var dragSrcEl = null;
                    angular.element('.drag > li').on('dragstart', function ($event) {
                        $event.originalEvent.dataTransfer.effectAllowed = 'move';
//              $event.originalEvent.dataTransfer.setData('text/html', this.innerHTML);
                        dragSrcEl = this.innerHTML;
                    });
                    angular.element('div.drop div.item')
                        .on('dragstart', function ($event) {
                            return false;
                        }).on('dragover', function ($event) {
                            if ($event.originalEvent.preventDefault) {
                                $event.originalEvent.preventDefault(); // Necessary. Allows us to drop.
                            }
                            $event.originalEvent.dataTransfer.dropEffect = 'move';  // See the section on the DataTransfer object.
                            return false;
                        }).on('drop', function ($event) {
                            if ($event.originalEvent.stopPropagation) {
                                $event.originalEvent.stopPropagation(); // Stops some browsers from redirecting.
                            }

                            var _this = this
                                , thisClassName = _this.parentElement.className
                                , class_regExp = /(part_[a-z]+)/g
                                , class_name = thisClassName.match(class_regExp)
                                , part_name = RegExp.$1
//              , innerHTML = event.dataTransfer.getData('text/html')
                                , innerHTML = dragSrcEl
                                , item_regExp = /alt="([a-z]+)"/g
                                , item = innerHTML.match(item_regExp)
                                , item_name = RegExp.$1;

                            $scope.safeApply(function () {
                                var html_reqexp = /(src="[a-z_ /]+)/g
//                                    , _html = innerHTML.replace(html_reqexp, '$1_drag').replace('draggable="true"', 'onmousedown="return false;"');
                                    , _html = innerHTML.replace(html_reqexp, '$1').replace('draggable="true"', 'onmousedown="return false;"');

                                var delete_div = angular.element('<div/>').addClass('delete').bind('click', deleteAuthItem),
                                    deleteImg = angular.element('<img/>', {
                                        'data-item-type': item.toString().replace(item_regExp, '$1')
                                    }).addClass('delete').on('click', deleteAuthItem).attr('src', 'images/contents/btn_close_select_door.png');

                                if (part_name.indexOf('one') > -1 && $scope.auth_item_list[part_name].length >= 1) {
                                    return false;
								} else if (_this.id.indexOf('part_two_0') > -1 && $scope.auth_item_list[part_name].length >= 1) {
									return false;
                                } else if ($scope.auth_item_list[part_name].length >= 2) {
                                    return false;
                                }

//                                angular.element(_this).prepend(_html).append(delete_div);
                                angular.element(_this).prepend(_html).append(deleteImg);
                                $scope.auth_item_list[part_name].push(item_name);
                                $scope.auth_item.push(item_name);
                            });
                            return false;
                        });

                };

                $scope.AuthModeCombinationResult = '';
                $scope.$watch('auth_item_list', function (nv, ov) {
                    if (nv == ov) return false;

                    var ret = [];

                    if (nv.part_one.length > 0) {
                        ret.push(nv.part_one.join('_or_'));
                    }
                    if (nv.part_two.length > 0) {
                        ret.push(nv.part_two.join('_or_'));
                    }
                    if (nv.part_three.length > 0) {
                        ret.push(nv.part_three.join('_or_'));
                    }

                    if (ret.length == 1) {
                        ret.push('only');
                    }

                    var regExp = /([A-Z]+)/g;

                    var AUTH_MODE_STRING = ret.join('_').replace('finger', 'biometric').replace('password', 'pin').toUpperCase();
                    $scope.AuthModeCombinationResult = AUTH_MODE_STRING;

                }, true);

                $scope.$watch('selectedScheduleItem', function (nv, ov) {
                    console.log('$scope.selectedScheduleItem:', $scope.selectedScheduleItem);
                });

                $scope.selectSchedule = function (scheduleItem) {
                    console.log('selectSchedule: ', scheduleItem);
                    $scope.selectedScheduleItem = scheduleItem;
                };

                $scope.doSaveAuthModeCombination = function () {

                    var AuthItem = authModePreset.isHasAuthItem($scope.AuthModeCombinationResult.split('_'));

                    var correctCombineYn = Const.OPERATION_MODE.indexOf($scope.AuthModeCombinationResult) > -1;

//          console.log($scope.selectedScheduleItem);

                    if (correctCombineYn == -1) {
                        MessageService.displayWarningMessage(
                            MessageProperties.get('validate.InvalidAuthentication'));
                        return false;
                    }
//                    if (AuthItem >= 255 || AuthItem == -1) {
//                        MessageService.displayWarningMessage(
//                            MessageProperties.get('validate.InvalidAuthentication'));
//                        return false;
//                    }
                    if (angular.isUndefined($scope.selectedScheduleItem)) {
                        MessageService.displayWarningMessage(
                            MessageProperties.get('validate.pleaseSelectSchedule'));
                        return false;
                    }

                    if ($scope.AuthModeCombinationResult.length <= 0) {
                        MessageService.displayConfirmMessage(MessageProperties.get('validate.cancelEdit'), function (dialogResult) {
                            if (dialogResult) {
                                angular.element('#addAuthModeDlg').dialog('close');
                            }
                            return false;
                        });
                        return false;
                    }

                    var checkExistAuthMessage = '';
                    if (angular.isUndefined($scope.ngModel) || $scope.ngModel == '') {
                        $scope.ngModel = [];
                    }
                    var sameAuthModes = [];

                    for (var j = $scope.ngModel.length; j--;) {
                        var item = $scope.ngModel[j];

                        if (AUTH_MODE_SAME_TYPE[item.mode] == AUTH_MODE_SAME_TYPE[AuthItem]) {
                            /**
                             * 같은 인증모드로 시작하는 것 추출
                             */
                            if ($scope.editAuthModeRow && j == $scope.ngModel.indexOf($scope.editAuthModeRow) && auth_edit_mode == Const.PAGE_MODE.UPDATE) {
                                continue;
                            }
                            if (item.mode == AuthItem && item.schedule_id.id == $scope.selectedScheduleItem.id) {
                                console.log('인증모드와 스케줄이 같으면 불허');
                                checkExistAuthMessage = MessageProperties.get('validate.existsAuthMode');
                                break;
                            }
                            sameAuthModes.push({
                                'index': j,
                                'item': angular.copy(item)
                            });
                        }
                    }

                    if (checkExistAuthMessage == '') {
                        for (var i = 0; i < sameAuthModes.length; i++) {
                            var item = sameAuthModes[i].item;
                            /**
                             * 같은 인증모드로 시작하는 경우 스케줄이 같지 않다면 등록 가능함
                             * 기존 ALWAYS 인데 NO_TIME 이 아니면 불허
                             * 기존 NO_TIME 이 아닌데 ALWAYS 이면 불허
                             * 같으면 불허
                             */
                            if (item.schedule_id.id == $scope.selectedScheduleItem.id) {
                                console.log('같으면 불허');
                                checkExistAuthMessage = MessageProperties.get('validate.sameSchedule', AUTH_MODE_TYPE_TEXT[AuthItem]);
                                break;
                            } else if (item.schedule_id.id == Const.DEFAULT_SCHEDULE.ALWAYS && $scope.selectedScheduleItem.id != Const.DEFAULT_SCHEDULE.NO_TIME) {
                                console.log('기존 ALWAYS 인데 NO_TIME 이 아니면 불허');
                                checkExistAuthMessage = MessageProperties.get('validate.overlapSchedule', AUTH_MODE_TYPE_TEXT[AuthItem]);
                                break;
                            } else if (item.schedule_id.id != Const.DEFAULT_SCHEDULE.NO_TIME && $scope.selectedScheduleItem.id == Const.DEFAULT_SCHEDULE.ALWAYS) {
                                console.log('기존 NO_TIME 이 아닌데 ALWAYS 이면 불허');
                                checkExistAuthMessage = MessageProperties.get('validate.overlapSchedule', AUTH_MODE_TYPE_TEXT[AuthItem]);
                                break;
                            }
                        }
                    }

					ScheduleAgent.getScheduleMap().then(function success(data) {
						$scope.scheduleItem = data;
					});


                    if (auth_edit_mode == Const.PAGE_MODE.UPDATE && checkExistAuthMessage == '') {
                        $scope.ngModel[$scope.ngModel.indexOf($scope.editAuthModeRow)] = {'mode': AuthItem, 'schedule_id': {id: $scope.selectedScheduleItem.id, name: $scope.selectedScheduleItem.name}};
                        angular.element('#addAuthModeDlg').dialog('close');
                    } else if (checkExistAuthMessage == '') {
                        $scope.ngModel.push({'mode': AuthItem, 'schedule_id': {id: $scope.selectedScheduleItem.id, name: $scope.selectedScheduleItem.name}});
                        angular.element('#addAuthModeDlg').dialog('close');
                    } else {
                        MessageService.displayInformationMessage(checkExistAuthMessage, function (dialogResult) {
                        });
                    }

                };

                $scope.doCloseAddAuthModeDlg = function () {
                    angular.element('#addAuthModeDlg').dialog('close');
                };

//        $scope.doOpenAddAuthModeDlg();

            }],
            link: function postLink(scope, element, attrs, ngModel) {
                if (!ngModel) {
                    return;
                }

                ngModel.$render = function () {

                };


            }
        };
    });
});
