'use strict';

define(function () {
  var app = angular.module('biostarWebApp');
  app.register.directive('ngbssDeviceTnaEventList',
    ['$rootScope', '$timeout', 'Const', 'MessageService', 'MessageProperties', 'ScheduleAgent',
      function ($rootScope, $timeout, Const, MessageService, MessageProperties, ScheduleAgent) {

        return {
          restrict: 'EA',
          replace: true,
          scope: {
            tnaEvents: '=ngModel',
            tnaMode: '=tnaMode',
            readOnly: '='
          },
          templateUrl: 'modules/common/directives/ngbssDeviceTnaEventList.html',
          controller: ['$scope', function ($scope) {

            $scope.Const = Const;

            $scope.SCHEDULE_LIST = {};

            $scope.init = function () {
            };
          }],
          link: function postLink($scope, $element, $attrs, $timeout) {
            ScheduleAgent.getScheduleList(undefined, 'TnaEventGetSchedule').then(function (data) {
              if (data.ScheduleCollection != undefined && data.ScheduleCollection.rows != undefined) {
                $scope.SCHEDULE_LIST[''] = MessageProperties.get("common.none");
                for (var i = 0; i < data.ScheduleCollection.rows.length; i++) {
                  var oneItem = data.ScheduleCollection.rows[i];
                  $scope.SCHEDULE_LIST[oneItem.id] = oneItem.name;
                  if (!$scope.$root.$$phase) $scope.$apply();
                }
              }
            });

          }
        };
      }]);
});
