'use strict';

angular.module('commonModule')
    .directive('progressbar', function ($interval, $location) {
        return {
            restrict: 'A',
            require: '?ngModel',
            link: function (scope, element, attrs, ngModel) {
                if (!ngModel)
                    return;

                var option = {};

                option.width = 200;

                var timer;

                option.onChange = function (newValue, oldValue) {
                    scope.pValue = newValue;
                    if (newValue >= 100) {
                        $interval.cancel(timer);
                        $location.path('/');
                        element.progressbar('setValue', 0);
                    }
                };

                element.progressbar(option);

                scope.pStart = function () {
                    var value = element.progressbar('getValue');
                    timer = $interval(function () {
                        value += Math.floor(Math.random() * 10);
                        element.progressbar('setValue', value);

                    }, 500);
                };

                scope.pStop = function () {
                    $interval.cancel(timer);
                };
            }
        };
    });
