'use strict';

define(['modules/setting/dialog/inputScheduleController'], function () {
    var app = angular.module('commonModule');

    app.directive('daySegment', ['$rootScope', '$compile', '$window', '$timeout', 'Const', 'MessageService', 'MessageProperties', function ($rootScope, $compile, $window, $timeout, Const, MessageService, MessageProperties) {
        return {
            restrict: 'A',
            scope: {
                timeSegments: '=ngModel',
                dayIdx: '=',
                useDailyIteration: '=',
                holidayGroup: '=',
                ngDisabled: '=',
                disabledYn: '=',
                typeB: '='
            },
            template: '<div class="timeline" ng-class="{\'typeB\': typeB == true}">' +
                '<div class="graduationCover graduation" tabindex="-1" style="z-index: 1000; background-color: rgba(255,255,255,0.01); cursor: pointer; "></div>' +
                '<div class="graduation"><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span><span></span></div>' +
                '<div class="on timeController">' +
                '<div class="box" tabindex="-1"></div>' +
                '<div class="toastPopup" tabindex="-1">' +
                '<span style="float: left; margin: 5.5px 8px 0 2px;">' +
                '<input type="text" class="partialStartTime" ng-enter="doEditTime()"/> ' +
                '~ ' +
                '<input type="text" class="partialEndTime" ng-enter="doEditTime()"/>' +
                '</span>' +
                '<span style="margin: 7.5px 6px 0px 0px; float:left;"><a href="javascript:void(null)" class="ibtnCheck" tabindex="-1" ng-click="doEditTimeSlot()"></a></span>' +
                '<span style="margin: 7.5px 6px 0px 0px; float:left;"><a href="javascript:void(null)" class = "ibtnDelete" tabindex="-1" ng-click="doDeleteTimeSlot()"></a></span>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '<div class="actionBtn">' +
                '<span style="margin-right: 4px;"><button href="javascript:void(null)" ng-click="doAddTimeSegmentToTimeLine()" class="ibtnEdit"></button></span>' +
                '<span style="margin-right: 4px;"><button href="javascript:void(null)" ng-click="doRemoveTimeLine()" class = "ibtnClear"></button></span>' +
                '</div>' +
                '<div class="popupArea">' +
                '</div>',
            controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {

                var canvas = document.createElement('canvas');
                var startX, startXtoMinute, startY = 0, rectWidth, rectHeight;
                var startTimes = [], endTimes = [];
                var rectangles = [];

                $scope.clickedRect = {};
                $scope.clickedRectIndex = -1;

                var graduation = $element.find('.graduationCover');
                var context = canvas.getContext('2d');

                var drag = false;
                var timeControllerWidth = $element.find('.timeController').find('.left').width();

                var timeSegmentCg = context.createLinearGradient(0, 0, 0, 18),
                    selectCg = context.createLinearGradient(0, 0, 0, 18);

                var ratio = Const.TIME_LINE_BASE_MINUTE / Const.TIME_LINE_BASE_WIDTH;
                $scope.ratio = ratio;

                timeSegmentCg.addColorStop(0, '#f9b45f');
                timeSegmentCg.addColorStop(1, '#eaaa5a');

                selectCg.addColorStop(0, '#7ecace');
                selectCg.addColorStop(1, '#6db9be');

                $element.find('.timeline').append(canvas);

                angular.element(canvas).addClass('timeline');

                if ($scope.typeB) {
                    angular.element(canvas).addClass('typeB');
                    ratio = Const.TIME_LINE_BASE_MINUTE / 576;
                }

                function readyToDrawTimeSegment($event) {

                    if (angular.isDefined($scope.disabledYn) && Object.keys($scope.disabledYn).length == 0) {
                        return false;
                    }

                    var i, rect;

                    var w = canvas.width = canvas.clientWidth;
                    var h = canvas.height = canvas.clientHeight;

                    $scope.clickedRect = undefined;
                    $scope.clickedRectIndex = -1;

                    startX = $event.offsetX / 10;
                    if (startX % 0.5 == 0) {
                        startX *= 10;
                    } else {
                        startX = Math.round(startX) * 10;
                    }

                    for (i = rectangles.length; i--;) {
                        rect = angular.copy(rectangles[i]);
                        context.fillStyle = timeSegmentCg;
                        context.fillRect(rect.startX, rect.startY, rect.rectWidth, rect.rectHeight);
                        console.log(rect.startX, rect.endX);
                        if (startX >= rect.startX && startX <= rect.endX) {
                            $scope.clickedRect = angular.copy(rect);
                            $scope.clickedRectIndex = i;
                        }
                    }

                    angular.element('.timeController').find('.toastPopup').removeClass('focus');
                    angular.element('.timeController').find('.box').removeClass('focus');

                    if ($scope.clickedRect) {
                        var width = $element.find('.timeController').find('.left').width();

                        if (!$scope.$root.$$phase) $scope.$apply();

                        $element.find('.partialStartTime').val(formatMinutesToTimes($scope.clickedRect.startX * ratio));
                        $element.find('.partialEndTime').val(formatMinutesToTimes($scope.clickedRect.endX * ratio));

                        $element.find('.timeController').find('.toastPopup').width();
                        $element.find('.timeController').find('.toastPopup').css('left', ($scope.clickedRect.endX - 20) + 'px');
                        $element.find('.timeController').find('.toastPopup').addClass('focus');

                        $element.find('.timeController').find('.box').css('left', ($scope.clickedRect.startX) + 'px');
                        $element.find('.timeController').find('.box').css('width', $scope.clickedRect.rectWidth + 'px');
                        $element.find('.timeController').find('.box').addClass('focus');
//                        console.log('여기에 조절창을 띄웁니다.');
                    } else {

                        $scope.doAddTimeSegmentToTimeLine();

//                        if (rectangles.length >= Const.TIME_SEGMENT_MAX_COUNT) {
//                            MessageService.displayWarningMessage(MessageProperties.get('validate.onlyFiveItemsAreAllowedForTimeSegments'));
//                            return false;
//                        }
                    }
//
//                    rectWidth = $event.offsetX - startX;
//                    context.fillRect(startX, startY, rectWidth, canvas.height);
//                    drag = true;

                }

                function startDrawingTimeSegment($event) {
                    var tenMinutesToPixel;
                    if (drag == true) {
                        tenMinutesToPixel = convertMinutesToPixel(10);
                        rectWidth = Math.ceil(($event.offsetX - startX) / tenMinutesToPixel) * tenMinutesToPixel;

                        context.fillStyle = timeSegmentCg;
                        context.fillRect(startX, startY, rectWidth, canvas.height);
                        if (navigator.userAgent.indexOf('Chrome') > -1) {
                            var segment = timeSegmentRelocated({startX: startX, startY: startY, endX: startX + rectWidth, endY: startY, rectWidth: rectWidth, rectHeight: canvas.height});
                            if ($scope.clickedRect && segment) {
                                $element.find('.timeController').find('.left').css('left', (segment.startX - timeControllerWidth) + 'px');
                                $element.find('.timeController').find('.right').css('left', (segment.endX) + 'px');
                                $element.find('.timeController').find('.box').css('left', (segment.startX) + 'px');
                                $element.find('.timeController').find('.box').css('width', segment.rectWidth + 'px');

                                if (!$scope.$root.$$phase) $scope.$apply();
                            }
                            drawTimeSegment();
                        }
                    }
                }

                function stopDrawingTimeSegment() {
                    if (drag == true) {
                        if (rectWidth && startX != startX + rectWidth) {
                            var segment = timeSegmentRelocated({startX: startX, startY: startY, endX: startX + rectWidth, endY: startY, rectWidth: rectWidth, rectHeight: canvas.height});
                            if ($scope.clickedRect && segment) {
                                $element.find('.timeController').find('.left').css('left', (segment.startX - timeControllerWidth) + 'px');
                                $element.find('.timeController').find('.right').css('left', (segment.endX) + 'px');
                                $element.find('.timeController').find('.box').css('left', (segment.startX) + 'px');
                                $element.find('.timeController').find('.box').css('width', segment.rectWidth + 'px');

                                if (!$scope.$root.$$phase) $scope.$apply();
                            }
                            drawTimeSegment();
                        }
                        drag = false;
                    }
                }

                function timeSegmentRelocated(segment) {
                    var i, rect, swap, mergeYn = false;
                    var coveredAreaIndex = [], startXs = [], endXs = [];
                    var relocated = [];
                    var tenMinutesToPixel = convertMinutesToPixel(10);

                    if (segment.endX < segment.startX) {
                        swap = segment.endX;
                        segment.endX = segment.startX;
                        segment.startX = swap;
                        segment.rectWidth = segment.endX - segment.startX;
                    }

//                    if (segment.rectWidth < tenMinutesToPixel) {
//                        return false;
//                    }

                    for (i = rectangles.length; i--;) {
                        rect = rectangles[i];

//                        console.log(rect.startX, segment.startX, rect.endX, '::::', rect.startX, segment.endX, rect.endX);
//                        console.log('rect.startX <= segment.startX && rect.endX > segment.startX', rect.startX <= segment.startX && rect.endX > segment.startX);
//                        console.log('rect.startX < segment.endX &&  rect.endX >= segment.endX', rect.startX < segment.endX &&  rect.endX >= segment.endX);
//                        console.log('rect.startX > segment.startX && rect.endX < segment.endX', rect.startX > segment.startX && rect.endX < segment.endX);

                        // 앞선 세그먼트의 뒷부분을 덮을때
                        if (rect.startX <= segment.startX && rect.endX >= segment.startX) {
                            coveredAreaIndex.push(i);
                            if (startXs.indexOf(rect.startX) == -1) {
                                startXs.push(angular.copy(rect.startX));
                            }
                            if (startXs.indexOf(segment.startX) == -1) {
                                startXs.push(angular.copy(segment.startX));
                            }
                            if (endXs.indexOf(rect.endX) == -1) {
                                endXs.push(angular.copy(rect.endX));
                            }
                            if (endXs.indexOf(segment.endX) == -1) {
                                endXs.push(angular.copy(segment.endX));
                            }
                            mergeYn = true;
                        }

                        // 뒷선 세그먼트의 앞부분을 덮을때
                        if (rect.startX <= segment.endX && rect.endX >= segment.endX) {
                            coveredAreaIndex.push(i);
                            if (startXs.indexOf(rect.startX) == -1) {
                                startXs.push(angular.copy(rect.startX));
                            }
                            if (startXs.indexOf(segment.startX) == -1) {
                                startXs.push(angular.copy(segment.startX));
                            }
                            if (endXs.indexOf(rect.endX) == -1) {
                                endXs.push(angular.copy(rect.endX));
                            }
                            if (endXs.indexOf(segment.endX) == -1) {
                                endXs.push(angular.copy(segment.endX));
                            }
                            mergeYn = true;
                        }

                        // 모든 세그먼트 영역을 덮을 때
                        if (rect.startX >= segment.startX && rect.endX <= segment.endX) {
                            coveredAreaIndex.push(i);
                            if (startXs.indexOf(rect.startX) == -1) {
                                startXs.push(angular.copy(rect.startX));
                            }
                            if (startXs.indexOf(segment.startX) == -1) {
                                startXs.push(angular.copy(segment.startX));
                            }
                            if (endXs.indexOf(rect.endX) == -1) {
                                endXs.push(angular.copy(rect.endX));
                            }
                            if (endXs.indexOf(segment.endX) == -1) {
                                endXs.push(angular.copy(segment.endX));
                            }
                            mergeYn = true;
                        }
                    }

                    for (i = rectangles.length; i--;) {
                        if (coveredAreaIndex.indexOf(i) == -1) {
                            relocated.push(angular.copy(rectangles[i]));
                        }
                    }

                    startXs = startXs.sort(function (a, b) {
                        return b < a ? 1 : -1;
                    });
                    endXs = endXs.sort(function (a, b) {
                        return b > a ? 1 : -1;
                    });

                    if (startXs.length || endXs.length) {
                        segment = {startX: startXs[0], startY: startY, endX: endXs[0], endY: startY, rectWidth: endXs[0] - startXs[0], rectHeight: canvas.height};
                        relocated.push(angular.copy(segment));
                        $scope.clickedRectIndex = relocated.length - 1;
                    }

//                    console.log('relocated.length', relocated.length);
                    rectangles = angular.copy(relocated);

                    if (mergeYn == false) {
                        rectangles.push(angular.copy(segment));
                    }

                    $scope.timeSegments = [];
                    for (i = 0; i < rectangles.length; i++) {
                        rect = rectangles[i];
                        $scope.timeSegments.push({
                            start_time: Math.round(convertPixelToMinutes(rect.startX)),
                            end_time: Math.round(convertPixelToMinutes(rect.endX))
                        });
                    }

                    return segment;
                }

                function drawTimeSegment() {
                    var i, rect;
                    var w = canvas.width = canvas.clientWidth;
                    var h = canvas.height = canvas.clientHeight;

                    startTimes = [];
                    endTimes = [];

                    for (i = rectangles.length; i--;) {
                        rect = rectangles[i];
                        context.fillStyle = timeSegmentCg;
//                        if(i == $scope.clickedRectIndex) {
//                            context.fillStyle = selectCg;
//                        }
                        context.fillRect(rect.startX, rect.startY, rect.rectWidth, rect.rectHeight);

                        if (startTimes.indexOf($scope.timeSegments[i].start_time) == -1) {
                            startTimes.push(angular.copy($scope.timeSegments[i].start_time));
                        }
                        if (endTimes.indexOf($scope.timeSegments[i].end_time) == -1) {
                            endTimes.push(angular.copy($scope.timeSegments[i].end_time));
                        }
                    }

                    startTimes = startTimes.sort(function (a, b) {
                        return b < a;
                    });
                    endTimes = endTimes.sort(function (a, b) {
                        return b > a;
                    });


                    $scope.startTime = formatMinutesToTimes(startTimes[0] || 0);
                    $scope.endTime = formatMinutesToTimes(endTimes[0] || 0);

                    if (!$scope.$root.$$phase) $scope.$apply();
                }

                function focusInTimeSlot() {
                    console.log('%cFocus In Time Segment, Index' + $scope.dayIdx, 'color:blue;background:#f9b45f;');
                    if ($scope.clickedRectIndex > -1 && $scope.clickedRect) {
                        $element.find('.timeController').addClass('focus');
                        $element.find('.timeController').find('.box').addClass('focus');
                    }
                }


                var focusCount = 0;

                function focusOutTimeSlot() {
                    var event = window.event, nodeName, target;
                    console.log('%cFocus Out Time Segment, Index' + $scope.dayIdx, 'color:blue;background:#eaaa5a;');

                    if (event.relatedTarget) {
                        nodeName = event.relatedTarget.nodeName;
                        target = event.relatedTarget;
                    }
                    if (event.toElement) {
                        nodeName = event.toElement.nodeName;
                        target = event.toElement;
                    }

                    if (nodeName) {
                        focusCount++;
                    }

                    console.log(angular.element(target).closest('div.toastPopup').attr('class') == undefined);
                    if (!focusCount || angular.element(target).closest('div.toastPopup').attr('class') == undefined) {
                        $element.find('.timeController').removeClass('focus');
                        $element.find('.timeController').find('.toastPopup').removeClass('focus');
                        $element.find('.timeController').find('.box').removeClass('focus');
                        $scope.clickedRectIndex = -1;
                        $scope.clickedRect = undefined;
                    } else {
                        focusCount = 0;
                    }
                }

                function convertPixelToMinutes(pixel) {
                    return pixel * ratio;
                }

                function convertMinutesToPixel(minutes) {
//                    return minutes / Const.TIME_LINE_BASE_MINUTE * Const.TIME_LINE_BASE_WIDTH;
                    return minutes / ratio;
                }

                function formatMinutesToTimes(minutes) {

                    var hours = Math.floor(minutes / 60);
                    var min = Math.floor(minutes % 60);

                    if (hours < 10) {
                        hours = '0' + hours.toString();
                    }

                    if (min < 10) {
                        min = '0' + min.toString();
                    }

                    return hours + ":" + min;
                }

                $scope.formatMinutesToTimes = formatMinutesToTimes;

                function focusTimeController() {
                    $element.find('.timeController').find('.toastPopup').focus();
                    $element.find('.timeController').find('.box').focus();
                }

                function setTimeSegmentToCanvas() {
                    if ($scope.timeSegments) {
                        rectangles = [];
                        for (var i = 0; i < $scope.timeSegments.length; i++) {
                            var segment = $scope.timeSegments[i];
                            var rect = {
                                startX: convertMinutesToPixel(segment.start_time), startY: startY,
                                endX: convertMinutesToPixel(segment.end_time), endY: startY,
                                rectWidth: convertMinutesToPixel(segment.end_time - segment.start_time), rectHeight: canvas.height
                            };
                            rectangles.push(rect);
                        }
                        drawTimeSegment();
                    } else {
                        $scope.timeSegments = [];
                    }
                }

                $scope.startTime = formatMinutesToTimes(convertPixelToMinutes(0));
                $scope.endTime = formatMinutesToTimes(convertPixelToMinutes(0));

                $scope.doDeleteTimeSegment = function () {
                    MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                        if (confirmYn) {
                            $element.find('.timeController').removeClass('focus');
                            rectangles.splice($scope.clickedRectIndex, 1);
                            $scope.timeSegments.splice($scope.clickedRectIndex, 1);
                            drawTimeSegment();
                        } else {
                            $element.find('.timeController').addClass('focus');
                        }
                    });
                };

                $scope.doDecreaseStartTime = function () {
                    var timeSegment = $scope.timeSegments[$scope.clickedRectIndex];
                    var move = timeSegment.start_time - 1;

                    if (move < 0) {
                        return;
                    }

                    timeSegment.start_time = move;

                    setTimeSegmentToCanvas();
                    focusTimeController();
                };

                $scope.doIncreaseStartTime = function () {
                    var timeSegment = $scope.timeSegments[$scope.clickedRectIndex];
                    var move = parseInt(timeSegment.start_time) + 1;

                    if (move > timeSegment.end_time) {
                        return;
                    }
                    timeSegment.start_time = move;

                    setTimeSegmentToCanvas();
                    focusTimeController();
                };

                $scope.doDecreaseEndTime = function () {
                    var timeSegment = $scope.timeSegments[$scope.clickedRectIndex];
                    var move = timeSegment.end_time - 1;

                    if (move < timeSegment.start_time) {
                        return;
                    }

                    timeSegment.end_time = move;

                    setTimeSegmentToCanvas();
                    focusTimeController();
                };

                $scope.doIncreaseEndTime = function () {

                    var timeSegment = $scope.timeSegments[$scope.clickedRectIndex];
                    var move = parseInt(timeSegment.end_time) + 1;

                    if (move > Const.TIME_LINE_BASE_MINUTE) {
                        return;
                    }

                    timeSegment.end_time = move;

                    setTimeSegmentToCanvas();
                    focusTimeController();
                };


                $scope.timeSegmentRelocated = timeSegmentRelocated;

                $scope.doEditTimeSlot = function () {
                    var startTimes = $element.find('.partialStartTime').val(),
                        endTimes = $element.find('.partialEndTime').val();

                    var hours = NaN, minutes = NaN, startTime, endTime;

                    startTimes = startTimes.split(':');
                    endTimes = endTimes.split(':');

                    if (startTimes.length == 1) {
                        hours = parseInt(startTimes[0]) * 60;

                        if (isNaN(hours) || hours > Const.TIME_LINE_BASE_MINUTE) {
                            startTime = $scope.timeSegments[$scope.clickedRectIndex].start_time;
                        } else {
                            startTime = hours;
                        }
                    } else if (startTimes.length == 2) {
                        hours = parseInt(startTimes[0]) * 60;
                        minutes = parseInt(startTimes[1]);

                        if (isNaN(hours) || isNaN(minutes) || parseInt(hours + minutes) > Const.TIME_LINE_BASE_MINUTE) {
                            startTime = $scope.timeSegments[$scope.clickedRectIndex].start_time;
                        } else {
                            startTime = hours + minutes;
                        }
                    } else {
                        startTime = $scope.timeSegments[$scope.clickedRectIndex].start_time;
                    }

                    if (startTime < 0 || startTime > 1440) {
                        MessageService.displayWarningMessage(MessageProperties.get('validate.invalidTime'));
                        return false;
                    }


                    if (endTimes.length == 1) {
                        hours = parseInt(endTimes[0]) * 60;

                        if (isNaN(hours)) {
                            endTime = $scope.timeSegments[$scope.clickedRectIndex].end_time;
                        } else {
                            endTime = hours;
                        }
                    } else if (endTimes.length == 2) {
                        hours = parseInt(endTimes[0]) * 60;
                        minutes = parseInt(endTimes[1]);

                        if (isNaN(hours) || isNaN(minutes)) {
                            endTime = $scope.timeSegments[$scope.clickedRectIndex].end_time;
                        } else {
                            endTime = hours + minutes;
                        }
                    } else {
                        endTime = $scope.timeSegments[$scope.clickedRectIndex].end_time;
                    }

                    if (endTime < 0 || endTime > 1440) {
                        MessageService.displayWarningMessage(MessageProperties.get('validate.invalidTime'));
                        return false;
                    }

                    if (endTime == startTime) {

                    } else if (endTime > Const.TIME_LINE_BASE_MINUTE || startTime > Const.TIME_LINE_BASE_MINUTE) {

                    }
                    if (endTime <= startTime) {

                    } else {

                        $scope.clickedRect.startX = startTime / ratio;
                        $scope.clickedRect.endX = endTime / ratio;
                        $scope.clickedRect.rectWidth = $scope.clickedRect.endX - $scope.clickedRect.startX;

                        rectangles.splice($scope.clickedRectIndex, 1);
                        timeSegmentRelocated($scope.clickedRect);
                    }

                    $element.find('.timeController').removeClass('focus');
                    $element.find('.timeController').find('.toastPopup').removeClass('focus');
                    $element.find('.timeController').find('.box').removeClass('focus');

                    $element.find('.toastPopup').find('input').each(function () {
                        angular.element(this).val('');
                    });

                };

                $scope.doDeleteTimeSlot = function () {
                    $element.find('.timeController').removeClass('focus');
                    $element.find('.timeController').find('.toastPopup').removeClass('focus');
                    $element.find('.timeController').find('.box').removeClass('focus');

                    rectangles.splice($scope.clickedRectIndex, 1);
                    $scope.timeSegments.splice($scope.clickedRectIndex, 1);
                };


                var div = angular.element('<div />', {
                    'id': 'inputScheduleDlg',
                    'ng-include': '\'modules/setting/dialog/inputSchedule.html\'',
                    'onload': 'doOpenAfterAddTimeSegmentToTimeLine()'
                });

                $scope.doAddTimeSegmentToTimeLine = function () {

                    if (angular.isDefined($scope.disabledYn) && Object.keys($scope.disabledYn).length == 0) {
                        return false;
                    }

                    angular.element('.toastPopup').removeClass('focus');
                    angular.element('.box').removeClass('focus');

                    $element.find('.popupArea').append(div);
                    $compile($element.find('.popupArea'))($scope);

                    if (!$scope.$root.$$phase) $scope.$apply();
                };

                $scope.doOpenAfterAddTimeSegmentToTimeLine = function () {
                    var options = {};
                    options.modal = true;
                    options.shadow = false;
                    options.width = 480;
                    options.height = 'auto';
                    options.shadow = false;
                    options.title = MessageProperties.get('schedule.header.inputSchedule');

                    options.onClose = function () {
                        angular.element('#doAddTimeSegmentToTimeLineDlg').dialog('destroy');
                        $element.find('.popupArea').html('');
                        $compile($element.find('.popupArea'))($scope);
                    };

                    angular.element("#doAddTimeSegmentToTimeLineDlg").dialog(options);
                };

                $scope.doRemoveTimeLine = function () {

                    if (angular.isDefined($scope.disabledYn) && Object.keys($scope.disabledYn).length == 0) {
                        return false;
                    }

                    angular.element('.toastPopup').removeClass('focus');
                    angular.element('.box').removeClass('focus');

                    MessageService.displayConfirmMessage(MessageProperties.get('validate.removeAllTimeSlots'), function (confirmYn) {
                        if (confirmYn) {
                            $scope.timeSegments = [];
                        }
                    });
                };

                angular.element(graduation).on('mousedown', readyToDrawTimeSegment);

                angular.element(graduation).on('mousemove', startDrawingTimeSegment);

                angular.element(graduation).on('mouseup', stopDrawingTimeSegment);

                angular.element(graduation).on('mouseleave', stopDrawingTimeSegment);

                setTimeSegmentToCanvas();

                $element.bind('focusin', focusInTimeSlot);

                $element.bind('focusout', focusOutTimeSlot);

                $scope.$watch('timeSegments', function (newValue, oldValue) {
                    if (newValue != oldValue && newValue && newValue.length) {
                        setTimeSegmentToCanvas();
                    } else if (angular.isDefined(newValue) && newValue.length == 0) {
                        setTimeSegmentToCanvas();
                    }
                }, true);

                $scope.$watch('disabledYn', function (nv) {
                    if (angular.isDefined(nv) && Object.keys(nv).length == 0) {
                        angular.element(canvas).addClass('disabled');
                        $element.find('.ibtnEdit').addClass('disabled');
                        $element.find('.ibtnClear').addClass('disabled');
                    } else if (angular.isDefined(nv) && Object.keys(nv).length > 0) {
                        angular.element(canvas).removeClass('disabled');
                        $element.find('.ibtnEdit').removeClass('disabled');
                        $element.find('.ibtnClear').removeClass('disabled');
                    }
                });

                $scope.setTimeSegments = function (timeSegments) {
                    var segment;

                    rectangles = [];

                    if (timeSegments.length > 0) {

                        for (var i = 0; i < timeSegments.length; i++) {
                            segment = timeSegments[i];
                            timeSegmentRelocated({startX: segment.start_time / ratio, startY: startY, endX: segment.end_time / ratio, endY: startY, rectWidth: (segment.end_time - segment.start_time) / 2, rectHeight: canvas.height});
                        }
                    } else {
                        $scope.timeSegments = angular.copy(timeSegments);
                    }
                }
            }]
        }
    }]);

});