'use strict';

define(function () {
    var app = angular.module('commonModule');

    app.directive('tooltipBox', ['$compile', 'UUID', 'Util', function ($compile, UUID, Util) {
        return {
            restrict: 'E',
            scope : {
            },
            controller: ['$scope', '$element','$attrs', function($scope, $element, $attrs) {

                var i, node, tooltip, input, inputWidth, elementWidth;

                if(angular.element('tooltip-box').children().length > 0) {

                    if ($attrs.tooltipShowCondition && $attrs.tooltipLabel) {
                        tooltip = angular.element('<tooltip />', {
                            'data-tooltip-show-condition': $attrs.tooltipShowCondition,
                            'data-tooltip-label': $attrs.tooltipLabel
                        });

                        $element.append(tooltip);
                        $compile(tooltip)($scope.$parent);
                    }

                    inputWidth = $element.find('input').outerWidth(true);
                    elementWidth = $element.outerWidth(true);

                    $element.css('display', 'inline-block');
                    $element.css('position', 'relative');

                    if (inputWidth == elementWidth) {
                        $element.css('width', '100%');
                    }

                } else if(angular.element('tooltip-box').children().length == 0) {

                    var inputObject = {};

                    var ngForm = angular.element('<ng-form />', {
                    });

                    var name = UUID();

                    name = 'innerForm'+name.slice(0, 1);

                    ngForm.attr('name', name);

                    $element.append(ngForm);

                    for (var key in $attrs) {
                        if (typeof $attrs[key] == 'string' && key.indexOf('tooltip') < 0) {
                            inputObject[$attrs.$attr[key]] = $attrs[key];
                        }
                    }

                    input = angular.element('<input />', inputObject);

                    ngForm.append(input);

                    tooltip = angular.element('<tooltip />', {
                        'class' : 'warningTooltip',
                        'data-tooltip-show-condition': name + '.$invalid',
                        'data-tooltip-label': $attrs.tooltipLabel
                    });

                    ngForm.append(tooltip);

                    $compile(ngForm)($scope.$parent);

                    for( ; $element[0].attributes.length; ) {
                        node = $element[0].attributes[0];
                        $element.removeAttr(node.nodeName);
                    }

                }
            }]
        }
    }]);

    app.directive('tooltip', ['$compile', '$rootScope', 'Util', function ($compile, $rootScope, Util) {
        return {
            restrict: 'E',
            replace: true,
            scope : {

            },
            template: '<span></span>',
            controller: ['$scope', '$element','$attrs', function($scope, $element, $attrs) {
                Util.debug('tooltip', $scope);

                $element.addClass('warningTooltip');
                $element.attr('ng-if',$attrs.tooltipShowCondition);
                $element.attr('ng-label',$attrs.tooltipLabel);

                $compile($element)($scope.$parent);
            }]
        }
    }]);
});