'use strict';

define([
    'modules/common/services/auth',
    'modules/common/services/user-agent',
    'modules/common/services/device-agent',
    'modules/common/services/monitoringAgent',
    'modules/common/services/door-agent',
    'modules/common/websocketModule',
    'modules/common/alert/alertService',
    'modules/common/services/preferenceService'
], function () {

    var app = angular.module('biostarWebApp');

    app.run([
        '$rootScope', '$location', 'Auth', '$cookieStore', 'API', 'Const', 'MessageProperties', 'UserAgent', 'DeviceAgent', 'DoorAgent', 'MonitoringAgent', 'WebSocketService', 'AlertService', 'PrivilegeService', 'PreferenceService', 'MessageService', 'DialogService',
        function ($rootScope, $location, Auth, $cookieStore, API, Const, MessageProperties, UserAgent, DeviceAgent, DoorAgent, MonitoringAgent, WebSocketService, AlertService, PrivilegeService, PreferenceService, MessageService, DialogService) {
        $rootScope.Const = Const;
            $rootScope.MessageProperties = MessageProperties;

        $rootScope.safeApply = function (fn, scope) {
            var phase = $rootScope.$root.$$phase;
            if (scope != undefined) {
                phase = scope.$$phase;
            }
            if (phase == '$apply' || phase == '$digest') {
                if (fn && (typeof(fn) === 'function')) {
                    fn();
                }
            } else {
                if (scope != undefined) {
                    scope.$apply(fn);
                } else {
                    $rootScope.$apply(fn);
                }
            }
        };

        angular.element(document).on('keydown', function (event) {
            if (event.keyCode == 13) {
                if (angular.element(event.target).attr('class')) {
                    if (angular.element(event.target).attr('class').indexOf('inputSearch') > -1) {
                    } else if (angular.element(event.target).attr('class').indexOf('inputLogin') > -1) {
                    } else if (angular.element(event.target).attr('class').indexOf('enterKeyAllowed') > -1) {
                    } else {
                        if (event.preventDefault) event.preventDefault();
                        if (event.returnValue) event.returnValue = false;

                        event.cancelBubble = true;
                    }
                }
            }
        });

        $rootScope.clickCellOnGrid = function (gridId, rowIndex, field, idColumnName, nonCheckBoxClickCallback) {
            var rows = angular.element('#' + gridId).datagrid('getRows');
            var rowData = undefined;
            rowData = rows[rowIndex];
//            console.log("clickCellOnGrid", gridId, rowIndex, field, rowData);
            if (field == Const.FIELD_NAME.CHECKBOX) {
                var checkedRows = angular.element('#' + gridId).datagrid('getChecked');
                var isChecked = false;
                for (var i = 0; i < checkedRows.length; i++) {
                    if (checkedRows[i][idColumnName] == rowData[idColumnName]) {
                        isChecked = true;
                        angular.element('#' + gridId).datagrid('uncheckRow', rowIndex);
                    }
                }
                if (isChecked == false) {
                    angular.element('#' + gridId).datagrid('checkRow', rowIndex);
                }
            } else {
                if (nonCheckBoxClickCallback != undefined) {
                    nonCheckBoxClickCallback(rowData);
                }
            }
        };
    }]);


});