﻿'use strict';

define(function () {

    var routeResolver = function () {

        this.$get = function () {
            return this;
        };

        this.routeConfig = function () {
            var baseDirectory = '/app/modules/',

                setBaseDirectory = function (baseDir) {
                    baseDirectory = baseDir;
                },

                getBaseDirectory = function () {
                    return baseDirectory;
                };

            return {
                setBaseDirectory: setBaseDirectory,
                getBaseDirectory: getBaseDirectory
            };
        }();

        this.route = function (routeConfig) {

            var resolve = function (controllerNamePrefix, modulePath) {
                    if (!modulePath) {
                        modulePath = '';
                    }
                    var javascriptNamingConventionBaseName =
                        controllerNamePrefix.substr(0, 1).toLowerCase()
                        + controllerNamePrefix.substr(1);

                    var routeDef = {};
                    routeDef.templateUrl = routeConfig.getBaseDirectory() + modulePath
                        + javascriptNamingConventionBaseName + '.html';
                    routeDef.controller = controllerNamePrefix + 'Controller';
                    routeDef.resolve = {
                        load: ['$q', '$rootScope', function ($q, $rootScope) {
                            var dependencies = [routeConfig.getBaseDirectory() + modulePath
                                + javascriptNamingConventionBaseName + 'Controller.js'];
                            return resolveDependencies($q, $rootScope, dependencies);
                        }]
                    };

                    return routeDef;
                },

                resolveDependencies = function ($q, $rootScope, dependencies) {
                    var defer = $q.defer();
                    require(dependencies, function () {
                        defer.resolve();
                        $rootScope.$apply();
                    });

                    return defer.promise;
                };

            return {
                resolve: resolve
            }
        }(this.routeConfig);

    };

    var servicesApp = angular.module('routeResolverModule', []);

    //Must be a provider since it will be injected into module.config()    
    servicesApp.provider('routeResolver', routeResolver);

    return servicesApp;
});
