'use strict';

define([
    'modules/common/commonModule'
], function () {
    var app = angular.module('commonModule');
    app.service('CardsAgent', [
        '$log', '$q', '$rootScope', 'API', '$http', 'Const',
        function ($log, $q, $rootScope, API, $http, Const) {
        var
            httpTimeOut = undefined,
            canceller = $q.defer();

        function getCards(param, deferFunctionName) {
            var defer = $q.defer();

            API.get('cards', deferFunctionName, param).then(function (data) {
                defer.resolve(data);
            });

            return defer.promise;
        }

        function getCard(card_id) {
            var defer = $q.defer();
            API.get('card/' + card_id).then(function (data) {
                defer.resolve(data);
            });

//            defer.resolve({Card: {card_id: '213485', card_mask: '0', card_slot: '0', card_type: {id: '0', name: 'unknown', type: '0'}, id: '1', issue_count: '0'}});

            return defer.promise;
        }

        function getBlacklist(param) {
            var defer = $q.defer();

            API.get('setting/blacklist', 'getBlacklist', param).then(function (data) {
                defer.resolve(data);
            });

            return defer.promise;
        }

        function postBlacklist(param, callbackFunction) {
            API.post('setting/blacklist', 'postBlacklist', param).then(function success(data) {
                callbackFunction();
            }, function error() {
                callbackFunction();
            });
        }
        function deleteOneBlacklist(cardId, callbackFunction) {
            API.delete('setting/blacklist?id='+cardId, 'deleteOneBlacklist').then(function success(data) {
                callbackFunction();
            }, function error() {
                callbackFunction();
            });
        }

        function getCardIssueHistory(user_id) {
            var defer = $q.defer();

            API.get('users' + '/' + user_id + '/card_issue_history', 'getCardIssueHistory').then(function (data) {
                defer.resolve(data);
            });

            return defer.promise;
        }

        return {
            getCards: getCards,
            getCard: getCard,
            getBlacklist: getBlacklist,
            postBlacklist : postBlacklist,
            deleteOneBlacklist : deleteOneBlacklist,
            getCardIssueHistory: getCardIssueHistory
        }
    }]);
});