'use strict';

define([
    'modules/common/commonModule',
    'modules/common/services/datagridFilterService'
], function () {

    var app = angular.module('commonModule');
    app.service('MonitoringAgent', [
        '$q', '$rootScope', 'API', 'Const', 'Util',
        function ($q, $rootScope, API, Const, Util) {

        var monitoringAgent = {};
        var realtimeEventList = [];
        var initialViewId = Const.MONITORING_VIEW.PAST_EVENT;

        monitoringAgent = {
            init: function () {
                realtimeEventList = [];
            },
            addToTopOfRealtimeEventList: function (newObject) {
                realtimeEventList.unshift(newObject);
            },
            deleteOldData: function () {
                var count = realtimeEventList.length;
                if (count > Const.MAX_REAL_TIME_DATA_SIZE) {
                    realtimeEventList = realtimeEventList.slice(0, Const.MAX_REAL_TIME_DATA_SIZE);
                }
            },
            getRealtimeEventList: function () {
                return realtimeEventList;
            },
            setRealtimeEventList: function (paramRealtimeEventList) {
                realtimeEventList = paramRealtimeEventList;
            },
            getInitialViewId: function () {
                return initialViewId;
            },
            setInitialViewId: function (paramInitialViewId) {
                initialViewId = paramInitialViewId;
            }
        };

        $rootScope.$on('LoginToSuccess', function (event) {
            console.log('MonitoringAgent: LoginToSuccess');
            monitoringAgent.init();
        });
        return monitoringAgent;
    }]);

});