'use strict';

angular.module('biostarWebApp')
    .service('SearchBoxHistory', ['$cookieStore', function SearchBoxHistory($cookieStore) {
        // AngularJS will instantiate a singleton by calling "new" on this function


        return {
            loadHistory: function () {
                var history = $cookieStore.get('history') ? $cookieStore.get('history').split(',') : [];

                var i
                    , len = history.length
                    , ret_obj = []
                    , sort_obj = {};
                for (i = 0; i < len; i++) {
                    sort_obj[history[i]] = sort_obj[history[i]] !== undefined ? sort_obj[history[i]] + 1 : 1;
                }

                var item;
                for (item in sort_obj) {
                    ret_obj.push({name: item, id: sort_obj[item]});
                }

                return ret_obj;
            },
            saveHistory: function (word) {
                var history = $cookieStore.get('history') ? $cookieStore.get('history').split(',') : [];
                history.push(word);
                $cookieStore.put('history', history.join(','));
            }
        }
    }]);
