'use strict';

define([
    'modules/common/commonModule'
], function () {
    var app = angular.module('commonModule');
    app.service('UserAgent', [
        '$log', '$q', '$rootScope', '$location', 'API', 'Const', 'Util', 'MessageProperties',
        function ($log, $q, $rootScope, $location, API, Const, Util, MessageProperties) {
            var
                USER_GROUP_DATA,
                USER_GROUP_FLAT_DATA = undefined,
                USER_GROUP_PATH_DATA = {},
                USERS;

//        var allUserListWithoutStatus = [];
//        var allUserMapWithStatus = {};

//            function buildAllUserList(userList) {
//                if (userList != undefined) {
//                    allUserListWithoutStatus = [];
//                    allUserMapWithStatus = {};
//                    Util.rebuildListWithoutStatusAndMapWithStatus(userList, allUserListWithoutStatus, allUserMapWithStatus, 'user_id');
//                }
//            }

            function setTreeData(group) {
                var i, j,
                    item,
                    parentObj,
                    expandedState = {},
                    userGroupIdIndex = {};

                expandedState = window.sessionStorage.getItem('UserGroupTreeExpandedState');
                if (expandedState) {
                    expandedState = angular.fromJson(expandedState);
                } else {
                    expandedState = {};
                }

//            if (rebuildAllUserList == undefined) {
//                rebuildAllUserList = false;
//            }
//
//            if (rebuildAllUserList == true) {
//                allUserListWithoutStatus = [];
//                allUserMapWithStatus = {};
//            }

                USER_GROUP_PATH_DATA = {};
                // 유저 그룹 아이디 인덱스 생성 및 하위 유저그룹 초기화
                for (i = group.length; i--;) {
                    userGroupIdIndex[group[i].id] = i;
                    group[i].user_groups = [];
                    group[i].user_cnts = 0;
                }

                for (i = group.length; i--;) {
                    item = group[i];
//                if (rebuildAllUserList == true) {
//                    Util.rebuildListWithoutStatusAndMapWithStatus(item.users, allUserListWithoutStatus, allUserMapWithStatus, 'user_id');
//                }
                    if (item.parent_id) {
                        parentObj = group[userGroupIdIndex[item.parent_id.id]];

                        if (!parentObj) {
                            continue;
                        }

                        if (!parentObj.user_groups) {
                            parentObj.user_groups = [];
                        }
                        parentObj.user_groups.push(item);

                        // 유저그룹 경로 툴팁 생성
                        item.path = parentObj.name + ' > ' + item.name;
                        if (item.depth > 1)
                            item.path = '… > ' + item.path;

                        // 유저 목록에서 그룹 경로 표시를 위하여 오브젝트 데이터 생성
                        USER_GROUP_PATH_DATA[item.id] = item.path;
                    }
                }

                for (i = group.length; i--;) {
                    item = group[i];
                    if (item.user_groups != undefined && item.user_groups.length > 0) {
                        item.children = item.user_groups; // JQuery Easy UI Tree 를 위한 필드, 없으면 하위 노드 생성 안됨

                        if (item.user_groups && item.user_groups.length > 0) {
                            item.state = expandedState[item.id] || 'closed';
                            if (!expandedState[item.id]) {
                                expandedState[item.id] = 'closed';
                            }
                            item.children.sort(Util.dynamicSort('name'));
                        }
                    }
                }

//            if (rebuildAllUserList == true) {
//                allUserListWithoutStatus.sort(Util.dynamicSort("name"));
//            }

                for (var j = 0; j < group.length; j++) {
                    var cnt = findMyUsers(group[j]);
                    group[j].userTotal = cnt;
                }

                group[0].state = 'open';
                expandedState[group[0].id] = 'open';

                window.sessionStorage.setItem('UserGroupTreeExpandedState', angular.toJson(expandedState));

                return [group[0]]; // 최상위 그룹 하나만 사용하며, JQuery Easy UI Tree 생성을 위해 배열형으로 리턴
            }

            function findMyUsers(group) {
                var cnt = 0;
                if (group.user_groups && group.user_groups.length > 0) {
                    for (var i = 0; i < group.user_groups.length; i++) {
                        cnt += findMyUsers(group.user_groups[i]);
                    }
                }

                cnt += parseInt(group.user_count);

                return cnt;

            }

            function setTreeDataMemoization(group) {
                var i, parentObj,
                    userGroupIdIndex = {};
                USER_GROUP_FLAT_DATA = {};

                for (i = group.length; i--;) {
                    userGroupIdIndex[group[i].id] = i;
                }

                for (i = group.length; i--;) {
                    if (group[i].parent_id) {
                        var parentId = group[i].parent_id.id;
                        parentObj = group[userGroupIdIndex[parentId]];

                        if (!parentObj.user_groups) {
                            parentObj.user_groups = [];
                        }
                        parentObj.user_groups.push(group[i]);
                    }
                }

                for (var j = 0; j < group.length; j++) {
                    var cnt = findMyUsers(group[j]);
                    group[j].userTotal = cnt;

                    USER_GROUP_FLAT_DATA[group[j].id] = group[j];
                }

                return USER_GROUP_FLAT_DATA;
            }

            function getUsers(param, deferFunctionName) {
                var defer = $q.defer();
                if (param == undefined) {
                    // should not retrieve all users because decryption large amount data takes a long time
                    defer.reject({
                        Response: {
                            code: Const.SERVER_RESPONSE_CODE.INVALID_QUERY_PARAMETER
                        }
                    });
                }
                API.get('users', deferFunctionName, param).then(function success(data) {
                    USERS = data;
//                buildAllUserList(data.UserCollection.rows);
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                });
                return defer.promise;
            }

            function downloadCsv(params, body, deferFunctionName) {
                var defer = $q.defer();
                if (params == undefined) {
                    // should not retrieve all users because decryption large amount data takes a long time
                    defer.reject({
                        Response: {
                            code: Const.SERVER_RESPONSE_CODE.INVALID_QUERY_PARAMETER
                        }
                    });
                }
                var url = 'users/csv_export';
                if (params.id_list != undefined && params.id_list == Const.BIOSTAR_SERVER_PARAM_ALL) {
                    url += '?id=*';
                    url += '&query=' + (params.query == undefined ? '' : params.query);
                    url += '&offset=' + (params.offset == undefined ? '' : params.offset);
                    url += '&limit=' + (params.limit == undefined ? '' : params.limit);
                    url += '&group_id=' + (params.group_id == undefined ? '' : params.group_id);
                } else if (params.id_list != undefined && params.id_list.length > 0) {
                    url += '?id=';
                    for (var i = 0; i < params.id_list.length; i++) {
                        var userId = params.id_list[i];
                        if (i > 0) {
                            url += '+';
                        }
                        url += userId;
                    }
                } else {
                    url += '?query=' + (params.query == undefined ? '' : params.query);
                    url += '&offset=' + (params.offset == undefined ? '' : params.offset);
                    url += '&limit=' + (params.limit == undefined ? '' : params.limit);
                    url += '&group_id=' + (params.group_id == undefined ? '' : params.group_id);
                }

                var options = {
                    url: url,
                    deferFunctionName: deferFunctionName,
                    displaySuccessPopoup: false,
                    displayErrorPopup: true,
                    displayLoading: true,
                    params: body
                };

                API.postWithOptions(options).then(function (data) {
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                });
                return defer.promise;
            }

            function uploadCsv(body, deferFunctionName) {
                var defer = $q.defer();

                var url = 'users/csv_import';

                var options = {
                    url: url,
                    deferFunctionName: deferFunctionName,
                    displaySuccessPopoup: false,
                    displayErrorPopup: true,
                    displayLoading: true,
                    params: body
                };

                API.postWithOptions(options).then(function successful(data) {
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                });

                return defer.promise;
            }

            function uploadFileToWebDav(filename, body, deferFunctionName) {
                var defer = $q.defer();

                var options = {
                    url: $location.protocol() + "://" + $location.host() + ':' + $location.port() + Const.WEBDAV_PREFIX + filename,
                    deferFunctionName: deferFunctionName,
                    displaySuccessPopoup: false,
                    displayErrorPopup: true,
                    displayLoading: false,
                    headers: {
                        'Content-Type': 'application/octet-stream'
                    },
                    encryptData: false,
                    params: body,
                    transformRequest: []
                };

                API.putWithOptions(options).then(function successful(data) {
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                });

                return defer.promise;
            }


            function putUsers(param) {
                var query = '';
                var defer = $q.defer();

                if (param.userIDs.constructor == Array) {
                    API.put('users?id=' + param.userIDs.join('+'), 'putUsers', {"User": param.user}).then(function success(data) {
//                    console.log('api::putUsers::then');
                        defer.resolve(data);
                    }, function error(data) {
                        defer.reject(data);
                    }).finally(function () {
                        $rootScope.$broadcast('ReloadUserGroupData');
                    });
                    ;
                } else if (param.userIDs.constructor == String) {
                    if (param.query) {
                        if (param.query.group_id) {
                            query += 'group_id=' + param.query.group_id + '&';
                        }
                        if (param.query.query) {
                            query += 'query=' + param.query.query + '&';
                        }
                    }

                    API.put('users?' + query + 'id=*', 'putUsers', {"User": param.user}).then(function success(data) {
                        defer.resolve(data);
                    }, function error(data) {
                        defer.reject(data);
                    }).finally(function () {
                        $rootScope.$broadcast('ReloadUserGroupData');
                    });
                }
                return defer.promise;
            }

            function getOneUser(userId) {
                var defer = $q.defer();
                API.get('users' + '/' + userId, 'getOneUser', undefined, undefined, false, true, false).then(function success(data) {
//                console.log('api::getOneUser::then::'+data);
                    window.sessionStorage.setItem('userInfo', angular.toJson(data.User));
                    defer.resolve(data);
                });
                return defer.promise;
            }

            function getAutoGenerateUserId() {
                var defer = $q.defer();

                API.post('users/generate', 'getAutoGenerateUserId').then(function success(data) {
//                console.log('api::getAutoGenerateUserId::then::'+data);
                    defer.resolve(data.User.user_id);
                });

                return defer.promise;
            }

            function deleteUsers(param) {
                var defer = $q.defer(),
                    userIds,
                    query = '';

                userIds = param.UserIDs;

                if (userIds.constructor == Array) {
                    API.delete('users?id=' + (userIds.join ? userIds.join('+') : userIds), 'deleteUsers').then(function success(data) {
                        defer.resolve(data);
                    }, function error(data) {
                        defer.reject(data);
                    }).finally(function () {
                        $rootScope.$broadcast('ReloadUserGroupData');
                    });

                } else if (userIds.constructor == String) {

                    if (param.query) {
                        if (param.query.group_id) {
                            query += 'group_id=' + param.query.group_id + '&';
                        }
                        if (param.query.query) {
                            query += 'query=' + param.query.query + '&';
                        }
                    }

                    API.delete('users?' + query + 'id=*', 'deleteUsers').then(function success(data) {
                        defer.resolve(data);
                    }, function error(data) {
                        defer.reject(data);
                    }).finally(function () {
                        $rootScope.$broadcast('ReloadUserGroupData');
                    });
                }

                return defer.promise;
            }

            function postOneUser(user) {
                var defer = $q.defer();

                API.post('users', 'postOneUser', {"User": user}).then(function success(data) {
//                console.log('api::postOneUser::then::'+data);
                    if (USERS && angular.isDefined(USERS.UserCollection) &&
                        angular.isDefined(data.UserCollection) && data.UserCollection.rows.length > 0) {
                        if (USERS.UserCollection.rows == undefined) {
                            USERS.UserCollection.rows = [];
                        } else if (!Array.isArray(USERS.UserCollection.rows)) {
                            USERS.UserCollection.rows = [];
                        }
                        USERS.UserCollection.rows.push(data.UserCollection.rows[0]);
                        USERS.UserCollection.total = (parseInt(USERS.UserCollection.total) + 1) + '';
                    }
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                }).finally(function () {
                    $rootScope.$broadcast('ReloadUserGroupData');
                });

                return defer.promise;
            }

            function putOneUser(param, callbackFunction) {

                var defer = $q.defer();

                API.put('users/' + param.user_id, 'putOneUser', {"User": param.user}).then(function success(data) {
//                console.log('api::putOneUser::then::'+data);
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                }).finally(function () {
                    $rootScope.$broadcast('ReloadUserGroupData');
                });

                return defer.promise;
            }

            function checkDuplicatedId(param) {
                return API.post('users/verify', 'checkDuplicatedId', param, undefined, undefined, undefined, false);
            }

            function postOneUserGroup(param) {
                var defer = $q.defer();

                API.post('user_groups', 'postOneUserGroup', {"UserGroup": param}).then(function success(data) {
//                console.log('api::postOneUserGroup::then::'+data);
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                }).finally(function () {
//                $rootScope.$broadcast('ReloadUserGroupData');
                });

                return defer.promise;
            }

            function putOneUserGroup(param) {
                var defer = $q.defer(), group_id = param.id;

                API.put('user_groups/' + group_id, 'putOneUserGroup', {"UserGroup": param}).then(function success(data) {
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                }).finally(function () {
                    $rootScope.$broadcast('ReloadUserGroupData');
                });

                return defer.promise;
            }

            function getUserGroups(param, deferFunctionName) {
                var defer = $q.defer();
                API.get('user_groups', deferFunctionName, param).then(function success(data) {
                    if (data != undefined && data.UserGroupCollection != undefined && data.UserGroupCollection.rows != undefined
                        && data.UserGroupCollection.rows.length > 0) {
                        if (data.UserGroupCollection.rows[0].id == Const.DEFAULT_ALL_GROUP_ID) {
                            data.UserGroupCollection.rows[0].name = MessageProperties.get("menu.user.allUserGroups");
                        }
                    }
                    defer.resolve(data);
                }, function error(data) {
                    defer.reject(data);
                });
                return defer.promise;
            }

            function deleteUserGroups(groupIds) {
                var defer = $q.defer();
                API.delete('user_groups?id=' + (groupIds.join ? groupIds.join('+') : groupIds), 'deleteUserGroups').then(function success(data) {
                    defer.resolve(data);
                }, function error(data) {
                    defer.resolve(data);
                }).finally(function () {
                    $rootScope.$broadcast('ReloadUserGroupData');
                });
                return defer.promise;
            }

            function reloadUserGroupRecursiveData() {
                getUserGroups().then(function (data) {
                    Util.debug('reloadUserGroupRecursiveData');
                    setTreeDataToLocalVariable(data);

                })
            }

            function exportUsersToDevice(param) {
                var userIds,
                    overwriteYn = '',
                    defer = $q.defer();

                userIds = param.UserIDs;

                if (param.overwrite) {
                    overwriteYn += 'overwrite=' + param.overwrite + '&';
                } else {
                    overwriteYn += 'overwrite=false&';
                }

                if (userIds.constructor == Array) {
                    API.post('users/export?' + overwriteYn + 'id=' + (userIds.join ? userIds.join('+') : userIds), 'exportUsersToDevice', {"DeviceCollection": param.DeviceCollection},
                        undefined, true).then(function success(data) {
                            $rootScope.$broadcast('ReloadUserGroupData');
                            Util.debug("exportUsersToDevice post success");
                            defer.resolve(data);
                        });
                } else if (userIds.constructor == String) {
                    var query = '';
                    if (param.query) {
                        if (param.query.group_id) {
                            query += 'group_id=' + param.query.group_id + '&';
                        }
                        if (param.query.query) {
                            query += 'query=' + param.query.query + '&';
                        }
                    }

                    API.post('users/export?' + overwriteYn + query + 'id=*', 'exportUsersToDevice', {"DeviceCollection": param.DeviceCollection},
                        undefined, true).then(function success(data) {
                            Util.debug("exportUsersToDevice id all post success");
                            defer.resolve(data);
                        }).finally(function () {
                            $rootScope.$broadcast('ReloadUserGroupData');
                        });
                    ;
                }

                return defer.promise;
            }

            $rootScope.$on('LoginToSuccess', function () {
                console.log('Login to Success, UserAgentStart!.');
                getUserGroups().then(function (data) {
                    console.log("userAgent login to success");
                    setTreeDataToLocalVariable(data);
                    $rootScope.$broadcast('UserGroupDataReceiveSuccess');
                })
            });
            $rootScope.$on('reloadUserGroupRecursiveData', function () {
                Util.info('reloadUserGroupRecursiveData :: recieve emit');
                $rootScope.$broadcast('ReloadUserGroupData');
            });

            function setTreeDataToLocalVariable(data) {
                Util.debug("userAgent setTreeDataToLocalVariable");
                USER_GROUP_FLAT_DATA = setTreeDataMemoization(angular.copy(data.UserGroupCollection.rows));
                USER_GROUP_DATA = setTreeData(data.UserGroupCollection.rows, true);
            }

            var userAgent = {
                getUserGroupRecursiveData: function (deferFunctionName, reloadYn) {
                    var defer = $q.defer();
                    if (USER_GROUP_DATA && reloadYn != true) {
                        defer.resolve(USER_GROUP_DATA);
                    } else {
                        getUserGroups(undefined, deferFunctionName).then(function (data) {
//                        console.log("userAgent getUserGroupRecursiveData::"+data);
                            setTreeDataToLocalVariable(data);
                            defer.resolve(USER_GROUP_DATA);
                        });
                    }
                    return defer.promise;
                },
                getUserGroupPath: function (group_id) {
                    if (USER_GROUP_PATH_DATA) {
                        return USER_GROUP_PATH_DATA[group_id];
                    } else {
                        var defer = $q.defer();
                        getUserGroups().then(function (data) {
//                        console.log("userAgent getUserGroupPath");
                            USER_GROUP_DATA = setTreeData(data.UserGroupCollection.rows);
                            defer.resolve(USER_GROUP_PATH_DATA[group_id]);
                        });
                        return defer.promise;
                    }
                },
                getUserGroupMemoizationData: function (group_id) {
                    var defer = $q.defer();
                    if (USER_GROUP_FLAT_DATA) {
                        defer.resolve(USER_GROUP_FLAT_DATA);
                    } else {
                        getUserGroups().then(function (data) {
                            USER_GROUP_FLAT_DATA = setTreeDataMemoization(data.UserGroupCollection.rows);
                            defer.resolve(USER_GROUP_FLAT_DATA);
                        });
                    }
                    return defer.promise;
                },
                getUsers: getUsers,
                putUsers: putUsers,
                getOneUser: getOneUser,
                getAutoGenerateUserId: getAutoGenerateUserId,
                postOneUser: postOneUser,
                putOneUser: putOneUser,
                deleteUsers: deleteUsers,
                checkDuplicatedId: checkDuplicatedId,
                getUserGroups: getUserGroups,
                postOneUserGroup: postOneUserGroup,
                deleteUserGroups: deleteUserGroups,
                putOneUserGroup: putOneUserGroup,
                exportUsersToDevice: exportUsersToDevice,
                downloadCsv: downloadCsv,
                uploadCsv: uploadCsv,
                uploadFileToWebDav: uploadFileToWebDav
            };

            if (API.isLoggedIn() == true) {
                userAgent.getUserGroupRecursiveData();
            }

            return userAgent;
        }]);
});