/**
 * Created by jhkim2 on 2014-07-22.
 */
self.DBAgent = {
    db: null,
    storeNames: ['device', 'deviceGroup', 'searchHistory'],
    open: function (option) {
        try {
            // INFO: Indexed Database의 version은 2.3 등의 소수점은 사용할 수 없다. 반드시 정수로 증가되도록 할 것.
            var version = 6;
            var dbName = 'biostar';
            var iDB = indexedDB || webkitIndexedDB || mozIndexedDB || msIndexedDB;
            self.IDBTransaction = IDBTransaction || webkitIDBTransaction || mozIDBTransaction || msIDBTransaction || {};
            var request = iDB.open(dbName, version);
            console.log(dbName + ' version:' + version);
            request.onerror = option.error;
            request.onsuccess = function (evt) {
                console.log('onsuccess/evt.target.result');
                console.log(JSON.stringify(evt.target.result));
                console.log(JSON.stringify(request.result));
                self.DBAgent.db = evt.target.result;

                if (option.success) {
                    option.success(evt);
                }
            };

            request.onupgradeneeded = function (evt) {
                /*
                 * TODO: version 이 변경되면 기존의 table들읗 삭제하고 새로 만든다.
                 */
                console.log('onupgradeneeded/evt.target.result');
                console.log(JSON.stringify(evt.target.result));
                console.log(JSON.stringify(request.result));
                self.DBAgent.db = evt.target.result;

                evt.target.transaction.onerror = option.error;

                //------------------ Store 생성 :S----------------//
                for (var i = 0; i < self.DBAgent.storeNames.length; i++) {
                    if (self.DBAgent.db.objectStoreNames.contains(self.DBAgent.storeNames[i])) {
                        self.DBAgent.db.deleteObjectStore(self.DBAgent.storeNames[i]);
                    }
                }

                self.DBAgent.db.createObjectStore('device');
                self.DBAgent.db.createObjectStore('deviceGroup');
                self.DBAgent.db.createObjectStore('searchHistory');
                //------------------ Store 생성 :E----------------//


                if (option.upgradeneeded) {
                    option.upgradeneeded(evt);
                }
            };
        }
        catch (ex) {
            option.error(ex);
        }
    },
    addDevice: function (option) {
        try {
            var tx = self.DBAgent.db.transaction(['device'], 'readwrite');
            console.log('SYNC: 1');
            tx.oncomplete = function (event) {
                console.log('SYNC: 7');
                console.log(JSON.stringify(event));
                option.complete(event);
            };
            tx.onerror = function (event) {
                console.log('SYNC: 8');
                console.log(JSON.stringify(event));
                option.error(event);
            };
            console.log(JSON.stringify(tx));
            console.log('SYNC: 2');
            var deviceStore = tx.objectStore('device');
            console.log('SYNC: 3');
            var device = option.data.devices[i];
            console.log('SYNC: 4');
            console.log(JSON.stringify(device));
            var request = deviceStore.add(device);
            console.log('SYNC: 5');
            request.onsuccess = function (evt) {
                console.log('SYNC: 6');
                console.log(JSON.stringify(evt));
                rtnData.successDeviceIDs.put(device.id);
//                    if (device === option.devices[option.devices.length - 1]) {
//                        console.log('SYNC: 7');
//                    }
            };
            request.onerror = function (evt) {
                console.log('SYNC: 6.1');
                console.log(JSON.stringify(evt));
                rtnData.errorDeviceIDs.put(device.id);
//                    if (device === option.devices[option.devices.length - 1]) {
//                        console.log('SYNC: 7.1');
//                        option.complete(rtnData);
//                    }
            };
        }
        catch (ex) {
            console.log(JSON.stringify(ex));
            option.error(ex);
        }
    },
    syncAllDevice: function (option) {
        try {
            var tx = self.DBAgent.db.transaction(['device'], 'readwrite');
            console.log('SYNC: 1');
            var rtnData = {
                successDeviceIDs: [],
                errorDeviceIDs: []
            };
            tx.oncomplete = function (event) {
                console.log('SYNC: 7');
                console.log(JSON.stringify(event));
                option.complete(rtnData);
            };
            tx.onerror = function (event) {
                console.log('SYNC: 8');
                console.log(JSON.stringify(event));
                option.error(event);
            };
            console.log(JSON.stringify(tx));
            console.log('SYNC: 2');
            var deviceStore = tx.objectStore('device');
            console.log('SYNC: 3');
            for (var i = 0; i < option.data.devices.length; i++) {
                var device = option.data.devices[i];
                console.log('SYNC: 4');
                console.log(JSON.stringify(device));
                var request = deviceStore.add(device);
                console.log('SYNC: 5');
                request.onsuccess = function (evt) {
                    console.log('SYNC: 6');
                    console.log(JSON.stringify(evt));
                    rtnData.successDeviceIDs.put(device.id);
//                    if (device === option.data.devices[option.data.devices.length - 1]) {
//                        console.log('SYNC: 7');
//                    }
                };
                request.onerror = function (evt) {
                    console.log('SYNC: 6.1');
                    console.log(JSON.stringify(evt));
                    rtnData.errorDeviceIDs.put(device.id);
//                    if (device === option.data.devices[option.data.devices.length - 1]) {
//                        console.log('SYNC: 7.1');
//                        option.complete(rtnData);
//                    }
                };
            }
        }
        catch (ex) {
            console.log(JSON.stringify(ex));
            option.error(ex);
        }
    }
};

self.addEventListener('message', function (evt) {
    if (evt.data == 'testData') {
        self.DBAgent.open({
            success: function (evt) {
                self.postMessage('successfully opened db');
            },
            upgradeneeded: function (evt) {
                self.postMessage('successfully upgraded db');
            },
            error: function (evt) {
                self.postMessage('db open error');
            }
        });
    } else if (typeof evt.data == 'object' && evt.data.command) {
        self.DBAgent[evt.data.command]({
            data: evt.data,
            success: function (result) {
                console.log('syncAllDevice: success');
                self.postMessage(result);
            },
            error: function (result) {
                console.log('syncAllDevice: error');
                self.postMessage(result);
            },
            complete: function (result) {
                console.log('syncAllDevice: complete');
                self.postMessage(result);
            }
        });
    }
}, false);