﻿'use strict';

define([
    'modules/common/services/access-control-agent',
    'modules/common/services/user-agent',
    'modules/common/services/card-agent',
    'modules/common/services/preferenceService',
    'modules/common/services/scheduleAgent',
    'modules/common/services/device-agent'
], function () {

    var app = angular.module('widgetModule', []);
    app.directive('ngbssCommonSelectBox', function () {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                listData: '=',
                disabledYn: '='
            },
            template: '<div class="select" ng-class="{\'disabled\':!listData || disabledYn == true}" tabindex="-1"> ' +
                '<a href="javascript:void(null);">' +
//                '<span ng-show="!ngModel" ng-label="common.chooseAnItem"></span>' +
                '<span ng-show="ngModel">{{ ngModel }}</span>' +
                '</a> ' +
                '<div> ' +
                '<ul class="selectList"> ' +
                '<li ng-repeat="item in listData" ng-class="{\'selection\':ngModel == item}" ng-click="selectItem(item)">{{ item }}</li> ' +
                '</ul> ' +
                '</div> ' +
                '</div>',
            link: function ($scope, $element, $attrs) {

                $scope.selectItem = function (item) {
                    $scope.ngModel = item;
                    $element.blur();
                };

                // 팝업으로 띄웠을 때에는 max-height 조절 kjh
                if ($element.parents('.popCnt').length > 0) {
                    $element.find('.selectList').css('max-height', 91).addClass('scrollY');
                }

                $element.on('focusin', function () {
                    if (!$scope.listData || $scope.disabledYn) {
                        $element.blur();
                        return false;
                    }
                    $element.addClass('open');
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                });
            }
        }
    });

    app.directive('ngbssCommonKeyValueCombo', function () {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                listData: '=',
                disabledYn: '='
            },
            template: '<div class="select" ng-class="{\'disabled\':!listData || disabledYn == true}" tabindex="-1"> ' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="ngModel == undefined" ng-label="common.none"></span>' +
                '<span ng-show="ngModel != undefined">{{ listData[ngModel] }}</span>' +
                '</a> ' +
                '<div> ' +
                '<ul class="selectList"> ' +
                '<li ng-repeat="(key, value) in listData" ng-class="{\'selection\':ngModel == key}" ng-click="selectItem(key)">{{ value }}</li> ' +
                '</ul> ' +
                '</div> ' +
                '</div>',
            link: function ($scope, $element, $attrs) {
                $scope.selectItem = function (key) {
                    $scope.ngModel = key;
                    $element.blur();
                };

                $element.on('focusin', function () {
                    if (!$scope.listData || $scope.disabledYn) {
                        $element.blur();
                        return false;
                    }
                    $element.addClass('open');
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                });
            }
        }
    });

    app.directive('ngbssCommonSelectBoxIdNameCombo', ['$timeout', 'MessageProperties', function ($timeout, MessageProperties) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                listData: '=',
//                defaultNone: '=',
                notUseNoneItem: '=',
                disabledYn: '='
            },
            template: '<div class="select " tabindex="-1" ng-class="{\'disabled\': disabledYn == true}"> ' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="ngModel == undefined || ngModel.id == undefined" ng-label="common.none"></span>' +
                '<span ng-show="ngModel != undefined && ngModel.id != undefined">{{ getItemName(ngModel) }}</span>' +
                '</a> ' +
                '<div> ' +
                '<ul class="selectList"> ' +
                '<li ng-hide="notUseNoneItem" ng-class="{\'selection\':!ngModel.id}" ng-click="selectItem()" ng-label="common.none"></li>' +
                '<li ng-repeat="item in listData" ng-class="{\'selection\':ngModel.id == item.id}" ng-click="selectItem(item)">{{ item.name }}</li> ' +
                '</ul> ' +
                '</div> ' +
                '</div>',
            link: function ($scope, $element, $attrs) {

                $scope.selectItem = function (item) {
                    if (item) {
                        $scope.ngModel = item;
                    } else {
                        $scope.ngModel = {};
                    }
                    $element.trigger('blur');
                };

                $scope.getItemName = function (item) {
                    if (angular.isUndefined(item)) {
                        return MessageProperties.get('common.none');
                    } else if (angular.isDefined(item.name)) {
                        return item.name;
                    } else if (angular.isDefined(item.id)) {
                        for (var i = 0; i < $scope.listData.length; i++) {
                            if (item.id == $scope.listData[i].id) {
                                return $scope.listData[i].name;
                            }
                        }
                    } else if (angular.isDefined(item.user_id)) {
                        for (var i = 0; i < $scope.listData.length; i++) {
                            if (item.user_id == $scope.listData[i].user_id) {
                                return $scope.listData[i].name;
                            }
                        }

                    }

                    return MessageProperties.get('common.none');
                };

                $element.on('focusin', function () {
                    if ($scope.disabledYn) {
                        $element.trigger('blur');
                        return false;
                    }
                    $element.addClass('open');
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                });
            }
        }
    }]);

    app.directive('ngbssAccessGroupSelectBoxTypeCheckList', ['AccessControlAgent', '$timeout', 'Util', function (AccessControlAgent, $timeout, Util) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                selectLimit: '=',
                ngSubModel: '=',
                disabledYn: '=',
                defaultText: '='
            },
            template: //                '<div class="select" ng-class="{\'disabled\':!listData.length}">' +
                '<div class="select" style="min-width:50%" tabindex="-1" ng-class="{\'disabled\':disabledYn == true}">' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="!ngModel || !ngModel.length">{{ defaultTextModel }}</span>' +
                '<span ng-if="ngModel && ngModel.length" ng-repeat="item in ngModel | limitTo:1">' +
                '{{ item.name }}' +
                '<span ng-if="getNumberOfAccessGroups() > 0"> + </span>' +
                '<mark class="number" ng-if="getNumberOfAccessGroups() > 0">{{ getNumberOfAccessGroups() }}</mark>' +
                '</span>' +
                '<span ng-if="(ngModel == undefined || ngModel.length == 0) && ngSubModel && ngSubModel.length" ng-repeat="item in ngSubModel | limitTo:1">' +
                '{{ item.name }}' +
                '<span ng-if="(ngModel == undefined || ngModel.length == 0) && ngSubModel && ngSubModel.length && ngSubModel.length > 1"> + </span>' +
                '<mark class="number" ng-if="(ngModel == undefined || ngModel.length == 0) && ngSubModel && ngSubModel.length && ngSubModel.length > 1">{{ ngSubModel.length - 1 }}</mark>' +
                '</span>' +
                '</a>' +
                ' <div> ' +
                '<p class="searchSelect" id="listSearchBox" ng-class="{\'typeClear\':searchWord.length > 0}">' +
//                '<span ng-label="common.chooseAnItem"></span>' +
                '<input type="text" id="listSearchBoxInput" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch"  data-ng-click="listSearchOpen()">search</a>' +
                ' <a href="javascript:void(null);" class="btnClose" data-ng-click="listSearchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a> ' +
                '</p> ' +
                '<ul class="selectChkList scrollY" style="max-height: 300px;">' +
                '<li ng-repeat="item in filtered = (listData | listFilter:searchWord:\'name\')">' +
                '<input type="checkbox" class="chkChange" id="check0{{ $index }}" name="check" ' +
                'ng-checked="selectedItemArray.indexOf(item.id) > -1 || inUserGroupsArray.indexOf(item.id) > -1" ' +
                'ng-readonly="inUserGroupsArray.indexOf(item.id) > -1"' +
                'ng-disabled="inUserGroupsArray.indexOf(item.id) > -1"' +
                'ng-click="checkAccessGroupItem(item, $index)">' +
                '<label for="check0{{ $index }}">' +
                '<span class="txt">{{ item.name }}</span></label>' +
                '</li> ' +
                '<li ng-if="filtered.length==0" class="listNotFound"><span ng-label="validate.notFound"></span></li>' +
                '</ul> ' +
                '</div>',

            link: function ($scope, $element, $attrs) {
                var i, item,
                    selectBoxTitle = '', accessGroupCount = 0;

                $scope.selectedItemArray = [];
                $scope.inUserGroupsArray = [];
                $element.find('#selectBoxTitle').html(selectBoxTitle);

                $scope.defaultTextModel = '';
                if ($scope.defaultText) {
                    $scope.defaultTextModel = $scope.defaultText;
                }

                $scope.$watch('disabledYn', function (newValue, oldValue) {
                    if (newValue != oldValue) {
                        if (newValue) $element.addClass('disbaled');
                        else $element.removeClass('disabled');
                    }
                });

                $scope.checkAccessGroupItem = function (item, $index) {
                    var idx, selectedItem = item;

                    if ($scope.inUserGroupsArray.indexOf(selectedItem.id) > -1) {
                        return;
                    }

                    if ($scope.selectedItemArray.indexOf(selectedItem.id) == -1) {

                        if ($scope.selectLimit && $scope.selectLimit <= $scope.ngModel.length) {
                            $element.find('#check0' + $index).attr('checked', false);
                            return false;
                        }

                        $scope.selectedItemArray.push(selectedItem.id);
                        $scope.ngModel.push({"name": selectedItem.name, "id": selectedItem.id});
                    } else {
                        idx = $scope.selectedItemArray.indexOf(selectedItem.id);
                        $scope.selectedItemArray.splice(idx, 1);

                        for (var i = $scope.ngModel.length; i--;) {
                            var item = $scope.ngModel[i];
                            if (item.id === selectedItem.id) {
                                $scope.ngModel.splice(i, 1);
                                break;
                            }
                        }
                    }
                };

                if ($scope.ngModel && $scope.ngModel.length) {
                    for (i = $scope.ngModel.length; i--;) {
                        $scope.selectedItemArray.push($scope.ngModel[i].id);
                    }
                } else {
                    $scope.ngModel = [];
                }

                $scope.$watch('ngModel', function (nv, ov) {
                    if (angular.isDefined(nv) == true) {
                        $scope.selectedItemArray = [];
                        for (i = $scope.ngModel.length; i--;) {
                            $scope.selectedItemArray.push($scope.ngModel[i].id);
                        }
                    } else if (angular.isDefined(nv) == false && angular.isDefined(ov) == true) {
                        $scope.selectedItemArray = [];
                    }
                });

                if ($scope.ngSubModel && $scope.ngSubModel.length) {
                    for (i = $scope.ngSubModel.length; i--;) {
                        $scope.inUserGroupsArray.push($scope.ngSubModel[i].id);
                    }
                }

                $scope.$watch('ngSubModel', function (nv, ov) {
                    console.log('ngSubModel', nv, ov);
                    if (angular.isDefined(nv) == true) {
                        $scope.inUserGroupsArray = [];
                        for (i = $scope.ngSubModel.length; i--;) {
                            $scope.inUserGroupsArray.push($scope.ngSubModel[i].id);
                        }
                    } else if (angular.isDefined(nv) == false && angular.isDefined(ov) == true) {
                        $scope.inUserGroupsArray = [];
                    }
                });

                $scope.getNumberOfAccessGroups = function () {
                    accessGroupCount = 0;
                    if ($scope.ngModel.length > 1) {
                        accessGroupCount += parseInt($scope.ngModel.length) - 1;
                    }
                    if ($scope.ngSubModel && $scope.ngSubModel.length > 0) {
                        for (i = $scope.inUserGroupsArray.length; i--;) {
                            item = $scope.inUserGroupsArray[i];
                            if ($scope.selectedItemArray.indexOf(item) < 0) {
                                accessGroupCount++;
                            }
                        }
                    }
                    return accessGroupCount;
                };

                function initBox() {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                    $element.trigger('blur');
                }

                function listSearchOpen() {
                    angular.element('#listSearchBox').addClass('typeInput').removeClass('typeClear');
                    angular.element('#listSearchBoxInput').focus();
                }

                function listSearchClose() {
                    angular.element('#listSearchBox').removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                }

                $scope.listSearchOpen = listSearchOpen;
                $scope.listSearchClose = listSearchClose;

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#listSearchBoxInput').on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#listSearchBox').removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                AccessControlAgent.getAccessGroups({}, 'callAccessGroupInWidget').then(function success(data) {
                    $scope.listData = data.AccessGroupCollection.rows;
                });

                $element.on('focusin', function () {
                    if ($scope.disabledYn) {
                        $element.blur();
                        return false;
                    }

                    if ($element.attr('class').indexOf('disabled') > -1) {
                        $element.blur();
                        return false;
                    }
                    $element.addClass('open');
                    $scope.searchWord = undefined;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                function generateList() {
                    $element.attr('tabindex', '-1');
                }

                generateList();
            }
        }
    }]);

    app.directive('ngbssCommonListTypeCheckList', function () {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                listData: '=',
                label: '@'
            },
            template: '<div class="ngbssCommonListTypeCheckList">' +
                '<p class="searchSelect" ng-class="{\'typeInput\':listSearchYn === true, \'typeClear\':searchWord.length > 0}">' +
//                '<span ng-label="common.chooseAnItem"></span>' +
                '<input type="text" id="listSearchBox" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" ng-click="listSearchYn = true;">search</a>' +
                ' <a href="javascript:void(null);" class="btnClose" ng-click="closeSearchBox()">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a> ' +
                '</p> ' +
                '<ul class="selectChkList">' +
                '<li ng-repeat="item in filtered = (listData | userListFilter:searchWord:label) | limitTo:500">' +
                '<input type="checkbox" class="chkChange" id="check0{{ $index }}" name="check" ' +
                'ng-checked="selectedItemArray.indexOf(item.id) > -1" ' +
                'ng-click="checkItem(item)">' +
                '<label for="check0{{ $index }}">' +
                '<span class="txt" ng-if="item.user_id">{{ item.user_id }} <span ng-show="item[label] != undefined &&  item[label].length > 0">{{ \'( \'+ item[label] + \' )\' }}</span></span>' +
                '<span class="txt" ng-if="!item.user_id">{{ item[label] }}</span></label>' +
                '</li> ' +
                '<li ng-if="filtered.length==0" class="noData"><span ng-label="validate.notFound"></span></li>' +
                '</ul> ' +
                '</div>',

            link: function ($scope, $element, $attrs) {
                console.log($scope.listData);
                $scope.selectedItemArray = [];

                $scope.checkItem = function (item) {
                    var idx, selectedItem = item;

                    if ($scope.selectedItemArray.indexOf(selectedItem.id) == -1) {
                        $scope.selectedItemArray.push(selectedItem.id);
                        $scope.ngModel.push({"name": selectedItem[$scope.label], "id": selectedItem.id});
                    } else {
                        idx = $scope.selectedItemArray.indexOf(selectedItem.id);
                        $scope.selectedItemArray.splice(idx, 1);

                        for (var i = $scope.ngModel.length; i--;) {
                            var item = $scope.ngModel[i];
                            if (item.id === selectedItem.id) {
                                $scope.ngModel.splice(i, 1);
                                break;
                            }
                        }
                    }
                };

                if ($scope.ngModel && $scope.ngModel.length) {
                    for (var i = $scope.ngModel.length; i--;) {
                        $scope.selectedItemArray.push($scope.ngModel[i].id);
                    }
                } else {
                    $scope.ngModel = [];
                }

                $scope.listSearchYn = true;
//                function initBox() {
//                    $element.removeClass('open');
//                    $scope.listSearchYn = false;
//                    $scope.searchWord = undefined;
//                    $element.trigger('blur');
//                }

                $scope.closeSearchBox = function () {
//                    $scope.listSearchYn = false;
                    $scope.searchWord = undefined;
                };

                $element.on('focusin', function () {
                    if (!$scope.listData) {
                        $element.trigger('blur');
                        return false;
                    }
                    $element.addClass('open');
//                    $scope.listSearchYn = false;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                });

                angular.element('#listSearchBox').on('focusout', function () {
                    $element.removeClass('open');
//                    initBox()
                });

                function generateList() {
                    $element.attr('tabindex', '-1');
                }

                if ($scope.listData) {
                    generateList();
                }

                $scope.$watch('listData', function (nv, ov) {
                    if (nv !== ov) {
                        generateList();
                    }
                });
            }
        }
    });

    app.directive('ngbssUserGroupSelectBoxTypeTree', ['$rootScope', '$timeout', 'UserAgent', 'MessageProperties', 'UUID', function ($rootScope, $timeout, UserAgent, MessageProperties, UUID) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                treeData: '=',
                disabledYn: '='
            },
            template: '<div class="select " ng-class="{\'disabled\':disabledYn == true}">' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="!treeData"></span>' +
                '<span ng-show="treeData">{{ groupObj.name || groupObj.text}}</span>' +
                '</a> ' +
                '<div style="min-width: 35em;">' +
                '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length > 0}"> ' + // typeInput, typeClear
//                '<span ng-label="common.chooseAnItem"></span> ' +
                '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<div class="scrollY" style="max-height: 300px;"> ' +
                '<ul id="{{ treeId }}" class="treeTypeUser tree" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                '<ul class="selectList" ng-hide="searchWord == undefined || searchWord == \'\'" tabindex="-1"> ' +
                '<li ng-repeat="item in filtered = (UserGroupSearchResult | listFilter:searchWord:\'name\')" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                '<li ng-show="filtered.length == 0"><span ng-label="validate.notFound"></span></li>' +
                '</ul>' +
                '</div>' +
                '</div>' +
                '</div>',
            link: function ($scope, $element, $attrs) {
                $scope.treeId = UUID();
                var
                    treeOptions = {
                        formatter: function (node) {
                            if (node.depth === '0') {
                                return '<span>' + node.name + '</span>';
                            } else {
                                return '<span title="' + node.path + '">' + node.name + '</span>';
                            }
                        },
                        onClick: function (node) {
                            $scope.ngModel.id = node.id;
                            $scope.groupObj = node;

                            $scope.$apply(initTree);
                        }
                    };

                function generateTree() {
                    treeOptions.data = $scope.treeData;
                    angular.element('#' + $scope.treeId).tree(treeOptions);
//
                    if ($scope.ngModel && $scope.ngModel.id) {
                        $scope.groupObj = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                    } else {
                        $scope.ngModel = {};
                        $scope.ngModel.id = 1;
                        $scope.groupObj = angular.element('#' + $scope.treeId).tree('find', 1);
                    }

                    if ($scope.groupObj) {
                        angular.element('#' + $scope.treeId).tree('select', $scope.groupObj.target);
                    }

                    $element.attr('tabindex', '-1');
                }

                function initTree() {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                    $element.trigger('blur');
                }

                function treeSearchOpen() {
                    angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                }

                function treeSearchClose() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                }

                $scope.treeSearchOpen = treeSearchOpen;
                $scope.treeSearchClose = treeSearchClose;

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                $element.on('focusin', function () {
                    if ($scope.disabledYn) {
                        $element.blur();
                        return false;
                    }
                    $element.addClass('open');
                    $scope.searchWord = undefined;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                $scope.$watch('treeData', function (nv, ov) {
                    if (nv !== ov) {
                        generateTree();
                    }
                });
                $timeout(generateTree, 50);

                $scope.UserGroupSearchResult = [];
                UserAgent.getUserGroups().then(function success(data) {
                    $scope.UserGroupSearchResult = data.UserGroupCollection.rows || [];
                });

                $scope.$watch('ngModel', function (nv, ov) {
                    if (nv !== undefined && nv !== ov) {
                        if ($scope.ngModel && $scope.ngModel.id) {
                            $scope.groupObj = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                        } else {
                            $scope.ngModel = {};
                            $scope.ngModel.id = 1;
                            $scope.groupObj = angular.element('#' + $scope.treeId).tree('find', 1);
                        }

                        if ($scope.groupObj) {
                            angular.element('#' + $scope.treeId).tree('select', $scope.groupObj.target);
                        }
                    }
                }, true);

                $element.find('#treeSearchBox_' + $scope.treeId).on('keypress', function (event) {
                    if (event.keyCode == 13) {
                        if (event.preventDefault) event.preventDefault();
                        if (event.returnValue) event.returnValue = false;
                        return false;
                    }
                });

                $scope.selectItemInTreeSearchResult = function (item) {
                    $scope.ngModel.id = item.id;
                    $scope.groupObj = item;
                    initTree();
                };
            }
        };
    }]);


    app.directive('ngbssDeviceGroupSelectBoxTypeTree', ['$rootScope', 'Const', 'UserAgent', 'DeviceAgent', 'MessageProperties', 'UUID', '$timeout', 'Util',
        function ($rootScope, Const, UserAgent, DeviceAgent, MessageProperties, UUID, $timeout, Util) {
            return {
                restrict: 'A',
                replace: true,
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    treeData: '=',
                    usbData: '=usbData',
                    defaultYn: '=',
                    onlyDeviceYn: '=',
                    disabledYn: '='
                },
                template: '<div class="select" ng-class="{\'disabled\': (!treeData || disabledYn)}">' +
                    '<a href="javascript:void(null);">' +
                    '<span>{{ ngModel.name || ngModel.text }}</span>' +
                    '</a> ' +
                    '<div style="min-width: 30em;">' +
                    '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
                    '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                    '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                    '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                    '<img src="images/common/btn_search_close.png" alt="close">' +
                    '</a>' +
                    '</p>' +
                    '<div class="scroll" style="max-height: 300px;"> ' +
                    '<ul id="{{ treeId }}" class="treeTypeDevice tree" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                    '<ul id="{{ treeId }}_USB" class="treeTypeDevice tree" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                    '<ul class="selectList" ng-hide="searchWord == undefined || searchWord == \'\'" tabindex="-1"> ' +
                    '<li ng-repeat="item in filtered = (DeviceGroupSearchResult | listFilter:searchWord:\'name\') track by $index" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                    '<li ng-show="filtered.length==0"><span ng-label="validate.notFound"></span></li>' +
                    '</ul>' +
                    '</div>' +
                    '</div>' +
//                '<span class="warningMessage" style="position: absolute; right: 0; top: -30px" ng-show="whenGroupClick == true" ng-if="onlyDeviceYn == true" ng-label="validate.canNotSelectGroup"></span>' +
                    '<span class="warningMessage" style="position: absolute; right: 0; top: -30px" ng-show="whenSecureIOClick == true" ng-if="onlyDeviceYn == true" ng-label="validate.canNotSelectSecureIO"></span>' +
                    '</div>',
                link: function ($scope, $element, $attrs) {
                    var
                        treeOptions = {
                            onSelect: function (node) {
                                var i, family = [];
                                $scope.whenGroupClick = false;
                                $scope.whenSecureIOClick = false;
                                if ($scope.onlyDeviceYn) {
                                    if (!node.isDevice) {
                                        $scope.whenGroupClick = true;
                                        if (!$scope.$root.$$phase) $scope.$apply();
                                        return false
                                    }
                                }
                                if ($scope.onlyDeviceYn) {
                                    if (node.device_type_id.id == Const.DEVICE_TYPE_ID.SECURE_IO || node.device_type_id.id == Const.DEVICE_TYPE_ID.SECURE_IO2) {
                                        $scope.whenSecureIOClick = true;
                                        if (!$scope.$root.$$phase) $scope.$apply();
                                        return false
                                    }
                                }

                                $scope.ngModel = {id: node.id, name: node.text};
                                if ($scope.defaultYn) {
                                    Util.setSessionObject($scope.defaultYn, $scope.ngModel);
                                }

                                if (angular.isDefined(node.deviceSpec)) {
                                    angular.extend($scope.ngModel, {deviceSpec: node.deviceSpec});
                                }
                                if (angular.isDefined(node.device_type_id)) {
                                    angular.extend($scope.ngModel, {device_type_id: node.device_type_id});
                                }

                                initTree();

                                if (!$scope.$root.$$phase) $scope.$apply();

                                if ($scope.usbData) {
                                    angular.element('#' + $scope.treeId + '_USB').find('.tree-node-selected').removeClass('tree-node-selected');
                                }
                            }
                        };

                    $scope.treeId = UUID();

                    $scope.DeviceGroupSearchResult = [];


                    if ($scope.onlyDeviceYn) {
                        if (DeviceAgent.getAllDevicesWithoutStatus().then) {
                            DeviceAgent.getAllDevicesWithoutStatus().then(function success(data) {
                                $scope.DeviceGroupSearchResult = data;
                            });
                        } else {
                            $scope.DeviceGroupSearchResult = DeviceAgent.getAllDevicesWithoutStatus();
                        }
                    }

                    function removeDisconnectCls(node) {
                        var i, item;

                        if (node.iconCls) {
                            node.iconCls = node.iconCls.replace('disconnect', '');
                            node.iconCls = node.iconCls.replace('sync_error', '');
                        }

                        if (node.children) {
                            for (i = node.children.length; i--;) {
                                removeDisconnectCls(node.children[i])
                            }
                        }
                    }

                    function makeDeviceSearchResultList(node) {
                        var i;

                        if (node.device_type_id != undefined) {
                            $scope.DeviceGroupSearchResult.push(node);
                        }

                        if (node.children) {

                            for (i = node.children.length; i--;) {
                                makeDeviceSearchResultList(node.children[i])
                            }
                        }
                    }

                    function generateTree() {
                        var node, defaultModel;

                        if ($scope.treeData.constructor != Array) {
                            $scope.treeData = [$scope.treeData];
                        }

//                        removeDisconnectCls($scope.treeData[0]);

                        treeOptions.data = $scope.treeData;
                        $scope.DeviceGroupSearchResult = [];
                        makeDeviceSearchResultList($scope.treeData[0]);

                        angular.element('#' + $scope.treeId).tree(treeOptions);

                        if (!$scope.ngModel && $scope.onlyDeviceYn && $scope.defaultYn) {            // 처음 생성시 기본 값 선택 true라면
                            $scope.ngModel = Util.getSessionObject($scope.defaultYn);
                        }

                        if (!$scope.ngModel && $scope.onlyDeviceYn) {            // 처음 생성시 모델이 없고 디바이스 온리라면

                        } else if (!$scope.ngModel && !$scope.onlyDeviceYn) {    // 처음 생성시 모델이 없고 디바이스 온리가 아니라면
                            node = angular.element('#' + $scope.treeId).tree('getRoot');
                            $scope.ngModel = {id: node.id, name: node.text};
                        } else if ($scope.ngModel && $scope.ngModel.id) {                             // 모델이 있다면
                            node = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                            if (node) {
                                $scope.ngModel = {id: node.id, name: node.text};

                                if (angular.isDefined(node.deviceSpec)) {
                                    angular.extend($scope.ngModel, {deviceSpec: node.deviceSpec});
                                }
                                if (angular.isDefined(node.device_type_id)) {
                                    angular.extend($scope.ngModel, {device_type_id: node.device_type_id});
                                }
                            } else {
                                $scope.ngModel = undefined;
                            }
                        }

                        if (node && node.target) {
                            angular.element('#' + $scope.treeId).tree('select', node.target);
                        }

                        $element.attr('tabindex', '-1');
                    }

                    if ($scope.treeData) {
                        $timeout(generateTree, 50);
                    }

                    function initTree() {
                        angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        $scope.searchWord = undefined;
                        $element.trigger('blur');
                    }

                    $scope.treeSearchOpen = function treeSearchOpen() {
                        angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                        angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                    };

                    $scope.treeSearchClose = function treeSearchClose() {
                        angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        $scope.searchWord = undefined;
                    };

                    $timeout(function () {
                        // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                        angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                            if (!$scope.searchWord || !$scope.searchWord.length) {
                                angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                            }
                        });
                    }, 50);


                    $element.on('focusin', function () {
                        if (!$scope.treeData || $element.hasClass('disabled')) {
                            $element.blur();
                            return false;
                        }

                        if ($scope.DeviceGroupSearchResult && $scope.DeviceGroupSearchResult.length > 0) {

                        } else {
                            DeviceAgent.getDeviceGroupWithoutDevice().then(function success(data) {
                                $scope.DeviceGroupSearchResult = data;
                            });
                        }

                        $element.addClass('open');
                        $scope.searchWord = undefined;
                    });

                    $element.on('focusout', function () {
                        $scope.whenGroupClick = false;
                        $scope.whenSecureIOClick = false;
                        if (!$scope.$root.$$phase) $scope.$apply();
                        $element.removeClass('open');
                        $scope.searchWord = undefined;
                    });

                    $scope.$watch('treeData', function (nv, ov) {
                        if (nv !== ov && $scope.treeData) {
                            $timeout(generateTree, 50);
                        }
                    });

                    $scope.$watch('usbData', function (nv, ov) {
                        if (nv !== ov && $scope.usbData) {
                            angular.element('#' + $scope.treeId + '_USB').tree({
                                data: $scope.usbData,
                                lines: false,
                                animate: true,
                                onClick: function (node) {// 선택한 node값 search로 치환

                                    $scope.ngModel = {id: node.id, name: node.text};
                                    Util.setSessionObject($scope.defaultYn, $scope.ngModel);

                                    initTree();

                                    if (!$scope.$root.$$phase) $scope.$apply();

                                    angular.element('#' + $scope.treeId).find('.tree-node-selected').removeClass('tree-node-selected');
                                }
                            });

                            if (!$scope.ngModel && $scope.onlyDeviceYn && $scope.defaultYn) {            // 처음 생성시 기본 값 선택 true라면
                                $scope.ngModel = Util.getSessionObject($scope.defaultYn);

                                if ($scope.ngModel) {
                                    var node = angular.element('#' + $scope.treeId + '_USB').tree('find', $scope.ngModel.id);

                                    if (node) {
                                        angular.element('#' + $scope.treeId + '_USB').tree('select', node.target);
                                    }
                                }

                            }
                        }
                    });

                    $scope.$watch('ngModel', function (nv, ov) {
                        var node;

                        if (angular.isUndefined(nv)) {
                            return false;
                        }

                        if (nv && nv.id == Const.BIO_MINI_ID) {
                            node = angular.element('#' + $scope.treeId + '_USB').tree('find', $scope.ngModel.id);
                            angular.element('#' + $scope.treeId + '_USB').tree('select', node.target);
                        } else {
                            if (ov == undefined && nv != undefined) {
                                node = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                                angular.element('#' + $scope.treeId).tree('select', node.target);
                            } else if (nv.id != ov.id) {
                                node = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                                angular.element('#' + $scope.treeId).tree('select', node.target);
                            }
                        }

                    }, true);

                    $scope.selectItemInTreeSearchResult = function (item) {
                        var node = angular.element('#' + $scope.treeId).tree('find', item.id);

                        $scope.ngModel = {id: item.id, name: item.name};

                        angular.element('#' + $scope.treeId).tree('select', node.target);
                        initTree();
                    };

                }
            };
        }]);

    app.directive('ngbssCommonSelectButtonForGrid', ['$rootScope', 'Const', 'DeviceAgent', 'MessageProperties', 'UUID', function ($rootScope, Const, DeviceAgent, MessageProperties, UUID) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                disabledYn: '='
            },
            template: '<div class="select " ng-class="{\'disabled\': disabledYn}">' +
                '<a href="javascript:void(null);">' +
                '<span ng-if="ngModel">{{ ngModel.device_group_id.name || ngModel.device_group_id.text }}</span>' +
                //'<span ng-if="!ngModel" ng-label="device.chooseDeviceGroup"></span>' +
                '</a> ' +
                '</div>',
            link: function ($scope, $element, $attrs) {

                $scope.safeApply = function (fn) {
                    var phase = this.$root.$$phase;
                    if (phase == '$apply' || phase == '$digest') {
                        if (fn && (typeof(fn) === 'function')) {
                            fn();
                        }
                    } else {
                        this.$apply(fn);
                    }
                };
                $element.on('click', function () {
                    if ($element.hasClass('disabled')) {
                        $element.blur();
                        return false;
                    }
                    if ($element.hasClass('open')) {
                        $element.removeClass('open');
                        $rootScope.$emit('onCloseDeviceGroupTree');
                    } else {
                        $element.addClass('open');
                        var selectGroupTreeOption = {
                            target: $element,
                            selectedData: $scope.ngModel.device_group_id,
                            onSelect: function (node) {
                                console.log('selectGroupTreeOption:onSelect');
                                $scope.safeApply(function () {
                                    $scope.ngModel.device_group_id = {
                                        id: node.id,
                                        name: node.name || node.text
                                    };
                                    $element.removeClass('open');
                                    $rootScope.$emit('onCloseDeviceGroupTree');
                                });

                            }
                        };
                        $rootScope.$emit('onOpenDeviceGroupTree', selectGroupTreeOption);
                    }

                });
//
//                $element.on('focusout', function () {
//                    $element.removeClass('open');
//                    $rootScope.$emit('onCloseDeviceGroupTree');
//                });

                $scope.$watch('ngModel', function (nv, ov) {
                    var node;

                    if (angular.isUndefined(nv)) {
                        return false;
                    }
                }, true);
            }
        };
    }]);

    app.directive('ngbssDeviceGroupSelectTreeForGrid', ['$rootScope', '$timeout', 'Const', 'DeviceAgent', 'MessageProperties', 'UUID', function ($rootScope, $timeout, Const, DeviceAgent, MessageProperties, UUID) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                treeData: '=',
                disabledYn: '='
            },
            template: '<div style="min-width: 180px; display: none; position: absolute; border: 1px solid #b4b4b4; background: #fff; z-index: 60;">' +
                '   <p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
//                '       <span ng-label="common.chooseAnItem"></span> ' +
                '       <input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                '       <a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                '       <a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                '       <img src="images/common/btn_search_close.png" alt="close">' +
                '       </a>' +
                '   </p>' +
                '   <div class="scroll" style="max-height: 300px;"> ' +
                '       <ul id="{{ treeId }}" class="treeTypeDevice tree" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                '       <ul class="selectList" ng-hide="searchWord == undefined || searchWord == \'\'" tabindex="-1"> ' +
                '           <li ng-repeat="item in filtered = (DeviceGroupSearchResult | listFilter:searchWord:\'name\') track by $index" ' +
                'tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                '           <li ng-show="filtered.length==0"><span ng-label="validate.notFound"></span></li>' +
                '       </ul>' +
                '   </div>' +
                '</div>',
            link: function ($scope, $element, $attrs) {

                $scope.treeId = UUID();
                var treeOptions = {
                };
                $rootScope.$on('onOpenDeviceGroupTree', function (event, selectGroupTreeOption) {
                    angular.extend(treeOptions, selectGroupTreeOption);
                    treeOptions.data = $scope.treeData;

                    angular.element('#' + $scope.treeId).tree(treeOptions);
                    var targetPosition = angular.element(treeOptions.target).position();
                    $element.css({
                        top: targetPosition.top + 38,
                        left: targetPosition.left
                    });
                    $element.show();

                });
                $rootScope.$on('onCloseDeviceGroupTree', function (event) {

                    $element.hide();

                });

                $scope.treeSearchOpen = function treeSearchOpen() {
                    angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                };

                $scope.treeSearchClose = function treeSearchClose() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                DeviceAgent.getDeviceGroupWithoutDevice().then(function success(data) {
                    $scope.DeviceGroupSearchResult = data;
                });

                $element.on('focusin', function () {
                    if (!$scope.treeData || $element.hasClass('disabled')) {
                        $element.blur();
                        return false;
                    }

                    $element.addClass('open');
                    $scope.searchWord = undefined;
//                    if(!$scope.$root.$$phase) $scope.$apply();

                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                $scope.DeviceGroupSearchResult = [];
                $scope.DeviceGroupSearchResult = DeviceAgent.getDeviceGroupPath();

                $scope.selectItemInTreeSearchResult = function (item) {
                    var node = angular.element('#' + $scope.treeId).tree('find', item.id);

                    $scope.ngModel = {id: item.id, name: item.name};

                    angular.element('#' + $scope.treeId).tree('select', node.target);
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
//                    initTree();
                };
            }
        };
    }]);

    app.directive('ngbssDeviceGroupCheckboxTree', ['$rootScope', '$timeout', 'UserAgent', 'DeviceAgent', 'MessageProperties', 'UUID', 'Const', 'Util', function ($rootScope, $timeout, UserAgent, DeviceAgent, MessageProperties, UUID, Const, Util) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                treeData: '='
            },
            template: '<div>' +
                '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
//                '<span ng-label="common.chooseAnItem"></span> ' +
                '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<div class="scrollY"> ' +
                '<ul id="{{ treeId }}" class="treeGrid treeTypeDevice" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                '<ul class="selectList" ng-hide="searchWord == undefined || searchWord == \'\'" tabindex="-1"> ' +
                '<li ng-repeat="item in filtered = (DeviceGroupSearchResult | listFilter:searchWord:\'name\') track by $index" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                '<li ng-show="filtered.length == 0"><span ng-label="validate.notFound"></span></li>' +
                '</ul>' +
                '</div>' +
                '</div>',
            link: function ($scope, $element, $attrs) {

                Util.debug($scope.treeData);

                $scope.treeId = UUID();
                $scope.checkedItems = $scope.ngModel;
                if (!$scope.ngModel) {
                    $scope.checkedItems = [];
                }
                var
                    treeOptions = {
                        checkbox: true,
                        cascadeCheck: true,
                        onCheck: function (node, checked) {
                            var i,
                                items = $("#" + $scope.treeId).tree('getChecked');

                            $scope.checkedItems = [];
                            for (i = items.length; i--;) {
                                if (items[i].isDevice) {
                                    $scope.checkedItems.push({"id": items[i].id});
                                }
                            }
                            $scope.ngModel = $scope.checkedItems;
                            if (!$scope.$root.$$phase) $scope.$apply();
                        }
                    };

                $scope.DeviceGroupSearchResult = [];
                if (DeviceAgent.getAllDevicesWithoutStatus().then) {
                    DeviceAgent.getAllDevicesWithoutStatus().then(function success(data) {
                        $scope.DeviceGroupSearchResult = data;
                    });
                } else {
                    $scope.DeviceGroupSearchResult = DeviceAgent.getAllDevicesWithoutStatus();
                }

                function removeDisconnectCls(node) {
                    var i, item;

                    if (node.iconCls) {
                        node.iconCls = node.iconCls.replace('disconnect', '');
                        node.iconCls = node.iconCls.replace('sync_error', '');
                    }

                    if (node.children) {
                        for (i = node.children.length; i--;) {
                            removeDisconnectCls(node.children[i])
                        }
                    }
                }

                function generateTree() {
                    var i,
                        node;
                    // BSS-676 copy를 하면 infinite loop현상 발생 tree 구조에는 사용하지 말아야 함
//                    console.log("ngbssDeviceGroupCheckboxTree::generateTree::copy begin", $scope.ngModel);
//                    var items = angular.copy($scope.ngModel);
                    var items = $scope.ngModel;
//                    console.log("ngbssDeviceGroupCheckboxTree::generateTree::copy begin");

                    if ($scope.treeData.constructor !== Array) {
                        $scope.treeData = [$scope.treeData];
                    }

                    removeDisconnectCls($scope.treeData[0]);
                    treeOptions.data = $scope.treeData;

                    angular.element('#' + $scope.treeId).tree(treeOptions);

                    if (items && items.length) {
                        for (i = items.length; i--;) {
                            node = angular.element('#' + $scope.treeId).tree('find', items[i].id);
                            angular.element('#' + $scope.treeId).tree('check', node.target);
                        }
                    }

                    $element.attr('tabindex', '-1');

                }

                if ($scope.treeData) {
                    $timeout(generateTree, 50);
                }

                $scope.$watch('treeData', function (nv, ov) {
                    if (nv !== ov) {
                        $timeout(generateTree, 50);
                    }
                });

                $scope.treeSearchOpen = function treeSearchOpen() {
                    angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                };

                $scope.treeSearchClose = function treeSearchClose() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;

                    Util.debug($scope.$root.$$phase);
                    if (!$scope.$root.$$phase) $scope.$apply();
                };

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                $scope.selectItemInTreeSearchResult = function (item) {
                    var node = angular.element('#' + $scope.treeId).tree('find', item.id);

                    $scope.ngModel = {id: item.id, name: item.name};

                    angular.element('#' + $scope.treeId).tree('check', node.target);

                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };


                $element.on('focusin', function () {
                    if (!$scope.treeData) {
                        $element.blur();
                        return false;
                    }
                    $element.addClass('open');
                    $scope.searchWord = undefined;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined

                    Util.debug($scope.$root.$$phase);
                    if (!$scope.$root.$$phase) $scope.$apply();
                });

//                $scope.MessageProperties = {};
//                $scope.MessageProperties.NotBeFound = MessageProperties.get('validate.notFound');
            }
        };
    }]);

    app.directive('ngbssUserGroupCheckboxTree', ['$rootScope', '$timeout', 'UserAgent', 'MessageProperties', 'UUID', function ($rootScope, $timeout, UserAgent, MessageProperties, UUID) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                treeData: '=',
                checkedUsers: '=',
                cbFunction: '='
            },
            template: '<ul id="{{ treeId }}" class="treeGrid treeTypeUser"></ul>',
            link: function ($scope, $element, $attrs) {
                var i, j, item, treeOptions, node,
                    checkedTreeData = angular.copy($scope.ngModel);

                function apply(fn) {
                    if (!$scope.$root.$$phase) {
                        $scope.$apply(fn);
                    } else {
                        fn();
                    }
                }

                $scope.treeId = UUID();
                $scope.checkedItems = $scope.ngModel;

                if (!$scope.ngModel) {
                    $scope.checkedItems = [];
                }

                if (!$scope.checkedUsers) {
                    $scope.checkedUsers = [];
                }

                treeOptions = {
                    checkbox: true,
//                    cascadeCheck: false,
                    formatter: function (node) {
                        var mans = '';
                        if (node.users && node.users.length !== undefined) {
                            mans = '<b>' + node.users.length + '</b>';
                        }

                        if (node.depth === '0') {
                            return '<span>' + node.name + mans + '</span>';
                        } else {
                            return '<span title="' + node.path + '">' + node.name + mans + /*'<mark>' + node.path + '</mark>' +*/ '</span>';
                        }
                    },
                    onSelect: function (node) {
                        var treeObj = $("#" + $scope.treeId);
                        if ($scope.cbFunction) {
                            $scope.cbFunction(node, treeObj);
                        }
                    },
                    onCheck: function (node, checked) {
                        apply(function () {
                            var i, idx,
                                items = $("#" + $scope.treeId).tree('getChecked'),
                                users = [];

                            if (!items.length) {
                                $scope.checkedUsers = [];
                            }

                            $scope.checkedItems = [];
                            for (i = items.length; i--;) {
                                $scope.checkedItems.push({"id": items[i].id});
                                users = users.concat(items[i].users);
                            }

                            items = angular.copy(users);
                            users = [];
                            for (i = items.length; i--;) {
                                users.push(items[i].user_id);
                            }

                            $scope.ngModel = $scope.checkedItems;

                            for (i = users.length; i--;) {
                                if ($scope.checkedUsers.indexOf(users[i]) == -1) {
                                    $scope.checkedUsers.push(users[i]);
                                }
                            }

                            if (!checked) {
                                users = node.users;
                                for (i = users.length; i--;) {
                                    idx = $scope.checkedUsers.indexOf(users[i].user_id);
                                    if (idx > -1) {
                                        $scope.checkedUsers.splice(idx, 1);
                                    }
                                }
                            }
                        })
                    }
                };

                function generateTree() {
                    var treeObj = $("#" + $scope.treeId);

                    treeOptions.data = $scope.treeData;
                    angular.element("#" + $scope.treeId).tree(treeOptions);

                    if ($scope.ngModel) {
                        for (i = $scope.ngModel.length; i--;) {
                            item = $scope.ngModel[i];
                            node = treeObj.tree('find', item.id);
                            treeObj.tree('check', node.target);
                        }
                    }
                    partialSelection();
                }

                function partialSelection() {
                    var groupIds, key,
                        treeObj = $("#" + $scope.treeId),
                        groupMemberCount = {};

                    if ($scope.checkedUsers) {
                        for (i = $scope.checkedUsers.length; i--;) {
                            groupIds = UserAgent.getUsersIndexInUserGroups($scope.checkedUsers[i]);

                            for (j = groupIds.length; j--;) {
                                if (!groupMemberCount[groupIds[j]]) {
                                    groupMemberCount[groupIds[j]] = 0;
                                }

                                groupMemberCount[groupIds[j]]++;
                            }
                        }

                        for (key in groupMemberCount) {
                            node = treeObj.tree('find', key);

                            if (groupMemberCount[key] && groupMemberCount[key] < node.users.length) {
                                angular.element(node.target).find('.tree-checkbox').addClass('tree-checkbox2');
                            }
                        }
                    }

                }

                if ($scope.treeData) {
                    $timeout(generateTree, 50);
                }

                $scope.$watch('treeData', function (nv, ov) {
                    if (nv !== ov) {
                        $timeout(generateTree, 50);
                    }
                });

                $scope.$watch('checkedUsers', function (nv, ov) {
                    if (nv !== ov) {
                        $timeout(partialSelection, 50);
                    }
                }, true);

                $timeout(function () {

                }, 200);


//                $scope.MessageProperties = {};
//                $scope.MessageProperties.NotBeFound = MessageProperties.get('validate.notFound');
            }
        };
    }]);

    app.directive('ngbssListMoreButton', function () {
        return {
            restrict: 'ACE',
            replace: true,
            scope: {
                dropDownMenu: '='
            },
            template: '<div id="gridDropDownMenuDiv" class="btnAct" tabindex="-1">' +
                '<a href="javascript:void(null)" class="btnDropDown"></a>' +
                '<div class="dropDownMenu" style="right:0;top:27px;">' +
                '<ul ng-mouseleave="dropDwonMenuViewOK = false">' +
                '<li data-ng-repeat="item in dropDownMenu">' +
                '<a href="javascript:void(null)" ng-click="doDropDownMenuFunction(item)">{{item.menu}}</a></li> ' +
                '</ul>' +
                '</div>' +
                '</div>',
            link: function ($scope, $element, $attrs, API, Const) {

                $scope.doDropDownMenuFunction = function (item) {
                    $element.blur();
                    item.func();
                };

                $element.on('focusin', function (event) {
                    $element.find('.dropDownMenu').addClass('open');
                });

                $element.on('focusout', function (event) {
                    $element.find('.dropDownMenu').removeClass('open');
                });

                $element.find('a.btnDropDown').on('click', function () {
                    $element.focus();
                })
            }
        }
    });

    app.directive('datagridHeaderCheck', ['$rootScope', '$compile', 'UUID', function ($rootScope, $compile, UUID) {
        return {
            restrict: 'ACE',
            scope: {
                all: '=selectAllYn',
                gridID: '=datagridId',
                clear: '=clearFunction'
            },
            link: function ($scope, $element, $attrs) {
                var menuId = UUID(),
                    targetGrid;
                var dropDownMenuOpenYn = false,
                    html =
                        '<div id="btn' + menuId + '" tabindex="-1" class="btnAct" style="margin-left: 5px;">' +
                        '<a href="javascript:void(null);" class="btnChkSelect">Drop-down menu</a>' +
                        '<div id="' + menuId + '" class="dropDownMenu" style="left:0;top:42px;"> ' +
                        '<ul>' +
                        '<li ng-click="selectAllObject()"><a href="javascript:void(null);" ng-label="checkbox.selectAll"></a></li> ' +
                        '<li ng-click="unSelectAllObject()"><a href="javascript:void(null);" ng-label="checkbox.deselectAll"></a></li> ' +
                        '</ul> ' +
                        '</div>' +
                        '</div>';

                $element.append(html);
                $scope.$watch('all', function (nv) {
                    angular.element('#btn' + menuId).blur();
                    angular.element('#' + menuId).removeClass('open');
                });

                targetGrid = $('#' + menuId).closest('.panel.datagrid');

                $compile(angular.element('#btn' + menuId))($scope);

                angular.element('#btn' + menuId).on('focusin', function () {
                    angular.element('#' + menuId).addClass('open');
                    targetGrid.append(angular.element('#' + menuId));
                });

                angular.element('#btn' + menuId).on('focusout', function () {
                    if (!angular.element('#' + menuId).is(':hover')) {
                        angular.element('#' + menuId).removeClass('open');
                        $element.append(angular.element('#' + menuId));
                    }
                });

//                angular.element('#' + menuId).on('click', function() {
//                    angular.element('#btn' + menuId).focus()
//                });

                $scope.selectAllObject = function () {
                    $scope.all = true;
                    angular.element('#' + $scope.gridID).datagrid('checkAll');
                    angular.element('#btn' + menuId).blur();
                    angular.element('#' + menuId).removeClass('open');
                };
                $scope.unSelectAllObject = function () {
                    $scope.all = false;
                    angular.element('#' + $scope.gridID).datagrid('uncheckAll');
                    angular.element('#btn' + menuId).blur();
                    angular.element('#' + menuId).removeClass('open');
                    $element.append(angular.element('#' + menuId));

                    if ($scope.clear) {
                        $scope.clear();
                    }
                };
            }
        };
    }]);

    app.directive('ngbssTwinCalendar', ['$compile', '$filter', 'Const', 'MessageProperties', 'PreferenceService', function ($compile, $filter, Const, MessageProperties, PreferenceService) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
//                startDatetime: '=',
//                expiryDatetime: '=',
                ngModel: '=',
                ngDisabled: '='
            },
            template: '<div class="sm-period">' +
                '<input type="text" class="input ac" readonly ng-class="{\'disabled\':disabledYN}" ng-model="calendar.startDate">' +
                '<input type="text" class="input ac time" readonly ng-class="{\'disabled\':disabledYN}" ng-model="calendar.startTime">' +
                '<span class="dash" >~</span>' +
                '<input type="text" class="input ac" readonly ng-class="{\'disabled\':disabledYN}" ng-model="calendar.expiryDate">' +
                '<input type="text" class="input ac time" readonly ng-class="{\'disabled\':disabledYN}" ng-model="calendar.expiryTime">' +
                '<a href="javascript:void(0)" class="ibtnCalender" ng-class="{\'disabled\':disabledYN}" ng-click="doOpenTwinCalendar()">' +
                '<img src="images/common/btn_calendar.png" alt="calendar">' +
                '</a>' +
                '</div>',
            link: function postLink($scope, $element, $attrs) {

                var calendarHtml,
                    gmtStartDate,
                    gmtExpiryDate,
                    spinnerStartTime,
                    spinnerExpiryTime,
                    startDateOnCalendar,
                    expiryDateOnCalendar;

                calendarHtml = '';
                calendarHtml += '<div id="bssCalendarDlg" class="calendarPop">' +
                    '<div class="calenderCnt">' +
                    '<div class="calenderStar">' +
                    '<h4 class="title" ng-label="user.period.startDate"></h4>' +
                    '<div id="startDate" class="calendar" style="width:266px;height:263px;">' +
                    '</div> ' +
                    '<input id="startTimeSpinner" style="width:90px;height:30px;">' +
                    '</div>' +
                    '<div class="calenderEnd">' +
                    '<h4 class="title" ng-label="user.period.expiryDate"></h4>' +
                    '<div id="expiryDate" class="calendar" style="width:266px;height:263px;">' +
                    '</div>' +
                    '<input id="expiryTimeSpinner" style="width:90px;height:30px;">' +
                    '</div>' +
                    '</div>' +
                    '<div class="calendar-btn popFooter">' +
                    '<div class="fl">' +
                    '<button class="btnCntS btnColorDarkGray" ng-click="doSetToday()" ng-label="common.today"></button>' +
                    '</div>' +
                    '<div class="fr">' +
                    '<button class="btnCntS btnColorPoint" ng-click="doApplyDate()" ng-label="button.ok"></button> ' +
                    '<button class="btnCntS btnColorGray" ng-click="doCancelDate()" ng-label="button.cancel"></button>' +
                    '</div>' +
                    '</div>' +
                    '</div>';

				var calandarWatcher;

                function init() {
                    $scope.startDatetime = $scope.ngModel.start_datetime;
                    $scope.expiryDatetime = $scope.ngModel.expiry_datetime;

                    $scope.calendar = {};

                    console.log("ngbssTwinCalendar::begin");
                    if (!$scope.startDatetime) {
                        $scope.calendar.startDate = $filter('BssDate')(Const.DEFAULT_START_DATE, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        $scope.calendar.startTime = $filter('BssTime')(Const.DEFAULT_START_DATE, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        startDateOnCalendar = $scope.calendar.startDate;
                        spinnerStartTime = $filter('BssTime')(Const.DEFAULT_START_DATE, Const.DEFAULT_SHORT_TIME_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH, false);
                        gmtStartDate = new Date($filter('BssDate')(Const.DEFAULT_START_DATE, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH) + ' ' + $scope.calendar.startTime);
                        $scope.startDatetime = gmtStartDate.buildCurrentTimeWithNoTimeZoneInUTCString();
                        console.log('%c' + gmtStartDate, 'background:crimson;color:green;');
                    } else {
                        $scope.calendar.startDate = $filter('BssDate')($scope.startDatetime, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        $scope.calendar.startTime = $filter('BssTime')($scope.startDatetime, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        startDateOnCalendar = $scope.calendar.startDate;
                        spinnerStartTime = $filter('BssTime')($scope.startDatetime, Const.DEFAULT_SHORT_TIME_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH, false);
                        gmtStartDate = new Date(Date.parse($scope.startDatetime));
                    }
                    if (!$scope.expiryDatetime) {
                        $scope.calendar.expiryDate = $filter('BssDate')(Const.DEFAULT_EXPIRY_DATE, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        $scope.calendar.expiryTime = $filter('BssTime')(Const.DEFAULT_EXPIRY_DATE, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        expiryDateOnCalendar = $scope.calendar.expiryDate;
                        spinnerExpiryTime = $filter('BssTime')(Const.DEFAULT_EXPIRY_DATE, Const.DEFAULT_SHORT_TIME_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH, false);
                        gmtExpiryDate = new Date($filter('BssDate')(Const.DEFAULT_EXPIRY_DATE, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH) + ' ' + $scope.calendar.expiryTime);
                        $scope.expiryDatetime = gmtExpiryDate.buildCurrentTimeWithNoTimeZoneInUTCString();
                    } else {
                        $scope.calendar.expiryDate = $filter('BssDate')($scope.expiryDatetime, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        $scope.calendar.expiryTime = $filter('BssTime')($scope.expiryDatetime, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        expiryDateOnCalendar = $scope.calendar.expiryDate;
                        spinnerExpiryTime = $filter('BssTime')($scope.expiryDatetime, Const.DEFAULT_SHORT_TIME_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH, false);
                        gmtExpiryDate = new Date(Date.parse($scope.expiryDatetime));
                    }
                }

                init();

				calandarWatcher = $scope.$watch('ngModel', function (nv, ov) {
					if (angular.equals(nv, ov) == false) {
						init();
					}
				}, true);

                $scope.disabledYN = false;
                if ($scope.ngDisabled) {
                    $scope.disabledYN = $scope.ngDisabled;
                }
//
                $scope.$watch('ngDisabled', function (nv, ov) {
                    if (nv !== ov) {
                        $scope.disabledYN = $scope.ngDisabled;
                    }
                });

                $scope.doOpenTwinCalendar = function () {
                    if ($scope.disabledYN == true) {
                        return false;
                    }

                    $element.append(calendarHtml);

                    $compile(angular.element('#bssCalendarDlg'))($scope);

                    angular.element("#bssCalendarDlg").dialog({
                        title: MessageProperties.get('user.selectPeriod'),
                        modal: true,
                        shadow: false,
                        width: 657,
                        height: 492,
                        onClose: function () {
                            angular.element("#bssCalendarDlg").dialog('destroy');
                        }
                    });

                    angular.element("#startDate").calendar({
                        weeks: Const.SIMPLE_DAYS_TEXT,
                        months: Const.SIMPLE_MONTH_TEXT,
                        onSelect: function (startDate) {
                            var dayToMillisecond = 24 * 60 * 60 * 1000;
                            startDate = new Date(Date.parse(startDate));
                            startDateOnCalendar = $filter('BssDate')(startDate, null, Const.TIMEZONE_OFFSET.GREENWICH);

                            gmtStartDate = startDate;
                            console.log('%c' + gmtStartDate, 'background:crimson;color:green;');
                        },
                        onChange: function (newDate, oldDate) {
                            var expiryDateOptions = angular.element("#expiryDate").calendar('options'),
                                dayToMillisecond = 24 * 60 * 60 * 1000,
                                expiryDate;
                            expiryDateOptions.current = gmtExpiryDate;
                            expiryDateOptions.validator = function (date) {
                                return (date > newDate);
                            };
                            angular.element("#expiryDate").calendar(expiryDateOptions);

                            console.log(newDate.getTime());
                            console.log(gmtExpiryDate.getTime());
                            gmtExpiryDate = new Date($filter('BssDate')(gmtExpiryDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH));
                            if (newDate >= gmtExpiryDate) {
                                expiryDate = new Date(newDate.getTime() + dayToMillisecond);
                                expiryDateOnCalendar = $filter('BssDate')(expiryDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                                angular.element("#expiryDate").calendar('moveTo', new Date($filter('BssDate')(expiryDate, Const.DEFAULT_DATETIME_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH)));
                                gmtExpiryDate = expiryDate;
                            }
                            if (!$scope.$root.$$phase) $scope.$apply();
                        }
                    });

                    angular.element("#startTimeSpinner").timespinner();
                    angular.element("#startTimeSpinner").timespinner('setValue', spinnerStartTime);

                    angular.element("#expiryDate").calendar({
                        weeks: Const.SIMPLE_DAYS_TEXT,
                        months: Const.SIMPLE_MONTH_TEXT,
                        onSelect: function (expiryDate) {
                            expiryDate = new Date(Date.parse(expiryDate) - new Date().getTimezoneOffset() * 60 * 1000);
                            expiryDateOnCalendar = $filter('BssDate')(expiryDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                            gmtExpiryDate = expiryDate;
                            if (!$scope.$root.$$phase) $scope.$apply();
                        }
                    });

                    angular.element("#expiryTimeSpinner").timespinner({
                        formatter: function (date) {
                            console.log(date);
                            return '11:11';
                        }
                    });
                    angular.element("#expiryTimeSpinner").timespinner('setValue', spinnerExpiryTime);

                    angular.element("#startDate").calendar('moveTo', new Date($scope.calendar.startDate));
                    angular.element("#expiryDate").calendar('moveTo', new Date($scope.calendar.expiryDate));
                };

                $scope.doSetToday = function () {
                    var startDate = new Date();
                    var expiryDate = new Date();
                    expiryDate.setDate(startDate.getDate() + 1);

                    gmtStartDate = new Date($filter('BssDate')(startDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH));
                    gmtExpiryDate = new Date($filter('BssDate')(expiryDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH));

                    startDateOnCalendar = $filter('BssDate')(startDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                    expiryDateOnCalendar = $filter('BssDate')(expiryDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                    angular.element("#startDate").calendar('moveTo', new Date($filter('BssDate')(startDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH)));
                    angular.element("#expiryDate").calendar('moveTo', new Date($filter('BssDate')(expiryDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH)));

                    angular.element("#startTimeSpinner").timespinner('setValue', Const.DEFAULT_START_TIME);
                    angular.element("#expiryTimeSpinner").timespinner('setValue', Const.DEFAULT_START_TIME);
                };

                $scope.doApplyDate = function () {

                    var startDateForSave, expiryDateForSave;

                    $scope.calendar.startDate = startDateOnCalendar;
                    $scope.calendar.expiryDate = expiryDateOnCalendar;

                    startDateForSave = $filter('BssDate')(gmtStartDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH) + ' ' + angular.element("#startTimeSpinner").timespinner('getValue');
                    expiryDateForSave = $filter('BssDate')(gmtExpiryDate, Const.DEFAULT_DATE_FORMAT, Const.TIMEZONE_OFFSET.GREENWICH) + ' ' + angular.element("#expiryTimeSpinner").timespinner('getValue');

                    $scope.calendar.startTime = $filter('BssTime')(new Date(Date.parse(startDateForSave)));
                    $scope.calendar.expiryTime = $filter('BssTime')(new Date(Date.parse(expiryDateForSave)));

					calandarWatcher(); // watcher Off
                    $scope.ngModel.start_datetime = new Date(startDateForSave).buildCurrentTimeWithNoTimeZoneInUTCString();
					$scope.ngModel.expiry_datetime = new Date(expiryDateForSave).buildCurrentTimeWithNoTimeZoneInUTCString();
					calandarWatcher = $scope.$watch('ngModel', function (nv, ov) {
						if (angular.equals(nv, ov) == false) {
							init();
						}
					}, true);

                    angular.element("#bssCalendarDlg").dialog('destroy');
                };

                $scope.doCancelDate = function () {
                    angular.element("#bssCalendarDlg").dialog('destroy');
                };
            }
        };
    }]);

    app.directive('ngbsscalendar', ['$compile', 'MessageProperties', 'MessageService', function ($compile, MessageProperties, MessageService) {
        return {
            restrict: 'A',
            link: function postLink(scope, element, attrs) {
                if (attrs.ngDisabled) {
                    var elem = element[0];

                    for (var i = 0, len = elem.childNodes.length; i < len; i++) {
                        var obj = elem.childNodes[i];
//        		obj['data-ng-disabled'] = attrs.ngDisabled;
                        if (obj.nodeName === angular.uppercase('input')) {
                            $(obj).attr('data-ng-disabled', attrs.ngDisabled);
                        } else if (obj.nodeName === angular.uppercase('span')) {
                            $(obj).attr('data-ng-hide', attrs.ngDisabled);
                        }
                        $compile(obj)(scope);
                    }
                }
            },
            controller: ['$scope', '$rootScope', function ($scope, $rootScope) {

                var dateMap = {};

                $scope.doOpenCalander = function () {
                    $scope.template = 'calendar';
                    var cDate = new Date(),
                        sDate = new Date(cDate.getFullYear(), cDate.getMonth(), cDate.getDate()),
                        eDate = sDate;

                    var dateString = formatDate(cDate);

                    var _start_datetime = new Date();
                    var _expiry_datetime = new Date();
                    if (angular.isDefined($scope.user) && angular.isDefined($scope.user.start_date) && $.trim($scope.user.start_date) !== '') {
                        var _date = $scope.user.start_date.split('/');
                        _start_datetime = new Date(_date[0], _date[1] - 1, _date[2]);

                        dateMap.start_datetime = $scope.user.start_datetime;
                        dateMap.startdate = _date.join('/');
                        sDate = _start_datetime;

                    } else {
                        dateMap.start_datetime = new Date(cDate.getTime()).toISOString();
                        dateMap.startdate = dateString;
                    }
                    if (angular.isDefined($scope.user) && angular.isDefined($scope.user.expiry_date) && $.trim($scope.user.expiry_date) !== '') {
                        var _date = $scope.user.expiry_date.split('/');
                        _expiry_datetime = new Date(_date[0], _date[1] - 1, _date[2]);
                        dateMap.expiry_datetime = $scope.user.expiry_datetime;
                        dateMap.enddate = _date.join('/');
                        eDate = _expiry_datetime;
                    } else {
                        dateMap.expiry_datetime = new Date(cDate.getTime()).toISOString();
                        dateMap.enddate = dateString;
                    }

                    $scope.doOpenC = function () {


                        $("#startdatecc").calendar({
                            current: new Date(),
                            onChange: function (nD, oD) {

                                if (nD > eDate) {
                                    $('#enddatecc').calendar('moveTo', nD);
                                }

                                var dateString = formatDate(nD);

//      					if(angular.isDefined($scope.user) && angular.isDefined($scope.user.start_date)) {
                                dateMap.start_datetime = new Date(nD.getTime() + 86400000).toISOString();
                                dateMap.startdate = dateString;
//      					}

                                Util.debug(dateMap);
                            },
                            onSelect: function (date) {

                                var dateString = formatDate(date);

                                dateMap.start_datetime = new Date(date.getTime() + 86400000).toISOString();
                                dateMap.startdate = dateString;

                                sDate = new Date(date.getFullYear(), date.getMonth(), date.getDate());

                                var end_opt = $("#enddatecc").calendar('options');
                                end_opt.validator = function (date) {
                                    if (date < sDate) {
                                        return false;
                                    } else {
                                        return true;
                                    }
                                };
                                $("#enddatecc").calendar(end_opt);

                            }
                        });

                        $("#enddatecc").calendar({
                            current: new Date(),
                            onChange: function (nD, oD) {

                                if (nD <= sDate) {
                                    $('#startdatecc').calendar('moveTo', nD);
                                }

                                var dateString = formatDate(nD);
                                dateMap.expiry_datetime = new Date(nD.getTime() + 86400000).toISOString();
                                dateMap.enddate = dateString;
                            },
                            onSelect: function (date) {

                                var dateString = formatDate(date);

                                dateMap.expiry_datetime = new Date(date.getTime() + 86400000).toISOString();
                                dateMap.enddate = dateString;

                                eDate = new Date(date.getFullYear(), date.getMonth(), date.getDate());

                                var start_opt = $("#startdatecc").calendar('options');
                                start_opt.validator = function (date) {
                                    if (date > eDate) {
                                        return false;
                                    } else {
                                        return true;
                                    }
                                };
                                $("#startdatecc").calendar(start_opt);
                            }
                        });

                        $("#startdatecc").calendar('moveTo', _start_datetime);
                        $("#enddatecc").calendar('moveTo', _expiry_datetime);

//      			var options = {};
//
//      			options.iconCls = 'icon-save';
//      			options.closable = false;
//      			options.modal = true;
//      			options.shadow = false;
//
//      			options.title = '';
//      			options.width = 430;
//      			options.height = 280;
//
//      			$("#bssCalendarDlg").dialog(options);
                        $("#bssCalendarDlg").dialog({title: MessageProperties.get('common.period'), modal: true, shadow: false, width: 657, height: 492});

                    };
                };

                $scope.doSetToday = function () {
                    var cDate = new Date();
                    $("#startdatecc").calendar('moveTo', cDate);
                    $("#enddatecc").calendar('moveTo', cDate);
                };

                $scope.doCalApply = function () {

                    var sDate = new Date(dateMap.start_datetime);
                    var eDate = new Date(dateMap.expiry_datetime);

                    if (sDate.getTime() > eDate.getTime()) {
                        MessageService.displayWarningMessage(MessageProperties.get('validate.invalidStartDateTime'));
                        return;
                    }

                    $rootScope.$emit("getDate", dateMap);
                    $rootScope.$broadcast("getDate", dateMap);
                    $scope.doCalCancel();
                    console.log("<<ngbsscalendar>> Emit, Broadcast Event :: getDate, Object :: " + angular.toJson(dateMap));
                };

                $scope.doCalCancel = function () {
                    $scope.template = '';
                    $('#bssCalendarDlg').dialog('destroy');
                };

                function formatDate(date) {
                    var dateString = date.getFullYear() + "/";
                    var month = '' + parseInt(date.getMonth() + 1);
                    var _date = '' + parseInt(date.getDate());
                    dateString += month.length > 1 ? month : '0' + month + "/";
                    dateString += _date.length > 1 ? _date : '0' + _date;

                    return dateString;
                }

            }]
        };
    }]);

    app.directive('ngbssDatePickerNoTimeZone', ['$timeout', 'UUID', '$filter', 'Const', 'Util', function ($timeout, UUID, $filter, Const, Util) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                disabledYn: '='
            },
            template: '<div class="date">' +
                '<input type="text" class="input" ng-class="{\'disabled\': disabledYn}" readonly ' +
                'ng-value="selectDate"><a href="javascript:void(null);" class="ibtnCalender" ' +
                'ng-class="{\'disabled\': disabledYn}"></a>' +
                '<div id="{{ date_dlg }}" tabindex="-1" style="display: none;"></div>' +
                '</div>',
            controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {
                var selectDate;
                $scope.date_dlg = UUID();

                if ($scope.ngModel) {
//                    Util.debug($scope.ngModel);
                    selectDate = new Date();
                    selectDate.setDateAsLocalTimeFromUTCString($scope.ngModel);
//                    Util.debug(selectDate);
                    $scope.selectDate = $filter('BssDate')(selectDate, undefined, undefined, true);
//                    Util.debug($scope.selectDate);
                }

//                $scope.$watch('ngModel', function (nv, ov) {
//                    if (nv != ov) {
//                        selectDate = new Date();
//                        selectDate.setDateAsLocalTimeFromUTCString($scope.ngModel);
//                        $scope.selectDate = $filter('BssDate')(selectDate, undefined, undefined, true);
//                        angular.element('#' + $scope.date_dlg).calendar('moveTo', new Date($scope.selectDate));
//                        Util.debug($scope.selectDate);
//                    }
//                });

                var calendarOptions = {
                    weeks: Const.SIMPLE_DAYS_TEXT,
                    months: Const.SIMPLE_MONTH_TEXT,
                    height: 266,
                    width: 266,
                    current: new Date(),
                    validator: function (date) {
                        return (date >= new Date(Date.parse(Const.DEFAULT_START_DATE) - 1000 * 60 * 60 * 24));
                    },
                    onSelect: function (date) {
                        Util.debug(date);
//                        selectDate = new Date();
//                        selectDate.setDateAsLocalTimeFromUTCString(date);
////                        selectDate = new Date(Date.parse(date));
                        $scope.selectDate = $filter('BssDate')(date, undefined, undefined, true);
                        $scope.ngModel = date.buildCurrentTimeWithNoTimeZoneInUTCString();
                        Util.debug($scope.ngModel);

                        $element.blur();
                        if (!$scope.$root.$$phase) $scope.$apply();
                    }
                };

                $element.css('position', 'relative');
                $element.css('z-index', '30');

                $timeout(function () {
                    angular.element('#' + $scope.date_dlg).css('position', 'absolute');
                    angular.element('#' + $scope.date_dlg).css('z-index', '100');
                    angular.element('#' + $scope.date_dlg).css('left', '0');
                    angular.element('#' + $scope.date_dlg).css('top', '2.3em');
                    angular.element('#' + $scope.date_dlg).css('right', '0');
                    angular.element('#' + $scope.date_dlg).css('padding', '0 0 0 0');
                    angular.element('#' + $scope.date_dlg).calendar(calendarOptions);
                    $element.attr('tabindex', '-1');
                }, 50);

                $element.on('focusin', function () {
                    if (angular.isDefined($scope.disabledYn) && $scope.disabledYn) {
                        return;
                    }
                    angular.element('#' + $scope.date_dlg).css('display', 'block');
                    $element.css('z-index', '9999');
                });

                $element.on('focusout', function () {
                    angular.element('#' + $scope.date_dlg).css('display', 'none');
                    $element.css('z-index', '30');
                });
            }]
        }
    }]);

    app.directive('ngbssDatePicker', ['$timeout', 'UUID', '$filter', 'Const', function ($timeout, UUID, $filter, Const) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                absoluteTimeYn: '=',
                disabledYn: '='
            },
            template: '<div class="date">' +
                '<input type="text" class="input" ng-class="{\'disabled\': disabledYn}" readonly ' +
                'ng-value="selectDate"><a href="javascript:void(null);" class="ibtnCalender" ' +
                'ng-class="{\'disabled\': disabledYn}"></a>' +
                '<div id="{{ date_dlg }}" tabindex="-1" style="display: none;"></div>' +
                '</div>',
            controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {
                var selectDate;
                $scope.date_dlg = UUID();

                if ($scope.ngModel) {
                    selectDate = new Date(Date.parse($scope.ngModel));
                    $scope.selectDate = $filter('BssDate')(selectDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                }

                $scope.$watch('ngModel', function (nv, ov) {
                    if (nv != ov) {
                        selectDate = new Date(Date.parse($scope.ngModel));
                        $scope.selectDate = $filter('BssDate')(selectDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        angular.element('#' + $scope.date_dlg).calendar('moveTo', new Date($scope.selectDate));
                        console.log($scope.selectDate);
                    }
                });

                var calendarOptions = {
                    weeks: Const.SIMPLE_DAYS_TEXT,
                    months: Const.SIMPLE_MONTH_TEXT,
                    height: 266,
                    width: 266,
                    current: new Date(),
                    validator: function (date) {
                        return (date >= new Date(Date.parse(Const.DEFAULT_START_DATE) - 1000 * 60 * 60 * 24) &&
                            date <= new Date(Date.parse(Const.DEFAULT_EXPIRY_DATE) - 1000 * 60 * 60 * 24));
                    },
                    onSelect: function (date) {
                        selectDate = new Date(Date.parse(date));
                        $scope.selectDate = $filter('BssDate')(selectDate, null, Const.TIMEZONE_OFFSET.GREENWICH);
                        $scope.ngModel = date.convertLocaleDateToISOString();

                        $element.blur();
                        if (!$scope.$root.$$phase) $scope.$apply();
                    }
                };

                $element.css('position', 'relative');
                $element.css('z-index', '30');

                $timeout(function () {
                    angular.element('#' + $scope.date_dlg).css('position', 'absolute');
                    angular.element('#' + $scope.date_dlg).css('z-index', '100');
                    angular.element('#' + $scope.date_dlg).css('left', '0');
                    angular.element('#' + $scope.date_dlg).css('top', '2.3em');
                    angular.element('#' + $scope.date_dlg).css('right', '0');
                    angular.element('#' + $scope.date_dlg).css('padding', '0 0 0 0');
                    angular.element('#' + $scope.date_dlg).calendar(calendarOptions);
                    $element.attr('tabindex', '-1');
                }, 50);

                $element.on('focusin', function () {
                    if (angular.isDefined($scope.disabledYn) && $scope.disabledYn) {
                        return;
                    }
                    angular.element('#' + $scope.date_dlg).css('display', 'block');
                    $element.css('z-index', '9999');
                });

                $element.on('focusout', function () {
                    angular.element('#' + $scope.date_dlg).css('display', 'none');
                    $element.css('z-index', '30');
                });
            }]
        }
    }]);


    app.directive('ngbssDateTimePicker', ['$timeout', 'UUID', '$filter', '$compile', 'Const', 'PreferenceService', function ($timeout, UUID, $filter, $compile, Const, PreferenceService) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                timeZone: '=',
                disabledYn: '=?'
            },
            template: '<div style="width: 100%" class="dateTimePicker">' +
                '<div class="fl" ngbss-date-picker data-disabled-yn="disabledYn" data-ng-model="dateValue" style="width: calc(100% - 104px);"></div>' +
                '<div style="width: 92px; margin-left: 10px;" class="fr preventSelect">' +
                '<input id="timeSpinnerID" type="text" style="padding: 0 6px;" class="easyui-timespinner input inputTime fl">' +
                '</div>' +
                '</div>',
            controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {
                var timeSpinnerOption = {
                    width: 92,
                    height: 29,
                    showSeconds: true,
                    onSpinUp: function () {
                        if ($scope.disabledYn == true) {
                            angular.element('#timeSpinnerID').timespinner('setValue', $scope.timeValue);
                        } else {
                            $scope.timeValue = angular.element('#timeSpinnerID').timespinner('getValue');
                            if (!$scope.$root.$$phase) $scope.$apply();
                        }
                    },
                    onSpinDown: function () {
                        if ($scope.disabledYn == true) {
                            angular.element('#timeSpinnerID').timespinner('setValue', $scope.timeValue);
                        } else {
                            $scope.timeValue = angular.element('#timeSpinnerID').timespinner('getValue');
                            if (!$scope.$root.$$phase) $scope.$apply();
                        }
                    }
                };
                var selectionRange = function (timeSpinnerID) {
                    var options = angular.element(timeSpinnerID).timespinner('options');
                    var start, end;
                    switch (options.highlight) {
                        case 0:
                            start = 0;
                            end = 2;
                            break;
                        case 1:
                            start = 3;
                            end = 5;
                            break;
                        case 2:
                            start = 6;
                            end = 8;
                            break;
                        default:
                            start = 0;
                            end = 2;
                            break;
                    }
                    angular.element(timeSpinnerID)[0].setSelectionRange(start, end);
                };

//                $element.on('selectstart', function(){return false;});
//
                var dateTimeWatcher, dateWatcher, timeWatcher;

                function dateTimeWatchInfo() {
                    dateTimeWatcher = $scope.$watch('ngModel', function (nv, ov) {
                        if (nv != ov) {
                            dateWatcher();
                            timeWatcher();
                            $scope.dateValue = nv.date;
                            $scope.timeValue = $filter('BssTime')(nv.time, Const.DEFAULT_TIME_LONG_TERM_FORMAT, undefined, false);

                            angular.element('#timeSpinnerID').timespinner('setValue', $scope.timeValue);
                            dateWatchInfo();
                            timeWatchInfo();
                        }
                    }, true);
                }

                function dateWatchInfo() {
                    dateWatcher = $scope.$watch('dateValue', function (nv, ov) {
                        if (nv != ov) {
                            dateTimeWatcher();
                            timeWatcher();
                            var date = new Date(Date.parse($filter('BssDate')(nv, Const.DEFAULT_DATE_FORMAT) + ' ' + $scope.timeValue));
                            console.log('set Date Value ::: ', date.convertLocaleDateToISOString());
                            $scope.ngModel.time = date.convertLocaleDateToISOString();
                            $scope.ngModel.date = date.convertLocaleDateToISOString();
                            $scope.ngModel.dateTime = date.convertLocaleDateToISOString();
                            dateTimeWatchInfo();
                            timeWatchInfo();
                        }
                    });
                }

                function timeWatchInfo() {
                    timeWatcher = $scope.$watch('timeValue', function (nv, ov) {
                        if (nv != ov) {
                            dateTimeWatcher();
                            dateWatcher();
                            angular.element('#timeSpinnerID').timespinner('setValue', nv);
                            selectionRange('#timeSpinnerID');
                            var date = new Date(Date.parse($filter('BssDate')($scope.dateValue, Const.DEFAULT_DATE_FORMAT) + ' ' + nv));
                            console.log('set Time Value ::: ', date.convertLocaleDateToISOString());
                            $scope.ngModel.time = date.convertLocaleDateToISOString();
                            $scope.ngModel.date = date.convertLocaleDateToISOString();
                            $scope.ngModel.dateTime = date.convertLocaleDateToISOString();
                            dateTimeWatchInfo();
                            dateWatchInfo();
                        }
                    });
                }

//
                dateTimeWatchInfo();
                dateWatchInfo();
                timeWatchInfo();
//
                angular.element('#timeSpinnerID').timespinner(timeSpinnerOption);

                $scope.$watch('disabledYn', function (nv, ov) {
                    if (nv) {
                        angular.element('#timeSpinnerID').addClass('disabled').attr('disabled', 'disabled');
                        angular.element('.spinner-arrow-up').addClass('disabled').attr('disabled', 'disabled');
                        angular.element('.spinner-arrow-down').addClass('disabled').attr('disabled', 'disabled');
                    } else {
                        angular.element('#timeSpinnerID').removeClass('disabled').removeAttr('disabled');
                        angular.element('.spinner-arrow-up').removeClass('disabled').removeAttr('disabled');
                        angular.element('.spinner-arrow-down').removeClass('disabled').removeAttr('disabled');

                    }
                });
//
//
//
                $scope.dateValue = $filter('BssDate')(new Date().toISOString(), Const.DEFAULT_DATE_FORMAT);
                $scope.ngModel.date = new Date().convertLocaleDateToISOString(Const.TIMEZONE_OFFSET.GREENWICH);
                $scope.timeValue = $filter('BssTime')(new Date().toISOString(), Const.DEFAULT_TIME_LONG_TERM_FORMAT, undefined, false);
                angular.element('#timeSpinnerID').timespinner('setValue', $scope.timeValue);
                $scope.ngModel.dateTime = new Date(Date.parse($filter('BssDate')($scope.dateValue, Const.DEFAULT_DATE_FORMAT) + ' ' + $scope.timeValue));

                angular.element('#timeSpinnerID').on('focusout', function () {
                    if ($scope.disabledYn == true) {
                        angular.element('#timeSpinnerID').timespinner('setValue', $scope.timeValue);
                        selectionRange('#timeSpinnerID');
                        return false;
                    }

                    timeWatcher();
                    var date = new Date(Date.parse($filter('BssDate')($scope.dateValue, Const.DEFAULT_DATE_FORMAT) + ' ' + angular.element('#timeSpinnerID').timespinner('getValue')));

                    console.log('set Date Value ::: ', date.convertLocaleDateToISOString());
                    $scope.ngModel.time = date.convertLocaleDateToISOString();
                    $scope.ngModel.date = date.convertLocaleDateToISOString();
                    $scope.ngModel.dateTime = date.convertLocaleDateToISOString();
                    if (!$scope.$root.$$phase) $scope.$apply();

                    timeWatchInfo();
                });
            }]
        }
    }]);

    app.directive('ngbssDatetimeRangeFilter', ['$compile', 'Const', '$filter', function ($compile, Const, $filter) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                fromDatetime: '=',
                toDatetime: '=',
                applyFilter: "&"
            },
            template: '<button class="ibtnFilter fr" ng-click="openTwinCalendar()">filter</button>',
            controller: ['$scope', '$element', '$rootScope', function ($scope, $element, $rootScope) {

                var calendarHtml,
                    fromDateOnCalendar,
                    toDateOnCalendar,
                    fromday = new Date(),
                    today = new Date();

                fromday.setHours(0);
                fromday.setMinutes(0);
                fromday.setSeconds(0);
                today.setHours(23);
                today.setMinutes(59);
                today.setSeconds(59);

                fromday.setDate(today.getDate() - 7);

                calendarHtml = '';
                calendarHtml += '<div id="bssCalendarDlg" class="calendarPop">' +
                    '<div class="calenderCnt">' +
                    '<div class="calenderStar">' +
                    '<h4 class="title">Start date</h4>' +
                    '<div id="fromDate" class="calendar" style="width:266px;height:263px;">' +
                    '</div> ' +
                    '<input id="fromTimeSpinner" style="width:90px;height:30px;">' +
                    '</div>' +
                    '<div class="calenderEnd">' +
                    '<h4 class="title">End date</h4>' +
                    '<div id="toDate" class="calendar" style="width:266px;height:263px;">' +
                    '</div>' +
                    '<input id="toTimeSpinner" style="width:90px;height:30px;">' +
                    '</div>' +
                    '</div>' +
                    '<div class="calendar-btn popFooter">' +
                    '<div class="fl">' +
                    '<button class="btnCntS btnColorDarkGray" ng-click="doSetToday()" ng-label="common.today"></button>' +
                    '</div>' +
                    '<div class="fr">' +
                    '<button class="btnCntS btnColorPoint" ng-click="doApplyDate()" ng-label="button.ok"></button> ' +
                    '<button class="btnCntS btnColorGray" ng-click="doCancelDate()" ng-label="button.cancel"></button>' +
                    '</div>' +
                    '</div>' +
                    '</div>';

                function init() {

                    var hours, minutes;

                    $scope.calendar = {};
                    if (!$scope.fromDatetime) {
                        fromDateOnCalendar = fromday;
                        $scope.fromDatetime = fromday.toISOString();
                        $scope.calendar.fromDate = $filter('BssDate')(fromday);
                        $scope.calendar.fromTime = $filter('BssTime')(fromday);
                    } else {
                        fromDateOnCalendar = new Date($scope.fromDatetime);
                        $scope.calendar.fromDate = $filter('BssDate')(new Date($scope.fromDatetime));
                        $scope.calendar.fromTime = $filter('BssTime')(new Date($scope.fromDatetime));
                    }
                    if (!$scope.toDatetime) {
                        toDateOnCalendar = today;
                        $scope.toDatetime = today.toISOString();
                        $scope.calendar.toDate = $filter('BssDate')(today);
                        $scope.calendar.toTime = $filter('BssTime')(today);
                    } else {
                        toDateOnCalendar = new Date($scope.toDatetime);
                        $scope.calendar.toDate = $filter('BssDate')(new Date($scope.toDatetime));
                        $scope.calendar.toTime = $filter('BssTime')(new Date($scope.toDatetime));
                    }
                }

                init();

                $scope.disabledYN = false;
                if ($scope.ngDisabled) {
                    $scope.disabledYN = $scope.ngDisabled;
                }

                $scope.$watch('ngDisabled', function (nv, ov) {
                    if (nv !== ov) {
                        $scope.disabledYN = $scope.ngDisabled;
                    }
                });

                $scope.openTwinCalendar = function () {
                    if ($scope.disabledYN == true) {
                        return false;
                    }
                    if ($scope.fromDatetime == undefined || $scope.toDatetime == undefined || $scope.fromDatetime == "" || $scope.toDatetime == "") {
                        init();
                    }

                    $element.append(calendarHtml);

                    $compile(angular.element('#bssCalendarDlg'))($scope);

                    angular.element("#bssCalendarDlg").dialog({
                        title: 'Date Range',
                        modal: true,
                        shadow: false,
                        width: 657,
                        height: 492,
                        onClose: function () {
                            angular.element("#bssCalendarDlg").dialog('destroy');
                        }
                    });

                    angular.element("#fromDate").calendar({
                        current: fromday,
                        onSelect: function (date) {
                            fromDateOnCalendar = date;
                            if (fromDateOnCalendar >= toDateOnCalendar) {
                                console.log('시작날짜가 종료날짜보다 늦을 수 없습니다.');

                                toDateOnCalendar = new Date(date);
                                toDateOnCalendar.setDate(date.getDate() + 1);

                                angular.element("#toDate").calendar('moveTo', toDateOnCalendar);
                            }
                        },
                        onChange: function (newDate, oldDate) {
                            var toDateOptions = angular.element("#toDate").calendar('options');
                            toDateOptions.validator = function (date) {
                                return (date > newDate);
                            };
                            angular.element("#toDate").calendar(toDateOptions);
                        }
                    });

                    angular.element("#fromTimeSpinner").timespinner();
                    angular.element("#fromTimeSpinner").timespinner('setValue', '00:00');

                    angular.element("#toDate").calendar({
                        current: today,
                        onSelect: function (date) {
                            toDateOnCalendar = date;
                        }
                    });

                    angular.element("#toTimeSpinner").timespinner();
                    angular.element("#toTimeSpinner").timespinner('setValue', '23:59');

                    var fromDatetimeForDlgOpen = new Date($scope.fromDatetime),
                        toDatetimeForDlgOpen = new Date($scope.toDatetime);

                    angular.element("#fromDate").calendar('moveTo', fromDatetimeForDlgOpen);
                    angular.element("#toDate").calendar('moveTo', toDatetimeForDlgOpen);

                    angular.element("#fromTimeSpinner").timespinner('setValue',
                            fromDatetimeForDlgOpen.getHours() + ':' + fromDatetimeForDlgOpen.getMinutes());
                    angular.element("#toTimeSpinner").timespinner('setValue',
                            toDatetimeForDlgOpen.getHours() + ':' + toDatetimeForDlgOpen.getMinutes());

                    angular.element("#bssCalendarDlg").dialog('open');
                };

                $scope.doSetToday = function () {
//                    fromDateOnCalendar = fromday;
//                    angular.element("#fromDate").calendar('moveTo', fromday);
                    fromDateOnCalendar = today;
                    angular.element("#fromDate").calendar('moveTo', today);

                    toDateOnCalendar = new Date();
                    toDateOnCalendar.setDate(today.getDate() + 1);
                    angular.element("#toDate").calendar('moveTo', toDateOnCalendar);

                    angular.element("#fromTimeSpinner").timespinner('setValue', '00:00');
                    angular.element("#toTimeSpinner").timespinner('setValue', '00:00');
                };

                $scope.doApplyDate = function () {

                    var startHours = angular.element("#fromTimeSpinner").timespinner('getHours'),
                        startMinutes = angular.element("#fromTimeSpinner").timespinner('getMinutes'),
                        expiryHours = angular.element("#toTimeSpinner").timespinner('getHours'),
                        expiryMinutes = angular.element("#toTimeSpinner").timespinner('getMinutes');

                    fromDateOnCalendar.setHours(startHours);
                    fromDateOnCalendar.setMinutes(startMinutes);
                    fromDateOnCalendar.setSeconds(0);
//                    fromDateOnCalendar.setMilliseconds(0);

                    toDateOnCalendar.setHours(expiryHours);
                    toDateOnCalendar.setMinutes(expiryMinutes);
                    toDateOnCalendar.setSeconds(0);
                    toDateOnCalendar.setMilliseconds(0);

                    $scope.fromDatetime = new Date(fromDateOnCalendar).toISOString();
                    $scope.toDatetime = new Date(toDateOnCalendar).toISOString();

                    $scope.calendar.fromDate = $filter('BssDate')(fromDateOnCalendar);
                    $scope.calendar.toDate = $filter('BssDate')(toDateOnCalendar);

                    $scope.calendar.fromTime = angular.element("#fromTimeSpinner").timespinner('getValue');
                    $scope.calendar.toTime = angular.element("#toTimeSpinner").timespinner('getValue');

                    $scope.applyFilter({
                        filterSelectedInput: {
                            filterType: Const.DATA_FILTER.EVENT_DATE,
                            fromDatetime: $scope.fromDatetime,
                            toDatetime: $scope.toDatetime
                        }
                    });

                    angular.element("#bssCalendarDlg").dialog('destroy');
                };

                $scope.doCancelDate = function () {
                    angular.element("#bssCalendarDlg").dialog('destroy');
                };
            }],
            link: function postLink($scope, $element, $rootScope, $attrs) {

            }
        };
    }]);

    app.directive('ngbssEqualFilter', ['$compile', 'Const', function ($compile, Const) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                itemList: "=",
                filterType: "=",
                filterObject: "=",
                applyFilter: "&",
                label: '@'
            },
            template: '<a href="javascript:void(null);" class="ibtnFilter fr" ng-click="propertyEqualFilter()">filter</a>',
            controller: ['$scope', '$element', '$rootScope', function ($scope, $element, $rootScope) {

                $scope.propertyEqualFilter = function () {
                    $scope.filteredItems = {};
                    $scope.filteredItems.deviceList = [];
                    $scope.filteredItems.deviceNameList = [];
                    $scope.filteredItems.doorList = [];
                    $scope.filteredItems.eventList = [];
                    $scope.filteredItems.userGroupList = [];
                    $scope.filteredItems.userList = [];

                    if (!angular.isDefined($scope.label)) {
                        $scope.label = "name";
                    }
                    var html = '<div id="equalFilterDialog' + $scope.filterType + '">' +
                        '<div class="popCnt"></div>' +
                        '<div class="popFooter" >' +
                        '<div class="btnC">' +
                        '<a href="javascript:void(0);" class="btnCntS btnColorPoint" id="button_add_filter" ng-click="doAddCondition(' + $scope.filterType + ')" ng-label="button.addCondition"></a>' +
                        '<a href="javascript:void(0);" class="btnCntS btnColorGray"  style="margin-left: 3px;" ng-click="doCancel()" ng-label="button.cancel"></a>' +
                        '</div>' +
                        '</div>' +
                        '</div>' +
                        "";
                    $element.append(html);
//                    console.log($scope.itemList);
//                    console.log($scope.filterObject);
                    var filteredNgModelName = '';
                    if (Const.DATA_FILTER.DEVICE_ID == $scope.filterType) {
                        filteredNgModelName = "filteredItems.deviceList";
                        if ($scope.filterObject.deviceId != undefined && $scope.filterObject.deviceId.length > 0) {
                            for (var i = 0; i < $scope.filterObject.deviceId.length; i++) {
                                $scope.filteredItems.deviceList.push($scope.filterObject.deviceId[i]);
                            }
                        }
                    } else if (Const.DATA_FILTER.DEVICE_NAME == $scope.filterType) {
                        filteredNgModelName = "filteredItems.deviceNameList";
                        if ($scope.filterObject.deviceName != undefined && $scope.filterObject.deviceName.length > 0) {
                            for (var i = 0; i < $scope.filterObject.deviceName.length; i++) {
                                $scope.filteredItems.deviceNameList.push($scope.filterObject.deviceName[i]);
                            }
                        }
                    } else if (Const.DATA_FILTER.DOOR_ID == $scope.filterType || Const.DATA_FILTER.DOOR_NAME == $scope.filterType) {
                        filteredNgModelName = "filteredItems.doorList";
                        if ($scope.filterObject.doorName != undefined && $scope.filterObject.doorName.length > 0) {
                            for (var i = 0; i < $scope.filterObject.doorName.length; i++) {
                                $scope.filteredItems.doorList.push($scope.filterObject.doorName[i]);
                            }
                        }
                    } else if (Const.DATA_FILTER.EVENT_ID == $scope.filterType || Const.DATA_FILTER.EVENT_NAME == $scope.filterType) {
                        filteredNgModelName = "filteredItems.eventList";
                        if ($scope.filterObject.eventName != undefined && $scope.filterObject.eventName.length > 0) {
                            for (var i = 0; i < $scope.filterObject.eventName.length; i++) {
                                $scope.filteredItems.eventList.push($scope.filterObject.eventName[i]);
                            }
                        }
                    } else if (Const.DATA_FILTER.USER_GROUP_ID == $scope.filterType || Const.DATA_FILTER.USER_GROUP_NAME == $scope.filterType) {
                        filteredNgModelName = "filteredItems.userGroupList";
                        if ($scope.filterObject.userGroupName != undefined && $scope.filterObject.userGroupName.length > 0) {
                            for (var i = 0; i < $scope.filterObject.userGroupName.length; i++) {
                                $scope.filteredItems.userGroupList.push($scope.filterObject.userGroupName[i]);
                            }
                        }
                    } else if (Const.DATA_FILTER.USER_ID == $scope.filterType || Const.DATA_FILTER.USER_NAME == $scope.filterType) {
                        filteredNgModelName = "filteredItems.userList";
                        if ($scope.filterObject.userName != undefined && $scope.filterObject.userName.length > 0) {
                            for (var i = 0; i < $scope.filterObject.userName.length; i++) {
                                $scope.filteredItems.userList.push($scope.filterObject.userName[i]);
                            }
                        }
                    }
                    var title = $element.parent()[0].childNodes[0].data.trim();
                    var newHtml = '';
                    if (Const.DATA_FILTER.USER_ID == $scope.filterType || Const.DATA_FILTER.USER_NAME == $scope.filterType) {
                        newHtml = '<div ngbss-user-search-box ng-model="' + filteredNgModelName + '" hide-add-button="true" ></div>';
                    } else {
                        newHtml = '<div ngbss-common-list-type-check-list class="selectTypeA" data-list-data="itemList" data-ng-model="' + filteredNgModelName
                            + '" data-label="' + $scope.label + '" ></div>';
                    }

                    angular.element("#equalFilterDialog" + $scope.filterType + " .popCnt").html(newHtml);
                    $compile(angular.element('#equalFilterDialog' + $scope.filterType))($scope);

                    if ($scope.itemList.length > 11) {
                        angular.element(".selectChkList").css("overflow-y", "scroll");
                        angular.element(".selectChkList").css("height", "400");
                    }

                    angular.element("#equalFilterDialog" + $scope.filterType).dialog({
                        title: title,
                        modal: true,
                        shadow: false,
                        cache: false,
                        width: 450,
//                        height: 250,
                        onClose: function () {
                            angular.element('#equalFilterDialog' + $scope.filterType).dialog('destroy');
                        }
                    });
                };
            }],
            link: function postLink($scope, $element, $rootScope, $attrs) {
                $scope.doAddCondition = function (filterType) {
                    $scope.applyFilter({
                        filterSelectedInput: {
                            filterType: filterType,
                            filteredItems: $scope.filteredItems
                        }
                    });
                    angular.element('#equalFilterDialog' + $scope.filterType).dialog('destroy');
                };
                $scope.doCancel = function () {
                    angular.element('#equalFilterDialog' + $scope.filterType).dialog('destroy');
                };
            }
        };
    }]);

    app.directive('ngbssDoorGroupSelectBoxTypeTree', ['$rootScope', 'DoorAgent', 'MessageProperties', 'UUID', '$timeout', 'API', function ($rootScope, DoorAgent, MessageProperties, UUID, $timeout, API) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                treeData: '=',
                onlyChildYn: '='
            },
            template: '<div class="select" ng-class="{\'disabled\':!treeData}">' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="!treeData"></span>' +
                '<span ng-show="treeData && ngModel">{{ ngModel.name }}</span>' +
//                '<span ng-show="treeData && !ngModel" ng-label="common.chooseAnItem"></span>' +
                '</a> ' +
                '<div>' +
                '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
//                '<span ng-label="common.chooseAnItem"></span> ' +
                '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<div class="scrollY" style="max-height: 300px;"> ' +
                '<ul id="{{ treeId }}" class="treeTypeDoor tree" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                '<ul class="selectList" ng-hide="searchWord == undefined || searchWord == \'\'" tabindex="-1"> ' +
                '<li ng-repeat="item in filtered = (DoorGroupSearchResult | listFilter:searchWord:\'name\')" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                '<li ng-show="filtered.length == 0"><span ng-label="validate.notFound"></span></li>' +
                '</ul>' +
                '</div>' +
                '</div>' +
//                '<span class="warningMessage" ng-show="whenGroupClick == true" ng-if="onlyDeviceYn == true" ng-label="validate.canNotSelectGroup"></span>' +
                '</div>',
            link: function ($scope, $element, $attrs) {
                $scope.whenGroupClick = true;
                var
                    treeOptions = {
                        formatter: function (node) {
                            return node.name;
                        },
                        onClick: function (node) {
                            $scope.whenGroupClick = false;
                            if ($scope.onlyChildYn) {
                                if (node.doors) {
                                    $scope.whenGroupClick = true;
                                    if (!$scope.$root.$$phase) $scope.$apply();
                                    return false
                                }
                            }

                            if (!$scope.ngModel) {
                                $scope.ngModel = {};
                            }
                            $scope.ngModel.id = node.id;
                            $scope.ngModel.name = node.name;

                            $scope.$apply(initTree);
                        }
                    };

                $scope.treeId = UUID();

                DoorAgent.getDoorGroups().then(function success(data) {
                    $scope.DoorGroupSearchResult = data.DoorGroupCollection.rows;
                    console.log($scope.DoorGroupSearchResult);
                });

                function generateTree() {
                    var node;

                    DoorAgent.getDoorGroupRecursiveData().then(function success(data) {
                        treeOptions.data = data;

                        angular.element('#' + $scope.treeId).tree(treeOptions);

                        node = angular.element('#' + $scope.treeId).tree('find', 1);

                        if ($scope.ngModel && $scope.ngModel.id) {
                            node = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                            $scope.ngModel = {id: node.id, name: node.name};
                        } else {
                            node = angular.element('#' + $scope.treeId).tree('getRoot');
                            $scope.ngModel = {id: node.id, name: node.name};
                        }

                        angular.element('#' + $scope.treeId).tree('select', node.target);

                        $element.attr('tabindex', '-1');
                    });
                }

                if ($scope.treeData) {
                    $timeout(generateTree, 200);
                }

                function initTree() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                    $element.trigger('blur');
                }

                $scope.treeSearchOpen = function treeSearchOpen() {
                    angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                };

                $scope.treeSearchClose = function treeSearchClose() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                $element.on('click', function () {
                    $element.find('.scrollY').scrollTop(0);
                });

                $element.on('focusin', function () {
                    if (!$scope.treeData) {
                        $element.blur();
//                        return false;
                    }
                    $element.addClass('open');
                    $scope.searchWord = undefined;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                $scope.$watch('treeData', function (nv, ov) {
                    if (nv !== ov && $scope.treeData) {
                        $timeout(generateTree, 50);
                    }
                });

                $scope.selectItemInTreeSearchResult = function (item) {
                    var node = angular.element('#' + $scope.treeId).tree('find', item.id);

                    $scope.ngModel = {id: item.id, name: item.name};

                    angular.element('#' + $scope.treeId).tree('select', node.target);
                    initTree();
                };
            }
        };
    }]);

    app.directive('ngbssDoorGroupCheckBoxTypeTree', ['$rootScope', 'DoorAgent', 'MessageProperties', 'UUID', '$timeout', 'Util', function ($rootScope, DoorAgent, MessageProperties, UUID, $timeout, Util) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=',
                treeData: '=',
                onlyChildYn: '='
            },
            template: '<div class="select">' +
                '<a href="javascript:void(null);">' +
                '<span ng-if="ngModel && ngModel.length">' +
                '{{ ngModel[0].name }}' +
                '</span>' +
                '<span ng-if="ngModel && ngModel.length > 1">' +
                ' + <mark class="number" ng-if="ngModel.length > 1">{{ ngModel.length - 1 }}</mark>' +
                '</span>' +
//                '<span ng-if="!ngModel || !ngModel.length" ng-label="common.chooseAnItem"></span>' +
                '</a> ' +
                '<div style="min-width: 25em;">' +
                '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
//                '<span ng-label="common.chooseAnItem"></span> ' +
                '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<div class="scrollY" style="max-height: 300px;"> ' +
                '<ul id="{{ treeId }}" class="treeGrid treeTypeDoor" ng-hide="searchWord"></ul>' +
                '<ul class="selectList" ng-show="searchWord" tabindex="-1"> ' +
                '<li ng-repeat="item in filtered = (DoorGroupSearchResult | listFilter:searchWord:\'name\')" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                '<li ng-hide="filtered.length"><span ng-label="validate.notFound"></span></li>' +
                '</ul>' +
                '</div>' +
                '</div>' +
                '</div>',
            link: function ($scope, $element, $attrs) {
                var treeOptions,
                    safeApply;

                treeOptions = {
                    checkbox: true,
                    cascadeCheck: true,
                    formatter: function (node) {
                        return node.name;
                    },
                    onCheck: function (node, checkYn) {
                        var i, checkedList = [];

                        if (angular.isUndefined($scope.ngModel) || $scope.ngModel == '') {
                            $scope.ngModel = [];
                        }

                        for (i = 0; i < $scope.ngModel.length; i++) {
                            checkedList.push($scope.ngModel[i].id);
                        }
                        var children = [];
                        if (node.isDoorGroups == true) {
                            children = angular.element('#' + $scope.treeId).tree('getChildren', node.target);
                        } else {
                            children.push(node);
                        }

                        for (i = 0; i < children.length; i++) {
                            if (children[i].isDoorGroups != true) {
                                var idx = checkedList.indexOf(children[i].id);
                                if (checkYn == true) {
                                    if (idx == -1) {
                                        $scope.ngModel.push({id: children[i].id, name: children[i].name});
                                    }
                                } else {
                                    if (idx > -1) {
                                        $scope.ngModel.splice(idx, 1);
                                        checkedList.splice(idx, 1);
                                    }
                                }
                            }
                        }

                        if (!$scope.$root.$$phase) $scope.$apply();

                    }
                };

                $scope.treeId = UUID();

                function generateTree() {
                    treeOptions.data = $scope.treeData;
                    angular.element('#' + $scope.treeId).tree(treeOptions);
                    $element.attr('tabindex', '-1');
                }

                function initTree() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                    $element.trigger('blur');
                }

                function findSelectDoorInTree(door) {
                    var parent = angular.element('#' + $scope.treeId).tree('getRoot'),
                        children = angular.element('#' + $scope.treeId).tree('getChildren', parent.target);

                    for (var i = 0; i < children.length; i++) {
                        if (children[i].isDoorGroups != true && children[i].id == door.id) {
                            return children[i];
                        }
                    }
                }

                $scope.treeSearchOpen = function treeSearchOpen() {
                    angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                };

                $scope.treeSearchClose = function treeSearchClose() {
                    angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };

                $timeout(function () {
                    // Input Control Focus Out �태�때 검�상�� 공백�라�비활�화
                    angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                $scope.$watch('treeData', function () {
                    if (angular.isDefined($scope.treeId)) {
                        generateTree();
                    }
                });

                $scope.$watch('treeId', function () {
                    if (angular.isDefined($scope.treeData)) {
                        generateTree();
                    }
                });

                $element.on('focusin', function () {
                    if (!$scope.treeData) {
                        $element.blur();
                        return false;
                    }

                    if (!$scope.DoorGroupSearchResult) {
                        DoorAgent.getCachedDoors().then(function success(data) {
                            $scope.DoorGroupSearchResult = data;

                            var i,
                                node,
                                doorItems = angular.copy($scope.ngModel),
                                doorIds = [],
                                treeItems,
                                rootNode;

                            rootNode = angular.element('#' + $scope.treeId).tree('getRoot');
                            treeItems = angular.element('#' + $scope.treeId).tree('getChildren', rootNode.target);

                            if (doorItems && doorItems.length) {

                                for (i = 0; i < doorItems.length; i++) {
                                    doorIds.push(doorItems[i].id);
                                }

                                for (i = 0; i < treeItems.length; i++) {
                                    node = treeItems[i];
                                    if (node.isDoorGroups != true && doorIds.indexOf(node.id) > -1) {
                                        angular.element('#' + $scope.treeId).tree('check', node.target);
                                    }
                                }
                            }
                        });
                    }

                    $element.addClass('open');
                    $scope.searchWord = undefined;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                $scope.selectItemInTreeSearchResult = function (item) {
                    var node = findSelectDoorInTree(item);
                    angular.element('#' + $scope.treeId).tree('check', node.target);
                    initTree();
                };
            }
        };
    }]);

    app.directive('ngbssScheduleSelectBox', ['UUID', '$timeout', 'API', 'Const', 'MessageProperties', 'ScheduleAgent', 'Util', function (UUID, $timeout, API, Const, MessageProperties, ScheduleAgent, Util) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                disabledYn: '=',
                ngOnSelect: '=',
                defaultText: '=',
                defaultSelectYn: '='
            },
            template: '<div class="select" ng-class="{\'disabled\': disabledYn == true}" style="min-width:50%" tabindex="-1">' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="ngModel">{{ ScheduleMap[ngModel.id].name || ngModel.name }}</span>' +
//                '<span ng-show="ngModel">{{ ngModel.name }}</span>' +
                '<span ng-show="!ngModel">{{ defaultText }}</span>' +
//                '<span ng-show="!ngModel" ng-label="common.chooseAnItem"></span>' +
                '</a>' +
                '<div> ' +
                '<p class="searchSelect" id="searchBox_{{ boxId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
                '<input type="text" id="searchBoxInput_{{ boxId }}" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="searchOpen()">search</a>' +
                '<a href="javascript:void(null);" class="btnClose" data-ng-click="searchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<ul class="selectList scroll scrollY" style="max-height: 320px;"> ' +
                '<li style="line-height: 2.3; text-overflow: ' +
                'ellipsis; overflow: hidden; white-space: nowrap;" ng-repeat="item in filtered = (ScheduleListData | listFilter:searchWord:\'name\')" ng-class="{\'selection\':ngModel.id == item.id}" ng-click="selectItem(item)">{{ item.name }}</li> ' +
                '<li ng-if="filtered.length == 0"><span ng-label="validate.notFound"></span></li>' +
                '</ul> ' +
                '<p class="sm-btn">' +
                '<a href="javascript:void(null);" class="btnColorPoint" ng-click="doOpenAddScheduleDlg()" ng-label="button.plusAddSchedule"></a>' +
                '</p>' +
                '<div data-ng-include src="addScheduleDlg.url" onload="doAfterOpenAddScheduleDlg()"></div>' +
                '</div>',

            link: function ($scope, $element, $attrs) {

                var scheduleList, loadComplete = false;

                $scope.boxId = UUID();

                // 팝업으로 띄웠을 때에는 max-height 조절 kjh
                if ($element.parents('.popCnt').length > 0) {
                    $element.find('.selectList').css('max-height', 190);
                }

                $scope.selectedItemArray = [];

                $scope.groupObj = $scope.ngModel || [];
                $scope.checkAccessGroupItem = function ($index) {
                    var idx, selectedItem = $scope.ScheduleListData[$index];

                    if ($scope.selectedItemArray.indexOf($index) == -1) {
                        $scope.selectedItemArray.push($index);
                        $scope.groupObj.push({"name": selectedItem.name, "id": selectedItem.id});
                    } else {
                        idx = $scope.selectedItemArray.indexOf($index);
                        $scope.selectedItemArray.splice(idx, 1);

                        for (var i = $scope.groupObj.length; i--;) {
                            var item = $scope.groupObj[i];
                            if (item.id === selectedItem.id) {
                                $scope.groupObj.splice(i, 1);
                                break;
                            }
                        }
                    }
                    angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };

                $scope.listSearchYn = false;
                function initBox() {
                    angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                    $element.trigger('blur');
                }

                $scope.searchOpen = function searchOpen() {
                    angular.element('#searchBox_' + $scope.boxId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#searchBoxInput_' + $scope.boxId).focus();
                };

                $scope.searchClose = function searchClose() {
                    angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#searchBoxInput_' + $scope.boxId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                $scope.selectItem = function (item) {
                    if (item.id != undefined && item.name != undefined) {
                        $scope.ngModel = {id: item.id, name: item.name};
                    } else {
                        $scope.ngModel = undefined;
                    }

                    if ($scope.ngOnSelect) {
                        $scope.ngOnSelect(item);
                    }
                    $element.blur();
                };

                $element.find('#listSearchBox').on('keypress', function (event) {
                    if (event.keyCode == 13) {
                        if (event.preventDefault) event.preventDefault();
                        if (event.returnValue) event.returnValue = false;
                        return false;
                    }
                });

                $element.on('focusin', function () {
                    if ($scope.disabledYn) {
                        $element.blur();
                        return false;
                    }

                    if (angular.isUndefined($scope.ScheduleListData)) {
                        reloadScheduleList();
                    }

                    $element.addClass('open');
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                var notUse = [
                    {id: null, name: MessageProperties.get('common.notUse')}
                ];
                if (!$scope.defaultText) {
                    notUse = [];
                }

                ScheduleAgent.getScheduleMap().then(function success(data) {
                    $scope.ScheduleMap = data;
                }, function error(data) {
                    Util.debug('load server data :: getScheduleMap :: fail', Util.getSessionObject('getScheduleMap'));
                });

                if ($scope.defaultSelectYn == true) {
                    if ($scope.ngModel == undefined || $scope.ngModel.id == undefined || $scope.ngModel.id == 0) {
                        $scope.ngModel = {id: Const.DEFAULT_SCHEDULE.ALWAYS};
                    }
                }

                function reloadScheduleList(reloadYn) {
                    $element.find('.scrollY').scrollTop(0);
                    ScheduleAgent.getScheduleList().then(function success(data) {
                        if (data.ScheduleCollection) {
                            $scope.ScheduleListData = notUse.concat(data.ScheduleCollection.rows);
                        } else {
                            $scope.ScheduleListData = notUse.concat(data);
                        }
                    });
                }

                $scope.addScheduleDlg = undefined;
                $scope.doOpenAddScheduleDlg = function ($event) {
                    var addScheduleDlg = {};
                    addScheduleDlg.url = 'modules/accessControl/add-schedule.html';
                    $scope.addScheduleDlg = addScheduleDlg;
                };

                // Add Schedule 화면에서 데이터가 추가되면 호출.
                $scope.$on('reloadScheduleList', function () {
                    reloadScheduleList(true);
                });

                $scope.doAfterOpenAddScheduleDlg = function () {
                    var options = {};
                    options.modal = true;
                    options.shadow = false;
                    options.width = 1000;
                    options.height = 'auto';
                    options.shadow = false;
                    options.title = MessageProperties.get('button.addSchedule');

                    options.onClose = function () {
                        $scope.addScheduleDlg = {};
                        $('#addScheduleDlg').dialog('destroy');
                        reloadScheduleList(true);
                        if (!$scope.$root.$$phase) $scope.$apply();
                    };

                    $("#addScheduleDlg").dialog(options);
                };

                $scope.checkIn24Time = function (time) {
                    var t24s = [];
                    for (var i = 0; i < 24; i++) {
                        t24s.push(false);
                    }
                    for (var i = 0; i < time.time_segments.length; i++) {
                        var item = time.time_segments[i], start_time = Math.floor(item.start_time / 60), end_time = Math.floor(item.end_time / 60);
                        for (var j = start_time; j < end_time; j++) {
                            t24s[j] = true;
                        }
                    }
                    return t24s;
                };
            }
        }
    }]);

    app.directive('ngbssUserGroupTreeSideUserList', function () {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                selectedUser: '=ngModel',
                singleSelect: '='
            },
            template: '<div ng-class="{\'disabled\':!UserGroupTreeData}" ng-init="init()" tabindex="-1">' +
                '<a href="javascript:void(null);">{{selectedUser.name == undefined ? \'Choose Name\' : selectedUser.name}}</a>' +
                '<div class="selectUserList length2">' +
                '<!-- cntTypeB : s -->' +
                '<div class="cntTypeB">' +
                '<div class="scrollArea scrollY" style="max-height: 250px">' +
                '<ul class="tree treeGrid treeTypeUser">' +
                '<li ng-repeat="user_group in UserGroupTreeData" ng-include="\'field_renderer.html\'"></li>' +
                '</ul>' +
                '</div>' +
                '</div>' +
                '<!-- cntTypeB : e -->' +
                '<!-- cntTypeC : s -->' +
                '<div class="cntTypeC sliderBefore" >' + // style="top:35px;">' +
                '<h6>' +
                '<input type="checkbox" class="chkChange userListAllChk" ng-click="doAllCheckUserListItems()"' +
                ' ng-model="userListSelectAll" ng-checked="userListSelectAll == true" id="cntC01" name="cntC"' +
                ' ng-hide="singleSelect"/>' +
                '<label for="cntC01" ng-hide="singleSelect"></label> {{userGroupPath | limitTo:18}}' +
                '<span ng-hide="singleSelect">{{userCountOfUserGroups[selectedUserGroup.id]}}</span>' +
                '</h6>' +
                '<p class="searchSelect" id="userSearchBox" ng-class="{\'typeClear\':userSearchWord.length}">' +
                '<!--typeClear, typeInput-->' +
                '<span>Choose an User </span>' +
                '<input type="text" id="userSearchBoxInput" ng-model="userSearchWord" placeholder="">' +
                '<a href="javascript:void(null);" id="userSearchButton" ng-click="doActivateUserSearchBox()" class="ibtnSearch">search</a>' +
                '<a href="javascript:void(null);" id="userSearchBoxCloseButton" ng-click="doDeactivateUserSearchBox()" class="btnClose">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<div class="scrollArea scrollY" style="max-height: 178px">' +
                '<table summary="ID, Name for information.">' +
                '<caption>User</caption>' +
                '<colgroup>' +
                '<col width="*">' +
                '<col width="45%">' +
                '</colgroup>' +
                '<tbody>' +
                '<tr ng-repeat="user in UserListData | listFilter:userSearchWord:\'user_id\'" ng-click="doCheckUserItem(user, $index)"' +
                '   ng-class="{\'selection\': singleSelect && selectedUserIndex == $index}">' +
                '<td>{{user.user_id}}</td>' +
                '<td>{{user.name}}</td>' +
                '</tr>' +
                '</tbody>' +
                '</table>' +
                '</div>' +
                '</div>' +
                '<!-- cntTypeC : e -->' +
                '</div>',
            controller: ['$scope', '$element', '$attrs', '$timeout', 'UserAgent', function ngbssUserGroupTreeSideUserList($scope, $element, $attrs, $timeout, UserAgent) {

                var userGroupTreeHandler,
                    acGroupInfo = {};
                // User Group Tree Handler -start-
                $scope.checkedUserItem = [];
                $scope.selectedUserIndex = -1;
                $scope.userCountOfUserGroups = {};
                $scope.treeCollasedOK = {};
                function UserGroupTreeHandler(acGroupInfo) {
                    var i, item, userGroupList,
                        checkedUserGroupDataList = [],
                        userListInUserGroups = {},
                        userCountOfUserGroups = {};

                    $(".tree-checkbox").each(function () {
                        angular.element(this).removeAttr("class").addClass('tree-checkbox tree-checkbox0');
                    });

                    UserAgent.getUserGroupMemoizationData().then(function success(data) {
                        userGroupList = data;
                        setCheckedUserGroupDataList();
                        setCheckedUserDataList();
                        setTreeFoldingMemoization();
                    });


                    function setTreeFoldingMemoization() {
                        var i, key;
                        for (key in userGroupList) {
                            $scope.treeCollasedOK[key] = false;
                        }
                    }

                    function setCheckedUserGroupDataList() {
                        var i, element, isChecked, userGroup;

                        if (acGroupInfo.user_groups && acGroupInfo.user_groups.length) {
                            for (i = acGroupInfo.user_groups.length; i--;) {
                                item = acGroupInfo.user_groups[i];
                                checkedUserGroupDataList.push(item.id);
                            }

                            for (i = checkedUserGroupDataList.length; i--;) {
                                userGroup = userGroupList[checkedUserGroupDataList[i]];
                                if (!userGroup) {
                                    continue;
                                }
                                element = angular.element('#_user_tree_' + userGroup.id).find('.tree-checkbox');
                                isChecked = element.is('.tree-checkbox1');

                                if (!isChecked) {
                                    checkUserGroupTreeCheckbox(userGroup);
                                    removeChildrenUserGroupInCheckedList(userGroup);
                                }
                            }
                        }
                    }

                    function setCheckedUserDataList() {
                        var i;

                        $scope.checkedUserItem = [];

                        if (acGroupInfo.users && acGroupInfo.users.length) {
                            for (i = acGroupInfo.users.length; i--;) {
                                item = acGroupInfo.users[i];
                                $scope.checkedUserItem.push(item.user_id);
                            }
                        }
                        countCheckedUsers();
                    }

                    function countCheckedUsers() {
                        var i, key, user, element, isChecked, userGroup
                            , usersInCheckedUserGroup = [];
//                        console.info(userGroupList, userListInUserGroups);

                        for (key in userGroupList) {
                            userGroup = userGroupList[key];
                            element = angular.element('#_user_tree_' + userGroup.id).find('.tree-checkbox');
                            isChecked = element.is('.tree-checkbox1');

                            if (isChecked) {
                                for (i = userGroup.users.length; i--;) {
                                    if (usersInCheckedUserGroup.indexOf(userGroup.users[i].user_id) == -1) {
                                        usersInCheckedUserGroup.push(userGroup.users[i].user_id);
                                    }
                                }

                            }
                        }

                        for (key in userGroupList) {

                            userListInUserGroups[key] = userGroupList[key].users || [];
                            userCountOfUserGroups[key] = 0;

                            if (userListInUserGroups[key]) {
                                for (i = userListInUserGroups[key].length; i--;) {
                                    user = userListInUserGroups[key][i];
                                    if ($scope.checkedUserItem.indexOf(user.user_id) > -1
                                        || usersInCheckedUserGroup.indexOf(user.user_id) > -1) {
                                        userCountOfUserGroups[key]++;
                                    }
                                }
                            }
                        }

                        $scope.userCountOfUserGroups = userCountOfUserGroups;
                    }

                    function addUserGroupItemToCheckList(userGroup) {
                        var isChecked,
                            idx = checkedUserGroupDataList.indexOf(userGroup.id),
                            element = angular.element('#_user_tree_' + userGroup.id).find('.tree-checkbox');
                        isChecked = element.is('.tree-checkbox1');

                        if (idx == -1) {
                            if (isChecked) {
                                checkedUserGroupDataList.push(userGroup.id);
                            }
                        } else if (idx > -1) {
                            if (!isChecked) {
                                checkedUserGroupDataList.splice(idx, 1);
                            }
                        }
                    }

                    function doSelectUserGroup(userGroup) {
                        var idx,
                            event = window.event,
                            target,
                            element = angular.element('#_user_tree_' + userGroup.id).find('.tree-checkbox'),
                            isChecked = element.is('.tree-checkbox1');
                        if (event != null) {
                            target = event.target || (event.srcElement || document);
                        }

                        if (target && target.className.indexOf('tree-checkbox') > -1) {
                            closeUserList(userGroup);

//                            idx = checkedUserGroupDataList.indexOf(userGroup.id);

                            checkUserGroupTreeCheckbox(userGroup);
                        } else if (target && target.className.indexOf('tree-hit') > -1) {
                            $scope.treeCollasedOK[userGroup.id] = !$scope.treeCollasedOK[userGroup.id];
                        } else {
                            if (!isChecked) {
                                $scope.userGroupPath = userGroup.name;
                                openUserList(userGroup);
                            } else {
                                closeUserList(userGroup);
                            }
                        }

                        $scope.selectedUserGroup = userGroup;
                    }

                    function checkUserGroupTreeCheckbox(userGroup) {
                        var element = angular.element('#_user_tree_' + userGroup.id).find('.tree-checkbox'),
                            isChecked = element.is('.tree-checkbox1');

                        if (isChecked) {
                            element.removeAttr('class').addClass('tree-checkbox tree-checkbox0');
                        } else {
                            element.removeAttr('class').addClass('tree-checkbox tree-checkbox1');
                        }

                        addUserGroupItemToCheckList(userGroup);

                        childrenCascadeCheck(userGroup);
                        parentCascadeCheck(userGroup);

                        countCheckedUsers();

                    }

                    function childrenCascadeCheck(userGroup) {
                        var i, item, element,
                            isChecked = angular.element('#_user_tree_' + userGroup.id)
                                .find('.tree-checkbox').is('.tree-checkbox1'),
                            user_groups = userGroup.user_groups;

                        if (user_groups) {
                            for (i = user_groups.length; i--;) {
                                item = user_groups[i];
                                element = angular.element('#_user_tree_' + item.id).find('.tree-checkbox');


                                if (isChecked) {
                                    element.removeAttr('class').addClass('tree-checkbox tree-checkbox1');
                                } else {
                                    element.removeAttr('class').addClass('tree-checkbox tree-checkbox0');
                                }
                                childrenCascadeCheck(item);
                            }
                            removeChildrenUserGroupInCheckedList(userGroup);
                        }
                    }

                    function parentCascadeCheck(userGroup) {
                        var i, item, idx,
                            childElement, parent, element,
                            childIsCheckedCnt,
                            childIsIndeterminateCnt;


                        if (userGroup.parent_id) {
                            parent = userGroupList[userGroup.parent_id.id];
                            element = angular.element('#_user_tree_' + parent.id).find('.tree-checkbox');

                            childIsCheckedCnt = 0;
                            childIsIndeterminateCnt = 0;


                            for (i = parent.user_groups.length; i--;) {
                                item = parent.user_groups[i];
                                childElement = angular.element('#_user_tree_' + item.id).find('.tree-checkbox');

                                if (childElement.is('.tree-checkbox1')) {
                                    childIsCheckedCnt++;
                                }

                                if (childElement.is('.tree-checkbox2')) {
                                    childIsIndeterminateCnt++;
                                }
                            }


                            if (parent.user_groups && parent.user_groups.length) {
                                if (childIsCheckedCnt && childIsCheckedCnt == parent.user_groups.length) {

                                    element.removeAttr('class').addClass('tree-checkbox tree-checkbox1');
                                    addUserGroupItemToCheckList(parent);
                                    removeChildrenUserGroupInCheckedList(parent);
                                } else if (childIsCheckedCnt == 0 && parent.user_groups.length > 0) {

                                    element.removeAttr('class').addClass('tree-checkbox tree-checkbox0');
                                } else {

                                    element.removeAttr('class').addClass('tree-checkbox tree-checkbox2');
                                    addUserGroupItemToCheckList(parent);

                                    for (i = parent.user_groups.length; i--;) {
                                        item = parent.user_groups[i];
                                        addUserGroupItemToCheckList(item);
                                    }
                                }

                                if (childIsCheckedCnt < parent.user_groups.length && childIsIndeterminateCnt > 0) {
                                    element.removeAttr('class').addClass('tree-checkbox tree-checkbox2');
                                }
                            }

                            parentCascadeCheck(parent);
                        }
                    }

                    function removeChildrenUserGroupInCheckedList(parent) {
                        var i, item, idx;

                        if (parent.user_groups) {
                            for (i = parent.user_groups.length; i--;) {
                                item = parent.user_groups[i];
                                idx = checkedUserGroupDataList.indexOf(item.id);
                                if (idx > -1) {
                                    checkedUserGroupDataList.splice(idx, 1);
                                }
                            }
                        }
                    }

                    function openUserList(userGroup) {
                        $scope.UserListData = userGroup.users;
                        if ($scope.singleSelect) {
                            for (var i = 0; i < $scope.UserListData.length; i++) {
                                if ($scope.selectedUser.user_id == $scope.UserListData[i].user_id) {
                                    $scope.selectedUserIndex = i;
                                    $scope.checkedUserItem = [];
                                    $scope.checkedUserItem.push($scope.UserListData[i]);
                                }
                            }
                        }
                        $scope.userListSelectAll = false;
                        angular.element('.sliderBefore').removeClass('sliderBefore').addClass('sliderAfter');
                    }

                    function closeUserList(userGroup) {
                        angular.element('.sliderAfter').removeClass('sliderAfter').addClass('sliderBefore');
                    }

                    function doCheckUserItem(user, userIndex) {
                        var idx,
                            event = window.event,
                            target = event.target || (event.srcElement || document);

                        if (target.nodeName !== 'INPUT') {
                            idx = $scope.checkedUserItem.indexOf(user.user_id);
                            if (idx > -1) {
                                $scope.checkedUserItem.splice(idx, 1);
                            } else if (idx == -1) {
                                if ($scope.singleSelect) {
                                    $scope.checkedUserItem = [];
                                    $scope.selectedUser = user;
                                    $scope.selectedUserIndex = userIndex;
                                }
                                $scope.checkedUserItem.push(user.user_id);
                            }
                            countCheckedUsers();
                        } else {
                            if (event.returnValue) event.returnValue = false;
                            if (event.preventDefault) event.preventDefault();
                        }
                    }

                    function doAllCheckUserListItems() {
                        var i, idx, item; // checkedUserItem
                        $scope.userListSelectAll = !$scope.userListSelectAll;
                        for (i = $scope.UserListData.length; i--;) {
                            item = $scope.UserListData[i];
                            idx = $scope.checkedUserItem.indexOf(item.user_id);
                            if ($scope.userListSelectAll) {
                                if (idx == -1) {
                                    $scope.checkedUserItem.push(item.user_id);
                                }
                            } else if (!$scope.userListSelectAll) {
                                if (idx > -1) {
                                    $scope.checkedUserItem.splice(idx, 1);
                                }
                            }
                            countCheckedUsers();
                        }
                    }

                    return {
                        doSelectUserGroup: doSelectUserGroup,
                        doCheckUserItem: doCheckUserItem,
                        doAllCheckUserListItems: doAllCheckUserListItems,
                        getUserGroupsChecked: function () {
                            var i,
                                item,
                                _checkedItems = [];

                            for (i = checkedUserGroupDataList.length; i--;) {
                                item = checkedUserGroupDataList[i];
                                _checkedItems.push({id: userGroupList[item].id});
                            }

                            return angular.copy(_checkedItems);
                        },
                        getUsersChecked: function () {
                            var i,
                                item,
                                _checkedItems = [];

                            for (i = $scope.checkedUserItem.length; i--;) {
                                item = $scope.checkedUserItem[i];
                                _checkedItems.push({user_id: $scope.checkedUserItem[i]});
                            }

                            return _checkedItems;
                        }
                    }
                }


                $timeout(function () {
                    userGroupTreeHandler = new UserGroupTreeHandler(acGroupInfo);
                    $scope.doSelectUserGroup = userGroupTreeHandler.doSelectUserGroup;
                    $scope.doCheckUserItem = userGroupTreeHandler.doCheckUserItem;
                    $scope.doAllCheckUserListItems = userGroupTreeHandler.doAllCheckUserListItems;
                    if ($scope.selectedUserGroup == null && $scope.doSelectUserGroup != null && $scope.UserGroupTreeData != null) {
                        $scope.doSelectUserGroup($scope.UserGroupTreeData[0]);
                    }
                }, 200);

                // User 검색 상자 활성화
                $scope.doActivateUserSearchBox = function doActivateUserSearchBox() {
                    angular.element('#userSearchBox').addClass('typeInput').removeClass('typeClear');
                    angular.element('#userSearchBoxInput').focus();
                };

                // User 검색 상자 비활성화
                $scope.doDeactivateUserSearchBox = function doDeactivateUserSearchBox() {
                    angular.element('#userSearchBox').removeClass('typeInput').removeClass('typeClear');
                    $scope.userSearchWord = undefined;
                };

                // Input Control Focus Out �태�때 검�상�� 공백�라�비활�화
                angular.element('#userSearchBoxInput').on('focusout', function () {
                    if (!$scope.userSearchWord || !$scope.userSearchWord.length) {
                        angular.element('#userSearchBox').removeClass('typeInput').removeClass('typeClear');
                    }
                });

                // User Group Tree Handler -end-

                $scope.init = function () {
                    UserAgent.getUserGroupRecursiveData('inWidget').then(function success(data) {
                        $scope.UserGroupTreeData = data;
                        if ($scope.selectedUserGroup == null && $scope.doSelectUserGroup != null) {
                            $scope.doSelectUserGroup($scope.UserGroupTreeData[0]);
                        }
                    });
                };
            }],

            link: function ($scope, $element, $attrs) {

                $element.on('focusin', function () {
                    if (!$scope.UserGroupTreeData) {
                        $element.blur();
                        return false;
                    }
                    $element.addClass('open');
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                });
            }
        };
    });

    app.directive('ngbssCollapsibleBox', function () {
        return {
            restrict: 'AC',
            link: function ($scope, $element, $attrs) {

                $element.on('click', function () {
                    console.log('a.formBox click');
                    if (event == undefined) {
                        return false;
                    }
                    if (event.preventDefault) {
                        event.preventDefault();
                    }
                    var target = event.target || (event.srcElement || document);

                    var collapsibleBox = angular.element(target).parents('.formBox');
                    //.btnFormEdit 가 없거나 있다하더라고 숨김일 경우에 동작
                    if (collapsibleBox.find('.btnFormEdit').length <= 0 || collapsibleBox.find('.btnFormEdit').hasClass('ng-hide')) {
                        if (collapsibleBox.find('.invisibleCnt').length > 0) {
                            collapsibleBox.find('.invisibleAct, .invisibleCnt').toggleClass('open');
                        } else {
                            collapsibleBox.toggleClass('formBoxClose');
                        }
                    }
                });
            }
        };
    });

    app.directive('ngbssCollapsibleSubBox', function () {
        return {
            restrict: 'AC',
            link: function ($scope, $element, $attrs) {

                $element.on('click', function (event) {
                    console.log('a.subBox click');
                    if (event == undefined) {
                        return false;
                    }
                    if (event.preventDefault) {
                        event.preventDefault();
                    }
                    var target = event.target || (event.srcElement || document);

                    angular.element(target).parents('.subBox').find('.subBoxAct, .subBoxCnt').toggleClass('open');
                });
            }
        };
    });

    app.directive('ngbssEditableBox', function () {
        return {
            restrict: 'AC',
            link: function ($scope, $element, $attrs) {

                $element.on('click', function (event) {
                    if (event == undefined) {
                        return false;
                    }
                    if (event.preventDefault) {
                        event.preventDefault();
                    }
                    var target = event.target || (event.srcElement || document);

                    $element.toggleClass('pressed');
                    var collapsibleBox = angular.element(target).parents('.formBox');
                    if (collapsibleBox.find('.invisibleCnt').length > 0) {
                        collapsibleBox.find('.invisibleAct, .invisibleCnt').toggleClass('open');
                    } else {
                        collapsibleBox.toggleClass('formBoxClose');
                    }
                });
            }
        };
    });

    app.directive('ngbssBatchEditButton', function () {
        return {
            restrict: 'AC',
            scope: {
                ngModel: '='
            },
            link: function ($scope, $element, $attrs) {

                $scope.safeApply = function (fn) {
                    var phase = this.$root.$$phase;
                    if (phase == '$apply' || phase == '$digest') {
                        if (fn && (typeof(fn) === 'function')) {
                            fn();
                        }
                    } else {
                        this.$apply(fn);
                    }
                };

                if (!$element.hasClass('btnFormEdit')) {
                    $element.addClass('btnFormEdit');
                }

                if ($scope.ngModel != undefined) {
                    if ($scope.ngModel) {
                        $element.addClass('pressed');
                    } else {
                        $element.removeClass('pressed');
                    }
                }

                $element.on('click', function (event) {
                    if (event == undefined) {
                        return false;
                    }
                    if (event.preventDefault) {
                        event.preventDefault();
                    }

                    $element.toggleClass('pressed');
                    $scope.safeApply(function () {
                        $scope.ngModel = $element.hasClass('pressed');
                    });
                });
            }
        };
    });

    app.directive('ngbssOutputSignalSelectBox', ['UUID', 'API', '$timeout', 'MessageProperties', 'MessageService', function (UUID, API, $timeout, MessageProperties, MessageService) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '='
            },
            template: '<div class="select" >' +
                '<a href="javascript:void(null);">' +
                '<span ng-show="ngModel">{{ ngModel.name || SignalMap[ngModel.id]}}</span>' +
//                '<span ng-show="!ngModel" ng-label="common.chooseAnItem"></span>' +
                '</a>' +
                '<div> ' +
                '<p class="searchSelect" id="searchBox_{{ boxId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
//                '<span ng-label="common.chooseAnItem"></span> ' +
                '<input type="text" id="searchBoxInput_{{ boxId }}" ng-model="searchWord" placeholder="">' +
                '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="searchOpen()">search</a>' +
                '<a href="javascript:void(null);" class="btnClose" data-ng-click="searchClose();">' +
                '<img src="images/common/btn_search_close.png" alt="close">' +
                '</a>' +
                '</p>' +
                '<ul class="selectList"> ' +
                '<li ' +
                'style="line-height: 2.3em;" ' +
                'ng-repeat="item in filtered = (SignalList | listFilter:searchWord:\'name\')" ' +
                'ng-class="{\'selection\':ngModel.id == item.id}" ng-click="selectItem(item)"' +
                '><span class="ellipsislabel" title="{{item.name}}">{{ item.name }}</span>' +
                '<b class="edit" style="float: right;">' +
                '<a href="javascript:void(null)" class="iconEdit" ng-click="editItem(item)" style="margin-right: 0.5em;">' +
                '<img src="images/common/icon_edit.png" alt="Edit">' +
                '</a>' +
                '<a href="javascript:void(null)" class="iconDelete" ng-click="deleteItem(item)">' +
                '<img src="images/common/icon_delete.png" alt="Delete">' +
                '</a>' +
                '</b>' +
                '</li> ' +
                '<li ng-if="filtered.length == 0"><span ng-label="validate.notFound"></span></li>' +
                '</ul> ' +
                '<p class="sm-btn">' +
                '<a href="javascript:void(null);" class="btnColorPoint"' +
                'ng-click="doOpenOutputSignalEditDlg()" ng-label="common.addSignal"></a>' +
                '</p>' +
                '<div data-ng-include src="outputSignalEditDlg.url" onload="doAfterOpenOutputSignalEditDlg()"></div>' +
                '</div>',

            link: function ($scope, $element, $attrs) {

                $scope.boxId = UUID();

                $scope.selectedItemArray = [];

                $scope.listSearchYn = false;
                function initBox() {
                    angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                    $element.trigger('blur');
                }

                $scope.searchOpen = function searchOpen() {
                    angular.element('#searchBox_' + $scope.boxId).addClass('typeInput').removeClass('typeClear');
                    angular.element('#searchBoxInput_' + $scope.boxId).focus();
                };

                $scope.searchClose = function searchClose() {
                    angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                    $scope.searchWord = undefined;
                };

                $timeout(function () {
                    // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                    angular.element('#searchBoxInput_' + $scope.boxId).on('focusout', function () {
                        if (!$scope.searchWord || !$scope.searchWord.length) {
                            angular.element('#searchBox_' + $scope.boxId).removeClass('typeInput').removeClass('typeClear');
                        }
                    });
                }, 50);

                function generateList() {
                    $element.attr('tabindex', '-1');
                }

                function reloadOutputSignalList() {
                    API.get('setting/output_signals').then(function (data) {
                        $scope.SignalList = data.OutputSignalCollection.rows;

                        $scope.SignalMap = {};
                        for (var i = data.OutputSignalCollection.rows.length; i--;) {
                            $scope.SignalMap[data.OutputSignalCollection.rows[i].id] = data.OutputSignalCollection.rows[i].name;
                        }
                    });
                }

                $scope.$watch('SignalList', function (nv, ov) {
                    if (nv !== ov) {
                        console.log('genrateSingalList');
                        generateList();
                    }
                });

                $scope.selectItem = function (item) {
                    var event = window.event,
                        target = event.target || (event.srcElement || document);

                    if (target.nodeName == 'A' || target.nodeName == 'IMG') {
                        return false
                    }

//                    $scope.ngModel = {id: item.id, name: item.name};
                    $scope.ngModel = angular.copy(item);
                    $element.blur();
                };

                $scope.editItem = function (item) {
                    window.sessionStorage.setItem('currSelectSignalItem', angular.toJson(item));
                    $scope.$emit('OpenOutputSignalEditDlg');
                };

                $scope.deleteItem = function (item) {
                    MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                        if (confirmYn) {
                            API.del('setting/output_signals' + '/' + item.id).then(function (data) {
                                reloadOutputSignalList();
                            });
                        }
                    });
                };

                $element.find('#listSearchBox').on('keypress', function (event) {
                    if (event.keyCode == 13) {
                        if (event.preventDefault) event.preventDefault();
                        if (event.returnValue) event.returnValue = false;
                        return false;
                    }
                });

                $element.on('focusin', function () {
//                    if (!$scope.SignalList) {
//                        $element.blur();
//                        return false;
//                    }
                    $element.addClass('open');
                    $scope.searchWord = undefined;
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                    $scope.searchWord = undefined;
                });

                $scope.SignalList = undefined;
                reloadOutputSignalList();

                $scope.outputSignalEditDlg = {};
                $scope.doOpenOutputSignalEditDlg = function () {
                    var outputSignalEditDlg = {};
                    outputSignalEditDlg.url = 'modules/accessControl/dialog/door-output-signal-add-dlg.html';
                    $scope.outputSignalEditDlg = outputSignalEditDlg;
                };

                $scope.$on('CloseOutputSignalEditDlg', function () {
                    $scope.outputSignalEditDlg = {};
                    angular.element('#addNewOutputSignalDlg').dialog('destroy');

                    API.get('setting/output_signals').then(function (data) {
                        $scope.SignalList = data.OutputSignalCollection.rows;
                    });
                });
                $scope.$on('OpenOutputSignalEditDlg', function () {
                    $scope.doOpenOutputSignalEditDlg();
                });

                $scope.doAfterOpenOutputSignalEditDlg = function () {
                    var options = {};
                    options.modal = true;
                    options.shadow = false;
                    options.border = false;
                    options.title = MessageProperties.get("triggerAction.addNewSignal");
                    options.width = 600;
                    options.height = 'auto';

                    options.onClose = function () {
                        $scope.$apply(function () {
                            $scope.outputSignalEditDlg = {url: ''};
                            angular.element('#addNewOutputSignalDlg').dialog('destroy');
                        });
                    };

                    angular.element("#addNewOutputSignalDlg").dialog(options);
                };
            }
        }
    }]);

    app.directive('ngbssUserSearchBox', ['UserAgent', 'MessageService', 'MessageProperties', 'UUID', 'API', 'Const', 'Util', function (UserAgent, MessageService, MessageProperties, UUID, API, Const, Util) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                disabledYn: '=',
                hideAddButton: '@'
            },
            templateUrl: 'modules/common/ngbssUserSearchBox.html',
            link: function ($scope, $element, $attrs) {
                var i;

                var userListLimit = Const.SELECT_LIST_ITEM_LIMIT, userListOffset = 0, userOriginList, userOriginTotal;

                $scope.searchBoxId = UUID();
                $scope.checkedUserItem = [];

                if ($scope.hideAddButton != undefined && $scope.hideAddButton == 'true') {
                    $scope.hideAddButton = true;
                } else {
                    $scope.hideAddButton = false;
                }

                if ($scope.ngModel && $scope.ngModel.length > 0) {
                    for (i = $scope.ngModel.length; i--;) {
                        $scope.checkedUserItem.push($scope.ngModel[i].user_id);
                    }
                }

                $scope.$watch('ngModel', function (nv, ov) {

                    if (!$scope.ngModel) {
                        $scope.ngModel = [];
                        $scope.checkedUserItem = [];
                    }

                    if (angular.equals(nv, ov) == false) {
                        $scope.checkedUserItem = [];
                        if ($scope.ngModel && $scope.ngModel.length > 0) {
                            for (i = $scope.ngModel.length; i--;) {
                                $scope.checkedUserItem.push($scope.ngModel[i].user_id);
                            }
                        }
                    }
                }, true);

                function userSearchLoad() {
                    API.get('users', 'userSearchLoad', {limit: userListLimit, offset: userListOffset, query: $scope.userSearchWord}, null, null, null, false).then(function success(data) {
                        $scope.UserListData = data.UserCollection.rows;
                        $scope.userListTotal = data.UserCollection.total;
                        if (data.UserCollection.total == 0) {
                            $scope.UserListData = angular.copy(userOriginList);
                        }
                    });
                }

                $scope.filtered = [];
                $scope.userListTotal = null;
                $scope.$watch('filtered ', function (nv, ov) {
                    if (nv != ov) {
                        if ($scope.filtered.length == 0) {
                            userSearchLoad();
                        }
                    }
                }, true);

                $scope.$watch('userSearchWord', function (nv, ov) {
                    if (angular.isDefined(nv) && angular.isDefined(ov)) {
                        if (nv.length < ov.length) {
                            userSearchLoad();
                        }
                    }
                });

                $scope.moreDataShowCondition = function () {
                    if ($scope.UserListData && $scope.userListTotal != $scope.UserListData.length) {
                        if ($scope.noDataShowCondition()) {
                            return false;
                        } else {
                            return true;
                        }
                    } else {
                        return false;
                    }
                };

                $scope.noDataShowCondition = function () {
                    if ($scope.filtered.length == 0) {
                        return true;
                    } else if ($scope.filtered.length > 0 && $scope.checkedUserItem.length > 0) {
                        var checkedUserItemListInFilteredItemsCount = 0;

                        for (var i = 0; i < $scope.filtered.length; i++) {
                            if ($scope.checkedUserItem.indexOf($scope.filtered[i].user_id) > -1) {
                                checkedUserItemListInFilteredItemsCount++;
                            }
                        }

                        return $scope.filtered.length == checkedUserItemListInFilteredItemsCount;
                    } else {
                        return false;
                    }
                };

                // User Add 버튼
                $scope.doAddUser = function doAddUser() {
                    if ($scope.disabledYn == true) {
                        return;
                    }

                    $element.find('#' + $scope.searchBoxId + '').removeClass('typeInput').removeClass('typeClear');
                    $scope.userSearchWord = undefined;
                    userSearchLoad();

                    $element.find('.listForUserAddArea').focusin();
                    $element.find('.listForUserAddArea').focus();
                };

                $scope.doDeleteUserInCheckList = function doDeleteUserInCheckList(item) {

                    if ($scope.disabledYn == true) {
                        return;
                    }

                    MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                        if (confirmYn) {
                            var idx = -1;
                            for (i = $scope.ngModel.length; i--;) {
                                if (item.user_id == $scope.ngModel[i].user_id) {
                                    idx = i;
                                }
                            }
                            if (idx > -1) {
                                $scope.ngModel.splice(idx, 1);
                                $scope.checkedUserItem.splice($scope.checkedUserItem.indexOf(item.user_id), 1);
                            }
                            if (!$scope.$root.$$phase) $scope.$apply();
                        }
                    });
                };

                $scope.doCheckUserItem = function (user) {
                    var idx,
                        event = window.event;

                    idx = $scope.checkedUserItem.indexOf(user.user_id);
                    if (idx > -1) {
                    } else if (idx == -1) {
                        $scope.ngModel.push({id: user.user_id, user_id: user.user_id, name: user.name || ''});
                    }
                    $element.find('.listForUserAddArea').focus();
                };

                $element.find('.listForUserAddArea').on('focusin', function () {
                    console.log('focusin');
                    $element.find('.listForUserAddArea').removeClass('hide')
                });
                if ($scope.hideAddButton == false) {
                    $element.find('.listForUserAddArea').on('focusout', function () {
                        console.log('focusout');
                        $element.find('.listForUserAddArea').addClass('hide');
                    });
                }
                // User 검색 상자 활성화
                $scope.doActivateUserSearchBox = function doActivateUserSearchBox() {
                    $element.find('#' + $scope.searchBoxId + '').addClass('typeInput').removeClass('typeClear');
                    $element.find('#' + $scope.searchBoxId + 'Input').focus();
                };

                // User 검색 상자 비활성화
                $scope.doDeactivateUserSearchBox = function doDeactivateUserSearchBox() {
                    $element.find('#' + $scope.searchBoxId + '').removeClass('typeInput').removeClass('typeClear');
                    $scope.userSearchWord = undefined;
                    userSearchLoad();
                    $scope.doAddUser();
                };

                // Input Control Focus Out 상태일때 User 검색상자가 공백이라면 비활성화
                $element.find('#' + $scope.searchBoxId + 'Input').on('focusout', function () {
                    if (!$scope.userSearchWord || !$scope.userSearchWord.length) {
                        $element.find('#' + $scope.searchBoxId + '').removeClass('typeInput').removeClass('typeClear');
                    }
                });
                if ($scope.hideAddButton == true) {
                    $element.find('.tableADD').hide();
                    $scope.doAddUser();
                }
            }
        }
    }]);

    app.directive('ngbssTimeZoneSelectboxTypeList', ['$compile', 'API', 'Const', function ($compile, API, Const) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                timeZoneList: '=?',
                disabledYn: '='
            },
            template: '<div class="select " ng-class="{\'disabled\': !timeZoneList || disabledYn == true}" tabindex="-1"> ' +
                '<a href="javascript:void(null);">' +
//                '<span ng-show="!timeZoneList">Waiting...</span>' +
//                '<span ng-show="!ngModel && timeZoneList" ng-label="common.chooseAnItem"></span>' +
                '<span ng-show="ngModel && timeZoneList">{{ timeZoneList[ngModel.id].name }}</span>' +
                '</a> ' +
                '<div class="scroll scrollY" style="max-height: 30em; min-width: 40em;"> ' +
                '<ul class="selectList"> ' +
                '<li ng-repeat="item in timeZoneList" ng-class="{\'selection\':ngModel.id == item.id}" ng-click="selectItem(item)">{{ item.name }}</li> ' +
                '</ul> ' +
                '</div> ' +
                '</div>',
            link: function ($scope, $element, $attrs) {

                $scope.thisTime = new Date();
//                Util.debug($scope.thisTime);

                if ($scope.timeZoneList == undefined || $scope.timeZoneList.length <= 0) {
                    $scope.timeZoneList = Const.TIMEZONE_OPTIONS;
                }

//                $element.parent()
//                    .append('<div id="testTimeZone" style="position: fixed; right: 13em; top: 21.2em; width: 40em;" class="select selectTypeA">' +
//                        '<a>{{ thisTime }}</a>' +
//                        '</div>');
//
//                $compile(angular.element('#testTimeZone'))($scope);

                $scope.selectItem = function (item) {
                    if (item) {
                        $scope.ngModel = item;
                    } else {
                        $scope.ngModel = undefined;
                    }
                    $element.trigger('blur');
                };

                $element.on('focusin', function () {
                    if (!$scope.timeZoneList || $scope.disabledYn) {
                        $element.trigger('blur');
                        return false;
                    }
                    $element.addClass('open');
                });

                $element.on('focusout', function () {
                    $element.removeClass('open');
                });

//                $scope.$watch('ngModel', function (nv, ov) {
//                    if (nv != ov) {
//                        console.log(nv);
//                    }
//                })
            }
        }
    }]);

    app.directive('ngbssSplitter', ['Util', function (Util) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
            },
            template: '<button href="javascript:void(0);" class="splitterRight" ng-click="splitterClicked()"></button>',

            link: function ($scope, $element, $attrs) {

                $scope.selectedItemArray = [];

                $scope.splitterClicked = function () {
                    Util.resizeLeftTreeWidth();
                };
            }
        }
    }]);

    app.directive('ngbssNumberSpinner', ['$rootScope', '$timeout', 'UUID', '$filter', 'Const', 'MessageProperties', function ($rootScope, $timeout, UUID, $filter, Const, MessageProperties) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '=',
                minValue: '=',
                maxValue: '=',
                width: '=',
                height: '=',
                defaultValue: '=',
                disabledYn: '='
            },
            template: '<input id="{{spinnerID}}" type="text" ' +
                'class="input" ng-class="{\'disabled\': disabledYn}" >',
            controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {
                // ---------------------- Time Spinner s ----------------------
                $scope.spinnerID = $attrs['inputId'] || UUID();

                var numberspinnerOption = {
                    min: 0,
                    max: parseInt($scope.maxValue),
//                    width: $scope.width,
                    height: $scope.height || 29,
                    value: $scope.ngModel || $scope.defaultValue,
                    'onChange': function (evt) {
                        console.log('numberspinner: change');
                        if ($element.find('.spinner').hasClass('disabled')) {
                            return false;
                        }
                        console.log('numberspinner: onChange');
                        //$scope.ngModel이 undefined일 경우 onChange시 ngModel의 변화가 없는 문제가 있어 주석처리함 [bjh]
//                        if ($scope.ngModel) {
//                            console.log('old::' + $scope.ngModel);
                        $scope.ngModel = angular.element('#' + $scope.spinnerID).numberspinner('getValue').toString();
//                            console.log('changevalue', $scope.ngModel);
                        if (!$rootScope.$$phase) $scope.$apply();
//                        }
                    },
                    'onSpinDown': function (event) {
                        console.log('numberspinner: onSpinDown');
                        if ($element.find('.spinner').hasClass('disabled')) {
                            return false;
                        }
                        var spinValue = angular.element('#' + $scope.spinnerID).numberspinner('getValue');
                        if (spinValue < parseInt($scope.minValue)) {
                            angular.element('#' + $scope.spinnerID).numberspinner('setValue', parseInt($scope.minValue));
                            return false;
                        }
                    }
                };

                // ---------------------- Time Spinner e ----------------------
                $scope.$watch('disabledYn', function (nv, ov) {
                    if (nv === ov) return false;

                    if (angular.element('#' + $scope.spinnerID) != undefined && angular.element('#' + $scope.spinnerID).numberspinner() != undefined) {
                        if (nv) {
                            angular.element('#' + $scope.spinnerID).numberspinner('disable');
                        } else {
                            angular.element('#' + $scope.spinnerID).numberspinner('enable');
                        }
                    }
                    console.log(nv, ov);
                });

                $scope.$watch('ngModel', function (nv, ov) {
                    if (nv === ov || nv == null) return false;

                    if (nv) {
                        if (angular.element('#' + $scope.spinnerID).hasClass('numberspinner-f')) {
                            var spnrValue = angular.element('#' + $scope.spinnerID).numberspinner('getValue');
                            if (spnrValue != $scope.ngModel) {
                                angular.element('#' + $scope.spinnerID).numberspinner('setValue', $scope.ngModel);
                            }
                        } else {
                            numberspinnerOption.value = $scope.ngModel || $scope.defaultValue;
                        }

                    }
                    console.log('ngModel', nv, ov);
                });

                $timeout(function () {

                    angular.element('#' + $scope.spinnerID).numberspinner(numberspinnerOption)
                        .on('keyup', function ($event) {
                            if ($event.keyCode == 13) {
                                $element.find('.inputTime').blur();
                            }
                            console.log('numberspinner: keyup');
                        }).on('focusin', function (evt) {
                            console.log('focusin');
                            if ($element.find('.spinner').hasClass('disabled')) {
                                return false;
                            }
//                            if(angular.element('#' + $scope.spinnerID).hasClass()) {
//                                angular.element('#' + $scope.spinnerID).numberspinner({min:0,max:9999});
//                                angular.element('#' + $scope.spinnerID).focus();
//                            }
                            console.log('numberspinner.textbox: focusin');
                        }).on('focusout', function (evt) {
                            console.log('focusout');
                            if ($element.find('.spinner').hasClass('disabled')) {
                                return false;
                            }
                            var spinValue = angular.element('#' + $scope.spinnerID).numberspinner('getValue');
                            if (spinValue < parseInt($scope.minValue)) {
                                angular.element('#' + $scope.spinnerID).numberspinner('setValue', parseInt($scope.minValue));
                            }
//                            angular.element('#' + $scope.spinnerID).numberspinner({
//                                min: parseInt($scope.minValue),
//                                max: parseInt($scope.maxValue)
//                            });
                            console.log('numberspinner.textbox: focusout');
                        });

                    if ($scope.disabledYn) {
                        angular.element('#' + $scope.spinnerID).numberspinner('disable');
                    }

                }, 100);
            }]
        }
    }]);

    app.directive('ngbssPlaceholder', ['MessageProperties', function (MessageProperties) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
            },

            link: function ($scope, $element, $attrs) {

                if ($attrs.ngbssPlaceholder) {
                    $element.attr('placeholder', MessageProperties.get($attrs.ngbssPlaceholder));
                }
            }
        }
    }]);

    app.directive('ngbssNumberConvert', function () {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                ngModel: '='
            },

            link: function ($scope, $element, $attrs) {

                if ($scope.ngModel && typeof $scope.ngModel == 'string') {
                    var convertedValue = parseInt($scope.ngModel);
                    if (convertedValue.toString() != 'NaN') {
                        $scope.ngModel = convertedValue;
                    }
                }
            }
        }
    });

    app.directive('ngbssSortableColumn', ['Const', function (Const) {
        return {
            restrict: 'A',
            replace: true,
            require: '?ngModel',
            scope: {
                ngModel: '=?'
            },

            link: function ($scope, $element, $attrs) {

                $scope.safeApply = function (fn) {
                    var phase = this.$root.$$phase;
                    if (phase == '$apply' || phase == '$digest') {
                        if (fn && (typeof(fn) === 'function')) {
                            fn();
                        }
                    } else {
                        this.$apply(fn);
                    }
                };
                $element.css('cursor', 'pointer');

                $element.on('click', function () {
                    if ($element.parents('th[field]').length > 0) {
                        $scope.ngModel.field = $element.parents('th[field]').attr('field');
                    }
                    if ($element.hasClass('datagrid-sort-desc')) {
                        $element.removeClass('datagrid-sort-desc').addClass('datagrid-sort-asc');
                        $scope.ngModel.direction = Const.SORTING_DIRECTION.ASCEND;
//                    } else if ($element.hasClass('datagrid-sort-asc')) {
//                        $scope.ngModel.field = '';
//                        $element.removeClass('datagrid-sort-desc').removeClass('datagrid-sort-asc');
//                        $scope.ngModel.direction = Const.SORTING_DIRECTION.NONE;
                    } else {
                        $element.removeClass('datagrid-sort-asc').addClass('datagrid-sort-desc');
                        $scope.ngModel.direction = Const.SORTING_DIRECTION.DESCEND;
                    }
                    $element.parents('tr').find('.datagrid-sort-asc, .datagrid-sort-desc').not($element)
                        .removeClass('datagrid-sort-desc').removeClass('datagrid-sort-asc');
                    $scope.safeApply();
                    console.log('$scope.ngModel.direction:', $scope.ngModel.direction, ' $scope.ngModel.field:', $scope.ngModel.field);
                });
            }
        }
    }]);

    return app;
});
