'use strict';

define([
        'modules/common/services/monitoringAgent',
        'modules/common/alert/alertListService',
        'modules/common/alert/alertService',
        'modules/common/alert/alertListController'
    ],
    function () {
        var app = angular.module('biostarWebApp');
        app.register.controller('DashboardController', ['$scope', 'Const', 'API', 'MessageProperties', 'DialogService', '$location', '$window', '$timeout', function ($scope, Const, API, MessageProperties, DialogService, $location, $window, $timeout) {
            var i,
                SystemStatus = function (systemStatus) {
                    var name,
                        point,
                        total;
                    if (systemStatus) {
                        name = systemStatus.name;
                        point = systemStatus.point;
                        total = systemStatus.total;
                    }
                    return {
                        name: name,
                        point: point,
                        total: total
                    };
                },
                OVERVIEW_DEFAULT_TAB = 0,
                ALERT_COLOR = ['#ff6657', '#ffb164', '#d3d041', '#72c8cd'],
                ALERT_COLOR_TYPE = ['colorType1', 'colorType2', 'colorType3', 'colorType4'],
                ALERT_COLOR_POINT = ['#ff3e25', '#ff8c1a', '#ddd903', '#52dde5'],
                dashboardReloadPromise;

            $scope.doOpenNoticeItemDlg = function (item){
                var dialogOptions = {
                    divId: 'NoticeDlg',
                    title: item.name,
                    width: 520,
                    hideCancelButton : true,
                    okButtonCallback: function () {
                        DialogService.closeDialog(dialogOptions);
                    },
                    cancelButtonCallback: function () {
                        DialogService.closeDialog(dialogOptions);
                    },
                    content: item.description
                };
                DialogService.openDialog(dialogOptions);


            };
            $scope.doChangUrlStatus = function (url) {
                if (url === undefined) return false;
                $location.path(url);
            };
//            monitoring status url
            $scope.OVERVIEW_TAB_LABEL = [
                'year',
                'month',
                'week'
//                'day'
            ]
            $scope.overviewScopeTitle;
            $scope.overviewTotal = 0;
//            $scope.alertListUrl;
//            $scope.$watch('alertListUrl', function () {
//                console.log('titleAct', $('#alertListPopupDiv').length)
//            }, true);

//            overview total watch
            $scope.$watch('overviewDoughnutGraphData', function () {
                var i;
                $scope.overviewTotal = 0;
                for (i = $scope.overviewDoughnutGraphData.length; i--;) {
                    $scope.overviewTotal += $scope.overviewDoughnutGraphData[i].value;
                }
            }, true);

//            overview currentTab
            $scope.overviewCurTab = 0;//year
            $scope.doOverviewTabClick = function (index) {
                var i,
                    j,
                    itrMax,
                    prevYear,
                    prevMonth,
                    prevWeekDay,
                    prevMonthDay,
                    prevSaturday,
                    isPrevYear = false,
                    isPrevMonth = false,
                    isPrevPrevMonth = false,
                    isPrevDay = false,
                    startDay,
                    targetDay,
                    targetWeek,
                    targetMonth,
                    targetYear,
                    curDate = new Date(),
//                    curDate = new Date('10/1/2014'),
                    group_id = 0,
                    monthArr = Const.SIMPLE_MONTH_TEXT,
                    monthFullNameArr = Const.FULL_MONTH_TEXT,
                    weekDayArr = Const.FULL_DAYS_TEXT,
                    totalGraphUnit = 0;
                function getWeek(date) {
//                    var newDate = (date !== undefined)? date : new Date(),
                    var newDate = (date !== undefined)? date : curDate,
                        onejan = new Date(newDate.getFullYear(),0,1);
                    return Math.ceil((((newDate - onejan) / 86400000) + onejan.getDay())/7)-1;
                }
                prevMonth = new Date();
                prevMonth.setMonth(curDate.getMonth(), 0);
                prevMonthDay = prevMonth.getDate();
                prevWeekDay = curDate.getDate() - 7;
                $scope.overviewCurTab = index;
                $scope.overviewLineGraphData.labels = [];
                $scope.overviewLineGraphData.datasets = [
                    {
                        label: "ABP Fail",
                        fillColor: "rgba(220,220,220,0)",
                        strokeColor: ALERT_COLOR[0],
                        pointColor: ALERT_COLOR_POINT[0],
                        pointStrokeColor: "#fff",
                        pointHighlightFill: "#fff",
                        pointHighlightStroke: "rgba(220,220,220,1)",
                        data: [] // currently empty will contain all the data points for bills
                    },
                    {
                        label: "Disable",
                        fillColor: "rgba(151,187,205,0)",
                        strokeColor: ALERT_COLOR[1],
                        pointColor: ALERT_COLOR_POINT[1],
                        pointStrokeColor: "#fff",
                        pointHighlightFill: "#fff",
                        pointHighlightStroke: "rgba(151,187,205,1)",
                        data: [] // currently empty will contain all the data points for bills
                    },
                    {
                        label: "Blacklisted",
                        fillColor: "rgba(151,187,205,0)",
                        strokeColor: ALERT_COLOR[2],
                        pointColor: ALERT_COLOR_POINT[2],
                        pointStrokeColor: "#fff",
                        pointHighlightFill: "#fff",
                        pointHighlightStroke: "rgba(151,187,205,1)",
                        data: [] // currently empty will contain all the data points for bills
                    },
                    {
                        label: "Etc",
                        fillColor: "rgba(151,187,205,0)",
                        strokeColor: ALERT_COLOR[3],
                        pointColor: ALERT_COLOR_POINT[3],
                        pointStrokeColor: "#fff",
                        pointHighlightFill: "#fff",
                        pointHighlightStroke: "rgba(151,187,205,1)",
                        data: [] // currently empty will contain all the data points for bills
                    }
                ];
                switch ($scope.OVERVIEW_TAB_LABEL[index]) {
                    case 'year':
                        group_id = 2;
//                        line
                        $scope.overviewLineGraphData.labels = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
                        break;
                    case 'month':
                        if (curDate.getMonth() === 0
                            && curDate.getDate() < 29) {
                            isPrevYear = true;
                        }
                        group_id = 1;
//                        line(일간)
//                        for (i = 0; i < 5; i++) {
//                            if (!isPrevMonth) {
//                                targetDay = curDate.getDate() - i;
//                            } else {
//                                --targetDay;
//                            }
//                            if (targetDay === 0) {
//                                targetDay = prevMonthDay;
//                                isPrevMonth = true;
//                            }
//                            $scope.overviewLineGraphData.labels.push(targetDay);
//                        }
//                        오늘부터 5주간 간격 토요일 날자 구함
                        for (i = 0, itrMax = 5; i < itrMax; i++) {
                            if (isPrevMonth) {
                                if (curDate.getMonth()-1 < 0) {
                                    targetMonth = monthFullNameArr[monthFullNameArr.length -1];
                                    isPrevYear = true;
                                } else {
                                    targetMonth = monthFullNameArr[prevMonth.getMonth()];
                                }
                            } else {
                                targetMonth = monthFullNameArr[curDate.getMonth()];
                            }
                            if (i === 0) {
                                targetDay = curDate.getDate();
                                prevSaturday = curDate.getDate() - curDate.getDay() -1;
                            } else {
                                targetDay = prevSaturday;
                                prevSaturday = prevSaturday - 7;
                            }
                            if (prevSaturday <= 0) {
                                if (isPrevMonth) {
                                    targetMonth = monthFullNameArr[prevMonth.getMonth()];
                                    prevMonth = angular.copy(prevMonth);
                                    prevMonth.setMonth(prevMonth.getMonth(), 0);
                                    prevMonthDay = prevMonth.getDate();
                                }
                                isPrevMonth = true;
                                prevSaturday = prevMonthDay + prevSaturday;
                            }
                            $scope.overviewLineGraphData.labels.push(targetDay + ' ' + targetMonth);
                        }
                        startDay = prevSaturday + 1;
//                        $scope.overviewLineGraphData.labels = ['this week', '1 weeks ago', '2 weeks ago', '3 weeks ago', '4 weeks ago']
                        break;
                    case 'week':
                        if (curDate.getMonth() === 0 && getWeek() === 0) {
                            isPrevYear = true;
                        }
                        group_id = 0;
//                        line
                        targetDay = curDate.getDate();
                        for (i = 0; i < 7; i++) {
                            if (targetDay === 0) {
                                targetDay = prevMonthDay;
                                isPrevMonth = true;
                            }
                            $scope.overviewLineGraphData.labels.push(MessageProperties.get('common.dashboard.dayDate', targetDay));
                            if (i < 6) {
                                --targetDay;
                            }
                        }
                        startDay = targetDay;
                        break;
                    case 'day':
//                        line
                        targetDay = curDate.getHours();
                        for (i = 0; i < 24; i++) {
                            $scope.overviewLineGraphData.labels.push(targetDay);
                            --targetDay;
                            if (targetDay === 0) {
                                targetDay = 24;
                            }
                        }
                        break;
                    default:
                        break;
                }
                totalGraphUnit = $scope.overviewLineGraphData.labels.length;
                API.get('dashboard/alert_statistic?' + 'group_id=' + group_id).then(function (data) {
                    var datasetsKeyArr = [],
                        item,
                        graphDataArr = [],
                        AlertStatisticCollection,
                        chkMaxValue = 0,
                        targetValue = 0,
                        chkDigit,
                        chkYearItr,
                        limit,
                        chkEtc = 0,
                        k = 0,
                        labelsArr = [],
                        curEventName = '',
                        Top3EventLabel = [],
                        chkTop3EventName = 0;
//                    console.log('group_id='+group_id)
//                    console.log(data.AlertStatisticCollection.rows);
                    switch ($scope.OVERVIEW_TAB_LABEL[index]) {
                        case 'year':
							var startMonth, startYear, endMonth, endYear;

                            if (curDate.getMonth() === $scope.overviewLineGraphData.labels.length -1) {
								startMonth = monthFullNameArr[0];
								startYear = curDate.getFullYear();
                            } else {
								startMonth = monthFullNameArr[curDate.getMonth() + 1];
								startYear = (parseInt(curDate.getFullYear()) - 1);
                            }
							endMonth =  monthFullNameArr[curDate.getMonth()];
							endYear =  curDate.getFullYear();
							$scope.overviewScopeTitle = MessageProperties.get('common.dashboard.periodType.mmyyyy', startMonth, startYear, endMonth, endYear);

//                        line
                            $scope.overviewLineGraphData.labels = [];
                            targetMonth = curDate.getMonth();
                            for (i = 0, itrMax = monthArr.length; i < itrMax; i++) {
                                graphDataArr[i] = undefined;//init graph data
                                $scope.overviewLineGraphData.labels.push(monthArr[targetMonth]);
                                //api로 불러온 데이터의 키값 배열
                                datasetsKeyArr.push(
                                    ((!isPrevYear)? curDate.getFullYear() : parseInt(curDate.getFullYear()) -1)
                                    + ('0' + (targetMonth+1)).slice(-2));
                                if (targetMonth === 0) {
                                    targetMonth = monthArr.length - 1;
                                    isPrevYear = true;
                                } else {
                                    --targetMonth;
                                }
                            }
                            break;
                        case 'month':
							var startMonth = ((isPrevMonth)? monthFullNameArr[prevMonth.getMonth()] : monthFullNameArr[curDate.getMonth()]),
								startYear = ((isPrevYear)? (parseInt(curDate.getFullYear()) - 1) : curDate.getFullYear()),
								endDay = curDate.getDate(),
								endMonth = monthFullNameArr[curDate.getMonth()],
								endYear = curDate.getFullYear();

							$scope.overviewScopeTitle = MessageProperties.get('common.dashboard.periodType.ddmmyyyy', startDay, startMonth, startYear, endDay, endMonth, endYear);

                            isPrevYear = false;
                            chkYearItr = 0;
                            for (i = 0, itrMax = 5; i < itrMax; i++) {
                                graphDataArr[i] = undefined;//init graph data
                                targetWeek = parseInt(getWeek(curDate));
                                if (chkYearItr == 0) {
                                    if (targetWeek - i < 1) {
                                        targetWeek = parseInt(getWeek(prevMonth));
                                        isPrevYear = true;
                                        ++chkYearItr;
                                    } else {
                                        targetWeek = parseInt(getWeek(curDate)) - i;
                                    }
                                } else {
                                    targetWeek = parseInt(getWeek(prevMonth)) - (chkYearItr++);
                                }
                                targetWeek = targetWeek.toString();
                                if (targetWeek.length < 2) {
                                    targetWeek = '0' + targetWeek;
                                }
                                if (!isPrevYear) {
                                    targetYear = curDate.getFullYear();
                                } else {
                                    targetYear = curDate.getFullYear() -1;
                                }
                                datasetsKeyArr.push( targetYear + targetWeek)
                            }
                            break;
                        case 'week':
							var startMonth = ((isPrevMonth)? monthFullNameArr[prevMonth.getMonth()] : monthFullNameArr[curDate.getMonth()]),
								startYear = ((isPrevYear)? (parseInt(curDate.getFullYear()) - 1) : curDate.getFullYear()),
								endDay = curDate.getDate(),
								endMonth = monthFullNameArr[curDate.getMonth()],
								endYear = curDate.getFullYear();

							$scope.overviewScopeTitle = MessageProperties.get('common.dashboard.periodType.ddmmyyyy', startDay, startMonth, startYear, endDay, endMonth, endYear);

                            targetYear = curDate.getFullYear();
                            targetMonth = curDate.getMonth();
                            targetDay = curDate.getDate();
                            for (i = 0, itrMax = 7; i < itrMax; i++) {
                                graphDataArr[i] = undefined;//init graph data
                                datasetsKeyArr[i] = targetYear;
                                if(targetDay === 0) {
                                    targetDay = prevMonthDay;
                                    if (targetMonth === 0) {
                                        targetYear = parseInt(curDate.getFullYear()) -1;
                                        datasetsKeyArr[i] = targetYear;
                                        targetMonth = 11;
                                    } else {
                                        --targetMonth;
                                    }
                                    datasetsKeyArr[i] += ('0' + (targetMonth+1)).slice(-2)
                                    + ('0' + targetDay).slice(-2);
                                    --targetDay;
                                } else {
                                    datasetsKeyArr[i] += ('0' + (targetMonth+1)).slice(-2)
                                        + ('0' + targetDay).slice(-2);
                                    --targetDay;
                                }
                            }
                            break;
                        default:
                            break;
                    }
                    datasetsKeyArr.reverse();
                    $scope.overviewLineGraphData.labels.reverse();


                    AlertStatisticCollection = data.AlertStatisticCollection.rows;
                    for (i = AlertStatisticCollection.length; i--;) {
                        item = AlertStatisticCollection[i];
                        graphDataArr[datasetsKeyArr.indexOf(item.id)] = item;
                    }
//                            get top3 event name
                    for (i = 0; i < datasetsKeyArr.length; i++) {
                        if (AlertStatisticCollection[i] && AlertStatisticCollection[i].top3_event !== undefined) {
                            for (j = AlertStatisticCollection[i].top3_event.length; j--;) {
                                if (AlertStatisticCollection[i].top3_event[j].event_type_id.name === undefined) {
                                    curEventName = AlertStatisticCollection[i].top3_event[j].event_type_id.code;
                                } else {
                                    curEventName = AlertStatisticCollection[i].top3_event[j].event_type_id.name;
                                }
                                if (Top3EventLabel.length === 0) {
                                    Top3EventLabel.push(curEventName);
                                } else{
                                    chkTop3EventName = 0;
                                    for (k = 0; k < Top3EventLabel.length; k++) {
                                        if (Top3EventLabel[k] !== curEventName) {
                                            ++chkTop3EventName;
                                        }
                                    }
                                    if (chkTop3EventName === k) {
                                        Top3EventLabel.push(curEventName);
                                    }
                                }
                            }
                        }
                    }
                    $scope.overviewDoughnutGraphData = [];
                    chkMaxValue = 0;
                    Top3EventLabel.sort();
                    if (Top3EventLabel.length > 0) {
                        for (i = 0; i < Top3EventLabel.length+1; i++) {
                            $scope.overviewDoughnutGraphData[i] = {};
                            $scope.overviewDoughnutGraphData[i].value = 0;
                            $scope.overviewLineGraphData.datasets[i].data = [];
                            for (j = 0; j < datasetsKeyArr.length; j++ ) {
                                if (graphDataArr[j] !== undefined && graphDataArr[j].top3_event !== undefined) {
                                    chkEtc = 0;
                                    targetValue = 0;
                                    if (i < Top3EventLabel.length) {
                                        for (k = 0; k < graphDataArr[j].top3_event.length; k++) {
                                            if (graphDataArr[j].top3_event[k].event_type_id.name === Top3EventLabel[i]
                                                || graphDataArr[j].top3_event[k].event_type_id.code === Top3EventLabel[i]) {
                                                if (!labelsArr[i])  labelsArr[i] = Top3EventLabel[i];
                                                targetValue = parseInt(graphDataArr[j].top3_event[k].count);
                                            }
                                        }
                                        $scope.overviewLineGraphData.datasets[i].data[j] = targetValue;
                                        $scope.overviewDoughnutGraphData[i].value += targetValue
                                    }else {
                                        //etc 처리
                                        for (k = 0; k < 3; k++) {
                                            if ($scope.overviewLineGraphData.datasets[k].data[j]) {
                                                chkEtc += $scope.overviewLineGraphData.datasets[k].data[j];
                                            }
                                        }
                                        labelsArr[i] = 'etc';
                                        targetValue = parseInt(graphDataArr[j].count) - chkEtc;
                                        $scope.overviewLineGraphData.datasets[i].data[j] = targetValue;
                                        $scope.overviewDoughnutGraphData[i].value += targetValue;
                                    }
                                } else {
                                    targetValue = $scope.overviewLineGraphData.datasets[i].data[j] = 0;
                                }
                                if (targetValue > chkMaxValue) {
                                    chkMaxValue = targetValue;
                                }
                            }
                        }
                    }
//                    console.log($scope.overviewLineGraphData.datasets);
//                            top3 data init
//                    for (i = AlertStatisticCollection.length; i--;) {
//                        item = AlertStatisticCollection[i];
//                        graphDataArr[datasetsKeyArr.indexOf(item.id)] = item;
//                    }
//                    for (i = 0; i < 4; i++) {
//                        $scope.overviewLineGraphData.datasets[i].data = [];
//                        $scope.overviewDoughnutGraphData[i] = {};
//                        $scope.overviewDoughnutGraphData[i].value = 0;
//                        for (j = 0, itrMax = graphDataArr.length; j < itrMax; j++) {
//                            chkEtc = 0;
//                            if (graphDataArr[j] === undefined) {//데이터가 없을 경우
//                                $scope.overviewLineGraphData.datasets[i].data[j] = 0;
//                            } else {
//                                if (graphDataArr[j].top3_event[i]) {
//                                    targetValue = parseInt(graphDataArr[j].top3_event[i].count);
//                                    if (!labelsArr[i])  labelsArr[i] = graphDataArr[j].top3_event[i].event_type_id.name;
//                                    $scope.overviewLineGraphData.datasets[i].data[j] = targetValue;
//                                    $scope.overviewDoughnutGraphData[i].value += targetValue;
//                                    if (targetValue > chkMaxValue) {
//                                        chkMaxValue = targetValue;
//                                    }
//                                } else {
//                                    $scope.overviewLineGraphData.datasets[i].data[j] = 0;
//                                    $scope.overviewDoughnutGraphData[i].value += 0;
//                                }
//                                if (i === 3) {//etc처리
//                                    for (k = 0; k < 3; k++) {
//                                        if (!labelsArr[k]) {
//                                            labelsArr[k] = 0;
//                                        }
//                                        if ($scope.overviewLineGraphData.datasets[k].data[j]) {
//                                            chkEtc += $scope.overviewLineGraphData.datasets[k].data[j];
//                                        }
//                                    }
//                                    targetValue = parseInt(graphDataArr[j].count);
//                                    labelsArr[i] = 'etc';
////                                    $scope.overviewLineGraphData.datasets[i].data[j] = targetValue;
////                                    $scope.overviewDoughnutGraphData[i].value += targetValue;
//                                    $scope.overviewLineGraphData.datasets[i].data[j] = targetValue - chkEtc;
//                                    $scope.overviewDoughnutGraphData[i].value += $scope.overviewLineGraphData.datasets[i].data[j];
//                                }
//                            }
//                        }
//                    }
                    for (i = 0, itrMax = labelsArr.length; i < itrMax; i++) {
                        if (labelsArr[i] && labelsArr[i].indexOf('_') !== -1) {
                            labelsArr[i] = labelsArr[i].replace('_', ' ');
                        }
                        if ($scope.overviewDoughnutGraphData[i].value > 0) {
                            $scope.overviewLineGraphData.datasets[i].label = labelsArr[i];
                            $scope.overviewDoughnutGraphData[i].label = labelsArr[i];
                            $scope.overviewDoughnutGraphData[i].color = ALERT_COLOR[i];
                            $scope.overviewDoughnutGraphData[i].colorType = ALERT_COLOR_TYPE[i];
                            $scope.overviewDoughnutGraphData[i].highlight = ALERT_COLOR_POINT[i];
                        } else {
                            $scope.overviewLineGraphData.datasets[i].data = [];
                        }
                    }
//                    console.log('datasetsKeyArr = ', datasetsKeyArr);
//                    그래프 값 스케일 조정
                    chkDigit = String(chkMaxValue).length - 1;
                    limit = chkDigit;
                    if (chkDigit < 1) {
                        chkMaxValue = 10;
                    } else {
                        chkDigit = 1;
                        for (i = 0; i < limit; i++) {
                            chkDigit = chkDigit * 10;
                        }
                        chkMaxValue = chkMaxValue / chkDigit;
                        chkMaxValue = Math.ceil(chkMaxValue);
                        chkMaxValue = chkMaxValue * chkDigit;
                    }
                    $scope.overviewLineGraphDataOption.scaleStepWidth = chkMaxValue/$scope.overviewLineGraphDataOption.scaleSteps;
                });
            };
            $scope.$on('AlertReceived', function (event, alertObject) {
                $scope.doOverviewTabClick($scope.overviewCurTab);
            });
            angular.element($window).on('resize', function () {
                if (angular.isDefined(!dashboardReloadPromise)) {
                    $timeout.cancel(dashboardReloadPromise);
                }
                dashboardReloadPromise = $timeout(function () {
                    $scope.doOverviewTabClick($scope.overviewCurTab);
                    $timeout.cancel(dashboardReloadPromise);
                }, 250);
            });
            $scope.$on('$destroy', function() {
                angular.element($window).off('resize');
                $timeout.cancel(dashboardReloadPromise);
            });

            $scope.noticeList = [];
            $scope.systemStatusInfo = [];
            $scope.overviewDoughnutGraphData = [];
            $scope.overviewLineGraphData = {
                labels: [], // currently empty will contain all the labels for the data points
                datasets: []
            };
            $scope.overviewLineGraphDataOption = {
                ///Boolean - Whether grid lines are shown across the chart
                scaleShowGridLines: true,
                //String - Colour of the grid lines
                scaleGridLineColor: "rgba(0,0,0,.05)",
                //Number - Width of the grid lines
                scaleGridLineWidth: 1,
                //Boolean - If we want to override with a hard coded scale
                scaleOverride: true,
                //** Required if scaleOverride is true **
                //Number - The number of steps in a hard coded scale
                scaleSteps: 5,
                //Number - The value jump in the hard coded scale
                scaleStepWidth: 20,
                //Number - The scale starting value
                scaleStartValue: 0,
                scaleFontFamily: "'roboto', 'nanumgothic'",
                //Boolean - Whether the line is curved between points
                bezierCurve: true,
                //Number - Tension of the bezier curve between points
                bezierCurveTension: 0.4,
                //Boolean - Whether to show a dot for each point
                pointDot: true,
                //Number - Radius of each point dot in pixels
                pointDotRadius: 4,
                //Number - Pixel width of point dot stroke
                pointDotStrokeWidth: 1,
                //Number - amount extra to add to the radius to cater for hit detection outside the drawn point
                pointHitDetectionRadius: 20,
                //Boolean - Whether to show a stroke for datasets
                datasetStroke: true,
                //Number - Pixel width of dataset stroke
                datasetStrokeWidth: 2,
                //Boolean - Whether to fill the dataset with a colour
                datasetFill: false,
                //Number - Number of animation steps
                animationSteps: 40,
                //String - Animation easing effect
                animationEasing: "easeOutCubic",
                //String - A legend template
                legendTemplate: "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<datasets.length; i++){%><li><span style=\"background-color:<%=datasets[i].lineColor%>\"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>"
            };


            $scope.overviewDoughnutGraphDataOptions = {
                //Boolean - Whether we should show a stroke on each segment
                segmentShowStroke: true,
                //String - The colour of each segment stroke
                segmentStrokeColor: "rgba(0, 0, 0, 0)",
                //Number - The width of each segment stroke
                segmentStrokeWidth: 0,
                //Number - The percentage of the chart that we cut out of the middle
                percentageInnerCutout: 60, // This is 0 for Pie charts
                //Number - Amount of animation steps
                animationSteps: 50,
                //String - Animation easing effect
                animationEasing: "easeOutBack",
                //Boolean - Whether we animate the rotation of the Doughnut
                animateRotate: true,
                //Boolean - Whether we animate scaling the Doughnut from the centre
                animateScale: false,
                //String - A legend template
                legendTemplate: "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<%=segments[i].fillColor%>\"></span><%if(segments[i].label){%><%=segments[i].label%><%}%></li><%}%></ul>"
            };
//            System status 도넛 그래프
            $scope.sStatusDoughnutGraphDataOptions = {
                //Boolean - Whether we should show a stroke on each segment
                segmentShowStroke: true,
                //String - The colour of each segment stroke
                segmentStrokeColor: "#fff",
                //Number - The width of each segment stroke
                segmentStrokeWidth: 2,
                //Number - The percentage of the chart that we cut out of the middle
                percentageInnerCutout: 75, // This is 0 for Pie charts
                //Number - Amount of animation steps
                animationSteps: 50,
                //String - Animation easing effect
                animationEasing: "easeOutCubic",
                //Boolean - Whether we animate the rotation of the Doughnut
                animateRotate: true,
                //Boolean - Whether we animate scaling the Doughnut from the centre
                animateScale: false,
                //String - A legend template
                legendTemplate: "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<%=segments[i].fillColor%>\"></span><%if(segments[i].label){%><%=segments[i].label%><%}%></li><%}%></ul>"
            };

            function initPageData() {
                $scope.doOverviewTabClick(OVERVIEW_DEFAULT_TAB);
//               load system status
                API.get('biostar/status').then(function (data) {
                    var targetValue = 0,
                        remainValue = 0;
                    var i,
                        status,
                        item,
                        propName;
//                    디자인에 맞게 소팅
                    $scope.systemStatusInfo[0] = data.BiostarStatus.users;
                    $scope.systemStatusInfo[0].url = '/user';
                    $scope.systemStatusInfo[1] = data.BiostarStatus.finger_templates;
                    $scope.systemStatusInfo[1].url = '/user';
                    $scope.systemStatusInfo[2] = data.BiostarStatus.cards;
                    $scope.systemStatusInfo[2].url = '/setting/card';
                    $scope.systemStatusInfo[3] = data.BiostarStatus.devices;
                    $scope.systemStatusInfo[3].url = '/device';
                    $scope.systemStatusInfo[4] = data.BiostarStatus.doors;
                    $scope.systemStatusInfo[4].url = '/access-control/ac-doors';
                    $scope.systemStatusInfo[5] = data.BiostarStatus.access_groups;
                    $scope.systemStatusInfo[5].url = '/access-control/ac-groups';

                    for (status in $scope.systemStatusInfo) {
                        item = $scope.systemStatusInfo[status];
                        for (propName in  item) {
                            if (!isNaN(item[propName])) {
                                item[propName] = parseInt(item[propName]);
                            }
                        }
                        if (item.max_count > 0) {
                            targetValue = item.count / item.max_count * 100;
                            remainValue = 100 - targetValue;
                            item.dataSet = [
                                {
                                    value: targetValue,
                                    color: "#f4c880",
                                    highlight: "#ffb234",
                                    label: "current"
                                },
                                {
                                    value: remainValue,
                                    color: "#f78d86",
                                    highlight: "#e8473c",
                                    label: MessageProperties.get('common.remaining')
                                }
                            ];
                        } else {
                            item.dataSet = [
                                {
                                    value: 0,
                                    color: "#f4c880",
                                    highlight: "#ffb234",
                                    label: "current"
                                },
                                {
                                    value: 100,
                                    color: "#f78d86",
                                    highlight: "#e8473c",
                                    label: MessageProperties.get('common.remaining')
                                }
                            ];
                        }
                    }
                    $scope.systemStatusInfo[0].name = MessageProperties.get('common.user');
                    $scope.systemStatusInfo[1].name = MessageProperties.get('common.fingerPrint');
                    $scope.systemStatusInfo[2].name = MessageProperties.get('common.card');
                    $scope.systemStatusInfo[3].name = MessageProperties.get('common.device');
                    $scope.systemStatusInfo[4].name = MessageProperties.get('common.door');
                    $scope.systemStatusInfo[5].name = MessageProperties.get('common.accessGroup');
                });
//                공지사항 로드
                API.get('notices').then(function (data) {
//                    console.log(data);
                    $scope.noticeList = data.NoticeCollection.rows;
                })
            }

            initPageData();
            window.sessionStorage.setItem('SelectedMenuIndex', Const.GNB_MENU_ITEMS.DASHBOARD.id);
        }]);


        app.register.directive('ngbssChart', ['$compile', function ($compile) {
            return {
                restrict: 'A',
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    graphOptions: '=',
                    graphType: '@'
                },
                /**
                 * @param ngModel object json chart data
                 * @param options chart options(라이브러리 문서 참고)
                 * @param graphType string chart type(라이브러리 문서 참고)
                 */

                link: function ($scope, $element) {
                    var chart,
                        canvas = $($element.append('<canvas></canvas>').find('canvas')[0]),
                        ctx = canvas.get(0).getContext("2d"),
                        options = ($scope.graphOptions) ? $scope.graphOptions : {};
                    $scope.$watch('ngModel', function (nv, ov) {
                        ctx.canvas.width = $($element).outerWidth(true);
                        ctx.canvas.height = $($element).outerHeight(true);
                        chart = new Chart(ctx)[$scope.graphType]($scope.ngModel, options);
                    }, true);
                }
            }
        }]);
    });
