'use strict';

define([
    'modules/common/services/device-agent',
//    'modules/common/directives/ngbssInputTypeTime',
    'modules/common/directives/ngbssAuthModeList',
    'modules/common/directives/ngbssTriggerActionList',
    'modules/common/directives/ngbssOutputSignalModule',
  'modules/common/directives/ngbssDeviceOperatorList',
  'modules/common/directives/ngbssDeviceTnaEventList'
], function () {
    var app = angular.module('biostarWebApp');

    app.register.controller('DeviceInfoController', ['$scope', '$rootScope', '$location', 'API', 'Const', 'Util', 'DeviceAgent', '$timeout', 'MessageProperties', 'MessageService', 'PrivilegeService', 'ScheduleAgent', 'FileService',
        function ($scope, $rootScope, $location, API, Const, Util, DeviceAgent, $timeout, MessageProperties, MessageService, PrivilegeService, ScheduleAgent, FileService) {

            var options = {};
            var initCompleted = false;
            $scope.info = {};
            $scope.modifiedInfo = {};
            $scope.origin = {};
            $scope.isLoading = true;

            $scope.ipAddress = Const.REGULAR_EXPRESSION.IP_ADDRESS;// /(((\d{1,2})|(1\d{2})|(2[0-4]\d)|(25[0-5]))\.){3}(((\d{1,2})|(1\d{2})|(2[0-4]\d)|(25[0-5])))/;
            $scope.number = /^[-0-9]+$/;
//        $scope.matching_timeout_index = 0;
//        $scope.matching_timeout_unit = ['3 sec', '7 sec', '10 sec', '15 sec', '20 sec', '30 sec'];
            $scope.readOnly = true;
            var jsData = window.sessionStorage.getItem('deviceData');
            var deviceData = JSON.parse(jsData);
            var deviceID = null;
            $scope.isBatchEdit = false;
            $scope.isAllorSlave = false;
            $scope.isDisplayEdit = true;
            $scope.isBlackfinEdit = true;
            $scope.isFingerprintEdit = true;
            $scope.isMasterXPS2 = false;
            $scope.isSecureIO2 = false;
            $scope.isCardOnlyDevice = true;
            $scope.blackfinBaseband = false;
            $scope.blackfinBasebandType = Const.BLACKFIN_BASE_BAND_LABEL;
            $scope.WLAN_SECURITY_TYPE = ['Open System', 'Shared key', 'WPA_PSK'];
            $scope.RS485_MODE = Const.RS485_MODE_FOR_SELECT_BOX;
            $scope.RS485_BAUDRATE = Const.RS485_BAUDRATE;
            $scope.WIEGAND_FAIL_CODE = Const.WIEGAND_FAIL_CODE;
            $scope.FINGERPRINT_FAST_MODE = Const.FINGERPRINT_FAST_MODE_FOR_SELECT_BOX;
          $scope.FINGERPRINT_SENSOR_MODE = Const.FINGERPRINT_SENSOR_MODE_OPTIONS;
            $scope.FINGERPRINT_TEMPLATE_FORMAT = Const.FINGERPRINT_TEMPLATE_FORMAT;
            $scope.WIEGAND_USE_YN = Const.WIEGAND_USE_YN;
            $scope.CARD_BYTE_ORDER = Const.CARD_BYTE_ORDER;
            $scope.DEVICE_DISPLAY_LANGUAGE = Const.DEVICE_DISPLAY_LANGUAGE;
            $scope.DEVICE_LOCK_STATUS = Const.DEVICE_LOCK_STATUS;
            $scope.DEVICE_FINGERPRINT_SECURITY_LEVEL = Const.DEVICE_FINGERPRINT_SECURITY_LEVEL;
          $scope.DEVICE_WLAN_OPERATION_MODES = Const.DEVICE_WLAN_OPERATION_MODES;
          $scope.DEVICE_WLAN_AUTHORIZATION_TYPES = Const.DEVICE_WLAN_AUTHORIZATION_TYPES;
          $scope.DEVICE_WLAN_ENCRYPTION_TYPES = Const.DEVICE_WLAN_ENCRYPTION_TYPES;
            $scope.DEVICE_TNA_MODES_OPTIONS = Const.DEVICE_KEYPAD_TNA_MODES_OPTIONS;
            $scope.DEVICE_TNA_FIXED_CODE_OPTIONS = Const.DEVICE_TNA_FIXED_CODE_OPTIONS;
          $scope.DEVICE_DISPLAY_THEME_OPTIONS = Const.DEVICE_DISPLAY_THEME_OPTIONS;
          $scope.DEVICE_DISPLAY_BACKGROUND_OPTIONS = Const.DEVICE_DISPLAY_BACKGROUND_OPTIONS;
            $scope.BACKLIGHT_TIMEOUT_STEP_SIZE = 5;

            $scope.deviceDateTime = {
                time: undefined,
                date: undefined,
                dateTime: undefined
            };
            $scope.menuTimeoutDataList = {
                '0': {'value': '0', 'text': MessageProperties.get('device.info.alwaysOn')},
                '5': {'value': '5', 'text': '5 sec'},
                '10': {'value': '10', 'text': '10 sec'},
                '15': {'value': '15', 'text': '15 sec'},
                '20': {'value': '20', 'text': '20 sec'},
                '25': {'value': '25', 'text': '25 sec'},
                '30': {'value': '30', 'text': '30 sec'},
                '35': {'value': '35', 'text': '35 sec'},
                '40': {'value': '40', 'text': '40 sec'},
                '45': {'value': '45', 'text': '45 sec'},
                '50': {'value': '50', 'text': '50 sec'},
                '55': {'value': '55', 'text': '55 sec'},
                '60': {'value': '60', 'text': '60 sec'}
            };
            $scope.backlightDataList = {
                '0': {'value': '0', 'text': MessageProperties.get('device.info.alwaysOn')},
                '5': {'value': '5', 'text': '5 sec'},
                '10': {'value': '10', 'text': '10 sec'},
                '15': {'value': '15', 'text': '15 sec'},
                '20': {'value': '20', 'text': '20 sec'},
                '25': {'value': '25', 'text': '25 sec'},
                '30': {'value': '30', 'text': '30 sec'},
                '35': {'value': '35', 'text': '35 sec'},
                '40': {'value': '40', 'text': '40 sec'},
                '45': {'value': '45', 'text': '45 sec'},
                '50': {'value': '50', 'text': '50 sec'},
                '55': {'value': '55', 'text': '55 sec'},
                '60': {'value': '60', 'text': '60 sec'}
            };
            $scope.invalidUsers = [];
            $scope.invalidNames = [];
            /**
             * TODO: API /preference 를 통해서 가져온 값으로 사용해야 한다.
             * @type {{language: string, time_zone: string, date_format: (constant.DEFAULT_DATE_FORMAT|*), time_format: (constant.DEFAULT_SHORT_TIME_FORMAT|*)}}
             */
            $scope.Preference = {
                language: 'en',
                time_zone: '9.0',
                date_format: Const.DEFAULT_DATE_FORMAT,
                time_format: Const.DEFAULT_SHORT_TIME_FORMAT
            };

            $scope.safeApply = function (fn) {
                var phase = this.$root.$$phase;
                if (phase == '$apply' || phase == '$digest') {
                    if (fn && (typeof(fn) === 'function')) {
                        fn();
                    }
                } else {
                    this.$apply(fn);
                }
            };

            $scope.back = function (listReload) {
                $scope.safeApply(function (listReload) {
                    $scope.$emit('CloseDeviceInfo');
                    if (listReload) {
                        $rootScope.$emit('reloadDeviceTree');
                        $rootScope.$emit('onRefreshDeviceList');
                    }
                }(listReload));
            };

            $scope.backDeviceList = function (listReload) {
                // TODO: 수정된 내용을 확인하고 되돌아가야함.
                if (!Util.isEmpty($scope.origin) && !$scope.readOnly && !$scope.isBatchEdit) {
                    $scope.mappingCheckboxData();
                    if (listReload == undefined) {
                        listReload = false;
                        $scope.back(listReload);
                    } else {
                        $scope.back(listReload);
                    }
                } else {
                    $scope.back(listReload);
                }

            };


            function watchInfo() {
                $scope.$watch('info.lan', function (newObject, oldObject) {
                    if (oldObject == undefined) {
                        return;
                    }
                    if (!angular.equals(newObject, oldObject)) {
                        $scope.modifiedInfo.lan = newObject;
                    }
                }, true);
                $scope.$watch('useDHCP', function (newObject, oldObject) {
                    if (oldObject == undefined) {
                        return;
                    }
                    if (!angular.equals(newObject, oldObject)) {
                        $scope.info.lan.enable_dhcp = ($scope.useDHCP).toString();
                        $scope.modifiedInfo.lan = $scope.info.lan;
                    }
                }, true);
                $scope.$watch('info.fingerprint', function (newObject, oldObject) {
                    if (oldObject == undefined) {
                        return;
                    }
//                console.log("fingerprint");
//                console.log(oldObject);
//                console.log(newObject);
                    if (!angular.equals(newObject, oldObject)) {
                        $scope.modifiedInfo.fingerprint = newObject;
                    }
                }, true);
                $scope.$watch('info.output_signals', function (newObject, oldObject) {
                    if (oldObject == undefined || initCompleted == false) {
                        return;
                    }
//                console.log('watch info.output_signals');
//                console.log(newObject);
//                console.log(oldObject);
                    if (!angular.equals(newObject, oldObject)) {
                        $scope.modifiedInfo.output_signals = newObject;
                    }
                }, true);
                $scope.$watch('info.rs485', function (newObject, oldObject) {
                    if (oldObject == undefined) {
                        return;
                    }
                    if (!angular.equals(newObject, oldObject)) {
                        $scope.modifiedInfo.rs485 = newObject;
                    }
                }, true);
                $scope.$watch('info.name', function (newObject, oldObject) {
                    if (oldObject == undefined) {
                        return;
                    }
                    if (newObject != oldObject) {
                        $scope.modifiedInfo.name = newObject;
                    }
                }, true);
            }

            $scope.bindingDeviceData = function () {
                $scope.safeApply(function () {
                    if (angular.isDefined($scope.info.lan)) {
                        $scope.useDHCP = (angular.isDefined($scope.info.lan.enable_dhcp) && $scope.origin.lan.enable_dhcp == 'true');
//                    $scope.connection_mode = Const.CONNECTION_MODE[$scope.info.lan.connection_mode || '_default'];
                        $scope.blackfinBaseband = ($scope.info.lan.baseband == Const.BLACKFIN_BASE_BAND_TYPE['1']);
//                    $scope.numberSpinnerInit($scope.info.lan.mtu_size);
                    }

//                if (angular.isDefined($scope.info.usb)) {
//                    if (typeof $scope.origin.usb.enable_usb == 'string') {
//                        $scope.info.usb.enable_usb = $scope.origin.usb.enable_usb == 'true';
//                    }
//                    if (typeof $scope.info.usb.enable_usb_memory == 'string') {
//                        $scope.info.usb.enable_usb_memory = $scope.origin.usb.enable_usb_memory == 'true';
//                    }
//                }
//                if (angular.isDefined($scope.info.authentication)) {
//                    if (typeof $scope.origin.authentication.enable_full_access == 'string') {
//                        $scope.info.authentication.enable_full_access = $scope.origin.authentication.enable_full_access == 'true';
//                    }
//
//                    //$scope.info.authentication.enable_server_matching = $scope.origin.authentication.enable_server_matching == 'true';
////                    $scope.info.authentication.enable_private_auth = $scope.origin.authentication.enable_private_auth == 'true';
////                    $scope.matching_timeout_index = $scope.matching_timeout_unit.indexOf($scope.info.authentication.matching_timeout + ' sec');
//                }

                    if (angular.isDefined($scope.info.system) && angular.isDefined($scope.info.system.timezone)) {
                        for (var i = 0; i < Const.TIMEZONE_OPTIONS.length; i++) {
                            if ((parseInt(Const.TIMEZONE_OPTIONS[i].offset) * 60) == $scope.info.system.timezone) {
                                $scope.info.system.timezone = Const.TIMEZONE_OPTIONS[i];
                                break;
                            }
                        }
                        $scope.timeZoneList = Const.TIMEZONE_OPTIONS;
                    }
                  if ($scope.info.device_type_id.id == Const.DEVICE_TYPE_ID.BIO_STATION_2) {
                      $scope.BACKLIGHT_TIMEOUT_STEP_SIZE = 10;
                    if (angular.isDefined($scope.info.fingerprint)) {
                      if (!angular.isDefined($scope.info.fingerprint.advanced_enrollment)) {
                        $scope.info.fingerprint.advanced_enrollment = "true";
                      }
                      if (!angular.isDefined($scope.info.fingerprint.show_image)) {
                        $scope.info.fingerprint.show_image = "false";
                      }
                      if (!angular.isDefined($scope.info.fingerprint.sensor_mode)) {
                        $scope.info.fingerprint.sensor_mode = Const.FINGERPRINT_SENSOR_MODE.DEFAULT;
                      }
                    }

                    if (angular.isDefined($scope.info.wlan)) {
                      if (!angular.isDefined($scope.info.wlan.enabled)) {
                        $scope.info.wlan.enabled = Const.BOOLEAN.FALSE;
                      }
                    }
                    if (angular.isDefined($scope.info.system)) {
                      if (!angular.isDefined($scope.info.system.interphone_type)) {
                        $scope.info.system.interphone_type = Const.DEVICE_INTERPHONE_TYPES.DISABLED;
                      }
                    }


                    if (!angular.isDefined($scope.info.display)) {
                      $scope.info.display = {};
                    }

                    if (!angular.isDefined($scope.info.display.background_theme)) {
                      $scope.info.display.background_theme = Const.DEVICE_DISPLAY_THEME_OPTION_DEFAULT;
                    }
                    if (!angular.isDefined($scope.info.display.background)) {
                      $scope.info.display.background = Const.DEVICE_DISPLAY_BACKGROUND_OPTION_DEFAULT;
                    }
                    $scope.info.display.background_logo = '';
                    angular.element('#logoImage').on('change', function (event) {
                        FileService.imageFileReader(event, 'logoCanvas').then(function (imageData) {
                        $scope.info.display.background_logo = imageData;
                        if (!$scope.$root.$$phase) $scope.$apply();
                      });
                    });
                    $scope.info.display.background_slide_show = [];
                    var changeImage = function (slideShowIndex) {
                      $scope.info.display.background_slide_show[slideShowIndex] = '';
                      angular.element('#slideShowImage' + slideShowIndex).on('change', function (event) {
                          FileService.imageFileReader(event, 'slideShowCanvas' + slideShowIndex).then(function (imageData) {
                          $scope.info.display.background_slide_show[slideShowIndex] = imageData;
                          if (!$scope.$root.$$phase) $scope.$apply();
                        });
                      });
                    }
                    for (var slideShowIndex = 0; slideShowIndex < 10; slideShowIndex++) {
                      changeImage(slideShowIndex);
                    }

                    if (!angular.isDefined($scope.info.display.use_voice)) {
                      $scope.info.display.use_voice = Const.BOOLEAN.FALSE;
                    }

                      if (!angular.isDefined($scope.info.display.sounds)) {
                          $scope.info.display.sounds = [];
                      }
                      angular.element('.soundInput').on('change', function (event) {
                          var element = this;
                          var index = angular.element(element).attr("data-index");
                          angular.element("#soundFileLabel" + index).val(this.value);
                          FileService.soundFileReader(event).then(function (data) {
                              //var index = angular.element(element).attr("data-index");
                              $scope.info.display.sounds[index] = data;
                              if (!$scope.$root.$$phase) $scope.$apply();
                          });
                      });

                  }
                    if ($scope.info.device_type_id.id != Const.DEVICE_TYPE_ID.SECURE_IO &&
                        $scope.info.device_type_id.id != Const.DEVICE_TYPE_ID.SECURE_IO2) {
                        var tempTnaEvents = [];
                        for (var tempIndex = 0; tempIndex < Const.DEVICE_TNA_EVENT_KEYS_OBJECT_LIST.length; tempIndex++) {
                            var tempEvent = Const.DEVICE_TNA_EVENT_KEYS_OBJECT_LIST[tempIndex];
                            var mergedEvent = {
                                order: tempEvent.order,
                                key: tempEvent.key,
                                keyName: tempEvent.name,
                                schedule_id: {
                                    id: undefined
                                }
                            };
                            if (angular.isDefined($scope.info.tna) && angular.isDefined($scope.info.tna.tna_keys)) {
                                for (var keyIndex = 0; keyIndex < $scope.info.tna.tna_keys.length; keyIndex++) {
                                    var existingEvent = $scope.info.tna.tna_keys[keyIndex];
                                    if (keyIndex == tempEvent.key) {
                                        if (existingEvent.schedule_id != undefined) {
                                            mergedEvent.schedule_id.id = existingEvent.schedule_id.id;
                                            mergedEvent.schedule_id.name = existingEvent.schedule_id.name;
                                        }
                                        mergedEvent.label = existingEvent.label;
                                        break;
                                    }
                                }
                            }
                            tempTnaEvents.push(mergedEvent);
                        }
                        if ($scope.info.tna == undefined) {
                            $scope.info.tna = {};
                        }
                        $scope.info.tna.tna_keys = tempTnaEvents;
                        if (!angular.isDefined($scope.info.tna.mode)) {
                            $scope.info.tna.mode = Const.DEVICE_TNA_MODE_DEFAULT;
                        }
                    }

                    if (!$scope.isBatchEdit) {
                        $scope.isAllorSlave = false;
                        $scope.isDisplayEdit = true;
                        $scope.isBlackfinEdit = true;
                        $scope.isFingerprintEdit = true;
                        $scope.isCardEdit = true;
                        $scope.isPinIdEdit = true;
                        $scope.isVolumeSlider = true;
                        $scope.isSecureIO2 = false;
                        $scope.isCardOnlyDevice = true;
                        if (angular.isDefined($scope.info.parent_device_id) && angular.isDefined($scope.info.parent_device_id.id)) {
                            $scope.isAllorSlave = true;
                        }

                        if ($scope.info.device_type_id) {
                            if (Const.DISPLAY_DEVICES.indexOf($scope.info.device_type_id.id) < 0) {
                                $scope.isDisplayEdit = false;
                            }

                            if (Const.BLACKFIN_DEVICES.indexOf($scope.info.device_type_id.id) < 0) {
                                $scope.isBackfinEdit = false;
                            }

                            /**
                             * XPassS2는 Fingerprint 장치가 아니지만 Master 일 때에는 지문정보를 저장하기 때문에
                             * 인증모드에서 지문을 지원해야 한다. (BSS-1415)
                             * (2015.02.06 - 다시 지원하지 않는 것으로 한다.)
                             */
                            if (Const.FINGERPRINT_DEVICES.indexOf($scope.info.device_type_id.id) < 0 && !($scope.info.device_type_id.id == Const.DEVICE_TYPE.X_PASS_S2 && $scope.info.rs485.mode == Const.RS485_MODE.MASTER)) {
                                $scope.isFingerprintEdit = $scope.isFingerprintEdit && false;
                            }

                            $scope.isMasterXPS2 = ($scope.info.device_type_id.id == Const.DEVICE_TYPE.X_PASS_S2 && $scope.info.rs485.mode == Const.RS485_MODE.MASTER);

                            if (Const.CARD_DEVICES.indexOf($scope.info.device_type_id.id) < 0) {
                                $scope.isCardEdit = $scope.isCardEdit && false;
                            }

                            if (Const.KEYPAD_DEVICES.indexOf($scope.info.device_type_id.id) < 0) {
                                $scope.isPinIdEdit = $scope.isPinIdEdit && false;
                            }

                            if (Const.VOLUME_DEVICES.indexOf($scope.info.device_type_id.id) < 0) {
                                $scope.isVolumeSlider = $scope.isVolumeSlider && false;
                            }

                            if (Const.DEVICE_TYPE.SECURE_IO_2 == $scope.info.device_type_id.id) {
                                $scope.isSecureIO2 = true;
                            }

                            if (Const.CARD_ONLY_DEVICE.indexOf($scope.info.device_type_id.id) < 0) {
                                $scope.isCardOnlyDevice = $scope.isCardOnlyDevice && false;
                            }
                        }
                        if (angular.isDefined($scope.targetIndex) && $scope.targetIndex >= 0) {
                            $scope.prevDisabled = $scope.prevIndex < 0;
                            $scope.nextDisabled = $scope.nextIndex >= $scope.Parameters.total;
                        }
                    }
                    $timeout(function () {
                        $scope.$broadcast(Const.UI_EVENT_TYPE.DEVICE_INFO_LOADED);
                    }, 50);
                    watchInfo();
                });
            };

            //var deviceData = sessionStorage.getItem('deviceData');
            //var viewName = $.parseJSON(deviceData);

            //console.log("viewName:" + viewName.length);
            $scope.init = function () {
                $scope.info = undefined;
                $scope.origin = {};
                $scope.isLoading = true;
                var paramData = sessionStorage.getItem('deviceQueryParam');
                if (paramData != null) {
                    $scope.Parameters = angular.fromJson(paramData);
                }
//            angular.element('#div_loading_img').show();
                var batchData = sessionStorage.getItem('deviceBatchEditData');
                var batchDataSelectAll = sessionStorage.getItem('deviceBatchEditSelectAll');
                sessionStorage.removeItem('deviceBatchEditData');
                sessionStorage.removeItem('deviceBatchEditSelectAll');
                if (batchData == null) {
                    /**
                     * 단일 장치의 편집
                     */
                    $scope.isBatchEdit = false;
                    $scope.isAllorSlave = false;
                    $scope.prevDisabled = true;
                    $scope.nextDisabled = true;
                    $scope.pageLine = '- /' + $scope.Parameters.total;
                    $scope.targetIndex = -1;
                    if (sessionStorage.getItem('deviceSelectedIndex') != null) {
                        $scope.targetIndex = parseInt(sessionStorage.getItem('deviceSelectedIndex'));
                    }
                    if (angular.isDefined($scope.targetIndex) && $scope.targetIndex >= 0) {
                        $scope.paramNum = $scope.targetIndex + 1;
                        $scope.pageLine = $scope.paramNum + '/' + $scope.Parameters.total;
                        $scope.prevIndex = ($scope.targetIndex - 1);
                        $scope.nextIndex = ($scope.targetIndex + 1);

                    }
                    console.log("$scope.targetIndex: " + $scope.targetIndex + " $scope.prev:::" + $scope.prevIndex + ":::::$scope.next:" + $scope.nextIndex);

                    deviceID = DeviceAgent.getSelectedDevice().id;
                    $scope.info = undefined;
                    DeviceAgent.getDevice(deviceID).then(
                        function (data) {

                            if (data.Device.device_group_id != undefined && data.Device.device_group_id.id == Const.DEFAULT_ALL_GROUP_ID) {
                                data.Device.device_group_id.name = MessageProperties.get("menu.device.allDeviceGroups");
                            }
                            $scope.origin = data.Device;
                            $scope.info = angular.copy($scope.origin);

                            /**
                             * 장치 속성 변경 권한이 있는 사용자라면
                             * 장치의 Fingerprint Template Format 이 Server Setting 의 Format 과 다르다면 서버 설정을 따르도록 해야 한다.
                             */
                            if (!PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.DEVICE)) {
                                $scope.readOnly = true;
                            } else {
                                $scope.readOnly = false;
                            }
                            // Fingerprint 지원 장치에만 해당된다.
                            if (Const.FINGERPRINT_DEVICES.indexOf(data.Device.device_type_id.id) >= 0) {
                                checkFingerprintTemplateFormat();
                            }

                            $rootScope.$broadcast(Const.UI_EVENT_TYPE.DEVICE_INFO_UPDATED, data.Device);
                            $scope.bindingDeviceData();

                            $scope.isLoading = false;

                            //Slave 장치인 경우 연결상태인 status 값을 확인하여 disconnect 상태이면 경고 팝업을 띄운다.
                            if (data.Device.status == Const.DEVICE_STATUS.DISCONNECTED) {
                                MessageService.displayWarningMessage(MessageProperties.get('serverResponse.DEVICE_IS_NOT_CONNECTED'));
                                $scope.readOnly = true;
                            }
                            if (Const.KEYPAD_DEVICE_TYPES[$scope.info.device_type_id.id] == undefined) {
                                $scope.DEVICE_TNA_MODES_OPTIONS = Const.DEVICE_TNA_MODES_OPTIONS;
                            } else {
                                $scope.DEVICE_TNA_MODES_OPTIONS = Const.DEVICE_KEYPAD_TNA_MODES_OPTIONS;
                            }
                        },
                        function (reason) {

                            $scope.readOnly = true;
                            angular.element('#boxSystem').addClass('formBoxClose');

                            if (angular.isDefined($scope.targetIndex) && $scope.targetIndex >= 0) {
                                $scope.origin = angular.copy(deviceData[parseInt($scope.targetIndex % $scope.Parameters.limit)]);
                            } else if (DeviceAgent.getSelectedDevice() != undefined) {
                                $scope.origin = angular.copy(DeviceAgent.getAllDevicesMapWithStatus()[DeviceAgent.getSelectedDevice().id]);
                            }
                            $scope.info = angular.copy($scope.origin);

                            $scope.bindingDeviceData();

                            $scope.isLoading = false;
                        });

                } else {
                    /**
                     * 여러 장치의 정보 일괄 편집
                     */
                    $scope.isBatchEdit = true;
                    $scope.readOnly = false;
                    $scope.isLoading = false;
                    if (!PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.DEVICE)) {
                        $scope.readOnly = true;
                    }

                    if (batchDataSelectAll == Const.SELECTED_ALL) {
                        $scope.batchDeviceName = 'All Devices ';
                        $scope.batchDeviceCount = $scope.Parameters.total;
                        $scope.isAllorSlave = true;
                        $scope.isDisplayEdit = false;
                        $scope.isBlackfinEdit = false;
                        $scope.isFingerprintEdit = false;
                        $scope.isCardEdit = false;
                        $scope.isPinIdEdit = false;
                        $scope.isVolumeSlider = true;
                        $scope.isSecureIO2 = false;
                        $scope.isCardOnlyDevice = true;
                        deviceID = batchDataSelectAll;
                    } else {
                        var deviceBatchEditData = angular.fromJson(batchData);
                        $scope.batchDeviceIDs = [];
                        $scope.isAllorSlave = false;
                        $scope.isDisplayEdit = true;
                        $scope.isBlackfinEdit = true;
                        $scope.isFingerprintEdit = true;
                        $scope.isCardEdit = true;
                        $scope.isPinIdEdit = true;
                        $scope.isVolumeSlider = true;
                        $scope.isSecureIO2 = false;
                        $scope.isCardOnlyDevice = true;

                        for (var i = 0; i < deviceBatchEditData.length; i++) {
                            var device = deviceBatchEditData[i];
                            $scope.batchDeviceIDs.push(device.id);

                            if (!$scope.isAllorSlave && (angular.isDefined(device.parent_device_id) && angular.isDefined(device.parent_device_id.id))) {
                                $scope.isAllorSlave = true;
                            }
                            if (device.device_type_id) {
                                if (Const.DISPLAY_DEVICES.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isDisplayEdit = $scope.isDisplayEdit && false;
                                }

                                if (Const.BLACKFIN_DEVICES.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isBackfinEdit = $scope.isBackfinEdit && false;
                                }

                                if (Const.FINGERPRINT_DEVICES.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isFingerprintEdit = $scope.isFingerprintEdit && false;
                                }

                                if (Const.CARD_DEVICES.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isCardEdit = $scope.isCardEdit && false;
                                }

                                if (Const.KEYPAD_DEVICES.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isPinIdEdit = $scope.isPinIdEdit && false;
                                }

                                if (Const.VOLUME_DEVICES.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isVolumeSlider = $scope.isVolumeSlider && false;
                                }

                                if (Const.DEVICE_TYPE.SECURE_IO_2 == device.device_type_id.id) {
                                    $scope.isSecureIO2 = true;
                                }

                                if (Const.CARD_ONLY_DEVICE.indexOf(device.device_type_id.id) < 0) {
                                    $scope.isCardOnlyDevice = $scope.isCardOnlyDevice && false;
                                }
                            }
                        }
                        deviceID = $scope.batchDeviceIDs.join('+');
                        $scope.batchDeviceName = deviceBatchEditData[0].name + ' +';
                        $scope.batchDeviceCount = (deviceBatchEditData.length - 1);
                    }
                    $scope.info = {
                        'name': $scope.batchDeviceName,
                        'device_group_id': {
                            'id': undefined
                        },
                        'lan': {
                            'enable_dhcp': 'false',
                            'gateway': '',
                            'subnet_mask': '',
                            'server_ip': '',
                            'device_port': '',
                            'server_port': '',
                            'connection_mode': '0',
                            'baseband': '0',
                            'mtu_size': '1514'
                        },
                        'rs485': {
//                        'mode': '',
                            'channels': [
                                {
                                    'baudrate': ''
                                }
                            ]
                        },
                        'authentication': {
                            //'enable_server_matching': undefined,
                            'matching_timeout': '3',
                            'auth_timeout': '10',
                            'enable_full_access': 'false',
                            'operation_modes': [],
                            'operators': []
                        },
                        'fingerprint': {
                            'security_level': '0',
                            'fast_mode': '0',
                            'sensitivity': '7',
                          'show_image': "false",
                            'scan_timeout': '10',
                            //'detect_afterimage': false,
                          'template_format': '0',
                          sensor_mode: Const.FINGERPRINT_SENSOR_MODE.DEFAULT,
                          advanced_enrollment: 'true'
                        },
                      wlan: {
                        enabled: Const.BOOLEAN.FALSE
                      },
                        'sound': {
                            'volume': 0
                        },
                        'display': {
                            'menu_timeout': '10',
                            'backlight_timeout': '5',
                            'message_timeout': '500'
                        },
                        'output_signals': [
                            {
                                'status': 0,
                                'led': {
                                    'count': 1,
                                    'signals': [
                                        {
                                            'color': '0',
                                            'duration': 0,
                                            'delay': 0
                                        },
                                        {
                                            'color': '0',
                                            'duration': 0,
                                            'delay': 0
                                        },
                                        {
                                            'color': '0',
                                            'duration': 0,
                                            'delay': 0
                                        }
                                    ]
                                },
                                'buzzer': {
                                    'count': 1,
                                    'signals': [
                                        {
                                            'tone': '0',
                                            'fadeout': 'false',
                                            'duration': 0,
                                            'delay': 0
                                        },
                                        {
                                            'tone': '0',
                                            'fadeout': 'false',
                                            'duration': 0,
                                            'delay': 0
                                        },
                                        {
                                            'tone': '0',
                                            'fadeout': 'false',
                                            'duration': 0,
                                            'delay': 0
                                        }
                                    ]
                                }
                            }
                        ],
                        'wiegand': {
                            'wiegand_in_out': '0',
                            'out_pulse_width': '40',
                            'out_pulse_interval': '2000',
                            'enable_bypass_mode': 'false',
                            'format_id': {
                                'id': '1'
                            }
                        }
                    };
                    $scope.origin = angular.copy($scope.info);
                    $scope.bindingDeviceData();
//                angular.element('#div_loading_img').hide();
                    $scope.isLoading = false;
                }

                $scope.$on(Const.UI_EVENT_TYPE.DEVICE_INFO_INIT_COMPLETED, function () {
                    console.log(Const.UI_EVENT_TYPE.DEVICE_INFO_INIT_COMPLETED + ' received');
                    $timeout(function () {
                        initCompleted = true;
                    }, 1000);
                });

                $rootScope.$on('$routeChangeStart', function (evt, next, curr) {
                    console.log('Device: 메뉴를 빠져나가기 전에 정리해야 하는 작업');
                    sessionStorage.removeItem('deviceBatchEditData');
                    sessionStorage.removeItem('deviceBatchEditSelectAll');
                    sessionStorage.removeItem('deviceSelectedIndex');
                    DeviceAgent.rejectGetDevice();
                    DeviceAgent.rejectGetDeviceList();
                    DeviceAgent.removeDevice();
                });

                angular.element('#txtDeviceName').on('keydown', function (event) {
                    //console.log('keyCode:' + event.keyCode);
//                if (event.keyCode == 53) {
//                    // INFO: KeyCode: 53 = '%'
//                    return false;
//                } else if (event.keyCode == 188) {
//                    // INFO: KeyCode: 188 = '<'
//                    return false;
//                }
                });
            };

            $scope.prevDevice = function () {
                if ($scope.prevDisabled) {
                    return;
                }
                sessionStorage.setItem('deviceSelectedIndex', $scope.prevIndex);

                var pvdeviceIndex = $scope.Parameters.offset - $scope.prevIndex;
                if (pvdeviceIndex >= deviceData.length) {
                    $scope.Parameters.offset -= parseInt($scope.Parameters.limit);
                    DeviceAgent.getDeviceList($scope.Parameters).then(function (data) {
                        if (data.DeviceCollection.rows.length > 0) {
                            $scope.prevDisabled = false;
                            var jsData = angular.toJson(data.DeviceCollection.rows);
                            window.sessionStorage.setItem("deviceData", jsData);// 세션저장
                            deviceData = data.DeviceCollection.rows;
                            $scope.Parameters.total = data.DeviceCollection.total;

                            var pvDevice = deviceData[$scope.Parameters.limit - 1];
                            DeviceAgent.setSelectedDevice({'id': pvDevice.id, 'name': pvDevice.name});
                            $scope.init();
                        }
                    });
                } else {
                    var pvDevice = deviceData[parseInt($scope.prevIndex % $scope.Parameters.limit)];
                    DeviceAgent.setSelectedDevice({'id': pvDevice.id, 'name': pvDevice.name});
                    $scope.init();
                }

            };
            $scope.nextDevice = function () {
                if ($scope.nextDisabled) {
                    return;
                }
                sessionStorage.setItem('deviceSelectedIndex', $scope.nextIndex);
                var nxdeviceIndex = $scope.nextIndex - $scope.Parameters.offset;
                if (nxdeviceIndex >= deviceData.length) {
                    $scope.Parameters.offset += parseInt($scope.Parameters.limit);
                    DeviceAgent.getDeviceList($scope.Parameters).then(function (data) {
                        if (data.DeviceCollection.rows.length > 0) {
                            $scope.nextDisabled = false;
                            var jsData = angular.toJson(data.DeviceCollection.rows);
                            window.sessionStorage.setItem("deviceData", jsData);// 세션저장
                            deviceData = data.DeviceCollection.rows;
                            $scope.Parameters.total = data.DeviceCollection.total;

                            var nxDevice = deviceData[0];
                            DeviceAgent.setSelectedDevice({'id': nxDevice.id, 'name': nxDevice.name});
                            $scope.init();
                        }
                    });
                } else {
                    var nxDevice = deviceData[parseInt($scope.nextIndex % $scope.Parameters.limit)];
                    DeviceAgent.setSelectedDevice({'id': nxDevice.id, 'name': nxDevice.name});
                    $scope.init();
                }
            };


            $scope.dummyInfo = {
                firmware_ver: "V1.20",
                'wlan': {
                    'enable_wlan': false,
                    'ssid': '',
                    'security_type': '',
                    'passphrase': ''
                },
                'operation_modes': [
                    {mode: 0,
                        schedule_id: {id: 0,
                            name: "Always"}
                    }
                ],
                card: {
                    use_wiegand_format: 'true'
                }
            };

//        $scope.connection_mode = true;

            $scope.deviceGroupTreeInit = function () {
                if (DeviceAgent.getDeviceGroupTreeOnlyGroup().then) {
                    DeviceAgent.getDeviceGroupTreeOnlyGroup().then(function success(data) {
                        $scope.deviceGroupTree = [data];
                    })
                } else {
                    $scope.deviceGroupTree = [DeviceAgent.getDeviceGroupTreeOnlyGroup()];
                }
            };

            $scope.deviceGroupTreeInit();

            $scope.wiegandFormats = {};
            $scope.wiegandTypeInit = function () {
                API.get('setting/wiegand_formats', undefined, undefined, undefined, false, false, false).then(function (data) {
                    $scope.wiegandFormats = data.WiegandFormatCollection.rows;
                });
            };

            $scope.wiegandTypeInit();


            $scope.scheduleListData = [];
            $scope.scheduleInit = function () {
                ScheduleAgent.getScheduleList(undefined, 'deviceInfoGetScheduleList').then(function (data) {
                    $scope.scheduleListData = data.ScheduleCollection.rows;
                    if (!$scope.$root.$$phase) $scope.$apply();
                });
            };

            $scope.scheduleInit();

//        $scope.numberSpinnerInit = function(data) {
//            angular.element('#numMtuSize').numberspinner({
//                min: 1078,
//                max: 1514,
//                width: 117,
//                height: 29,
//                value: data || 1514
//            });
//        };
//        $scope.numberSpinnerInit();

            $scope.selectClick = function (id) {
                if ($(id).hasClass('disabled')) {
                    return false;
                }
                $(id).toggleClass('open');
            };

            $scope.treeDo = function (url, id) {  //tree 생성
                API.get(url).then(function (data) {

                    setTreeValue(data);

                    $(id).tree({
                        data: data,
                        lines: true,
                        method: 'get',
                        animate: true
                    });
                });
            };

            $scope.tooltipDo = function (id) {//tooltip 생성
                $(id).tooltip({
                    position: 'bottom',
                    content: '<span style="color:#fff">This is the tooltip message.</span>',
                    onShow: function () {
                        $(this).tooltip('tip').focus().unbind().bind('mouseenter', function () {

                            $(this).tooltip('show');

                        }).bind('mouseleave', function () {
                            $(this).tooltip('hide');
                        });
                    }
                });

            };

            var setTreeValue = function (data) {
                for (var i = 0, len = data.length; i < len; i++) {
                    data[i].text = data[i].name;
                    if (data[i]['user-groups'] !== undefined && typeof data[i]['user-groups'] === 'object') {
                        data[i].children = data[i]['user-groups'];
                        setTreeValue(data[i]['user-groups']);
                    }
                }
            };


            $scope.add = function () { //파일 업로드
                var f = document.getElementById('file').files[0],
                    r = new FileReader();
                r.onloadend = function (e) {
                    var data = e.target.result;
                    //send you binary data via $http or $resource or do anything else with it
                };
                r.readAsBinaryString(f);
            };


            $scope.useDHCP = false;

            $scope.doOpenPop = function (val, name) {//popup load

                options.iconCls = 'icon-save';
                options.closable = false;
                options.modal = true;
                options.shadow = false;

                options.title = name;
                options.width = 800;
                options.height = 600;

                $scope.options = options;


                $scope.tooltippage = {url: 'views/device/' + val + '-device.html'};
            };

            $scope.doDialog = function () {
                $('#tooltipCont').dialog($scope.options);
                $('#tooltipCont').dialog('open');
            };

            $scope.doDlgOK = function () {
                $scope.tooltippage = {url: ''};
                $('#tooltipCont').dialog('destroy');
                $scope.$emit('dlgClose', 'OK');
            };

            $scope.doDlgDone = function (name) {
                $scope.tooltippage = {url: ''};
                $('#' + name).dialog('destroy');

                $scope.$emit('dlgClose', 'done');
            };

            $scope.doDlgCancel = function () {
                $scope.tooltippage = {url: ''};
                $('#tooltipCont').dialog('destroy');

                $scope.$emit('dlgClose', 'Cancel');
            };

            /*$scope.myData = [{name: "Moroni", age: 50},
             {name: "Tiancum", age: 43},
             {name: "Jacob", age: 27},
             {name: "Nephi", age: 29},
             {name: "Enos", age: 34}];

             $scope.gridOptions = { data: 'myData' };

             $scope.toggle = function() {//toggle 기능
             $scope.$broadcast('event:toggle');
             }*/

            $scope.mappingCheckboxData = function () {
                if (angular.isDefined($scope.info.lan)) {
//                $scope.info.lan.connection_mode = Const.CONNECTION_MODE[$scope.connection_mode];
                    $scope.info.lan.enable_dhcp = ($scope.useDHCP).toString();
                }
            };

            $scope.invalidDeviceName = false;
            $scope.invalidIPAddress = false;
            $scope.invalidSubnetMask = false;
            $scope.invalidGateway = false;
            $scope.invalidServerIP = false;
            var validationCheck = function () {
                var valid = true;

                $scope.invalidDeviceName = false;
                $scope.invalidIPAddress = false;
                $scope.invalidSubnetMask = false;
                $scope.invalidGateway = false;
                $scope.invalidServerIP = false;

                var focusElement = undefined;
                if ($scope.info.name == null || $scope.info.name == '' || $scope.info.name.length > 48) {
                    $scope.invalidDeviceName = true;
                    valid = false;
                    focusElement = focusElement || '#txtDeviceName';
                }

                if ($scope.info != undefined && $scope.info.lan != undefined) {
                    if ($scope.info.lan.enable_dhcp == 'false') {
                        if (!$scope.ipAddress.test($scope.info.lan.ip) || $scope.info.lan.ip == '0.0.0.0') {
                            $scope.invalidIPAddress = true;
                            valid = false;
                            focusElement = focusElement || '#txtIPAddress';
                        }
                        if (!$scope.ipAddress.test($scope.info.lan.subnet_mask) || $scope.info.lan.subnet_mask == '0.0.0.0') {
                            $scope.invalidSubnetMask = true;
                            valid = false;
                            focusElement = focusElement || '#txtSubnetMask';
                        }
                        if (!$scope.ipAddress.test($scope.info.lan.gateway) || $scope.info.lan.gateway == '0.0.0.0') {
                            $scope.invalidGateway = true;
                            valid = false;
                            focusElement = focusElement || '#txtGateway';
                        }
                    }
                    if ($scope.info.lan.connection_mode == Const.CONNECTION_MODE.DEVICE_TO_SERVER) {
                        if (!$scope.ipAddress.test($scope.info.lan.server_ip) || $scope.info.lan.server_ip == '0.0.0.0') {
                            $scope.invalidServerIP = true;
                            valid = false;
                            focusElement = focusElement || '#txtServerIP';
                        }
                    }
                }

                if (focusElement != undefined) {
                    angular.element(focusElement).focus();
                }
                return valid;
            };

            var checkFingerprintTemplateFormat = function () {
                var serverSetting = Util.getSessionObject(Const.SESSION_STORAGE_KEY.SERVER_SETTING);
                if (serverSetting && serverSetting.fingerprint_format &&
                    $scope.info && $scope.info.fingerprint && $scope.info.fingerprint.template_format &&
                    serverSetting.fingerprint_format != $scope.info.fingerprint.template_format) {

                    MessageService.displayConfirmMessage(MessageProperties.get('device.fingerprintFormatDiffWarning'), function (dialogResult) {
                        if (dialogResult) {
                            var saveData = {
                                'fingerprint': {
                                    'template_format': serverSetting.fingerprint_format
                                }
                            };
                            API.put('devices/' + deviceID, undefined, {'Device': saveData}).then(function (data) {
                                $scope.afterSaveSuccess();
                            });
                        } else {

                        }
                    });
                }
            };

            var isValidRange = function (val, min, max) {
                var valid = true;
                var val = parseInt(val);
                if (isNaN(val)) {
                    valid = true;
                    return valid;
                } else if (val < min || val > max) {
                    valid = true;
                    return valid;
                }
                return valid;
            };
            $scope.saveResources = function (deviceId, resourceData) {
                var options = {
                    url: 'resources/update',
                    params: {
                        'DeviceCollection': {
                            total: 1,
                            rows: [
                                {
                                    id: deviceId
                                }
                            ]
                        },
                        'ResourceDataCollection': resourceData
                    },
                    displaySuccessPopoup: true,
                    displayErrorPopup: true,
                    displayLoading: true
                };
                if (resourceData != undefined && resourceData.total > 0) {
                    API.postWithOptions(options).then(function success(data) {

                    }, function error(data) {
                        MessageService.displayInformationMessage(MessageProperties.get("validate.failedToUpdateResource"));
                        Util.error("Failed to update resources", data, resourceData);
                    });
                }
            };

          $scope.saveDisplayImages = function () {
            var sendData = {};
            if ($scope.info.display.background == Const.DEVICE_DISPLAY_BACKGROUND.LOGO) {
                sendData.total = 0;
              sendData.type = Const.BIOSTAR_RESOURCE_DATA_TYPE.LOGO;
              sendData.rows = [];
                var imageData = $scope.info.display.background_logo;
                if (imageData != undefined && imageData.length > 0) {
                    sendData.total = 1;
                    sendData.rows.push(
                        {
                            slot: 0,
                            data: imageData
                        }
                    );
                }
            } else if ($scope.info.display.background == Const.DEVICE_DISPLAY_BACKGROUND.NOTICE) {
              sendData.total = 1;
              sendData.type = Const.BIOSTAR_RESOURCE_DATA_TYPE.NOTICE;
              sendData.rows = [];
              sendData.rows.push(
                {
                  slot: 0,
                    data: base64.encode($scope.info.display.background_notice)
                }
              );
            } else if ($scope.info.display.background == Const.DEVICE_DISPLAY_BACKGROUND.SLIDE_SHOW) {
              sendData.total = 0;
              sendData.type = Const.BIOSTAR_RESOURCE_DATA_TYPE.SLIDE_SHOW;
              sendData.rows = [];
              for (var slideIndex = 0; slideIndex < $scope.info.display.background_slide_show.length; slideIndex++) {
                var imageData = $scope.info.display.background_slide_show[slideIndex];
                if (imageData != undefined && imageData.length > 0) {
                  sendData.total = sendData.total + 1;
                  sendData.rows.push(
                    {
                      slot: slideIndex,
                      data: imageData
                    }
                  );
                }
              }
            }
              $scope.saveResources($scope.info.id, sendData)
          };

            $scope.saveDisplaySounds = function () {
                var sendData = {};
                sendData.total = 0;
                sendData.type = Const.BIOSTAR_RESOURCE_DATA_TYPE.SOUND;
                sendData.rows = [];
                for (var slideIndex = 0; slideIndex < $scope.info.display.sounds.length; slideIndex++) {
                    var soundData = $scope.info.display.sounds[slideIndex];
                    if (soundData != undefined && soundData.length > 0) {
                        sendData.total = sendData.total + 1;
                        sendData.rows.push(
                            {
                                slot: slideIndex,
                                data: soundData
                            }
                        );
                    }
                }
                $scope.saveResources($scope.info.id, sendData)
            }

            $scope.ApplyInfo = function (invalid) {
                if ($scope.readOnly) {
                    return false;
                }
                if (!PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.DEVICE)) {
                    return false;
                }
                $scope.mappingCheckboxData();
                /**
                 */
                if (!validationCheck() || invalid) {
                    return false;
                }

                var saveData;
                if ($scope.isBatchEdit) {
                    saveData = Util.extractModifiedFields($scope.origin, $scope.info);
                } else {
                    saveData = angular.copy($scope.info);

//            if (saveData == undefined) {
//                MessageService.displayWarningMessage(MessageProperties.get('common.'));
//                return false;
//            }

                    // set read only properties to undefined before saving
                    saveData.status = undefined;
                    saveData.version = undefined;
                    saveData.device_type_id = undefined;
                    saveData.id = undefined;

                    // set big data to undefined in order to prevent big data being sent even though it is not modified
                    saveData.lan = undefined;
                    if ($scope.modifiedInfo.lan != undefined) {
                        saveData.lan = $scope.modifiedInfo.lan;
                    }
                    saveData.fingerprint = undefined;
                    if ($scope.modifiedInfo.fingerprint != undefined) {
                        saveData.fingerprint = $scope.modifiedInfo.fingerprint;
                    }
                    saveData.output_signals = undefined;
                    if ($scope.modifiedInfo.output_signals != undefined) {
                        saveData.output_signals = $scope.modifiedInfo.output_signals;
                    }
                    saveData.rs485 = undefined;
                    if ($scope.modifiedInfo.rs485 != undefined) {
                        saveData.rs485 = $scope.modifiedInfo.rs485;
                    }
                    saveData.name = undefined;
                    if ($scope.modifiedInfo.name != undefined) {
                        saveData.name = $scope.modifiedInfo.name;
                    }

                    if (saveData.device_group_id != undefined && saveData.device_group_id.id == undefined) {
                        saveData.device_group_id = undefined;
                    }
                }
                if (saveData.system != undefined && saveData.system.timezone != undefined && saveData.system.timezone.offset != undefined) {
//                console.log(saveData.system.timezone, parseInt(saveData.system.timezone.offset * 60));
                    saveData.system.timezone = parseInt(saveData.system.timezone.offset * 60);
                }

              // background resources are saved by different action
              // this should be merged, but server is not supporting combined action
              saveData.display.background_logo = undefined;
              saveData.display.background_notice = undefined;
              saveData.display.background_slide_show = undefined;

                console.log(saveData);

                var valid = true;
                /**
                 * RS485 Mode 유효성 검사
                 */
                if (($scope.origin && $scope.origin.rs485 && $scope.origin.rs485.mode && $scope.origin.rs485.mode == Const.RS485_MODE.MASTER) &&
                    ($scope.info && $scope.info.rs485 && $scope.info.rs485.mode && ($scope.info.rs485.mode == Const.RS485_MODE.SLAVE || $scope.info.rs485.mode == Const.RS485_MODE.AUTO)) &&
                    $scope.info.rs485.channels.length > 0 && $scope.info.rs485.channels[0].slave_devices && $scope.info.rs485.channels[0].slave_devices.length > 0) {

                    MessageService.displayWarningMessage(MessageProperties.get('validate.existsSlaves'), function () {
                        $scope.info.rs485.mode = Const.RS485_MODE.MASTER;
                    });
                    return false;
                }

                /**
                 * Administrator 유효성 검사
                 */
                $scope.invalidUsers = [];
                $scope.invalidNames = [];
                if (saveData.authentication && saveData.authentication.operators &&
                    saveData.authentication.operators.length > 0) {
                    var userIDs = [];
                    for (var i = 0; i < saveData.authentication.operators.length; i++) {
                        if (angular.isUndefined(saveData.authentication.operators[i].user_id)) {
                            continue;
                        }
                        var crrUserID = saveData.authentication.operators[i].user_id.user_id;
                        if (userIDs.contains(crrUserID)) {
                            valid = valid && false;
                            $scope.invalidNames.push(saveData.authentication.operators[i].user_id.name);
                            if (!$scope.invalidUsers.contains(crrUserID)) {
                                $scope.invalidUsers.push(crrUserID);
                            }
                        } else {
                            userIDs.push(crrUserID);
                        }
                    }
                    if (!valid) {
                        MessageService.displayWarningMessage(MessageProperties.get('error.duplicateUserId'));
                        return false;
                    }
                }
                /**
                 * Output Signal 유효성 검사 및 빈 값 정제
                 */
                if (angular.isDefined(saveData.output_signals) && saveData.output_signals.length > 0) {
                    for (var i = saveData.output_signals.length - 1; i >= 0; i--) {
                        if (saveData.output_signals[i] == undefined) {
                            continue;
                        }
                        if (Util.isNullOrUndefined(saveData.output_signals[i].status)) {
                            MessageService.displayWarningMessage(MessageProperties.get('common.pleaseEnterEventStatus'));
                            return false;
                        } else {
                            var validLED = [];
                            for (var ledIndex = 0; ledIndex < saveData.output_signals[i].led.signals.length; ledIndex++) {
                                var ledSignal = saveData.output_signals[i].led.signals[ledIndex];
                                if (!isValidRange(ledSignal.delay, Const.SIGNAL.MIN_VALUE_DELAY, Const.SIGNAL.MAX_VALUE_DELAY)) {
                                    $scope.$emit(Const.UI_EVENT_TYPE.EVENT_TYPE_CLICKED, i, saveData.output_signals[i].status);
                                    MessageService.displayWarningMessage(MessageProperties.get('validate.outOfRange', MessageProperties.get('device.info.delay'),
                                        Const.SIGNAL.MIN_VALUE_DELAY, Const.SIGNAL.MAX_VALUE_DELAY), function (dialogResult) {
                                        $scope.$emit(Const.UI_EVENT_TYPE.INPUT_FOCUS, saveData.output_signals[i].status);
                                    });
                                    return false;
                                } else if (!Util.isNullOrUndefined(ledSignal.color) && !Util.isNullOrUndefined(ledSignal.duration)) {
                                    validLED.push(angular.copy(ledSignal));
                                }
                            }
                            saveData.output_signals[i].led.signals = validLED;

                            var validBuzzer = [];
                            for (var buzzerIndex = 0; buzzerIndex < saveData.output_signals[i].buzzer.signals.length; buzzerIndex++) {
                                var buzzerSignal = saveData.output_signals[i].buzzer.signals[buzzerIndex];
                                if (!Util.isNullOrUndefined(buzzerSignal.tone) && !Util.isNullOrUndefined(buzzerSignal.duration)) {
                                    validBuzzer.push(angular.copy(buzzerSignal));
                                }
                            }
                            saveData.output_signals[i].buzzer.signals = validBuzzer;

                        }
                    }
                }

                //            var refineData = {};
//            refineData = angular.copy(saveData);
                //Schecdule 값 정제(id만 남김);
//            if (refineData.authentication && refineData.authentication.operation_modes) {
////                refineData.id = deviceID;
//                for (var i = refineData.authentication.operation_modes.length - 1; i >= 0; i--) {
//                    var schedule_id = refineData.authentication.operation_modes[i].schedule_id.id;
//                    refineData.authentication.operation_modes[i].schedule_id = angular.copy({"id": "-1"});
//                    console.log(refineData.authentication.operation_modes[i]);
//                }
//            }
//            console.log(refineData);

                if ($scope.isBatchEdit) {
                    if (angular.isDefined($scope.Parameters)) {
                        if (angular.isDefined($scope.Parameters.group_id) && $scope.Parameters.group_id != '') {
                            deviceID += '&group_id=' + $scope.Parameters.group_id;
                        }
                        if (angular.isDefined($scope.Parameters.query) && $scope.Parameters.query != '') {
                            deviceID += '&query=' + $scope.Parameters.query;
                        }
                    }
                    API.put('devices?id=' + deviceID, undefined, {'Device': saveData}).then(function (data) {
                        $scope.afterSaveSuccess();
                    });
                } else {
                    API.put('devices/' + deviceID, undefined, {'Device': saveData}).then(function (data) {
                        $scope.afterSaveSuccess();
                    });
                }

            };

            /**
             * Device List에 표시되는 컬럼이 변경되었다면 List 재조회한다.
             */
            $scope.afterSaveSuccess = function () {
                var listReload = false;

                if ($scope.info.device_group_id != null && $scope.origin.device_group_id != null &&
                    $scope.origin.device_group_id.id !== $scope.info.device_group_id.id) {
                    listReload = true;
                }
                if ($scope.info.name != null && $scope.origin.name != null &&
                    $scope.origin.name !== $scope.info.name) {
                    listReload = true;
                }
                if ($scope.info.device_type_id != null && $scope.origin.device_type_id != null &&
                    $scope.origin.device_type_id.id !== $scope.info.device_type_id.id) {
                    listReload = true;
                }
                if ($scope.info.lan != null && $scope.origin.lan != null) {
                    if ($scope.origin.lan.ip !== $scope.info.lan.ip) {
                        listReload = true;
                    }
                    if ($scope.origin.lan.connection_mode !== $scope.info.lan.connection_mode) {
                        listReload = true;
                    }
                }
                if ($scope.info.rs485 != null && $scope.origin.rs485 != null &&
                    $scope.origin.rs485.mode !== $scope.info.rs485.mode) {
                    listReload = true;
                }
                $scope.origin = angular.copy($scope.info);

                //MessageService.displayInformationMessage(MessageProperties.get('common.applied'), function (result) {
                $scope.backDeviceList(listReload);
                //});
            };

            $scope.firmwareUpgradePopup = function () {
                var target = event.target || (event.srcElement || document);

                if (angular.element(target).hasClass('disabled')) {
                    return false;
                }
                $rootScope.$emit('firmwareUpgradePopup');
            };

            $scope.languageResourcePopup = function () {
                if (angular.element(event.target || event.srcElement).hasClass('disabled')) {
                    return false;
                }
                $rootScope.$emit('languageResourcePopup');
            };

            $scope.getDeviceTime = function () {
                if ($scope.readOnly) {
                    return false;
                }
                if (angular.element(event.target || event.srcElement).hasClass('disabled')) {
                    return false;
                }
                API.get('devices/' + $scope.info.id + '/get_time').then(function (data) {
                    var timezone = Const.TIMEZONE_OFFSET.GREENWICH;
                    if (data.DeviceTime) {
//                    if ($scope.info.system && $scope.info.system.timezone && $scope.info.system.timezone.offset) {
//                        timezone = -$scope.info.system.timezone.offset;
//                    }
                        console.log('getDeviceTime :::: ', data.DeviceTime.datetime, ' ::: ', new Date(data.DeviceTime.datetime * 1000).toISOString());
                        $scope.deviceDateTime.dateTime = new Date(data.DeviceTime.datetime * 1000).toISOString();
                        $scope.deviceDateTime.date = new Date(data.DeviceTime.datetime * 1000).toISOString();
                        $scope.deviceDateTime.time = new Date(data.DeviceTime.datetime * 1000).toISOString();
                    }
                });
            };

            $scope.setDeviceTime = function () {
                if ($scope.readOnly) {
                    return false;
                }
                if (angular.element(event.target || event.srcElement).hasClass('disabled')) {
                    return false;
                }
                var date, getTime;

//            if($scope.deviceDateTime.dateTime) {
//                date = $scope.deviceDateTime.dateTime.toISOString();
//                getTime = $scope.deviceDateTime.dateTime.getTime();
//            } else {
//                date = $scope.deviceDateTime.date.toISOString();
//            }

                console.log('setDeviceTime', $scope.deviceDateTime.dateTime, Date.parse($scope.deviceDateTime.dateTime));
                API.put('devices/' + $scope.info.id + '/set_time', undefined, {'DeviceTime': {'datetime': Date.parse($scope.deviceDateTime.dateTime) / 1000}}).then(function (data) {
                    MessageService.displayInformationMessage(MessageProperties.get('common.applied'), function (result) {
                    });
                });
            };

            $scope.resetDevice = function () {
                var target = event.target || (event.srcElement || document);

                if (angular.element(target).hasClass('disabled')) {
                    return false;
                }
                if (!PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.DEVICE)) {
                    return false;
                }
                MessageService.displayConfirmMessage(MessageProperties.get('confirm.factoryDefault'), function (dialogResult) {
                    if (dialogResult) {
                        var rows = [];
                        if ($scope.isBatchEdit && $scope.batchDeviceIDs) {
                            for (var i = 0; i < $scope.batchDeviceIDs.length; i++) {
                                rows.push({'id': $scope.batchDeviceIDs[i]});
                            }
                        }
                        if (rows.length <= 0) {
                            rows.push({'id': $scope.info.id});
                        }
                        DeviceAgent.resetDevices(rows).then(function (data) {
                            MessageService.displayInformationMessage(
                                MessageProperties.get('common.applied'), function (result) {
                                    var listReload = true;
                                    $scope.backDeviceList(listReload);
                                });
                        });
                    }
                });
            };

            $scope.unlockDevice = function () {
                var target = event.target || (event.srcElement || document);

                if (angular.element(target).hasClass('disabled')) {
                    return false;
                }
                if (!PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.DEVICE)) {
                    return false;
                }
                MessageService.displayConfirmMessage(MessageProperties.get('confirm.unlock'), function (dialogResult) {
                    if (dialogResult) {
                        var rows = [];
                        if ($scope.isBatchEdit && $scope.batchDeviceIDs) {
                            for (var i = 0; i < $scope.batchDeviceIDs.length; i++) {
                                rows.push({'id': $scope.batchDeviceIDs[i]});
                            }
                        }
                        if (rows.length <= 0) {
                            rows.push({'id': $scope.info.id});
                        }
                        API.post('devices/unlock', undefined, {
                            'DeviceCollection': {
                                'total': rows.length,
                                'rows': rows
                            }
                        }).then(function (data) {
                            MessageService.displayInformationMessage(
                                MessageProperties.get('common.applied'), function (result) {
                                    $scope.init();
                                });
                        });
                    }
                });
            };
            $scope.lockDevice = function () {
                var target = event.target || (event.srcElement || document);

                if (angular.element(target).hasClass('disabled')) {
                    return false;
                }
                if (!PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.DEVICE)) {
                    return false;
                }
                MessageService.displayConfirmMessage(MessageProperties.get('confirm.lock'), function (dialogResult) {
                    if (dialogResult) {
                        var rows = [];
                        if ($scope.isBatchEdit && $scope.batchDeviceIDs) {
                            for (var i = 0; i < $scope.batchDeviceIDs.length; i++) {
                                rows.push({'id': $scope.batchDeviceIDs[i]});
                            }
                        }
                        if (rows.length <= 0) {
                            rows.push({'id': $scope.info.id});
                        }
                        API.post('devices/lock', undefined, {
                            'DeviceCollection': {
                                'total': rows.length,
                                'rows': rows
                            }
                        }).then(function (data) {
                            MessageService.displayInformationMessage(
                                MessageProperties.get('common.applied'), function (result) {
                                    $scope.init();
                                });
                        });
                    }
                });
            };

            $scope.$watch('info.authentication.enable_full_access', function (nv, ov) {
                if (nv == null || nv === ov || (ov == null && nv != null) || (typeof nv == 'string' && typeof ov == 'boolean')) {
                    return;
                }
                if ($scope.info.authentication.enable_full_access == 'true') {
                    MessageService.displayConfirmMessage(MessageProperties.get('confirm.allowFullAccess'), function (dialogResult) {
                        if (!dialogResult) {
                            $scope.safeApply(function () {
                                $scope.info.authentication.enable_full_access = 'false';
                            });
                        }
                    });
                }
            }, true);

            $scope.$watch('blackfinBaseband', function (nv, ov) {
                if (nv == null || nv === ov || (ov == null && nv != null) || (typeof nv == 'string' && typeof ov == 'boolean')) {
                    return;
                }
                $scope.info.lan.baseband = (Const.BLACKFIN_BASE_BAND_VALUE[$scope.blackfinBaseband].toString());
                console.log('baseband: ' + $scope.info.lan.baseband);
            }, true);

            $scope.slideImageClear = function (slideShowIndex) {
                $scope.info.display.background_slide_show[slideShowIndex] = undefined;
                angular.element("#slideShowImage" + slideShowIndex).val('');
                if (!$scope.$root.$$phase) $scope.$apply();
            };
            $scope.logoImageClear = function () {
                $scope.info.display.background_logo = undefined;
                angular.element("#logoImage").val('');
                if (!$scope.$root.$$phase) $scope.$apply();
            };
        }]);


});
