'use strict';

define(function () {
    var app = angular.module('biostarWebApp');

    app.register.controller('AddSlaveDeviceController', ['$scope', '$rootScope', 'Const', 'API', 'DeviceAgent', function ($scope, $rootScope, Const, API, DeviceAgent) {

        $scope.deviceSpec = undefined;
        $scope.init = function () {
            DeviceAgent.getDeviceSpec().then(function success(data) {
                $scope.deviceSpec = data;
            }).finally(function () {
                $('#addgrid').datagrid({
                    fitColumns: true,
                    iconCls: 'icon-edit',
                    //singleSelect:true,
                    selectOnCheck: true,
                    checkOnSelect: true,
                    checkbox: true,
                    onClickCell: onClickCell,
                    columns: [
                        [
                            {field: 'ck', checkbox: true},
                            {field: 'name', title: 'Name', width: 130,
                                formatter: function (value, row) {
                                    if (row.name && row.name.length > 0) {
                                        return row.name;
                                    } else {
                                        row.name = $scope.deviceSpec[row.device_type_id.id].name + ' ' + row.id;
                                        return row.name;
                                    }
                                },
                                editor: 'text'
                            },
                            {field: 'id', title: 'ID', width: 50},
                            {field: 'parent_device_id', hidden: true},
                            {field: 'device_type_id', title: 'Device Type', width: 80,
                                formatter: function (value, row) {
                                    return $scope.deviceSpec[value.id].name;
                                }
                            }
                        ]
                    ],
                    onLoadSuccess: function (data) {
                        $('#tooltipCont').parents('.panel').find('.panel-tool-close').click(function () {
                            $scope.doDlgCancel();
                        });
                    }
                }).datagrid('loadData', $scope.dlgSlaveDeviceList.result);
            });
        };

        $.extend($.fn.datagrid.methods, {
            editCell: function (jq, param) {
                return jq.each(function () {
                    var opts = $(this).datagrid('options');
                    var fields = $(this).datagrid('getColumnFields', true).concat($(this).datagrid('getColumnFields'));
                    for (var i = 0; i < fields.length; i++) {
                        console.log("fie:" + fields[i]);
                        var col = $(this).datagrid('getColumnOption', fields[i]);
                        col.editor1 = col.editor;
                        if (fields[i] != param.field) {
                            col.editor = null;
                        }
                    }
                    $(this).datagrid('beginEdit', param.index);
                    for (var i = 0; i < fields.length; i++) {
                        var col = $(this).datagrid('getColumnOption', fields[i]);
                        col.editor = col.editor1;
                    }
                });
            }
        });

        var editIndex = undefined;

        function endEditing() {
            if (editIndex == undefined) {
                return true
            }
            if ($('#addgrid').datagrid('validateRow', editIndex)) {
                $('#addgrid').datagrid('endEdit', editIndex);
                editIndex = undefined;
                return true;
            } else {
                return false;
            }
        }

        function onClickCell(index, field) {
            console.log(index + "=" + field);

            if (endEditing()) {
                $('#addgrid').datagrid('selectRow', index)
                    .datagrid('editCell', {index: index, field: field});
                editIndex = index;
            }
        }


        $scope.addSlave = [];
        $scope.doDlgApply = function (name) {

            if ($('#btnAddDevice').hasClass('disabled')) {
                return;
            }
            var data = $('#addgrid').datagrid('getSelections');//선택된 데이터 배열

            console.log(data);
//            $('#addCont').text('0');
            angular.forEach(data, function (deviceData) {
                //angular.extend(deviceData, {name:''});
                //TODO: device_type_id.id를 '1'로 고정하여 값을 넣는 것은 임시 조치이다. 반드시 서버가 준비된 이후 제거해야 한다.
//                deviceData.device_type_id = {id:'1'};
//                deviceData.device_group_id = {id:'1'};
                API.post('devices', undefined, {'Device': deviceData}).then(function (data) {
                    console.log('저장됨');
                    $('#addgrid').datagrid('deleteRow', $('#addgrid').datagrid('getRowIndex', deviceData));

                    $('#searchSlaveDeviceGrid').datagrid('deleteRow', $('#searchSlaveDeviceGrid').datagrid('getRowIndex', deviceData));
                    var crrData = $('#addgrid').datagrid('getData');
                    $scope.addSlave.push(deviceData);
                    if (crrData.rows.length == 0) {
                        $scope.doDlgCancel();
                    }
                });
            });

//            $scope.$emit('addDevices', data);
        };


        $scope.doDlgCancel = function () {
            $scope.tooltippage = {url: ''};
            $('#tooltipCont').dialog('destroy');

            /**
             * toasrMessage 띄우는 부분
             */
                //$('#addCont').text($scope.addCount + '');
            $scope.$emit('dlgClose', {addSlave: $scope.addSlave});
        };


    }]);
});