'use strict';

define([], function () {
    var app = angular.module('biostarWebApp');

app.register.controller('LanguageResourceController', ['$scope', '$timeout', 'API', 'Const', 'Util', 'MessageProperties', 'MessageService', '$filter', 'DeviceAgent', function ($scope, $timeout, API, Const, Util, MessageProperties, MessageService, $filter, DeviceAgent) {

        $scope.languageFilesData = [];

        $scope.deviceSpec = undefined;
        $scope.initPopup = function () {
            DeviceAgent.getDeviceSpec().then(function success(data) {
                $scope.deviceSpec = data;
            }).finally(function () {
                API.get('resources').then(function(data) {
                    if(data && data.ResourceFileCollection) {
                        $scope.languageFilesData = data.ResourceFileCollection.rows;
                        var options = angular.element('#dlgLanguageResource').dialog('options');
                        $scope.selectedDevices = options.selectedDevices;
                        var selectedDeviceTypes = [];
                        for (var i = 0; i < $scope.selectedDevices.length; i++) {
                            var deviceTypeID = $scope.selectedDevices[i].device_type_id.id;
                            if (selectedDeviceTypes.indexOf(deviceTypeID) < 0) {
                                selectedDeviceTypes.push(deviceTypeID);
                            }
                        }
                        $scope.languageFiles = $filter('devicesTypeFilter')($scope.languageFilesData, selectedDeviceTypes);
                    }
                });
            });
        };

        $scope.applyUpgrade = function(file) {
            console.log(file);
           MessageService.displayConfirmMessage(MessageProperties.get('device.languageResourceConfirm'), function (dialogResult) {
                if (dialogResult) {
                    API.post('resources/update', undefined, {
                        'ResourceFile': file,
                        'DeviceCollection': {total: $scope.selectedDevices.length, rows: $scope.selectedDevices}
                    }).then(function (data) {
                        MessageService.displayInformationMessage(MessageProperties.get('device.languageResourceSuccess'));
                    });
                } else {
                }
            });
        };
        $scope.closePopup = function() {
            angular.element('#dlgLanguageResource').dialog('close');
        };
    }]);
});