'use strict';

define([], function () {
    var app = angular.module('biostarWebApp');

    app.register.controller('ManageUsersInDeviceController', ['$scope', '$rootScope', '$timeout', '$compile', 'API', 'Const', 'Util', 'MessageProperties', 'MessageService', function ($scope, $rootScope, $timeout, $compile, API, Const, Util, MessageProperties, MessageService) {

        var options = {};

        $scope.addCount = 0;
        $scope.gridId = "grdUserInDevice";

        $scope.Parameters = {
            query: undefined,
            offset: 0,
            limit: 15,
            flag: undefined,
            total: 0
        };
        $scope.queryParameters = {
            page: 0,
            limit: 15,
            flag: undefined
        };

        $scope.SYNC_STATUS = {
            '0': 'All',
            '1': 'New User',
            '2': 'Different',
            '3': 'Different or New User'
        };
        $scope.selectedUserIDs = [];
        $scope.selectedUsers = [];

        $scope.safeApply = function (fn) {
            var phase = this.$root.$$phase;
            if (phase == '$apply' || phase == '$digest') {
                if (fn && (typeof(fn) === 'function')) {
                    fn();
                }
            } else {
                this.$apply(fn);
            }
        };

        $scope.foundMessage = '';
        $scope.selected = false;

        angular.element('#btnUserSearchOption').on('focusin', function () {
            angular.element('#btnUserSearchOption').addClass('open');
        }).on('focusout', function () {
            angular.element('#btnUserSearchOption').removeClass('open');
        });

        $scope.initPopup = function () {


            angular.element('#grdUserInDevice').datagrid({
                view: $.extend({}, $.fn.datagrid.defaults.view, {
                    onBeforeRender: function (target, rows) {
                        angular.element(target).datagrid('resize');
                    },
                    onAfterRender: function (target) {
                        $.fn.datagrid.defaults.view.onAfterRender.call(this, target);
                        var opts = angular.element(target).datagrid('options');
                        var grdPanel = angular.element(target).datagrid('getPanel');
                        grdPanel.find(".datagrid-empty").remove();
                        var vc = grdPanel.children('div.datagrid-view');
                        var resultBoxHeight = 360;
                        if (opts.height) {
                            resultBoxHeight = opts.height - 39;
                        }
                        if ($(target).datagrid('getRows').length === 0) {
                            var html = '<div style="width:100%; height:' + resultBoxHeight +
                                'px; font-size:1.333em; line-height: ' + resultBoxHeight +
                                'px; vertical-align: middle; text-align: center;">' + MessageProperties.get('validate.notFound') + '</div>';
                            grdPanel.find('div.datagrid-view2 div.datagrid-body').html(html);
                        }

                        //헤더에 전체선택 버튼이 없다면 추가
                        if (grdPanel.find('.datagrid-header-check.compiled').length <= 0) {
                            grdPanel.find('.datagrid-header-check').attr({
                                'select-all-yn': 'SelectAllYN',
                                'datagrid-id': '"grdUserInDevice"',
                                'clear-function': 'clearCheckItemArray'
                            });
                            $compile(grdPanel.find('.datagrid-header-row'))($scope);
                            grdPanel.find('.datagrid-header-check').addClass('compiled');
                        }
                        if ($scope.searchFlag == '-1') {
                            grdPanel.find('.datagrid-header-check .btnAct').show();
                        } else {
                            grdPanel.find('.datagrid-header-check .btnAct').hide();
                        }
                    }
                }),
                fitColumns: true,
                scrollbarSize: 0,
                height: 308,
                iconCls: 'icon-edit',
                singleSelect: true,
                selectOnCheck: false,
                checkOnSelect: false,
                //editOnSelect: true, // TODO: editOnSelect는 없는 속성이다. 구현해야 한다. 편집중일 때 선택이 풀리는 문제
                checkbox: true,
                columns: [
                    [
                        {field: 'ck', checkbox: true, showAllCheckOption: false, width: 55},
                        {field: 'user_id', title: MessageProperties.get('common.userId'), width: 180},
                        {field: 'name', title: MessageProperties.get('common.userName'), width: 200, hidden: true},
                        {field: 'fingerprint_templates_count', title: MessageProperties.get('user.fingerprintTemplateNum'), width: 100},
                        //TODO: Face 포함시킬 경우 아래 필드와 함께 deviceTreeController.js의 afterOpenManageUsersInDevicePopupDlg에서 팝업 Width를 더 늘려야 한다.
                        //{field: 'face_templates_count', title: 'Face Num.', width: 100},
                        {field: 'security_level', title: MessageProperties.get('user.fingerSecurityLevel'), width: 100, formatter: function (value, row, index) {
                            return Const.FINGERPRINT_SECURITY_LEVEL[value] || '';
                        }},
                        {field: 'flag', title: MessageProperties.get('user.syncStatus'), width: 120, formatter: function (value, row, index) {
                            return Const.USER_SYNC_STATUS_LABEL[value];
                        }}
                    ]
                ],
                onLoadSuccess: function (data) {
                    if ($scope.SelectAllYN) {
                        angular.element('#grdUserInDevice').datagrid('checkAll');
                    } else {
                        for (var i = 0; i < data.rows.length; i++) {
                            var idxID = $scope.selectedUserIDs.indexOf(data.rows[i].user_id);
                            if (idxID >= 0) {
                                angular.element('#grdUserInDevice').datagrid('checkRow', i);
                            } else {
                                angular.element('#grdUserInDevice').datagrid('uncheckRow', i);
                            }
                        }
                    }
                    angular.element('#grdUserInDevice').datagrid('scrollTo', 0);
                    $('#btnSearch').removeAttr('disabled').removeClass('disabled');
                },
                onClickCell: function (rowIndex, field) {
                    $rootScope.clickCellOnGrid($scope.gridId, rowIndex, field, "user_id");
                },
                onCheck: function (rowIndex, rowData) {
                    var idxID = $scope.selectedUserIDs.indexOf(rowData.user_id);
                    if (idxID < 0) {
                        if ($scope.selectedUserIDs.length >= Const.SELECT_LIST_ITEM_LIMIT) {
                            MessageService.displayWarningMessage(MessageProperties.get('validate.canNotSelectMoreItem', Const.SELECT_LIST_ITEM_LIMIT));
                            angular.element('#grdUserInDevice').datagrid('uncheckRow', rowIndex);
                        } else {
                            $scope.selectedUserIDs.push(rowData.user_id);
                            $scope.selectedUsers.push(rowData);
                        }
                    }
                    if ($scope.selectedUserIDs.length > 0) {
                        $scope.safeApply(function () {
                            $scope.selected = true;
                        });
                    }
                },
                onUncheck: function (rowIndex, rowData) {
                    if ($scope.SelectAllYN) {
                        $scope.SelectAllYN = false;

                        $scope.selectedUserIDs = [];
                        $scope.selectedUsers = [];
                        var checkedRows = angular.element('#grdUserInDevice').datagrid('getChecked');
                        for (var i = 0; i < checkedRows.length; i++) {
                            $scope.selectedUserIDs.push(checkedRows[i].user_id);
                            $scope.selectedUsers.push(checkedRows[i]);
                        }
                    } else {
                        var idxID = $scope.selectedUserIDs.indexOf(rowData.user_id);
                        if (idxID >= 0) {
                            $scope.selectedUserIDs.splice(idxID, 1);
                            $scope.selectedUsers.splice(idxID, 1);
                        }
                    }
                    if ($scope.selectedUserIDs.length <= 0) {
                        $scope.safeApply(function () {
                            $scope.selected = false;
                        });
                    }
                },
                onCheckAll: function (rows) {
                    if ($scope.SelectAllYN == true) {
                        if ($scope.UsersData && $scope.UsersData.length > 0) {
                            $scope.selected = true;
                        }
                    } else {
                        var i, uncheckList = [];
                        for (i = 0; i < rows.length; i++) {
                            var item = rows[i];
                            var idx = $scope.selectedUserIDs.indexOf(item.user_id);

                            if (idx == -1) {
                                if ($scope.selectedUserIDs.length < Const.SELECT_LIST_ITEM_LIMIT) {
                                    $scope.selectedUserIDs.push(item.user_id);
                                } else {
                                    uncheckList.push(item);
                                }
                            }
                        }

                        if (uncheckList.length > 0) {
                            MessageService.displayWarningMessage(MessageProperties.get('validate.canNotSelectMoreItem', Const.SELECT_LIST_ITEM_LIMIT));
                            for (i = uncheckList.length; i--;) {
                                //console.log(uncheckList[i].user_id);
                                angular.element('#grdUserInDevice').datagrid('uncheckRow', angular.element('#grdUserInDevice').datagrid('getRowIndex', uncheckList[i]));
                            }
                        }
                        if ($scope.selectedUserIDs.length > 0) {
                            $scope.safeApply(function () {
                                $scope.selected = true;
                            });
                        }
                    }

                    if (!$scope.$root.$$phase) $scope.$apply();
                },
                onUncheckAll: function (rows) {
                    if ($scope.SelectAllYN == true) {
                        $scope.SelectAllYN = false;
                        $scope.selectedUserIDs = [];
                    }
                    for (var i = rows.length; i--;) {
                        var item = rows[i];
                        var idx = $scope.selectedUserIDs.indexOf(item.user_id);
                        if (idx > -1) {
                            $scope.selectedUserIDs.splice(idx, 1);
                        }
                    }
                    if ($scope.selectedUserIDs.length < 1) {
                        $scope.safeApply(function () {
                            $scope.selected = false;
                        });
                    }

                }
            });


            if ($rootScope.$$listeners[Const.ON_SEARCH_USERS_IN_DEVICE] != undefined) {
                $rootScope.$$listeners[Const.ON_SEARCH_USERS_IN_DEVICE] = undefined;
            }
            $rootScope.$on(Const.ON_SEARCH_USERS_IN_DEVICE, function (event, data) {
                $scope.searchUsersInDevice();
            });
        };

        $scope.selectedDevice = undefined;

//        $scope.UserSearchOption = {
//            'all': true,
//            'same': false,
//            'new': false,
//            'diff': false,
//            'diff_new': false
//        };

//        $scope.SYNC_STATUS = {
//            '-1': MessageProperties.get('UserSyncOptionAll'),
//            '0': MessageProperties.get('UserSyncOptionSame'),
//            '1': MessageProperties.get('UserSyncOptionNew'),
//            '2': MessageProperties.get('UserSyncOptionDiff'),
//            '3': MessageProperties.get('UserSyncOptionDiffNew')
//        };
//        $scope.$watch('UserSearchOption', function(nv, ov) {
//            if(nv === ov) {
//                return;
//            }
//            if($scope.UserSearchOption.all) {
//                $scope.Parameters.flag = undefined;
//            } else if ($scope.UserSearchOption.same) {
//                $scope.Parameters.flag = Const.USER_SYNC_STATUS.SAME;
//            } else if ($scope.UserSearchOption.new) {
//                $scope.Parameters.flag = Const.USER_SYNC_STATUS.NEW;
//            } else if ($scope.UserSearchOption.diff) {
//                $scope.Parameters.flag = Const.USER_SYNC_STATUS.DIFF;
//            } else if ($scope.UserSearchOption.diff_new) {
//                $scope.Parameters.flag = Const.USER_SYNC_STATUS.DIFF_NEW;
//            }
//        }, true);

        $scope.searchFlag = '-1';
        $scope.$watch('searchFlag', function (nv, ov) {
            if (nv === ov) {
                return;
            }
            if ($scope.searchFlag == '-1') {
                $scope.Parameters.flag = undefined;
            } else {
                $scope.Parameters.flag = $scope.searchFlag.toString();
            }
            $scope.Parameters.offset = 0;
            $scope.searchUsersInDevice();
        }, true);

        $scope.convertOffset = function () {
            var page = parseInt($scope.Parameters.offset / $scope.Parameters.limit);
            return {
                page: page,
                limit: $scope.Parameters.limit,
                flag: $scope.Parameters.flag || undefined
            }
        };

        $scope.searchUsersInDevice = function () {
            angular.element('#btnUserSearchOption').blur();
            angular.element('#btnUserSearchOption').removeClass('open');
            $('#btnSearch').attr({'disabled': 'disabled'}).addClass('disabled');

            $scope.selectedDevice = angular.fromJson(sessionStorage.getItem('selectedDeviceNode'));

            API.get('devices/' + $scope.selectedDevice.id + '/users', undefined, $scope.convertOffset()).then(function (data) {

//                if (data.UserCollection == undefined || data.UserCollection.rows.length <= 0) {
//                    MessageService.displayWarningMessage(MessageProperties.get("common.");
//                }

                var crrScrollbarSize = angular.element('#grdUserInDevice').datagrid('options').scrollbarSize;
                var newScrollbarSize = 11;

                if (data.UserCollection == undefined || data.UserCollection.rows.length < 8) {
                    newScrollbarSize = 0;
                }

                $scope.UsersData = data.UserCollection.rows || [];
                $scope.Parameters.total = data.UserCollection.total || data.UserCollection.rows.length;
                if (newScrollbarSize === crrScrollbarSize) {
                    angular.element('#grdUserInDevice').datagrid('loadData', (data.UserCollection == undefined || data.UserCollection.rows.length <= 0) ? [] : data.UserCollection.rows);
                } else {
                    angular.element('#grdUserInDevice').datagrid({
                        scrollbarSize: newScrollbarSize,
                        'data': data.UserCollection.rows || []
                    });
                }
            }, function error(data) {
                $('#btnSearch').removeAttr('disabled').removeClass('disabled');
            });
        };

        $scope.searchUsersInDeviceCallback = {
            fn: $scope.searchUsersInDevice
        };

        $scope.SelectAllYN = false;

        $scope.$watch('SelectAllYN', function (nv) {
            if (nv) {
                angular.element('#grdUserInDevice').datagrid('checkAll');
            } else {
                if (angular.element('#grdUserInDevice').datagrid('getChecked').length == $scope.Parameters.limit) {
                    angular.element('#grdUserInDevice').datagrid('uncheckAll');
                }
            }
        });

        $scope.clearCheckItemArray = function () {
            $scope.selectedUserIDs = [];
            $scope.selectedUsers = [];
            $scope.selected = false;
        };

        $scope.exportUsersFromDevice = function () {
            var target = event.target || (event.srcElement || document);
            if ($(target).hasClass('disabled')) {
                return;
            }
            var containDifferent = false;
            var userIDs = [];
            if ($scope.SelectAllYN) {
                userIDs.push(Const.SELECTED_ALL);
            } else {

                var diffrentFlags = ['2', '3'];

                var rows = $scope.selectedUsers;//선택된 데이터 배열
                if (rows <= 0) {
                    return;
                }
                for (var i = 0; i < rows.length; i++) {
                    var device = rows[i];

                    if (diffrentFlags.indexOf(device.flag) >= 0) {
                        containDifferent == true;
                    }
                    if (!$scope.SelectAllYN) {
                        userIDs.push(rows[i].user_id);
                    }
                    if (containDifferent && $scope.SelectAllYN) {
                        break;
                    }
                }
            }
            console.log(userIDs);

            var msgConfirm = containDifferent ? 'confirm.uploadDifferentUser' : 'confirm.uploadSelectedUser';

            MessageService.displayConfirmMessage(MessageProperties.get(msgConfirm), function (dialogResult) {
                if (dialogResult) {
                    if (userIDs.length >= 0) {
                        API.post('devices/' + $scope.selectedDevice.id + '/users/export?id=' + userIDs.join('+')).then(function (data) {
                            console.log('export');
                            $scope.Parameters.offset = 0;
                            $scope.SelectAllYN = false;
                            angular.element('#grdUserInDevice').datagrid('uncheckAll');
                            $scope.selectedUserIDs = [];

                            $scope.searchUsersInDevice();
                            console.log('reloadUserData');
                            $scope.$emit('reloadUserGroupRecursiveData');
                        });
                    }
                }
            });
        };

        $scope.deleteUsersFromDevice = function () {
            var target = event.target || (event.srcElement || document);
            if ($(target).hasClass('disabled')) {
                return;
            }
            var userIDs = [];
            if ($scope.SelectAllYN) {
                userIDs.push(Const.SELECTED_ALL);
            } else {
                userIDs = $scope.selectedUserIDs;
            }
            if (userIDs.length <= 0) {
                return;
            }
            console.log(userIDs);

            MessageService.displayConfirmMessage(MessageProperties.get('confirm.deleteSelectedUser'), function (dialogResult) {
                if (dialogResult) {
                    if (userIDs.length >= 0) {
                        API.del('devices/' + $scope.selectedDevice.id + '/users?id=' + userIDs.join('+')).then(function (data) {
                            console.log('delete');
                            $scope.Parameters.offset = 0;
                            $scope.SelectAllYN = false;
                            angular.element('#grdUserInDevice').datagrid('uncheckAll');
                            $scope.selectedUserIDs = [];

                            $scope.searchUsersInDevice();
                        });
                    }
                }
            });
        };

        $scope.closePopup = function () {
            angular.element('#manageUsersInDevicePopupDlg').dialog('close');
        };
    }]);
});