'use strict';

angular.module('biostarWebApp')
    .controller('UserListPrintPreviewCtrl', function ($scope, $location, API, Util, Const, User, $rootScope) {

        User.get(function (data) {
            $('#dgUsers').datagrid({data: data.UserCollection.rows || [],
                columns: [
                    [
                        {title: '<input type="button"/>', checkbox: true},
                        {field: 'user_id', title: 'ID'},
                        {field: 'name', title: 'Name'},
                        {field: 'email', title: 'E-mail', width: 120, styler: function (value, row, index) {
                            return {class: 'cell-ellipsis'};
                        }},
                        {field: 'user_group_id', title: 'Group', formatter: function (value, row, index) {
                            var returnVal = [];
                            if (angular.isArray(value || [])) {
                                for (var i = 0; i < (value || []).length; i++) {
                                    returnVal.push(value[i].name);
                                }
                            } else {
                                returnVal.push(value.name);
                            }
                            return returnVal.join(', ');
                        }, width: 120, styler: function (value, row, index) {
                            return {class: 'cell-ellipsis'};
                        }},
                        {field: 'access_groups', title: 'Access Group', formatter: function (value, row, index) {
                            var returnVal = [];
                            for (var i = 0; i < (value || []).length; i++) {
                                returnVal.push(value[i].name);
                            }
                            return returnVal.join(', ');
                        }, width: 220, styler: function (value, row, index) {
                            return {class: 'cell-ellipsis'};
                        }}
                    ]
                ],
                toolbar: '#tb'
            });
        });

        $scope.doPrintPreview = function () {

            $('.sm-container, section.wrap').addClass('reportviewer');
            //$('#printPreviewDlg').show('slow');
            Util.beforeUrl($location.url());
            $location.path('/user/users-report');


        };

        $scope.doAfterOpenDialog = function () {

//			var options = {};
//			options.title = 'Print Preview';
//			options.modal = true;
//			options.onClose = function() {
//				$scope.printPreviewDlg.url = '';
//				$('#printPreviewDlg').dialog('close');
//			};
//			
//			$("#printPreviewDlg").dialog(options);
        };

    });
