'use strict';
define(['modules/common/services/user-agent'],
    function () {
        /*
         * predefined level은 수정할 수 있는 것과 수정할 수 없는 것들이 있는가?
         * */
        var app = angular.module('biostarWebApp');
        app.register.controller('AccountsController', ['$scope', '$location', 'UserAgent', 'MessageService', 'MessageProperties', 'Const', 'API', function ($scope, $location, UserAgent, MessageService, MessageProperties, Const, API) {

            $scope.CanHandleAlarm = Const.PERMISSION_TYPE.CanHandleAlarm;
            $scope.CanUpdate = Const.PERMISSION_TYPE.CanUpdate;
            $scope.CanRead = Const.PERMISSION_TYPE.CanRead;

            var keepPermissionData,
                PermissionItems = (function () {

                    return [
                        {
                            module: "User",
                            permission: 0
                        },
                        {
                            module: "Device",
                            permission: 0
                        },
                        {
                            module: "Access Control",
                            permission: 0
                        },
                        {
                            module: "Monitoring",
                            permission: 0
                        }
                    ]
                });

            function Operators(user_id) {
                this.user_id = user_id;
            }

            function loadPermissionData() {
                API.get('permissions').then(function success(data) {
                    var i, item;
                    $scope.permissionListData = data.PermissionCollection.rows;

                    for (i = $scope.permissionListData.length; i--;) {
                        item = $scope.permissionListData[i];
                    }

                    $scope.doSelectPermission($scope.permissionListData[0]);
                });
            }

            loadPermissionData();

            $scope.selectedItemId = undefined;
            $scope.permissionOperators = [];
            $scope.doSelectPermission = function (item) {
                $scope.selectedItemId = item.id;
                API.get('permissions' + '/' + item.id).then(function (data) {
                    if (!data.Permission.permission_items || data.Permission.permission_items.constructor != Array) {
                        data.Permission.permission_items = new PermissionItems();
                    }

                    keepPermissionData = angular.copy(data.Permission);
                    $scope.permission = angular.copy(data.Permission);
                    for (var i = 0; i < $scope.permission.permission_items.length; i++) {
                        var permissionModule = $scope.permission.permission_items[i];
                        permissionModule.module = Const.PERMISSION_MODULE_NAME[permissionModule.module_id];
                    }
                });
            };

            $scope.addOperators = function () {
                $scope.permissionOperators.push(new Operators());
            };


            $scope.deleteOperators = function ($index) {
                MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                    if (confirmYn) {
                        $scope.permissionOperators.splice($index, 1);
                        if (!$scope.$root.$$phase) $scope.$apply();
                    }
                });
            };

            $scope.setPermission = function (item, permission) {
                if ((item.permission & permission) > 0) {
                    item.permission = item.permission ^ permission;
                } else {
                    item.permission = item.permission | permission;
                }
            };

            $scope.returnBitExpression = function (item, permission) {
                return item.permission & permission;
            };

            $scope.backSetting = function () {
                $location.path('/setting');
            };

            $scope.doApplyPermissionData = function () {

                var id = '',
                    httpProtocol = API.post;

                if ($scope.permission.id) {
                    httpProtocol = API.put;
                    id = '/' + $scope.permission.id;
                }

                var invalid = false;
                if ($scope.permission.id == Const.PERMISSION.ADMIN) {
                    invalid = true;
                    if ($scope.permission.operators != undefined && $scope.permission.operators.length > 0) {
                        for (var i = 0; i < $scope.permission.operators.length; i++) {
                            if (Const.ADMINISTRATOR_DEFAULT_ID == $scope.permission.operators[i].user_id) {
                                invalid = false;
                                break;
                            }
                        }
                    }
                }

                if (invalid == true) {
                    MessageService.displayErrorMessage({Response: {code: Const.SERVER_RESPONSE_CODE.ADMIN_COULD_NOT_BE_DELETED}}, true);
                } else {
                    httpProtocol('permissions' + id, undefined, {"Permission": {"operators": $scope.permission.operators}}).then(function success(data) {
                        loadPermissionData();
                    });
                }
            };

            $scope.doEditCancelPermissionData = function () {
                $scope.permission = angular.copy(keepPermissionData);
                $scope.backSetting();
            };


        }]);
    });
