'use strict';

define([
        'modules/setting/dialog/event-type-modify-dlg'
    ],
    function () {

        var app = angular.module('biostarWebApp');
        app.register.controller('AlertController', ['$scope', 'Const', 'API', '$rootScope', '$location', 'MessageProperties', function ($scope, Const, API, $rootScope, $location, MessageProperties) {
            var applyParams,
                applyQueryParams,
                unenabledAlert,
                isSelected,
                i,
                j,
                k,
                itemArr;

            $scope.DEVICE_LIST = Const.ALERT_TYPE.DEVICE;
            $scope.DOOR_LIST = Const.ALERT_TYPE.DOOR;
            $scope.ZONE_LIST = Const.ALERT_TYPE.ZONE;
            $scope.USER_LIST = Const.ALERT_TYPE.USER;
            $scope.AUTH_LIST = Const.ALERT_TYPE.AUTH;
            $scope.alarmListAll = [];
            $scope.alertList = [[], [], [], [], []];
            $scope.selectedAlert = [[], [], [], [], []];



//            email server setting dialog
            $scope.eventTypeModifyDlg = undefined;
            $scope.doOpenEventTypeModifyDlg = function (eventTypeItem) {
                var eventTypeModifyDlg = {};
                if (eventTypeItem) {
                    window.sessionStorage.setItem('eventTypeItem', angular.toJson(eventTypeItem));
                }
                eventTypeModifyDlg.url = 'modules/setting/dialog/event-type-modify-dlg.html';
                $scope.eventTypeModifyDlg = eventTypeModifyDlg;
            };
            $scope.backSetting = function () {
                $location.path('/setting');
            };



            $scope.$on('closeEventTypeModifyDlg', function (evt, params) {
                var i,
                    chkArr,
                    j,
                    eventProp;
                $scope.eventTypeModifyDlg = {url: ''};
                angular.element('#eventTypeModifyDlg').dialog('destroy');
                if (params && params.updateEventItem) {
                    for (i = $scope.alertList.length; i--;) {
                        chkArr = $scope.alertList[i];
                        for(j = chkArr.length; j--;) {
                            if (chkArr[j].code === params.updateEventItem.code) {
                                for (eventProp in params.updateEventItem) {
                                    chkArr[j][eventProp] = params.updateEventItem[eventProp];
                                    console.log(eventProp);
                                }
                            }
                        }
                    }
                }
            });

            $scope.doAfterOpenEventTypeModifyDlg = function () {
                var options = {};
                options.modal = true;
                options.shadow = false;
                options.width = 500;
//                options.height = 595;
                options.shadow = false;
                options.title = MessageProperties.get('setting.alert.alertMessage');

                options.onClose = function () {
                    $scope.$emit('closeEventTypeModifyDlg');
                    if (!$scope.$$phase) $scope.$apply();
                };
                $("#eventTypeModifyDlg").dialog(options);
            };

            $scope.$on('onAlertListItemClick', function (evt, params) {
                $scope.doOpenEventTypeModifyDlg(params.item);
            });

            $scope.applyEventTypesList = function () {
                applyParams = {
                    EventType: {
                        enable_alert: false
                    }
                };
//                applyParams = angular.toJson(applyParams);
                applyQueryParams = 'id=';
                for (i = $scope.alertList.length; i--;) {
                    itemArr = $scope.alertList[i];
                    for (j = itemArr.length; j--;) {
                        if ($scope.selectedAlert[i].indexOf(itemArr[j]) === -1 && itemArr[j] !== undefined) {
                            console.log(itemArr[j])
                            applyQueryParams += itemArr[j].code + '+';
                        }
                    }
                }
                applyQueryParams = applyQueryParams.slice( 0, -1);
                API.put('event_types?' + applyQueryParams, undefined, applyParams).then(function (data) {
                    applyParams = {
                        EventType: {
                            enable_alert: true
                        }
                    };
//                    applyParams = angular.toJson(applyParams);
                    applyQueryParams = 'id=';
                    for (i = $scope.selectedAlert.length; i--;) {
                        itemArr = $scope.selectedAlert[i];
                        for (j = itemArr.length; j--;) {
                            applyQueryParams += itemArr[j].code + '+';
                        }
                    }
                    applyQueryParams = applyQueryParams.slice( 0, -1);
//                    applyParams = {
//                        EventType: {
//                            enable_alert: false
//                        }
//                    };
////                    applyParams = angular.toJson(applyParams);
//                    applyQueryParams = 'id=';
//                    unenabledAlert = [];
//                    for (i = $scope.alertList.length; i--;) {
//                        itemArr = $scope.alertList[i];
//                        for (j = itemArr.length; j--;) {
//                            isSelected = false;
//                            for (k = $scope.selectedAlert[i].length; k--;) {
//                                if (itemArr[j].code === $scope.selectedAlert[i][j]) {
//                                    isSelected = true;
//                                }
//                            }
//                            if (!isSelected) {
//                                unenabledAlert.push(itemArr[j].code);
//                            }
//                        }
//                    }
//                    for (i = unenabledAlert.length; i--;) {
//                        applyQueryParams += unenabledAlert[i] + '+';
//                    }
//                    applyQueryParams = applyQueryParams.slice( 0, -1);
                    API.put('event_types?' + applyQueryParams, undefined, applyParams).then(function (data) {
                        $location.path('/setting');
                    });
                });
            };

            $scope.cancelEventTypesList = function () {
                $location.path('/setting');
            };

            $rootScope.$on('$routeChangeStart', function (evt, next, curr) {
                window.sessionStorage.removeItem('eventTypeItem');
            });
            function initPageData() {
                API.get('event_types').then(function (data) {
                    var i,
                        item,
                        chkHexa;
                    $scope.alarmListAll = data.EventTypeCollection.rows;
                    for (i = $scope.alarmListAll.length; i--;) {
                        item = $scope.alarmListAll[i];
                        item.code = parseInt(item.code);
                        if (item.alertable === 'true' ) {
                            if (item.code >= 12288 && item.code < 20480) {
                                //TODO BSS-1128 TCP_DISCONNECTED, LINK_DISCONNECTED 막기
                                if (item.code !== 15360 && item.code !== 13312) {
                                    $scope.alertList[$scope.DEVICE_LIST].push(item);
                                    if (item.enable_alert === 'true') {
                                        $scope.selectedAlert[$scope.DEVICE_LIST].push(item);
                                    }
                                }
                            } else if (item.code >= 20480 && item.code < 32768) {
                                //TODO BSS-1128 FIRE_ALARM, TIMED_APB_ALARM 막기
                                if (item.code !== 26368 && item.code !== 25600) {
                                    $scope.alertList[$scope.DOOR_LIST].push(item);
                                    if (item.enable_alert === 'true') {
                                        $scope.selectedAlert[$scope.DOOR_LIST].push(item);
                                    }
                                }
                            }
                            //현재 zone과 user타입의 얼럿은 쓰이고 있지 않아 주석처리
//                            else if (item.code >= 24576 && item.code <= 26624) {
//                                $scope.alertList[$scope.ZONE_LIST].push(item);
//                                if (item.enable_alert === 'true') {
//                                    $scope.selectedAlert[$scope.ZONE_LIST].push(item);
//                                }
//                            } else if (item.code >= 8192 && item.code <= 9472) {
//                                $scope.alertList[$scope.USER_LIST].push(item);
//                                if (item.enable_alert === 'true') {
//                                    $scope.selectedAlert[$scope.USER_LIST].push(item);
//                                }
//                            }
                            else if (item.code >= 4096 && item.code < 8192) {
//                                chkHexa = item.code.toString(16);
//                                chkHexa = parseInt(chkHexa);
//                                chkHexa = parseInt(chkHexa.toString().substr(2, 2));
//                                if (chkHexa === 0x00) {
//                                    $scope.alertList[$scope.AUTH_LIST].push(item);
//                                    if (item.enable_alert === 'true') {
//                                        $scope.selectedAlert[$scope.AUTH_LIST].push(item.code);
//                                    }
//                                }
                                chkHexa = item.code.toString(16);
                                chkHexa = chkHexa.toString().substr(2, 2);
                                if (chkHexa === '00') {
                                    $scope.alertList[$scope.AUTH_LIST].push(item);
                                    if (item.enable_alert === 'true') {
                                        $scope.selectedAlert[$scope.AUTH_LIST].push(item);
                                    }
                                }
                            }
                        }
                    }
                });
            }

            initPageData();
        }]);

        app.register.directive('alertCheckboxList', ['$rootScope', function ($rootScope) {
            return {
                restrict: 'A',
                replace: true,
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    listData: '=',
                    editItemFunction: '&'
                },
                template: '<ul class="selectChkList">' +
                    '<li ' +
                    'ng-repeat="item in listData">' +
                    '<span>' +
                    '<input type="checkbox" class="chkChange"' +
                    'ng-checked="ngModel.indexOf(item) > -1" />' +
                    '<label  ng-click="doClickItem(item)"><span class="txt">{{ item.name }}</span></label>' +
                    '<a href="javascript:void(null);" class="ibtnHistory" ng-click="doClickEditItem(item)">edit</a>' +
                    '</span>' +
                    '<span ng-if="item === \'noData\'">' +
                    'There are no Event type' +
                    '</span>' +
                    '</li>' +
                    '</ul>',
                link: function ($scope, $element) {
                    var i,
                        listItem;
                    for (i = $scope.listData.length; i--;) {
                        listItem = $scope.listData[i];
                    }
                    $scope.doClickItem = function doClickItem(item) {
                        var event = window.event,
                            target = event.target || (event.srcElement || document),
                            idx = $scope.ngModel.indexOf(item);

                        if (idx > -1) {
                            $scope.ngModel.splice(idx, 1);
                            item.enable_alert = false;
                        } else {
                            $scope.ngModel.push(item);
                            item.enable_alert = true;
                        }
                    };
                    $scope.doClickEditItem = function (item) {
                        $scope.$emit('onAlertListItemClick', {item: item});
                    };

//                $scope.editItem = function (item) {
//                    console.log($scope.editFunction);
//                    $scope.editFunction(item);
//                };
                }
            };
        }]);

    });