'use strict';
define(function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('CardBatchEnrollController', ['$scope', '$rootScope', '$location', 'API', 'Const', 'DeviceAgent', function ($scope, $rootScope, $location, API, Const, DeviceAgent) {
        API.get('cards/types').then(function success(data) {
            console.log(data);
            $scope.cardTypeListData = data.CardTypeCollection.rows;
        });

        if (DeviceAgent.getDeviceGroupRecursiveData().then) {
            DeviceAgent.getDeviceGroupRecursiveData().then(function success(data) {
                $scope.DeviceTreeData = [data];
            })
        } else {
            $scope.DeviceTreeData = [DeviceAgent.getDeviceGroupRecursiveData()];
        }

        $scope.doMakeCardList = function () {
            var i,
                item,
                cardCollection = [],
                range = $scope.cardIdEndPoint - $scope.cardIdStartPoint;

            console.log($scope.cardIdStartPoint - $scope.cardIdEndPoint);
            if (range <= 0) {
                console.error('Card ID 범위가 유효하지 않습니다.');
            } else if (!$scope.cardType) {
                console.error('Card Type이 선택되지 않았습니다.');
            } else {
                for (i = 0; i <= range; i++) {
                    item = {
                        "card_id": (parseInt($scope.cardIdStartPoint) + i).toString(),
                        "card_type": $scope.cardType,
                        wiegand_format_id : { // FIXME BSS-188 wiegand_format_id is added here to prevent errors from the server, remove wiegand_format_id only if server does not require wiegand_format_id
                            id : 1
                        }
                    };

                    cardCollection.push(angular.copy(item));
                }

                $scope.cardCollection = cardCollection;
            }
        }


        $scope.doBatchEnrollApply = function () {

            API.post('cards', undefined, {"CardCollection": {"rows": $scope.cardCollection}}).then(function success(data) {
                $scope.doBatchEnrollCancel();
            });
        };

        $scope.doBatchEnrollCancel = function () {
            window.sessionStorage.removeItem('cardInfo');
            $scope.$emit('CloseDetailView');
        };

        $rootScope.$on('$routeChangeStart', function (evt, next, curr) {
            window.sessionStorage.removeItem('cardInfo');
        });
    }]);
});