define([],
    function () {
    var app = angular.module('biostarWebApp');
        app.register.controller('SmtpSetupDlgController', ['$scope', 'API', 'Const',
            function ($scope, API, Const) {
            var AlarmSmtp = function (alarmSmtp) {
                var name,
                description,
                smtp_server_addr,
                smtp_server_port = 25,
                smtp_username,
                smtp_password,
                smtp_security,//['0 = None' or '1 = SSL' or '2 = TLS'],
                smtp_sender;
                if (alarmSmtp) {
                    name = alarmSmtp.name;
                    description = alarmSmtp.description;
                    smtp_server_addr = alarmSmtp.smtp_server_addr;
                    smtp_server_port = alarmSmtp.smtp_server_port;
                    smtp_username = alarmSmtp.smtp_username;
                    smtp_password = alarmSmtp.smtp_password;
                    smtp_security = alarmSmtp.smtp_security;
                    smtp_sender = alarmSmtp.smtp_sender;
                }
                return {
                    name: name,
                    description: description,
                    smtp_server_addr: smtp_server_addr,
                    smtp_server_port: smtp_server_port,
                    smtp_username: smtp_username,
                    smtp_password: smtp_password,
                    smtp_security: smtp_security,
                    smtp_sender: smtp_sender
                };
            },
                pageMode = 'create',
                reqUrl = 'setting/alarm_smtps',
                originalSmtpSetupInfo;
            $scope.smtpSetupInfo = new AlarmSmtp;
            $scope.smtpSetupInfo.smtp_security = 1;
            $scope.SETTING_ALARM_SMTP_SETUP = Const.SETTING_ALARM_SMTP_SETUP;
            $scope.doApplySmtpSetupDlg = function (valid) {
                var params = {AlarmSmtp: $scope.smtpSetupInfo},
                    crud = '';
                if (!angular.equals(originalSmtpSetupInfo, $scope.smtpSetupInfo)) {
                    switch (pageMode) {
                        case 'create':
                            crud = 'post';
                            break;
                        case 'update':
                            crud = 'put';
                            reqUrl = reqUrl + '/' + $scope.smtpSetupInfo.id;
                            break;
                        default:
                            break;
                    }
                    API[crud](reqUrl, undefined, params).then(function (data) {
                        window.sessionStorage.setItem('triggerActionSmtpSetUpInfo', angular.toJson(data.AlarmSmtp));
                        $scope.$emit('closeSmtpSetupDlg');
                    });
                } else {
                    $scope.$emit('closeSmtpSetupDlg');
                }
            };
            $scope.doCancelSmtpSetupDlg = function () {
                $scope.$emit('closeSmtpSetupDlg');
            };




            function initPageData () {
                API.get('setting/alarm_smtps').then(function (data) {
                    if (data.AlarmSmtpCollection.rows.length) {
                        pageMode = 'update';
                        $scope.smtpSetupInfo = data.AlarmSmtpCollection.rows[0];
                        originalSmtpSetupInfo = angular.copy($scope.smtpSetupInfo);
                        window.sessionStorage.setItem('triggerActionSmtpSetUpInfo', angular.toJson($scope.smtpSetupInfo));
                    }
                })
            }
            initPageData();
        }]);
});