'use strict';

define([
        'modules/setting/holidayInfoController',
        'modules/common/datagrid/columnSettingController',
        'modules/common/datagrid/columnSettingService',
        'modules/common/print/printOptionController',
        'modules/common/print/printOptionService'
    ],
    function () {
        var app = angular.module('biostarWebApp');

        app.register.controller('HolidayController', ['$scope', '$rootScope', '$location', '$compile', '$q', '$window', 'API', 'Util', 'Const', 'MessageProperties', 'ColumnSettingService', 'PrintOptionService', 'MessageService', function ($scope, $rootScope, $location, $compile, $q, $window, API, Util, Const, MessageProperties, ColumnSettingService, PrintOptionService, MessageService) {

            $scope.gridId = "holidayGrid";
            var menuID = "#holidayGroupContextMenu";

            var i,
                holidayInfo = undefined,
                holidayListQueryStrings = {
                    query: undefined,
                    offset: 0,
                    limit: 15,
                    total: undefined
                },
                holidayListDataGridOptions = {
                    scrollbarSize: 0,
                    view: $.extend({}, $.fn.datagrid.defaults.view, {
                        onBeforeRender: function (target, rows) {
                            $("#holidayGrid").datagrid('resize');
                        }, onAfterRender: function (target) {
                            $.fn.datagrid.defaults.view.onAfterRender.call(this, target);
                            var grdPanel = angular.element(target).datagrid('getPanel');
                            var opts = angular.element(target).datagrid('options');
                            var vc = grdPanel.children('div.datagrid-view');
                            grdPanel.find(".datagrid-empty").remove();

                            if (angular.element(target).datagrid('getRows').length === 0) {
                                var html = '<div style="width:100%; height:360px; font-size:1.333em; line-height: 360px; ' +
                                    'vertical-align: middle; text-align: center;">' + MessageProperties.get('validate.notFound') +
                                    '</div>';
                                grdPanel.find('div.datagrid-view2 div.datagrid-body').html(html);
                            }

                            //헤더에 전체선택 버튼이 없다면 추가
                            if (grdPanel.find('.datagrid-header-check.compiled').length <= 0) {
                                grdPanel.find('.datagrid-header-check').attr({
                                    'select-all-yn': 'SelectAllYN',
                                    'datagrid-id': '"' + target.id + '"',
                                    'clear-function': 'clearCheckItemArray'
                                });
                                $compile(grdPanel.find('.datagrid-header-row'))($scope);
                                grdPanel.find('.datagrid-header-check').addClass('compiled');
                            }
                        }
                    }),
                    fitColumns: true,
                    resize: true,
                    singleSelect: true,
                    selectOnCheck: false,
                    checkOnSelect: false,
                    columns: [
                        [
                            {
                                field: Const.FIELD_NAME.CHECKBOX, checkbox: true
                            },
                            {
                                field: 'name', title: MessageProperties.get('common.name'), width: 80, align: 'left'
                            },
                            {
                                field: 'description', title: MessageProperties.get('common.description'), width: 80, align: 'left'
                            }
                        ]
                    ],
                    onCheck: function (rowIndex, rowData) {
                        var existsYn = $scope.checkItemArray.indexOf(rowData.id);
                        if(existsYn == -1) {
                            if ($scope.checkItemArray.length >= Const.SELECT_LIST_ITEM_LIMIT) {
                                MessageService.displayWarningMessage(MessageProperties.get('validate.canNotSelectMoreItem', Const.SELECT_LIST_ITEM_LIMIT));
                                angular.element('#holidayGrid').datagrid('uncheckRow', rowIndex);
                            } else {
                                $scope.checkItemArray.push(rowData.id);
                                if (!$scope.$root.$$phase) $scope.$apply();
                            }
                        }
                    },
                    onUncheck: function (rowIndex, rowData) {
                        if ($scope.SelectAllYN == true) {
                            $scope.checkItemArray = [];
                            var data = angular.element('#holidayGrid').datagrid('getChecked');
                            $scope.SelectAllYN = false;
                            if (!$scope.$root.$$phase) $scope.$apply();
                            for (i = 0; i < data.length; i++) {
                                var index = angular.element('#holidayGrid').datagrid('getRowIndex', data[i]);
                                angular.element('#holidayGrid').datagrid('checkRow', index);
                            }
                        } else {
                            var idx = $scope.checkItemArray.indexOf(rowData.id);
                            if (idx > -1) {
                                $scope.checkItemArray.splice(idx, 1);

                                if (!$scope.$root.$$phase) $scope.$apply();
                            }
                        }
                    },
                    onCheckAll: function (rows) {
                        var i, uncheckList = [];
                        for (i = 0; i < rows.length; i++) {
                            var item = rows[i];
                            var idx = $scope.checkItemArray.indexOf(item.id);

                            if (idx == -1) {
                                if ($scope.checkItemArray.length < Const.SELECT_LIST_ITEM_LIMIT) {
                                    $scope.checkItemArray.push(item.id);
                                } else {
                                    uncheckList.push(item);
                                }
                            }
                        }

                        if (uncheckList.length > 0) {
                            MessageService.displayWarningMessage(MessageProperties.get('validate.canNotSelectMoreItem', Const.SELECT_LIST_ITEM_LIMIT));
                            for (i = uncheckList.length; i--;) {
                                console.log(uncheckList[i].user_id);
                                angular.element('#holidayGrid').datagrid('uncheckRow', angular.element('#holidayGrid').datagrid('getRowIndex', uncheckList[i]));
                            }
                        }

                        if (!$scope.$root.$$phase) $scope.$apply();
                    },
                    onUncheckAll: function (rows) {
                        if ($scope.SelectAllYN == true) {
                            $scope.SelectAllYN = false;
                            $scope.checkItemArray = [];
                        }
                        for (var i = rows.length; i--;) {
                            var item = rows[i];
                            var idx = $scope.checkItemArray.indexOf(item.id);
                            if (idx > -1) {
                                $scope.checkItemArray.splice(idx, 1);
                            }
                        }
                        if (!$scope.$root.$$phase) $scope.$apply();
                    },
                    onClickCell: function (rowIndex, field) {
                        $rootScope.clickCellOnGrid($scope.gridId, rowIndex, field, "id", function (rowData) {
                            var holiday_groups;
                            API.get('holiday_groups/' + rowData.id).then(function success(data) {
                                holiday_groups = data.HolidayGroup;
                                window.sessionStorage.setItem('holidayCurrPos', parseInt($scope.holidayListQueryStrings.offset) + rowIndex + 1);
                                window.sessionStorage.setItem('holidayInfo', angular.toJson(holiday_groups));

                                setHolidayInfoUrl();
                            });
                        });
                    },
                    onSortColumn: function (sort, order) {
                        var i,
                            orderItemArray,
                            descending = order == 'desc',
                            orderItemObject = {};

                        $scope.holidayListQueryStrings.order_by = sort + ":" + descending;

                        beSearchHolidayList();
                    }
                };

            function setHolidayInfoUrl() {
                $scope.selectedHolidayInfo = 'modules/setting/holidayInfo.html';
            }

            $scope.doLoadHolidayGroup = function doLoadHolidayGroup(item) {
                var holiday_groups;
                API.get('holiday_groups/' + item.id).then(function success(data) {
                    holiday_groups = data.HolidayGroup;
                    window.sessionStorage.setItem('holidayInfo', angular.toJson(holiday_groups));

                    setHolidayInfoUrl();
                });
            }

            $scope.checkItemArray = [];

            $scope.holidayListQueryStrings = holidayListQueryStrings;
            $scope.HolidayListData = [];

            angular.element('#holidayGrid').datagrid(holidayListDataGridOptions);

            //헤더에 전체선택 버튼 추가
            $scope.SelectAllYN = false;

            $scope.$watch('SelectAllYN', function (nv) {
                if (nv) {
                    angular.element('#holidayGrid').datagrid('checkAll');
                } else {
                    angular.element('#holidayGrid').datagrid('uncheckAll');
                    $scope.checkItemArray = [];
                }
            });

            $scope.cancelSelectAllHoliday = function () {
                angular.element('#holidayGrid').datagrid('uncheckAll');
            };

            function reloadHolidayLNBInfo() {
                API.get('holiday_groups').then(function (data) {
                    $scope.holidayGroupList = data.HolidayGroupCollection.rows;
                });
            }

            reloadHolidayLNBInfo();

            function beSearchHolidayList(query, deferFunctionName) {
                var i, rowData, allHolidayIdList, startIdx, limit;

                if (query) {
                    holidayListQueryStrings.query = query;
                }

                API.get('holiday_groups', 'getHoliday', $scope.holidayListQueryStrings).then(function success(data) {
                    $scope.HolidayListData = data.HolidayGroupCollection.rows || [];
                    window.sessionStorage.setItem('HolidayListData', angular.toJson($scope.HolidayListData));

                    angular.element('#holidayGrid').datagrid('loadData', $scope.HolidayListData);

                    allHolidayIdList = new Array(parseInt(data.HolidayGroupCollection.total));

                    startIdx = parseInt($scope.holidayListQueryStrings.offset);
                    limit = parseInt($scope.holidayListQueryStrings.limit);

                    if (parseInt($scope.holidayListQueryStrings.offset) + parseInt($scope.holidayListQueryStrings.limit) > data.HolidayGroupCollection.total) {
                        limit = parseInt(data.HolidayGroupCollection.total) - $scope.holidayListQueryStrings.offset;
                    }

                    for (i = 0; i < limit; i++) {
                        allHolidayIdList[startIdx + i] = data.HolidayGroupCollection.rows[i].id;
                    }

                    window.sessionStorage.setItem('getAllHolidayIdList', angular.toJson(allHolidayIdList));


                    if ($scope.SelectAllYN) {
                        for (i = $scope.HolidayListData.length; i--;) {
                            rowData = $scope.HolidayListData[i];
                            if ($scope.checkItemArray.indexOf(rowData.id) < 0) {
                                $scope.checkItemArray.push(rowData.id);
                            }
                        }
                    }

                    holidayListQueryStrings.total = data.HolidayGroupCollection.total || 0;

                    if (!$scope.SelectAllYN) {
                        angular.element('.datagrid-header-check').find('input').attr('checked', false);
                    } else {

                    }

                    for (i = $scope.HolidayListData.length; i--;) {
                        rowData = $scope.HolidayListData[i];
                        if ($scope.checkItemArray.indexOf(rowData.id) > -1) {
                            angular.element('#holidayGrid').datagrid('checkRow', i);
                        }
                    }

                });
            }

            beSearchHolidayList();


            $scope.SearchCallback = {
                fn: beSearchHolidayList
            };

            $scope.$on('ReloadHolidaysDataGrid', function (event, data) {
                angular.element('#holidayGrid').datagrid('uncheckAll');
                holidayListQueryStrings.offset = 0;
                if (data && data.offset) {
                    holidayListQueryStrings.offset = data.offset;
                }
                beSearchHolidayList();
                reloadHolidayLNBInfo();
            });

            // Delete Access Levels
            $scope.deleteSelectedHolidayInfo = function (itemIdx) {
                angular.element(menuID).menu("hide");

                var param = $scope.checkItemArray.join('+');
                if ($scope.SelectAllYN) {
                    param = Const.SELECTED_ALL;
                }

                if (itemIdx != undefined) {
                    param = [];
                    param.push(itemIdx);
                }

                MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                    if (confirmYn) {
                        API.del('holiday_groups' + '?id=' + param).then(function success(data) {
                            $scope.$emit('ReloadHolidaysDataGrid');
                        }, function error(data) {

                        });
                    }
                });


            };

            $scope.$watch(function () {
                return  angular.element('.panel.datagrid').width();
            }, function (nv, ov) {
                if (nv !== ov) {
                    angular.element('#holidayGrid').datagrid('resize');
                }
            }, true);

            angular.element($window).on('resize', function ($event) {
                var event = $event | window.event;
                angular.element('#holidayGrid').datagrid('resize');
                Util.debug('div#holidayGrid resize');
            });

            $scope.dropDownMenu = [
//                    {
//                        menu: MessageProperties.get('menu.print'),
//                        func: function () {
//                            PrintOptionService.openPrintOptionPopupDlg();
//                        }
//                    },
                {
                    menu: MessageProperties.get('menu.columnSetting'),
                    func: function () {
                        ColumnSettingService.openColumnSettingPopupDlg();
                    }
                }
            ];

            $scope.doAddHolidayInfo = function () {
                $scope.$emit('OpenHolidayInfo');
            };

            $scope.doLoadHolidayInfo = function (item) {
                if (item.id == Const.DEFAULT_SCHEDULE.NO_TIME || item.id == Const.DEFAULT_SCHEDULE.ALWAYS) {
                    return;
                }
                API.get('holidays/' + item.id, 'getOneHoliday').then(function success(data) {
                    window.sessionStorage.setItem('holidayInfo', angular.toJson(data.Holiday));
                    setHolidayInfoUrl()
                });
            };

            function removeSessionInfo() {
                window.sessionStorage.removeItem('holidayInfo');
                window.sessionStorage.removeItem('HolidayListData');
                window.sessionStorage.removeItem('holidayCurrPos');
            }

            $rootScope.$on('ClickMenuInit', function (event, data) {
                removeSessionInfo();
                $scope.$emit('ReloadHolidaysDataGrid');
                $scope.selectedHolidayInfo = undefined;
            });


            var clickMenuInitUnbind = $scope.$on('CloseHolidayInfo', function (event, data) {
                removeSessionInfo();
                $scope.$emit('ReloadHolidaysDataGrid');
                $scope.selectedHolidayInfo = undefined;
            });

            $scope.$on('$locationChangeStart', clickMenuInitUnbind);

            $scope.$on('OpenHolidayInfo', function (event, data) {
                window.sessionStorage.setItem('holidayInfo', '{}');
                setHolidayInfoUrl();
            });

            holidayInfo = window.sessionStorage.getItem('holidayInfo');

            if (holidayInfo && holidayInfo != 'undefined') {
                holidayInfo = angular.fromJson(holidayInfo);
                setHolidayInfoUrl()
            }

            $scope.doAddScheduleInfo = function () {
                window.sessionStorage.setItem('scheduleInfo', '{}');
                $location.path('/setting/schedule')
            };

            $scope.$watch('holidayListQueryStrings', function (nv, ov) {
                if (nv !== ov) {
                    // TODO BSS-195 BSS-192 server api not implemented
//                        PrintOptionService.buildGridQueryFunction(Const.REPORT_COLLECTION_NAME.ACCESS_GROUP, nv);
                }
            }, true);

            $scope.onClickScheduleTab = function (url) {
                console.log(url);
                $location.path(url);
            };

            $scope.backSetting = function () {
                $location.path('/setting');
            };

            $scope.selectedLnbItem = undefined;

            function initContextMenu() {
                angular.element(menuID).menu({});
            }

            function clearMenuContext(divId) {
                angular.element(divId).find(".menu-item").remove();
            }

            function buildContextMenuDiv(contextMenuObject, ngIfCondition) {
                var html = '<div';
                if (ngIfCondition != undefined) {
                    html += ' ng-if="' + ngIfCondition + '" ';
                }
                html += ' class="menu-item" style="height:31px;" ng-click="' + contextMenuObject.clickFunctionName + '()" ng-privilege><div class="menu-text">' + contextMenuObject.menuName + '</div></div>';
                return html;
            }

            var ContextMenu = {
                'DELETE_HOLIDAY_GROUP' : {
                    menuName: MessageProperties.get('button.deleteHoliday'), clickFunctionName: 'deleteSelectedHolidayInfo(selectedLnbItem)'
                }
            };

            initContextMenu();

            angular.element('.leftTreeMenu').on('contextmenu', function ($event) {
                var event = $event || window.event,
                    target = event.target;

                var top;

                var idx = angular.element(target).closest('li').attr('data-list-index');

                $scope.selectedLnbItem = $scope.holidayGroupList[idx].id;

                if (event.preventDefault()) event.preventDefault();
                if (event.returnValue) event.returnValue = false;

                event.cancelBubble = true;

                angular.element(menuID).menu("hide");
                clearMenuContext(menuID);

                angular.element(menuID).append(buildContextMenuDiv(ContextMenu.DELETE_HOLIDAY_GROUP));

                angular.element(menuID).css("height", "auto");
                angular.element(menuID).css("width", "auto");

                $compile(angular.element(menuID))($scope);

                angular.element(menuID).menu('show', {
                    left: event.pageX,
                    top: event.pageY
                });
            });

            PrintOptionService.getReportColumnNameFunction = function (gridColumnName) {
                var reportColumnName = gridColumnName;
                if (gridColumnName == "holiday_group_id") {
                    return "holiday_groups.name"
                } else if (gridColumnName == "access_groups") {
                    return "access_groups.name"
                } else if (gridColumnName == "fingerprint_templates") {
                    return "finger-tempates.count"
                } else if (gridColumnName == "cards") {
                    return "cards.count"
                }
                return reportColumnName;
            };
            $scope.reportUrl = Const.API.BASE_URL + 'holidays/report';
            $scope.openPrintOptionPopupDlg = PrintOptionService.openPrintOptionPopupDlg;
            $scope.openColumnSettingPopupDlg = ColumnSettingService.openColumnSettingPopupDlg;

            ColumnSettingService.setGridId($scope.gridId);
            ColumnSettingService.setCallbackFunction($scope.SearchCallback.fn);
            var customColumnSetting = ColumnSettingService.getColumnSettingFromLocalStroage();
            if (customColumnSetting) {
                ColumnSettingService.applyChangedColumnsToGrid(customColumnSetting, false);
            }
        }]);
    });