'use strict';


define([
    'modules/common/services/preferenceService'
], function () {

    var app = angular.module('biostarWebApp');
    app.register.controller('PreferenceController', ['$scope', '$location', 'API', 'Const', 'Util', 'Auth', 'PreferenceService', 'MessageProperties', '$http',
        function ($scope, $location, API, Const, Util, Auth, PreferenceService, MessageProperties, $http) {

            var loginUser;

            $scope.languageOptions = Const.PREFERENCE_LANGUAGE_OPTIONS;
            $scope.languageLabelList = {};

            $http.get('/resources/language.label').
                success(function (data, status, headers, config) {
                    var labelList = data.split('\n');
                    for (var i = 0; i < labelList.length; i++) {
                        if (labelList[i] != undefined) {
                            var temp = labelList[i].split('=');
                            if (temp != undefined && temp.length == 2) {
                                if (temp[0] != undefined && temp[1] != undefined) {
                                    $scope.languageLabelList[temp[0].trim()] = temp[1].trim();
                                }
                            }
                        }
                    }
                    //Util.debug('222222', $scope.languageLabelList);
                    $http.get('/resources').
                        success(function (data, status, headers, config) {
                            var optionList = {};
                            //Util.debug(data);
                            var listItem = data.split('.properties</a>');
                            //Util.debug(listItem);
                            for (var i = 0; i < listItem.length; i++) {
                                var oneItem = listItem[i];
                                var index = oneItem.lastIndexOf("messages_");
                                if (index > -1) {
                                    var languageCode = oneItem.substr(index + 9);
                                    if (languageCode != undefined && languageCode.length > 0) {
                                        optionList[languageCode] = $scope.languageLabelList[languageCode];
                                    }
                                }
                            }
                            //Util.debug(optionList);
                            $scope.languageOptions = optionList;
                            if (!$scope.$root.$$phase) $scope.$apply();

                        }).
                        error(function (data, status, headers, config) {
                        });

                }).
                error(function (data, status, headers, config) {
                });


            $scope.dateFormatOptions = Const.DATE_FORMAT_OPTIONS;
            $scope.timeFormatOptions = Const.TIME_FORMAT_OPTIONS;

            PreferenceService.init();

            PreferenceService.getPreference().then(function (data) {
                $scope.preference = angular.copy(data);
            });

            $scope.doApplyPreferenceInfo = function () {
                loginUser = Auth.getUser();
                var timeFormat = $scope.preference.time_format, len = timeFormat.indexOf('mm') + 'mm'.length;
                var timeLongTermFormat = timeFormat.slice(0, len) + ':ss' + timeFormat.slice(len, timeFormat.length);
                var param = {
                    Preference: {
                        user_id: {
                            user_id: loginUser.user_id
                        },
                        language: $scope.preference.language,
                        depend_on_os: $scope.preference.depend_on_os,
                        date_format: $scope.preference.date_format,
                        time_format: $scope.preference.time_format,
                        time_long_term_format: timeLongTermFormat
                    }
                };
                $scope.preference.time_long_term_format = timeLongTermFormat;

                if ($scope.preference.timeZoneObject != undefined) {
                    param.Preference.time_zone = $scope.preference.timeZoneObject.id;
                    $scope.preference.time_zone = param.Preference.time_zone;
                }

                Util.info($scope.preference)

                function applyPreference(preferenceObject) {
                    $scope.preference.default = Const.BOOLEAN.FALSE;
                    PreferenceService.setPreference($scope.preference);
                    if ($scope.preference.language != undefined) {
                        Const.localizationConstantVariables($scope.preference.language);
                    }
                    $location.path('/setting');
                }

                if (PreferenceService.doesDataExistOnServer() == true) {
                    API.put('preferences' + '/' + loginUser.user_id, undefined, param).then(function (data) {
                        applyPreference($scope.preference);
                    })
                } else {
                    API.post('preferences', undefined, param).then(function (data) {
                        applyPreference($scope.preference);
                    })
                }
            }

            $scope.backSetting = function () {
                $location.path('/setting');
            };
        }]);

});