'use strict';
define(function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('SearchCardController', ['$scope', '$rootScope', '$location', 'API', 'Const', 'DeviceAgent', 'CardsAgent', 'MessageProperties', '$timeout', 'MessageService', function ($scope, $rootScope, $location, API, Const, DeviceAgent, CardsAgent, MessageProperties, $timeout, MessageService) {
        API.get('cards/types').then(function success(data) {
            console.log(data);
            $scope.cardTypeListData = data.CardTypeCollection.rows;
        });
        if (DeviceAgent.getDeviceGroupRecursiveData().then) {
            DeviceAgent.getDeviceGroupRecursiveData().then(function success(data) {
                $scope.DeviceTreeData = [data];
            })
        } else {
            $scope.DeviceTreeData = [DeviceAgent.getDeviceGroupRecursiveData()];
        }

        $scope.doMakeCardList = function () {
            var i,
                item,
                cardCollection = [],
                range = $scope.cardIdEndPoint - $scope.cardIdStartPoint;

            if (range <= 0) {
                console.error('Card ID 범위가 유효하지 않습니다.');
            } else if (!$scope.cardType) {
                console.error('Card Type이 선택되지 않았습니다.');
            } else {
                for (i = 0; i <= range; i++) {
                    item = {
                        "card_id": (parseInt($scope.cardIdStartPoint) + i).toString(),
                        "card_type": $scope.cardType
                    };

                    cardCollection.push(angular.copy(item));
                }

                $scope.cardCollection = cardCollection;
            }
        };

        $scope.doSearchCardCancel = function () {
            window.sessionStorage.removeItem('cardInfo');
            $scope.$emit('CloseDetailView');
        };

        $rootScope.$on('$routeChangeStart', function (evt, next, curr) {
            window.sessionStorage.removeItem('cardInfo');
        });


        $scope.targetCard = null;


        $scope.readCard = function () {
            $scope.cardRegistrationProcessMessage = MessageProperties.get('common.placeCardNearCardReader');
//            선택된 카드 타입이 없을시
            if ($scope.cardType === undefined) {
                MessageService.displayWarningMessage(MessageProperties.get('setting.card.selectCardType'), function () {
                    angular.element('#cardTypeComboBox').focus();
                });
                return false;
            }
//            선택된 디바이스가 없을시
            if ($scope.selectedDeviceForRead === undefined) {
                MessageService.displayWarningMessage(MessageProperties.get('setting.card.selectDevice'), function () {
                    angular.element('#deviceComboBox').focus();
                });
                return false;
            }
            $scope.cardRegistrationProcessMessage = MessageProperties.get('common.placeCardNearCardReader');
            $timeout(function () {
                $scope.cardRegistrationProcessMessage = undefined;
            }, 1000);
        };

        $scope.getCard = function (card_id) {
            CardsAgent.getCard(card_id).then(function success(data) {
                $scope.targetCard = data.Card;
                console.log(data);
            }, function error(reason, status) {
                console.log(reason);
            });
        }
    }]);
});