'use strict';

define([
//        'modules/common/services/dialogService'
    'modules/user/fingerprintScanService'
], function () {

    var app = angular.module('biostarWebApp');
    app.register.controller('ServerController', ['$rootScope', '$scope', '$location', 'API', 'Const', 'Util', 'MessageService', 'MessageProperties', 'PrivilegeService', 'DialogService', 'FingerprintScanService', '$timeout', 'Auth',
        function ($rootScope, $scope, $location, API, Const, Util, MessageService, MessageProperties, PrivilegeService, DialogService, FingerprintScanService, $timeout, Auth) {
            var ORIGINAL_SERVER_SETTING,
                chkFingerprintTemplateFormat = false;

            $scope.dialogUrlObject = '';
            $scope.serverSetting = {
                ipAddress: '',
                port: '',
                logUploadType: '',
                automaticUserSync: '',
                checkDuplicateId: '',
                fingerprintTemplateFormat: '',
                autoUpgrade: '',
                sslAvailable: 0,
                sessionTimeout: '',
                upgradeAvailable: false
            };

            $scope.readOnly = true;
            if (PrivilegeService.isUIAuthorizedForUpdate(Const.PERMISSION_MODULE_ID.SETTING)) {
                $scope.readOnly = false;
            }

            API.get('setting/biostar').then(function (data) {
                Util.debug(data);

                ORIGINAL_SERVER_SETTING = data.BioStar;
//                $scope.serverSetting.ipAddress = data.BioStar.server_ip_list[0].ip;
                console.log(!data.BioStar.server_addr || data.BioStar.server_addr.length)
                $scope.serverSetting.ipAddress = data.BioStar.server_addr && data.BioStar.server_addr.length ? data.BioStar.server_addr : Const.BIOSTAR_IP_ADDRESS_LIST_DEFAULT_VALUE;
                Util.debug($scope.serverSetting.ipAddress);
                $scope.serverSetting.port = data.BioStar.server_port;
                $scope.serverSetting.logUploadType = data.BioStar.log_sync_method;
                $scope.serverSetting.automaticUserSync = data.BioStar.user_sync_method;
                $scope.serverSetting.checkDuplicateId = data.BioStar.check_duplicate_id_at_devices;
                $scope.serverSetting.fingerprintTemplateFormat = data.BioStar.fingerprint_format;
                $scope.serverSetting.autoUpgrade = data.BioStar.automatic_server_upgrade;
                $scope.serverSetting.sslAvailable = (data.BioStar.https) ? data.BioStar.https.use_ssl : 0;
                if (data.BioStar.session_timeout != undefined) {
                    $scope.serverSetting.sessionTimeout = parseInt(data.BioStar.session_timeout) / 60;
                }

                $scope.serverSetting.automaticUserSyncOptions = {};
                for (var key in Const.AUTOMATIC_USER_SYNC_OPTION) {
                    if (Const.AUTOMATIC_USER_SYNC_OPTION.hasOwnProperty(key)) {
                        $scope.serverSetting.automaticUserSyncOptions[key] = Const.AUTOMATIC_USER_SYNC_OPTION[key];
                    }
                }

                $scope.serverSetting.fingerprintTemplateFormatOptions = {};
                for (var key in Const.FINGERPRINT_TEMPLATE_FORMAT_OPTION) {
                    if (Const.FINGERPRINT_TEMPLATE_FORMAT_OPTION.hasOwnProperty(key)) {
                        $scope.serverSetting.fingerprintTemplateFormatOptions[key] = Const.FINGERPRINT_TEMPLATE_FORMAT_OPTION[key];
                    }
                }
                console.log('$scope.serverSetting.sslAvailable', $scope.serverSetting.sslAvailable)

                $scope.serverSetting.serverIpAddressOptions = {};
                if (data.BioStar.server_ip_list != undefined) {
                    angular.extend($scope.serverSetting.serverIpAddressOptions, Const.BIOSTAR_IP_ADDRESS_LIST_DEFAULT_OBJECT)
                    for (var i = 0; i < data.BioStar.server_ip_list.length; i++) {
                        $scope.serverSetting.serverIpAddressOptions[data.BioStar.server_ip_list[i].ip] = data.BioStar.server_ip_list[i].ip;
                    }
                }

//            Fingerprint template format 변경시 안내 경고 메세지
//                $scope.$watch('serverSetting.fingerprintTemplateFormat', function (nv, ov) {
//                    if (nv !== ov) {
//                        if (!chkFingerprintTemplateFormat) {
//                           MessageService.displayConfirmMessage(MessageProperties.get('setting.server.fingerprintFormatChangeWarning'), function (isConfirm) {
//                                if (isConfirm) {
//                                    $scope.serverSetting.fingerprintTemplateFormat = nv;
//                                } else {
//                                    $scope.serverSetting.fingerprintTemplateFormat = ov;
//                                    chkFingerprintTemplateFormat = true;
//                                }
//                                if (!$scope.$phase) $scope.$apply();
//                            });
//                        } else {
//                            chkFingerprintTemplateFormat = false;
//                        }
//                    }
//                });
            });

            API.get('setting/biostar/check_update', undefined, undefined, undefined, false, false, false).then(function success(data) {
                $scope.serverSetting.upgradeAvailable = true;
            });

//            function redirectWithNewProtocol(currentUrl, currentProtocol, newProtocol) {
//                Util.debug("redirectWithNewProtocol", currentUrl, currentProtocol, newProtocol);
//                var options = {
//                    url: newProtocol + '://' + $location.host() + ":" + $location.port() + "/#/login",
//                    displaySuccessPopoup: false,
//                    displayErrorPopup: false,
//                    displayLoading: false
//                };
//                API.getWithOptions(options).then(function (data) {
//                    Util.debug("redirectWithNewProtocol respond success", data);
//                    location.href = newProtocol + "://" + currentUrl.slice(location.protocol.length, currentUrl.length);
//                    API.closeLoadingPopup(true);
//                }, function error(data) {
//                    Util.debug("redirectWithNewProtocol respond fail", data);
//                    $timeout(function () {
//                        redirectWithNewProtocol(currentUrl, currentProtocol, newProtocol);
//                    }, 1000);
//                });
//
//            }

            function isProtocolChanged() {
                if ($scope.serverSetting.sslAvailable == Const.SERVER_WEB_SERVER_PROTOCOL.HTTPS && $location.protocol() == Const.WEB_SERVER_PROTOCOL.HTTP) {
                    return true;
                } else if ($scope.serverSetting.sslAvailable == Const.SERVER_WEB_SERVER_PROTOCOL.HTTP && $location.protocol() == Const.WEB_SERVER_PROTOCOL.HTTPS) {
                    return true;
                } else {
                    return false;
                }
            }

            function startWaitingForProtocolChange() {
                var url = $location.absUrl();
                if ($scope.serverSetting.sslAvailable == Const.SERVER_WEB_SERVER_PROTOCOL.HTTPS && $location.protocol() == Const.WEB_SERVER_PROTOCOL.HTTP) {
                    API.openLoadingPopup(true);
                    Auth.clearSessionData();
                    $timeout(function () {
//                        redirectWithNewProtocol(url, $location.protocol(), Const.WEB_SERVER_PROTOCOL.HTTPS);
                        location.href = 'https:' + url.slice(location.protocol.length, url.length);
                    }, 3000);
                    return true;
                } else if ($scope.serverSetting.sslAvailable == Const.SERVER_WEB_SERVER_PROTOCOL.HTTP && $location.protocol() == Const.WEB_SERVER_PROTOCOL.HTTPS) {
                    API.openLoadingPopup(true);
                    Auth.clearSessionData();
                    $timeout(function () {
//                        redirectWithNewProtocol(url, $location.protocol(), Const.WEB_SERVER_PROTOCOL.HTTP);
                        location.href = 'http:' + url.slice(location.protocol.length, url.length);
                    }, 3000);
                    return true;
                }
                return false;
            }

            $scope.doApply = function () {

                var params = {
                        BioStar: {
                            server_addr: $scope.serverSetting.ipAddress == MessageProperties.get("setting.server.ipAddress.any") ? '' : $scope.serverSetting.ipAddress,
                            server_port: $scope.serverSetting.port,
                            log_sync_method: $scope.serverSetting.logUploadType,
                            user_sync_method: $scope.serverSetting.automaticUserSync,
                            check_duplicate_id_at_devices: $scope.serverSetting.checkDuplicateId,
                            fingerprint_format: $scope.serverSetting.fingerprintTemplateFormat,
                            automatic_server_upgrade: $scope.serverSetting.autoUpgrade,
                            https: {
                                use_ssl: $scope.serverSetting.sslAvailable
                            }
                        }
                    },
                    reqFunc = function () {
                        API.put('setting/biostar', undefined, params).then(function (data) {
//                            SGPP전 통일되게 apply 후 메세저 띄우지 않음
//                            MessageService.displayWarningMessage(MessageProperties.get("alert.saved"), function () {
//                                $location.path('/setting');
//                                if (!$scope.$$phase) $scope.$apply();
//                            });
                            var oldServerSetting = Util.getSessionObject(Const.SESSION_STORAGE_KEY.SERVER_SETTING);
                            if (oldServerSetting && oldServerSetting.version) {
                                params.BioStar.version = oldServerSetting.version;
                            }
                            Util.setSessionObject(Const.SESSION_STORAGE_KEY.SERVER_SETTING, params.BioStar);

                            var url = $location.absUrl();

                            if (!startWaitingForProtocolChange()) {
                                $location.path('/setting');
                            }
                            $rootScope.safeApply(undefined, $scope);

                            // 서버 설정 바꿀 경우 -> Fingerprint Tempalte Format 변경되는 경우 FingerprintScanService의 Template 모드를 변경해줘야 합니다.
                            // 현재는 저장하면 무조건 호출해주고 있습니다.
                            FingerprintScanService.setTemplateType();
                        }, function error(data) {
                            if (isProtocolChanged()) {
                                startWaitingForProtocolChange();
                            }
                        });
                    };
                console.log(params);
                if ($scope.serverSetting.sessionTimeout != undefined) {
                    params.BioStar.session_timeout = '' + (parseInt($scope.serverSetting.sessionTimeout) * 60);
                }
                if ($scope.serverSetting.fingerprintTemplateFormat !== ORIGINAL_SERVER_SETTING.fingerprint_format) {
                    MessageService.displayConfirmMessage(MessageProperties.get('setting.server.fingerprintFormatChangeWarning'), function (isConfirm) {
                        if (isConfirm) reqFunc();
                    });
                } else {
                    reqFunc();
                }
            };
            $scope.doUpgrade = function () {
                var dialogOptions = {
                    divId: 'serverSettingDialog',
                    title: MessageProperties.get("common.biostar"),
                    width: 350,
                    okButtonLabel: "button.upgrade",
                    okButtonCallback: function () {
                        API.post('setting/biostar/start_update').then(function success(data) {
                            $scope.serverSetting.upgradeAvailable = false;
                            DialogService.closeDialog(dialogOptions);
                            MessageService.displayWarningMessage(MessageProperties.get('setting.server.upgradeStartedSuccessFully'), function () {
                                    Util.info('start_update called, Clear Session.');
                                    Auth.clearSessionData();
                                    $location.path('/login');
                                }
                            );
                        });
                    },
                    cancelButtonCallback: function () {
                        DialogService.closeDialog(dialogOptions);
                    },
                    content: '<div class="tableTop" style="text-align: center;">\
                    <h4 class="popCntTitleM" ng-label="setting.server.upgradeNow"></h4>\
                    </div>'
                };
                DialogService.openDialog(dialogOptions);
            };
            $scope.backSetting = function () {
                $location.path('/setting');
            };
        }]);
});