'use strict';
define([
        'modules/common/services/device-agent',
        'modules/common/services/user-agent',
//        'modules/device/deviceTreeController',
        'modules/accessControl/add-schedule',
        'modules/accessControl/dialog/door-output-signal-add-dlg',
        'modules/setting/dialog/smtp-setup-dlg'
    ],
    function () {
        var app = angular.module('biostarWebApp');
        app.register.controller('TriggerActionInfoController', ['$scope', 'DeviceAgent', 'DoorAgent', 'API', 'Const', 'Util', 'MessageService', '$rootScope', 'MessageProperties', '$timeout', 'ScheduleAgent',
            function ($scope, DeviceAgent, DoorAgent, API, Const, Util, MessageService, $rootScope, MessageProperties, $timeout, ScheduleAgent) {

                var TriggerAction = (function (triggerAction) {
                    var name = '',
                        priority = 0,
                        schedule_id,
                        trigger = {
                            source_type: undefined,
                            event_types: [],
                            devices: [],
                            doors: []
                        },
                        action = {
                            device_action_id: {
                                device_id: undefined,
                                relay_signal_id: undefined
                            },
                            email_action_id: {
                                receipients: []
                            },
                            smtp_id: undefined
                        };
                    if (triggerAction) {
                        name = triggerAction.name;
                        priority = triggerAction.priority;
                        schedule_id = triggerAction.schedule_id;
                        trigger = triggerAction.trigger;
                        action = triggerAction.action;
                    }
                    return {
                        name: name,
                        priority: priority,
                        schedule_id: schedule_id,
                        trigger: trigger,
                        action: action
                    };
                });
                var DeviceGroupTreeData = DeviceAgent.getDeviceGroupRecursiveData(),
                    defaultTriggerActionType = 1,//device
                    triggerActionEventInfo = [],
                    i,
                    item,
                    defaultTriggerActionActionSet = 0,//device;
                    saveData,
                    OriginalTriggerActionData,
                    pageMode = 'create',
                    TriggerActionListData = [],
                    UserQueryString = angular.copy($scope.userListQueryStrings),
                    triggerActionInfo;

                function safeApply(fn) {
                    $scope.$root.$$phase ? fn() : $scope.$apply(fn);
                }

                function setRelayPortList(output_device_id) {
                    DeviceAgent.getDeviceSpec().then(function success(data) {
                        var i,
                            relayCnt = data[output_device_id.device_type_id.id].relay_num;

                        $scope.TriggerActionsRelayList = {};

                        for (i = 0; i < relayCnt; i++) {
                            var item = {};
                            item[i] = MessageProperties.get('door.relay', i);
                            $scope.TriggerActionsRelayList[i] = MessageProperties.get('door.relay', i);
                        }
                    }, function error() {

                    });

//                DoorAgent.getDeviceTypes(output_device_id.device_type_id.id, setRelayPortList);
                }

                $scope.TAB_BIOSTAR = 0;
                $scope.TAB_DEVICE = 1;
                $scope.TAB_DOOR = 2;
//            $scope.TriggerActionEventData = [];
                $scope.TAB_ITEM_TYPE = angular.copy(Const.TRIGGER_ACTION_TYPE);
                $scope.TAB_ITEM_LABLE = angular.copy(Const.TRIGGER_ACTION_TYPE_LABEL);
                $scope.selectedTriggerActionItems = [
                    [],//biostar
                    [],//device
                    []//door
                ];
                $scope.selectedTriggerActionEventItems = [
                    [],//biostar
                    [],//device
                    []//door
                ];
                $scope.eventListData = [
                    [],
                    [],
                    []
                ];//0: biostar, 1: device, 2: door
                $scope.selectedTriggerActionType;

//            $scope.ActionSetActionData = [];
                $scope.TAB_ACTION_DEVICE = 0;
                $scope.TAB_ACTION_BIOSTAR = 1;
                $scope.TAB_ACTION_ITEM_LABLE = [
                    MessageProperties.get('common.device'),
                    MessageProperties.get('common.biostar')
                ];
                $scope.LABEL = {
                    recipient: MessageProperties.get('setting.triggerAction.recipient')
                };
                $scope.smtpSetup;
                $scope.isBioStarEmailAction = false;
                $scope.selectedTriggerActionActionSet = undefined;
                $scope.selectedTriggerActionActionSetType = defaultTriggerActionActionSet;
                $scope.isNew = false;

                triggerActionInfo = angular.fromJson(window.sessionStorage.getItem('triggerActionInfo'));
                if ($.isEmptyObject(triggerActionInfo)) {//check create
                    OriginalTriggerActionData = new TriggerAction();
                } else {//check put
                    triggerActionInfo.trigger.source_type = parseInt(triggerActionInfo.trigger.source_type);
                    OriginalTriggerActionData = triggerActionInfo;
                    $scope.selectedTriggerActionType = OriginalTriggerActionData.trigger.source_type;
                    pageMode = 'update';
                }
                $scope.triggerActionInfo = OriginalTriggerActionData;
//            if ($scope.triggerActionInfo.action.email_action_id !== undefined && $scope.triggerActionInfo.action.email_action_id.receipients.length > 0) {
//                $scope.isBioStarEmailAction = true;
//            }

                if ($scope.triggerActionInfo.action.smtp_id !== undefined && $scope.triggerActionInfo.action.smtp_id.id !== undefined) {
                    $scope.isBioStarEmailAction = true;
                }

                $scope.$watch('triggerActionInfo.action.device_action_id.device_id', function (nv, ov) {
                    if ($scope.triggerActionInfo.action.device_action_id.device_id && $scope.triggerActionInfo.action.device_action_id.device_id.id) {
                        setRelayPortList($scope.DeviceGroupSearchResult[$scope.triggerActionInfo.action.device_action_id.device_id.id]);
                        if ($scope.triggerActionInfo.action.device_action_id.relay_index === undefined) {
                            $scope.triggerActionInfo.action.device_action_id.relay_index = 0;
                        }
                    }
                }, true);


//        Schedule popup
                $scope.addScheduleDlg = undefined;
                $scope.doOpenAddScheduleDlg = function ($event) {
                    var addScheduleDlg = {};
                    addScheduleDlg.url = 'modules/accessControl/add-schedule.html';
                    $scope.addScheduleDlg = addScheduleDlg;
                };

                $scope.$on('closeAddScheduleDlg', function () {
                    $scope.addScheduleDlg = {url: ''};
                    angular.element('#addScheduleDlg').dialog('destroy');
                });

                $scope.doAfterOpenAddScheduleDlg = function () {
                    var options = {};
                    options.modal = true;
                    options.shadow = false;
                    options.width = 756;
                    options.height = 595;
                    options.shadow = false;
                    options.title = 'Add Schedule';

                    options.onClose = function () {
                        $scope.safeApply(function () {
                            $scope.addScheduleDlg = {};
                            $('#addScheduleDlg').dialog('destroy');
                        });
                    };

                    $("#addScheduleDlg").dialog(options);
                };


//            email server setting dialog
                $scope.smtpSetupDlg = undefined;
                $scope.doOpenSmtpSetupDlg = function ($event) {
                    var smtpSetupDlg = {};
                    smtpSetupDlg.url = 'modules/setting/dialog/smtp-setup-dlg.html';
                    $scope.smtpSetupDlg = smtpSetupDlg;
                };

                $scope.$on('closeSmtpSetupDlg', function () {
                    $scope.smtpSetupDlg = {url: ''};
                    angular.element('#smtpSetupDlg').dialog('destroy');
                    if (window.sessionStorage.getItem('triggerActionSmtpSetUpInfo')) {
                        $scope.smtpSetupInfo = angular.fromJson(window.sessionStorage.getItem('triggerActionSmtpSetUpInfo'));
                    }
                });

                $scope.doAfterOpenSmtpSetupDlg = function () {
                    var options = {};
                    options.modal = true;
                    options.shadow = false;
                    options.width = 500;
//                options.height = 595;
                    options.shadow = false;
                    options.title = MessageProperties.get('setting.triggerAction.smtpOption');

                    options.onClose = function () {
                        $scope.smtpSetupDlg = {};
                        $('#smtpSetupDlg').dialog('destroy');
                    };

                    $("#smtpSetupDlg").dialog(options);
                };


//            TriggerActionType
                //탭 스왑시
                $scope.doClickTriggerActionTypeTabItem = function (index) {
                    $scope.selectedTriggerActionType = index;
                };


//            // 체크된 TriggerActionEvent Item 배열
//            if(!triggerActionEventInfo.event_types) {
//                triggerActionEventInfo.event_types = [];
//            }
//
////            $scope.checkedTriggerActionEventItem = [];
//            for(i = triggerActionEventInfo.event_types.length; i--; ) {
//                item = triggerActionEventInfo.event_types[i];
//                $scope.selectedTriggerActionEventItems[$scope.selectedTriggerActionType].push(item.id);
//            }


//            TriggerActionActionSet
                $scope.doClickTriggerActionActionSetTabItem = function (index) {
                    $scope.selectedTriggerActionActionSetType = index;
                };


                $scope.applyTriggerAction = function () {
                    var reqUrl = '',
                        params,
                        crud = '',
                        selectedTriggerActionType = $scope.selectedTriggerActionType,
                        chkArr,
                        i,
                        isActionDeviceData = false,
                        isActionBioStarEmailData = false,
                        doGoList = function () {
                            window.sessionStorage.removeItem('triggerActionInfo');
                            $scope.$emit('CloseTriggerActionInfo');
                            $scope.$emit('ReloadTriggerActionsDataGrid');
                        },
                        chkValidation = true;
                    $scope.triggerActionInfo.trigger.source_type = selectedTriggerActionType;
                    $scope.triggerActionInfo.trigger.event_types = $scope.selectedTriggerActionEventItems[selectedTriggerActionType];

//                update시 속성없어 에러날 경우 대비
                    if ($scope.triggerActionInfo.action.device_action_id === undefined) {
                        $scope.triggerActionInfo.action.device_action_id = {};
                    }
                    if ($scope.triggerActionInfo.action.email_action_id === undefined) {
                        $scope.triggerActionInfo.action.email_action_id = {};
                        $scope.triggerActionInfo.action.email_action_id.receipients = [];
                    }
//                선택된 device 또는 biostar email 액션 정보가 모두 있을경우 체크
                    if ($scope.triggerActionInfo.action.device_action_id.device_id !== undefined
                        && $scope.triggerActionInfo.action.device_action_id.relay_signal_id !== undefined) {
                        isActionDeviceData = true;
                    }
                    if ($scope.isBioStarEmailAction
                        && $scope.triggerActionInfo.action.email_action_id.receipients.length > 0) {
                        isActionBioStarEmailData = true;
                    } else {
                        isActionBioStarEmailData = false;
                    }
//                name 없는 경우
                    if (!$.trim($scope.triggerActionInfo.name)) {
                        MessageService.displayWarningMessage(MessageProperties.get('validate.inputTriggerActionName'), function () {
                            $('#triggerActionName').focus();
                        });
                        return false;
                    }
//                schedule 없는 경우
                    if (!$scope.triggerActionInfo.schedule_id) {
                        MessageService.displayWarningMessage(MessageProperties.get("validate.selectSchedule"), function () {
                            $('#selectSchedule').focus();
                        });
                        return false;
                    }

//                trigger가 없는경우
                    switch ($scope.selectedTriggerActionType) {
                        case $scope.TAB_BIOSTAR:
                            if ($scope.triggerActionInfo.trigger.biostars.length === 0) {
                                chkValidation = false;
                            }
                            break;
                        case $scope.TAB_DEVICE:
                            if ($scope.triggerActionInfo.trigger.devices.length === 0) {
                                chkValidation = false;
                            }
                            break;
                        case $scope.TAB_DOOR:
                            if ($scope.triggerActionInfo.trigger.doors.length === 0) {
                                chkValidation = false;
                            }
                            break;
                        default:
                            chkValidation = true;
                            break;
                    }
                    if (!chkValidation) {
                        MessageService.displayWarningMessage(MessageProperties.get("validate.noTriggerInfoSelectTrigger"), function () {
                            $('#triggerEl').focus();
                        });
                        return false;
                    }
//                event_types가 없는경우
                    if ($scope.triggerActionInfo.trigger.event_types.length === 0) {
                        MessageService.displayWarningMessage(MessageProperties.get("validate.noEventInfoSelectEvent"));
                        return false;
                    }
//                action이 하나도 없는경우
                    if ($scope.isBioStarEmailAction === false && $scope.triggerActionInfo.action.device_action_id.device_id === undefined) {
                        MessageService.displayWarningMessage(MessageProperties.get("validate.noActionInfoSelectAction"));
                        return false;
                    }

//                BioStar email action이 정보가 완전하지 않을경우
                    if (!isActionBioStarEmailData) {
                        if ($scope.triggerActionInfo.action.device_action_id.device_id !== undefined) {
//                장치 signal 출력이 없는 경우
                            if ($scope.triggerActionInfo.action.device_action_id.relay_signal_id === undefined) {
                                $scope.selectedTriggerActionActionSetType = $scope.TAB_ACTION_DEVICE;
                                MessageService.displayWarningMessage(MessageProperties.get("validate.noActionDeviceSelectActionDevice"), function () {
                                    $('#selectSignal').focus();
                                });
                                return false;
                            }
                        }
                    } else {
//                    이메일 설정이 다 되었는데 smtp 설정 없을 경우
                        if ($scope.smtpSetupInfo === undefined) {
                            MessageService.displayWarningMessage(MessageProperties.get("validate.emailActionNeedSmtpSetup"), function () {
                                safeApply($scope.doOpenSmtpSetupDlg);
                            });
                            return false;
                        }
                    }
//                device action이 정보가 완전하지 않을경우
                    if (!isActionDeviceData) {
                        if ($scope.isBioStarEmailAction === true) {
//                    이메일 설정이 다 되었는데 smtp 설정 없을 경우
                            if ($scope.smtpSetupInfo === undefined) {
                                MessageService.displayWarningMessage(MessageProperties.get("validate.emailActionNeedSmtpSetup"), function () {
                                    safeApply($scope.doOpenSmtpSetupDlg);
                                });
                                return false;
                            }
//                email 리스트 없을 경우
                            if ($scope.triggerActionInfo.action.email_action_id.receipients.length === 0) {
                                $scope.selectedTriggerActionActionSetType = $scope.TAB_ACTION_BIOSTAR;
                                MessageService.displayWarningMessage(MessageProperties.get("validate.noEmailInfoInsertEmailInfo"), function () {
                                    if ($('.ngbssEmailAddDeleteList').css('display') !== 'block') {
                                        $('.ngbssEmailAddDeleteList').css('display', 'block');
                                    }
                                    if ($('.addEmailForm').css('display') === 'none') {
                                    }
                                    $('.ngbssEmailAddDeleteList input').focus();
                                });
                                return false;
                            }
                        }
                    }
//                BioStar email action 데이터가 완전하지 않을 경우 삭제
                    if (!isActionBioStarEmailData) {
//                    $scope.triggerActionInfo.action.email_action_id = undefined;
                        $scope.triggerActionInfo.action.smtp_id = undefined;
                    } else {
                        $scope.triggerActionInfo.action.smtp_id = {};
                        $scope.triggerActionInfo.action.smtp_id.id = $scope.smtpSetupInfo.id;
                    }
//                device action 데이터가 완전하지 않을 경우 삭제
                    if (!isActionDeviceData) {
                        $scope.triggerActionInfo.action.device_action_id = undefined;
                    }
                    console.log($scope.triggerActionInfo);
                    console.log({TriggerAction: $scope.triggerActionInfo});
                    reqUrl = 'trigger_actions';
                    params = {TriggerAction: $scope.triggerActionInfo};
                    switch (pageMode) {
                        case 'create':
                            crud = 'post';
                            break;
                        case 'update':
                            crud = 'put';
                            reqUrl = reqUrl + '/' + $scope.triggerActionInfo.id;
                            break;
                        default:
                            break;
                    }
                    API[crud](reqUrl, undefined, params).then(function (data) {
                        doGoList();
                    });
                };


                $scope.cancelAddTriggerAction = function () {
                    window.sessionStorage.removeItem('triggerActionInfo');
                    saveData = {};
                    $scope.retrieveTheModifiedField($scope.triggerActionInfo, OriginalTriggerActionData);
                    $scope.$emit('CloseTriggerActionInfo');
                };

                $scope.retrieveTheModifiedField = function (modifiedTriggerActiondata, originalTriggerActionData) {

                };

                $rootScope.$on('$routeChangeStart', function (evt, next, curr) {
                    window.sessionStorage.removeItem('TriggerActionListData');
                    window.sessionStorage.removeItem('triggerActionInfo');
                    window.sessionStorage.removeItem('triggerActionSmtpSetUpInfo');
                });

//            초기화 관련
                $scope.init = function () {
                };

                function initPageData() {
                    // Entry, Exit Device Tree Data Load
                    if (DeviceGroupTreeData.then) {
                        DeviceGroupTreeData.then(function success(data) {
                            $scope.DeviceTreeData = [data];
                        }).then(function () {
                        });
                    } else {
                        $scope.DeviceTreeData = [DeviceAgent.getDeviceGroupRecursiveData()];
                    }
                    //Schedule info request
                    ScheduleAgent.getScheduleList().then(function (data) {
                        $scope.ScheduleListData = data.ScheduleCollection.rows;
                    });
//                load smtp setup info
                    API.get('setting/alarm_smtps').then(function (data) {
                        $scope.smtpSetupInfo = data.AlarmSmtpCollection.rows[0];
//                    if ($scope.smtpSetupInfo) {
//                        $scope.triggerActionInfo.action.smtp_id = $scope.smtpSetupInfo.id;
//                    }
                    });
                    //load device info
                    if (DeviceAgent.getAllDevicesMapWithStatus().then) {
                        DeviceAgent.getAllDevicesMapWithStatus().then(function success(data) {
                            $scope.DeviceGroupSearchResult = data;
                        });
                    } else {
                        $scope.DeviceGroupSearchResult = DeviceAgent.getAllDevicesMapWithStatus();

                    }
//                load event_types info
                    API.get('event_types').then(function (data) {
                        var i,
                            item,
                            chkHexa,
                            selectedTriggerActionType,
                            modelEventTypes = $scope.triggerActionInfo.trigger.event_types,
                            eventListDataItem,
                            j,
                            eventTypesAll = data.EventTypeCollection.rows;
                        for (i = eventTypesAll.length; i--;) {
                            item = eventTypesAll[i];
                            item.code = parseInt(item.code);
                            if (item.alertable === 'true') {
                                if (item.code >= 12288 && item.code < 20480) {
                                    //TODO BSS-1128 TCP_DISCONNECTED, LINK_DISCONNECTED 막기
                                    if (item.code !== 15360 && item.code !== 13312) {
                                        $scope.eventListData[$scope.TAB_DEVICE].push(item);
                                    }
                                } else if (item.code >= 20480 && item.code < 32768) {
                                    //TODO BSS-1128 FIRE_ALARM, TIMED_APB_ALARM 막기
                                    if (item.code !== 26368 && item.code !== 25600) {
                                        $scope.eventListData[$scope.TAB_DOOR].push(item);
                                    }
                                }
                            }
                        }
                        if ($scope.selectedTriggerActionType) {
                            selectedTriggerActionType = $scope.selectedTriggerActionType;
                        } else {
                            $scope.selectedTriggerActionType = selectedTriggerActionType = defaultTriggerActionType;
                        }
                        //현재 선택된 탭에 해당하는 저장되었던 event list가 있을 경우
                        if (modelEventTypes.length > 0
                            && selectedTriggerActionType === $scope.triggerActionInfo.trigger.source_type) {
                            for (i = $scope.eventListData[selectedTriggerActionType].length; i--;) {
                                eventListDataItem = $scope.eventListData[selectedTriggerActionType][i];
                                for (j = modelEventTypes.length; j--;) {
                                    if (eventListDataItem.code === parseInt(modelEventTypes[j].code)) {
                                        $scope.selectedTriggerActionEventItems[selectedTriggerActionType].push(eventListDataItem);
                                    }
                                }
                            }
                        }
                    });
                }

                initPageData();
            }]);


        app.register.directive('triggeractionEventList', ['$rootScope', function ($rootScope) {
            return {
                restrict: 'A',
                replace: true,
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    listData: '='
                },
                template: '<ul class="selectChkList">' +
                    '<li ' +
                    'ng-class="{\'checked\':item !== \'noData\', \'noData\':item === \'noData\'}" ' +
                    'ng-repeat="item in listData">' +
                    '<span ng-if="item !== \'noData\'">' +
                    '<input type="checkbox" class="chkChange"' +
                    'ng-checked="ngModel.indexOf(item) > -1"/>' +
                    '<label ng-click="doClickTriggerActionEventItem(item)"><span class="txt">{{ item.name }}</span></label>' +
                    '</span>' +
                    '<span ng-if="item === \'noData\'">' +
                    'There are no TriggerAction Event' +
                    '</span>' +
                    '</li>' +
                    '</ul>',
                link: function ($scope) {
                    $scope.doClickTriggerActionEventItem = function doClickTriggerActionEventItem(triggerActionEventItem) {
                        var idx = $scope.ngModel.indexOf(triggerActionEventItem);
                        if (idx > -1) {
                            $scope.ngModel.splice(idx, 1);
                        } else {
                            $scope.ngModel.push(triggerActionEventItem);
                        }
                        console.log($scope.ngModel);
                    };
                }
            };
        }]);


        app.register.directive('ngbssEmailAddDeleteList', ['$rootScope', 'Util', 'Const', 'MessageService', 'MessageProperties', 'DialogService', function ($rootScope, Util, Const, MessageService, MessageProperties, DialogService) {
            return {
                restrict: 'A',
                replace: true,
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    tableHeader: "@"
                },
                template: '<div class="ngbssEmailAddDeleteList">' +
                    '<div class="tableListTypeA">' +
                    '<table summary="Door, Schedule for information.">' +
                    '<caption>Add Operator</caption>' +
                    '<colgroup>' +
                    '<col width="auto">' +
                    '<col width="42">' +
                    '</colgroup>' +
                    '<thead>' +
                    '<tr>' +
                    '<th>{{ tableHeader }}</th>' +
                    '<th></th>' +
                    '</tr>' +
                    '</thead>' +
                    '<tbody>' +
                    '<tr ng-repeat="email in ngModel">' +
                    '<td>' +
                    '<span title="{{ email }}">{{ email }}</span>' +
                    '</td>' +
                    '<td>' +
                    '<a href="javascript:void(null);" class="ibtnDelete"' +
                    'ng-click="deleteEmail(email)">delete</a>' +
                    '</td>' +
                    '</tr>' +
                    '<tr ng-if="!ngModel || ngModel.length == 0">' +
                    '<td class="space emailNoData" colspan="2">' +
                    '<span ng-label="common.noData"></span>' +
                    '</td>' +
                    '</tr>' +
                    '</tbody>' +
                    '</table>' +
                    '<div class="addEmailForm">' +
                    '<span class="spaceInput"><input type="email" class="input addEmailInput " id="addEmailInput" name="addEmailInput" ng-model="addEmailValue">' +
                    '<span><button type="button" href="javascript:void(null)" class="btnTableIn" id="btnAddEmail" ng-click="confirmAddEmail(addEmailForm.$valid)" ng-label="button.ok"></button></span>' +
                    '</span>' +
                    '</div>' +
                    '</div>' +
                    '<a href="javascript:void(null);"' +
                    'class="btnTextS btnColorBasic tableADD"' +
                    'ng-click="addEmail(email)">+ {{LABEL.add}}</a>' +
                    '</div>',
                link: function ($scope, $element) {
                    $scope.LABEL = {
                        add: MessageProperties.get('common.add')
                    };
                    if (!$scope.ngModel) {
                        $scope.ngModel = [];
                    }
                    if ($scope.ngModel.length === 0) {
                    } else {
                        $('.addEmailForm').css('display', 'none');
                    }
                    $scope.addEmail = function () {
//                        if (isAdding) return false;
                        $('.addEmailForm').toggle();
                        if ($('.addEmailForm').is(':visible')) {
                            $('#addEmailInput').focus();
                        }
                        if ($element.find('.emailNoData').css('display') !== 'none') {
                            $element.find('.emailNoData').css('display', 'none');
                        }

                    };
                    angular.element('.addEmailForm').on('keydown, keypress', function (evt) {
                        if (event.keyCode == 10 || event.keyCode == 13) {
                            if (evt.preventDefault) {
                                evt.preventDefault();
                            }
                            $scope.$apply($scope.confirmAddEmail);
                        }

                    });
                    $scope.deleteEmail = function (email) {
                        MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                            if (confirmYn) {
                                $scope.ngModel.splice($scope.ngModel.indexOf(email), 1);
                            }
                        });
                    };
                    $scope.confirmAddEmail = function () {
                        var inputVal = $('#addEmailInput').val(),
                            i;
//                        이미 입력된 이메일 주소인지 체크
                        for (i = $scope.ngModel.length; i--;) {
                            if (inputVal === $scope.ngModel[i]) {
                                MessageService.displayWarningMessage(MessageProperties.get('validate.emailAlreadyExist'));
                                $('#addEmailInput').focus();
                                return false;
                            }
                        }
                        if (validateEmail(inputVal)) {
                            $scope.ngModel.push(inputVal);
                            $('#addEmailInput').val('');
                        } else {
                            MessageService.displayWarningMessage(MessageProperties.get('validate.emailNotAvailable'), function () {
                                $('#addEmailInput').focus();
                            });
                            return false;
                        }
                    };
                    function validateEmail(email) {
                        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                        return re.test(email);
                    }
                }
            }
        }]);


        //TODO [bjh] 차후 widgetModule로 옮기기
        app.register.directive('ngbssDoorGroupCheckboxTree', ['$rootScope', 'DoorAgent', 'MessageProperties', 'UUID', '$timeout', function ($rootScope, DoorAgent, MessageProperties, UUID, $timeout) {
            return {
                restrict: 'A',
                replace: true,
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    onlyChildYn: '='
                },
                template: '<div class="" ng-class="{\'disabled\':!treeData}">' +
                    '<div>' +
                    '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
                    '<span></span> ' +
                    '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                    '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                    '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                    '<img src="images/common/btn_search_close.png" alt="close">' +
                    '</a>' +
                    '</p>' +
                    '<ul id="{{ treeId }}" class="treeGrid treeTypeDoor" ng-show="searchWord == undefined || searchWord == \'\'"></ul>' +
                    '<ul class="selectList" ng-hide="searchWord == undefined || searchWord == \'\'" tabindex="-1"> ' +
                    '<li ng-repeat="item in filtered = (treeSearchResult | listFilter:searchWord:\'name\')" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                    '<li ng-show="filtered.length == 0"><span> There are no Doors </span></li>' +
                    '</ul>' +
                    '</div>' +
                    '</div>',
                link: function ($scope, $element, $attrs) {
                    var treeOptions,
                        safeApply;

					function doorSelector(nodeId) {
						var findNode;
						var doorTreeArrays = angular.element('#' + $scope.treeId).tree('getChildren', angular.element('#' + $scope.treeId).tree('getRoot').target);

						for(var i = 0; i < doorTreeArrays.length; i++) {
							if(nodeId == doorTreeArrays[i].id && doorTreeArrays[i].isDoorGroups != true) {
								findNode = doorTreeArrays[i];
								break;
							}
						}

						if(findNode && findNode.target) {
							return findNode;
						}

						return undefined;
					}

                    safeApply = function (fn) {
                        if ($scope.$root.$$phase) {
                            fn();
                        } else {
                            $scope.$apply(fn);
                        }
                    };

                    treeOptions = {
                        checkbox: true,
                        cascadeCheck: true,
                        formatter: function (node) {
                            return node.name;
                        },
                        onCheck: function (node, clickYn) {
                            var i,
                                doors = [],
                                doorIds = [],
                                checkedItems = angular.element('#' + $scope.treeId).tree('getChecked');

                            for (i = checkedItems.length; i--;) {
                                if (!checkedItems[i].door_groups) {
                                    doors.push({id: checkedItems[i].id, name: checkedItems[i].name});
                                    doorIds.push(checkedItems[i].id);
                                }
                            }

                            safeApply(function () {
                                $scope.ngModel = angular.copy(doors);
                            });
                        },
                        onSelect: function (node) {
//                        angular.element('#' + $scope.treeId).tree('select', node.target);
                        }
                    };

                    $scope.treeId = UUID();

                    DoorAgent.getDoors(undefined, function successCallback(data) {
                        $scope.treeSearchResult = data.DoorCollection.rows;
                    });

                    function generateTree() {
                        var i,
                            node,
                            items = angular.copy($scope.ngModel);

                        treeOptions.data = $scope.treeData;

                        angular.element('#' + $scope.treeId).tree(treeOptions);
                        if (items && items.length) {
                            for (i = items.length; i--;) {
                                node = doorSelector(items[i].id);
                                angular.element('#' + $scope.treeId).tree('check', node.target);
                            }
                        }

                        $element.attr('tabindex', '-1');
                    }

                    function initTree() {
                        angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        $scope.searchWord = undefined;
                        $element.trigger('blur');
                    }

                    $scope.treeSearchOpen = function treeSearchOpen() {
                        angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                        angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                    };

                    $scope.treeSearchClose = function treeSearchClose() {
                        angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        $scope.searchWord = undefined;
                    };

                    $timeout(function () {
                        // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                        angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                            if (!$scope.searchWord || !$scope.searchWord.length) {
                                angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                            }
                        });
                    }, 50);

                    $element.on('focusin', function () {
                        if (!$scope.treeData) {
                            $element.blur();
                            return false;
                        }
                        $element.addClass('open');
                        $scope.searchWord = undefined;
                    });

                    $element.on('focusout', function () {
                        $element.removeClass('open');
                        $scope.searchWord = undefined;
                    });

                    $scope.$watch('treeId', function (nv, ov) {
                        if (angular.isDefined(nv)) {
                            DoorAgent.getDoorGroupRecursiveDataWithDoors().then(function success(data) {
                                $scope.treeData = data;
                                generateTree();
                            });
                        }
                    });

                    $scope.selectItemInTreeSearchResult = function (item) {
                        var node = doorSelector(item.id);

                        $scope.ngModel = {id: item.id, name: item.name};

                        angular.element('#' + $scope.treeId).tree('check', node.target);
                        initTree();
                    };
                }
            };
        }]);


        app.register.directive('ngbssDeviceGroupTree', ['$rootScope', '$timeout', 'UserAgent', 'DeviceAgent', 'MessageProperties', 'UUID', function ($rootScope, $timeout, UserAgent, DeviceAgent, MessageProperties, UUID) {
            return {
                restrict: 'A',
                replace: true,
                require: '?ngModel',
                scope: {
                    ngModel: '=',
                    treeData: '='
                },
                template: '<div>' +
                    '<p class="searchSelect" id="treeSearchBox_{{ treeId }}" ng-class="{\'typeClear\':searchWord.length}"> ' + // typeInput, typeClear
                    '<span></span> ' +
                    '<input type="text" id="treeSearchBoxInput_{{ treeId }}" ng-model="searchWord" placeholder="">' +
                    '<a href="javascript:void(null);" class="ibtnSearch" data-ng-click="treeSearchOpen()">search</a>' +
                    '<a href="javascript:void(null);" class="btnClose" data-ng-click="treeSearchClose();">' +
                    '<img src="images/common/btn_search_close.png" alt="close">' +
                    '</a>' +
                    '</p>' +
                    '<div class="scrollY"> ' +
                    '<ul id="{{ treeId }}" class="treeTypeDevice" ng-hide="searchWord"></ul>' +
                    '<ul class="selectList" ng-show="searchWord" tabindex="-1"> ' +
                    '<li ng-repeat="item in filtered = (DeviceGroupSearchResult | listFilter:searchWord:\'name\') track by $index" tabindex="-1" ng-click="selectItemInTreeSearchResult(item)">{{ item.name }}</li>' +
                    '<li ng-if="filtered.length==0"><span> There are no Device </span></li>' +
                    '</ul>' +
                    '</div>' +
                    '</div>',
                link: function ($scope, $element, $attrs) {
                    var targetNode;
                    $scope.treeId = UUID();
                    $scope.checkedItems = $scope.ngModel;
                    if (!$scope.ngModel) {
                        $scope.checkedItems = [];
                    }
                    var
                        treeOptions = {
                            checkbox: false,
                            cascadeCheck: false,
                            onClick: function (node) {
                                var targetNode = angular.element('#' + $scope.treeId).tree('find', node.id);
                                if (node.isDevice) {
                                    if ($scope.ngModel === undefined) {
                                        $scope.ngModel = {};
                                    }
                                    if ($scope.ngModel.id !== undefined) {
                                        if ($scope.ngModel.id !== node.id) {
                                            $scope.ngModel.id = node.id;
                                        } else {
                                            $scope.ngModel.id = undefined;
                                            $scope.ngModel = undefined;
                                            $(targetNode.target).removeClass('tree-node-selected');
                                        }
                                    } else {
                                        $scope.ngModel.id = node.id;
                                        $(targetNode.target).addClass('tree-node-selected');
                                    }
                                } else {
                                    $(node.target).removeClass('tree-node-selected');
                                    if ($scope.ngModel !== undefined && $scope.ngModel.id !== undefined) {
                                        targetNode = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                                        $(targetNode.target).addClass('tree-node-selected');
                                    }
                                }
                                if (!$scope.$$phase) {
                                    $scope.$apply();
                                }

                            }
                        };

                    $scope.DeviceGroupSearchResult = [];
                    if (DeviceAgent.getAllDevicesWithoutStatus().then) {
                        DeviceAgent.getAllDevicesWithoutStatus().then(function success(data) {
                            $scope.DeviceGroupSearchResult = data;
                        });
                    } else {
                        $scope.DeviceGroupSearchResult = DeviceAgent.getAllDevicesWithoutStatus();
                    }

                    function safeApply(fn) {
                        $scope.$root.$$phase ? fn() : $scope.$apply(fn);
                    }

                    function removeDisconnectCls(node) {
                        var i, item;

                        if (node.iconCls) {
                            node.iconCls = node.iconCls.replace('disconnect', '');
                        }

                        if (node.children) {
                            for (i = node.children.length; i--;) {
                                removeDisconnectCls(node.children[i])
                            }
                        }
                    }

                    function generateTree() {
                        var i,
                            node,
                            treeElem = angular.element('#' + $scope.treeId),
                            items = angular.copy($scope.ngModel);
                        if ($scope.treeData.constructor !== Array) {
                            $scope.treeData = [$scope.treeData];
                        }
                        removeDisconnectCls($scope.treeData[0]);

                        treeOptions.data = $scope.treeData;

                        treeElem.tree(treeOptions);

                        if (items && items.length) {
                            for (i = items.length; i--;) {
                                node = treeElem.tree('find', items[i].id);
                                treeElem.tree('check', node.target);
                            }
                        }

                        $element.attr('tabindex', '-1');
                        if ($scope.ngModel) {
                            treeElem.tree('select', treeElem.tree('find', $scope.ngModel.id).target);
                        }

                    }

                    if ($scope.treeData) {
                        $timeout(function () {
                            generateTree();
                            if ($scope.ngModel && $scope.ngModel.id) {
                                targetNode = angular.element('#' + $scope.treeId).tree('find', $scope.ngModel.id);
                                angular.element('#' + $scope.treeId).tree('expandTo', targetNode.target);
                            }
                        }, 50);
                    }

                    $scope.$watch('treeData', function (nv, ov) {
                        if (nv !== ov) {
                            $timeout(generateTree, 50);
                        }
                    });

                    $scope.treeSearchOpen = function treeSearchOpen() {
                        angular.element('#treeSearchBox_' + $scope.treeId).addClass('typeInput').removeClass('typeClear');
                        angular.element('#treeSearchBoxInput_' + $scope.treeId).focus();
                    };

                    $scope.treeSearchClose = function treeSearchClose() {
                        angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                        $scope.searchWord = undefined;
                    };

                    $timeout(function () {
                        // Input Control Focus Out 상태일때 검색상자가 공백이라면 비활성화
                        angular.element('#treeSearchBoxInput_' + $scope.treeId).on('focusout', function () {
                            if (!$scope.searchWord || !$scope.searchWord.length) {
                                angular.element('#treeSearchBox_' + $scope.treeId).removeClass('typeInput').removeClass('typeClear');
                            }
                        });
                    }, 50);


                    $element.on('focusin', function () {
                        if (!$scope.treeData) {
                            $element.blur();
                            return false;
                        }
                        $element.addClass('open');
                        $scope.searchWord = undefined;
                    });

                    $element.on('focusout', function () {
                        $element.removeClass('open');
                        $scope.searchWord = undefined;
                    });


//                $scope.MessageProperties = {};
//                $scope.MessageProperties.NotBeFound = MessageProperties.get('validate.notFound');
                }
            };
        }]);


    });
