'use strict';

define(['modules/common/services/card-agent'], function () {
    var app = angular.module('biostarWebApp');
    
    app.register.controller('CardIssueHistoryDlgCtrl',
        ['$scope','$filter','CardsAgent','Const','MessageProperties','PreferenceService',
        function ($scope, $filter, CardsAgent, Const, MessageProperties, PreferenceService) {

        $scope.doCloseCardIssueHistoryDlg = function () {
            $scope.$emit('closeCardIssueHistoryDlg');
        };

        $scope.cardIssueHistory = undefined;

        $scope.cardStatusText = {
            false: MessageProperties.get('common.activate'),
            true: MessageProperties.get('common.deactivate')
        };

        $scope.activateCardTotal = 0;
        function countActivateCard() {
            var i,
                item;

            for (i = $scope.cardIssueHistory.length; i--;) {
                item = $scope.cardIssueHistory[i];

                item.canceled = JSON.parse(item.canceled);

                if (!item.canceled) {
                    $scope.activateCardTotal++;
                }
            }

        }

        $scope.getClientTime = function(dateTime) {
            return $filter('BssDatetimeLongTerm')(dateTime);
        };

        CardsAgent.getCardIssueHistory($scope.user.user_id).then(function success(data) {
            $scope.cardIssueHistory = data.CardIssueHistoryCollection.rows;
            console.log($scope.cardIssueHistory);
            countActivateCard();
            $scope.total = data.CardIssueHistoryCollection.total;
        })

    }]);
});
