'use strict';

define(['modules/user/fingerprintScanService'], function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('UserFingerprintDlgCtrl', ['$scope', '$http', '$timeout', 'API', 'Const', 'Util', 'FingerprintScanService', 'MessageProperties', 'MessageService', 'DeviceAgent', function ($scope, $http, $timeout, API, Const, Util, FingerprintScanService, MessageProperties, MessageService, DeviceAgent) {

        $scope.fingerPrint = {
            "enrollQuality": "40",
            "enrollDevice": undefined,
            "fingerprint_templates": angular.copy($scope.user.fingerprint_templates)
        };

        console.log($scope);

        if (!$scope.fingerPrint.fingerprint_templates) {
            $scope.fingerPrint.fingerprint_templates = [];
            $scope.user.fingerprint_templates = [];
        }

        $scope.FINGERPRINT_QUALITY_LIST = Const.FINGERPRINT_QUALITY_LIST;


        var fpItem = {},
            _bs_session_id = API.getSessionID(),
            SCAN_FIRST_TEMPLATE = 1,
            SCAN_SECOND_TEMPLATE = 2,
            GET_FIRST_TEMPLATE_IMAGE = 4,
            GET_SECOND_TEMPLATE_IMAGE = 8,
            SCAN_FIRST_TEMPLATE_ON_DEVICE = 16,
            SCAN_SECOND_TEMPLATE_ON_DEVICE = 32,
            scanComplete =
                SCAN_FIRST_TEMPLATE | SCAN_SECOND_TEMPLATE,
            scanCompleteOnDevice =
                SCAN_FIRST_TEMPLATE_ON_DEVICE | SCAN_SECOND_TEMPLATE_ON_DEVICE,
            templateImageGetComplete =
                GET_FIRST_TEMPLATE_IMAGE | GET_SECOND_TEMPLATE_IMAGE,
            processComplete =
                SCAN_FIRST_TEMPLATE | SCAN_SECOND_TEMPLATE | GET_FIRST_TEMPLATE_IMAGE | GET_SECOND_TEMPLATE_IMAGE;

        $scope.scaningStatus = 0;
        $scope.fingerprintTemplateImage0 = undefined;
        $scope.fingerprintTemplateImage1 = undefined;
        $scope.fingerprintRawImage0 = undefined;
        $scope.fingerprintRawImage1 = undefined;
        $scope.fingerprintDuressOK = false;

        $scope.fingerprintDuplicationCheckOK = false;
        $scope.fingerprintRawImageViewOK = false;

        $scope.newFingerprintTemplate = [];

        $scope.EnrollQualityData = Const.FINGERPRINT_ENROLL_QUALITY;

        if (!$scope.user.security_level) {
            $scope.user.security_level = 0;
        }

        $scope.checkDuressSettingYN = function checkDuressSettingYN(selectedIdx) {

            var duressCnt = 0,
                fillFpCnt = 0,
                i, item;

            for (i = 0; i < $scope.fingerPrint.fingerprint_templates.length; i++) {
                item = $scope.fingerPrint.fingerprint_templates[i];

                if (item.finger_mask == Const.SERVER_TRUE_STRING && angular.isDefined(item.template0)) {
                    duressCnt++;
                }

                if (angular.isDefined(item.template0)) {
                    fillFpCnt++;
                }
            }

            if ($scope.fingerprintDuressOK == Const.SERVER_FALSE_STRING && $scope.fingerPrint.fingerprint_templates[selectedIdx].finger_mask == Const.SERVER_TRUE_STRING) {
                $scope.fingerPrint.fingerprint_templates[selectedIdx].finger_mask = Const.SERVER_FALSE_STRING;

                return;
            }

            if (fillFpCnt == 1) {
                $scope.fingerPrint.fingerprint_templates[selectedIdx].finger_mask = Const.SERVER_FALSE_STRING;
                $scope.fingerprintDuressOK = Const.SERVER_FALSE_STRING;
                MessageService.displayWarningMessage(MessageProperties.get('validate.atLeastOneNonDuressFingerprint'));

                return;
            } else if (fillFpCnt > 1 && fillFpCnt - duressCnt <= 1) {
                $scope.fingerPrint.fingerprint_templates[selectedIdx].finger_mask = Const.SERVER_FALSE_STRING;
                $scope.fingerprintDuressOK = Const.SERVER_FALSE_STRING;
                MessageService.displayWarningMessage(MessageProperties.get('validate.atLeastOneNonDuressFingerprint'));

                return;
            }

            $scope.fingerPrint.fingerprint_templates[selectedIdx].finger_mask = Const.SERVER_TRUE_STRING;
            $scope.fingerprintDuressOK = Const.SERVER_TRUE_STRING;
        };

        function checkCanDeleteFingerprint(selectedIdx) {
            var duressCnt = 0,
                fillFpCnt = 0,
                i, item;

            for (i = 0; i < $scope.fingerPrint.fingerprint_templates.length; i++) {
                item = $scope.fingerPrint.fingerprint_templates[i];

                if (i != selectedIdx) {
                    if (item.finger_mask == Const.SERVER_TRUE_STRING && angular.isDefined(item.template0)) {
                        duressCnt++;
                    }

                    if (angular.isDefined(item.template0)) {
                        fillFpCnt++;
                    }
                }
            }
            console.log(duressCnt != fillFpCnt);
            console.log(duressCnt, fillFpCnt);

            if (duressCnt == 0) {
                return true;
            }

            return duressCnt != fillFpCnt;
        }

        function createTreeNode(originalNode, newNode) {
//            newNode.status = originalNode.status;
            newNode.name = originalNode.name;
            newNode.text = originalNode.text;
            newNode.id = originalNode.id;
            newNode.device_type_id = originalNode.device_type_id;
            newNode.isDevice = originalNode.isDevice;
            newNode.iconCls = originalNode.iconCls;
            newNode.rs485 = originalNode.rs485;
//            newNode.status = originalNode.status;
            return newNode;
        }

        function remainingFingerprintScanDevice(newTreeNode, originalTreeNode) {
            var item, newChildren = [];

            newTreeNode = createTreeNode(originalTreeNode, newTreeNode);

            if (originalTreeNode.children != undefined) {
                for (var i = 0; i < originalTreeNode.children.length; i++) {
                    var originalChildNode = originalTreeNode.children[i];
                    var newChildNode = {};

                    if (newTreeNode.children == undefined) {
                        newTreeNode.children = [];
                    }

                    if (angular.isUndefined(originalChildNode.device_type_id)) {
                        newTreeNode.children.push(newChildNode);
                    } else if (Const.FINGERPRINT_DEVICES.indexOf(originalChildNode.device_type_id.id) > -1) {
                        if ((originalChildNode.rs485.mode == Const.RS485_MODE.SLAVE || originalChildNode.rs485.mode == Const.RS485_MODE.AUTO) &&
                            originalChildNode.parent_node_id != undefined) {
                            // do not display slave device
                        } else {
                            if (originalChildNode.rs485.mode != Const.RS485_MODE.SLAVE) {
                                newTreeNode.children.push(newChildNode);
                            }
                        }
                    }

                    remainingFingerprintScanDevice(newChildNode, originalChildNode);
                }
            }
        }

        $scope.EnrollDeviceData = [
            {}
        ];
        if (DeviceAgent.getDeviceGroupRecursiveData().then) {
            DeviceAgent.getDeviceGroupRecursiveData().then(function success(data) {

                remainingFingerprintScanDevice($scope.EnrollDeviceData[0], data);
            })
        } else {
            remainingFingerprintScanDevice($scope.EnrollDeviceData[0], DeviceAgent.getDeviceGroupRecursiveData());
        }

        // USBDeviceData
        FingerprintScanService.connectCheckUSBDevice().then(function (data) {
            var responseData = angular.fromJson(data);
            if (responseData && responseData.retcode && responseData.retcode != -2) {
                $scope.USBDeviceData = [
                    {
                        'id': '0',
                        'name': 'USB Device',
                        'text': 'USB Device',
                        'children': [
                            {
                                'id': Const.BIO_MINI_ID,
                                'name': 'USB Scanner',
                                'text': 'USB Scanner',
                                'iconCls': 'dvBiomini'
                            }
                        ]
                    }
                ];

            } else {
                // USB Agent 가 성공으로 응답했으나 responseData.retcode == -2 이면 USB 장치가 연결되지 않은 것이다.
            }
        });

        function scanCancel(data) {
            $scope.scaningStatus = 0;
            $scope.fingerPrintScanProcessMessage = MessageProperties.get('validate.failedToScanFingerPrint');

            $timeout(function () {
                $scope.qualityMessage = undefined;
                $scope.fingerPrintScanProcessMessage = undefined;
            }, 1000);

            fpItem = {};
        }

//        $scope.selectedIdx
        $scope.doScanFingerPrint = function () {
            var fingerprintIdx = parseInt($scope.selectedIdx) + 1;

            if (!$scope.fingerPrint.enrollDevice || !$scope.fingerPrint.enrollDevice.id) {
                MessageService.displayWarningMessage(MessageProperties.get('validate.pleaseDeviceSelect'));
                return;
            }

            if ($scope.selectedIdx == undefined) {
                MessageService.displayWarningMessage(MessageProperties.get('validate.pleaseSelectFingerprintItem'));
                return false;
            }

            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.pleasePlaceFingerNearTheSensor', fingerprintIdx == 1 ? MessageProperties.get('common.fingerprintIndexFirst', '1') : (fingerprintIdx == 2) ? MessageProperties.get('common.fingerprintIndexSecond', '2') : (fingerprintIdx == 3) ? MessageProperties.get('common.fingerprintIndexThird', '3') : MessageProperties.get('common.fingerprintIndexFourthOrMore', fingerprintIdx));

            if ($scope.fingerPrint.enrollDevice.id == Const.BIO_MINI_ID) {
                FingerprintScanService.getFingerprint({ cache: false, params: {
                    'enroll_quality': $scope.fingerPrint.enrollQuality} }).then(function success(data) {

                    var retCode = angular.fromJson(data);
                    fpItem.template0 = retCode.template;
                    fpItem.image0 = retCode.image.data;

                    $scope.$emit('scanSecondFingerTemplate');

                    $scope.scaningStatus = $scope.scaningStatus | SCAN_FIRST_TEMPLATE;
                }, scanCancel)
            } else {
                API.post('devices/' + $scope.fingerPrint.enrollDevice.id + '/scan_fingerprint', 'scanFingerprint',
                    {"ScanFingerprintOption": {"enroll_quality": $scope.fingerPrint.enrollQuality, "raw_image": $scope.fingerprintRawImageViewOK}},
                    undefined, undefined, undefined, false).then(function success(data) {
                        if (data.FingerprintTemplate) {
                            fpItem.template0 = data.FingerprintTemplate.template0;

                            if (data.FingerprintTemplate.template_image0) {
                                fpItem.template0Img = data.FingerprintTemplate.template_image0;
                            }

                            if (data.FingerprintTemplate.raw_image0) {
                                fpItem.image0 = data.FingerprintTemplate.raw_image0;
                            }

							$scope.fingerPrintScanProcessMessage = MessageProperties.get('common.pleasePlaceFingerNearTheSensor', fingerprintIdx == 1 ? MessageProperties.get('common.fingerprintIndexFirst', '1') : (fingerprintIdx == 2) ? MessageProperties.get('common.fingerprintIndexSecond', '2') : (fingerprintIdx == 3) ? MessageProperties.get('common.fingerprintIndexThird', '3') : MessageProperties.get('common.fingerprintIndexFourthOrMore', fingerprintIdx));
                            $scope.qualityMessage = MessageProperties.get('user.fingerprintEnrollQuality', data.FingerprintTemplate.enroll_quality);

                            $timeout(function () {
                                $scope.qualityMessage = undefined;
                                $scope.$emit('scanSecondFingerTemplateOnDevice');
                                $scope.scaningStatus = $scope.scaningStatus | SCAN_FIRST_TEMPLATE_ON_DEVICE;
                            }, 500);

                        } else {
                            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.scanQualityIsLow');
                            $timeout(function () {
                                $scope.fingerPrintScanProcessMessage = undefined;
                            }, 500);
                        }

                    }, scanCancel);
            }
        };

        $scope.$on('scanSecondFingerTemplate', function (event, data) {
            var fingerprintIdx = parseInt($scope.selectedIdx) + 1;
			$scope.fingerPrintScanProcessMessage = MessageProperties.get('common.pleasePlaceFingerNearTheSensorAgain', fingerprintIdx == 1 ? MessageProperties.get('common.fingerprintIndexFirst', '1') : (fingerprintIdx == 2) ? MessageProperties.get('common.fingerprintIndexSecond', '2') : (fingerprintIdx == 3) ? MessageProperties.get('common.fingerprintIndexThird', '3') : MessageProperties.get('common.fingerprintIndexFourthOrMore', fingerprintIdx));
            FingerprintScanService.getFingerprint({ cache: false, params: {
                'enroll_quality': $scope.fingerPrint.enrollQuality} }).then(function success(data) {
                var retCode = angular.fromJson(data);
                fpItem.template1 = retCode.template;
                fpItem.image1 = retCode.image.data;

                $scope.$emit('getFirstTemplateImg');
                $scope.scaningStatus = $scope.scaningStatus | SCAN_SECOND_TEMPLATE;
            }, scanCancel)
        });

        $scope.$on('scanSecondFingerTemplateOnDevice', function (event, data) {
            var fingerprintIdx = parseInt($scope.selectedIdx) + 1;
			$scope.fingerPrintScanProcessMessage = MessageProperties.get('common.pleasePlaceFingerNearTheSensorAgain', fingerprintIdx == 1 ? MessageProperties.get('common.fingerprintIndexFirst', '1') : (fingerprintIdx == 2) ? MessageProperties.get('common.fingerprintIndexSecond', '2') : (fingerprintIdx == 3) ? MessageProperties.get('common.fingerprintIndexThird', '3') : MessageProperties.get('common.fingerprintIndexFourthOrMore', fingerprintIdx));
            API.post('devices/' + $scope.fingerPrint.enrollDevice.id + '/scan_fingerprint', 'scanFingerprint',
                {"ScanFingerprintOption": {"enroll_quality": $scope.fingerPrint.enrollQuality, "raw_image": $scope.fingerprintRawImageViewOK}},
                undefined, undefined, undefined, false).then(function success(data) {
                    if (data.FingerprintTemplate) {
                        fpItem.template1 = data.FingerprintTemplate.template0;

                        if (data.FingerprintTemplate.template_image0) {
                            fpItem.template1Img = data.FingerprintTemplate.template_image0;
                        }

                        if (data.FingerprintTemplate.raw_image0) {
                            fpItem.image1 = data.FingerprintTemplate.raw_image0;
                        }


                        $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.pleasePlaceFingerNearTheSensorAgain', fingerprintIdx == 1 ? '1st' : (fingerprintIdx == 2) ? '2nd' : (fingerprintIdx == 3) ? '3rd' : fingerprintIdx + 'th');
                        $scope.qualityMessage = MessageProperties.get('user.fingerprintEnrollQuality', data.FingerprintTemplate.enroll_quality);
                        $timeout(function () {
                            $scope.qualityMessage = undefined;
                            $scope.scaningStatus = $scope.scaningStatus | SCAN_SECOND_TEMPLATE_ON_DEVICE;
                        }, 500);

                    } else {
                        $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.scanQualityIsLow');
                        $timeout(function () {
                            $scope.fingerPrintScanProcessMessage = undefined;
                        }, 500);
                    }

                }, scanCancel);
        });

        $scope.$on('getFirstTemplateImg', function (event, data) {
            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.loadFirstFingerprintTemplate');
            FingerprintScanService.getTemplateFingerprintImg({
                'template': fpItem.template0
            }).then(function success(data) {
                var images = angular.fromJson(data);
                fpItem.template0Img = images.image.data;
                $scope.scaningStatus = $scope.scaningStatus | GET_FIRST_TEMPLATE_IMAGE;

                $scope.$emit('getSecondTemplateImg', {'template': data.template});
            }, scanCancel)
        });

        $scope.$on('getSecondTemplateImg', function (event, data) {
            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.loadSecondFingerprintTemplate');
            FingerprintScanService.getTemplateFingerprintImg({
                'template': fpItem.template1
            }).then(function success(data) {
                var images = angular.fromJson(data);
                fpItem.template1Img = images.image.data;
                $scope.scaningStatus = $scope.scaningStatus | GET_SECOND_TEMPLATE_IMAGE;
            }, scanCancel)
        });


        $scope.$watch('scaningStatus', function (nv, ov) {
            console.log('scaningStatus::::::::::::::', nv, ov)
            if (nv !== ov) {
                if (processComplete == nv) {
                    $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.verifyingFingerprints');
                    FingerprintScanService.getVerifyFingerprint({
                        'template1': fpItem.template0, 'template2': fpItem.template1
                    }).then(function success(data) {

                        $scope.fingerprintTemplateImage0 = fpItem.template0Img;
                        $scope.fingerprintTemplateImage1 = fpItem.template1Img;
                        $scope.fingerprintRawImage0 = fpItem.image0;
                        $scope.fingerprintRawImage1 = fpItem.image1;


//                        $.messager.progress('close');
                        $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.fingerprintScanCompleted');
                        $timeout(function () {
                            $scope.qualityMessage = undefined;
                            $scope.fingerPrintScanProcessMessage = undefined;
                        }, 1000);
                        $scope.scaningStatus = 0;


                        $scope.fingerPrint.fingerprint_templates[$scope.selectedIdx]
                            = angular.copy({
                            template0: fpItem.template0,
                            template1: fpItem.template1,
                            template0Img: fpItem.template0Img,
                            template1Img: fpItem.template1Img,
                            finger_mask: $scope.fingerprintDuressOK,
                            finger_index: $scope.selectedIdx
                        });

                        fpItem = {};
                    }, scanCancel);
                } else if (templateImageGetComplete == nv) {
                    $scope.fingerprintTemplateImage0 = fpItem.template0Img;
                    $scope.fingerprintTemplateImage1 = fpItem.template1Img;
                    $scope.fingerprintRawImage0 = fpItem.image0;
                    $scope.fingerprintRawImage1 = fpItem.image1;

                    $timeout(function () {
                        $scope.qualityMessage = undefined;
                        $scope.fingerPrintScanProcessMessage = undefined;
                    }, 1000);
                    $scope.scaningStatus = 0;
                } else if (scanCompleteOnDevice == nv) {
                    $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.verifyingFingerprints');
                    API.post(Const.API.BASE_URL + 'devices/' + $scope.fingerPrint.enrollDevice.id + '/verify_fingerprint',
                        'verifyFingerprint',
                        {"FingerprintTemplate": {"template0": fpItem.template0, "template1": fpItem.template1}, "VerifyFingerprintOption": {"security_level": $scope.user.security_level}},
                        undefined, undefined, undefined, false).then(function success(data) {


                            if (data.DeviceResponse.result == 'false') {
                                scanCancel(data);
                                return;
                            }

                            $scope.fingerprintTemplateImage0 = fpItem.template0Img;
                            $scope.fingerprintTemplateImage1 = fpItem.template1Img;

                            $scope.fingerprintRawImage0 = fpItem.image0;
                            $scope.fingerprintRawImage1 = fpItem.image1;

                            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.fingerprintScanCompleted');
                            $timeout(function () {
                                $scope.qualityMessage = undefined;
                                $scope.fingerPrintScanProcessMessage = undefined;
                            }, 1000);
                            $scope.scaningStatus = 0;


                            $scope.fingerPrint.fingerprint_templates[$scope.selectedIdx]
                                = angular.copy({
                                template0: fpItem.template0,
                                template1: fpItem.template1,
                                template0Img: fpItem.template0Img,
                                template1Img: fpItem.template1Img,
                                finger_mask: $scope.fingerprintDuressOK,
                                finger_index: $scope.selectedIdx
                            });

                            fpItem = {};
                        }, scanCancel);
                }
            }
        });

        $scope.doAddFingerprint = function () {
            if ($scope.fingerPrint.fingerprint_templates.length >= 10) {
                return false;
            }
            $scope.fingerPrint.fingerprint_templates.push({
                template0: undefined, template1: undefined, finger_mask: false, finger_index: undefined
            });
            $scope.selectedIdx = $scope.fingerPrint.fingerprint_templates.length - 1;

            $scope.scaningStatus = 0;
            $scope.fingerprintTemplateImage0 = undefined;
            $scope.fingerprintTemplateImage1 = undefined;
            $scope.fingerprintRawImage0 = undefined;
            $scope.fingerprintRawImage1 = undefined;
            $scope.fingerprintDuressOK = false;

            fpItem = {};
        };

        $scope.selectedIdx = undefined;
        $scope.doSelectItem = function (index) {
            $scope.selectedIdx = index;

            $scope.scaningStatus = 0;
            $scope.fingerprintTemplateImage0 = undefined;
            $scope.fingerprintTemplateImage1 = undefined;
            $scope.fingerprintRawImage0 = undefined;
            $scope.fingerprintRawImage1 = undefined;
            $scope.fingerprintDuressOK = false;

            if ($scope.fingerPrint.fingerprint_templates[index].template0) {
                fpItem = angular.copy($scope.fingerPrint.fingerprint_templates[index]);
                $scope.fingerprintTemplateImage0 = fpItem.template_image0 || fpItem.template0Img;
                $scope.fingerprintTemplateImage1 = fpItem.template_image1 || fpItem.template1Img;
                $scope.fingerprintDuressOK = fpItem.finger_mask;
            }
        };

        $scope.doApplyFingerPrintScan = function () {

            var i, item, fillFpCnt = 0;

            for (i = 0; i < $scope.fingerPrint.fingerprint_templates.length; i++) {
                item = $scope.fingerPrint.fingerprint_templates[i];

                if (angular.isDefined(item.template0)) {
                    fillFpCnt++;
                }
            }

            if (fillFpCnt < $scope.fingerPrint.fingerprint_templates.length) {
                MessageService.displayWarningMessage(MessageProperties.get("validate.pleaseScanFingerprint"));
                return false;
            }

            $scope.user.fingerprint_templates = angular.copy($scope.fingerPrint.fingerprint_templates);
            for (i = 0; i < $scope.user.fingerprint_templates.length; i++) {
                var oneTemplate = $scope.user.fingerprint_templates[i];
                oneTemplate.finger_index = undefined;
            }

            $scope.$emit('closeFingerPrintScanDlg');
        };

        $scope.doCancelFingerPrintScan = function () {
            $scope.$emit('closeFingerPrintScanDlg');
        };

        $scope.doDeleteFingerPrint = function () {
            if ($scope.selectedIdx == undefined) {
                MessageService.displayWarningMessage(MessageProperties.get('validate.pleaseSelectFingerprintItem'));
                return false;
            }

            if (!checkCanDeleteFingerprint($scope.selectedIdx)) {
                MessageService.displayWarningMessage(MessageProperties.get('validate.atLeastOneNonDuressFingerprint'));
                return false;
            }

            MessageService.displayConfirmMessage(MessageProperties.get('confirm.delete'), function (confirmYn) {
                if (confirmYn) {

                    $scope.scaningStatus = 0;
                    $scope.fingerprintTemplateImage0 = undefined;
                    $scope.fingerprintTemplateImage1 = undefined;
                    $scope.fingerprintRawImage0 = undefined;
                    $scope.fingerprintRawImage1 = undefined;

                    $scope.fingerprintDuressOK = false;

                    $scope.fingerPrint.fingerprint_templates.splice($scope.selectedIdx, 1);

                    $scope.selectedIdx = undefined;

                    if (!$scope.$root.$$phase) $scope.$apply();
                }
            });
        };

        $scope.doVerifyFingerPrint = function () {
            if ($scope.selectedIdx == undefined) {
                return false;
            }

            if ($scope.selectedIdx == undefined) {
                return false;
            }
            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.scanFingerprintForVerification');
            FingerprintScanService.getFingerprint({ cache: false, params: {
                'enroll_quality': $scope.fingerPrint.enrollQuality} }).then(function success(data) {

                $scope.$emit('VerificationTest', data);

            }, scanCancel);
        };

        $scope.$on('VerificationTest', function (event, data) {
            $scope.fingerPrintScanProcessMessage = MessageProperties.get('common.verifyingFingerprints');

            FingerprintScanService.getVerifyFingerprint({
                'template1': fpItem.template0, 'template2': data.template
            }).then(function success(data) {
                $scope.fingerPrintScanProcessMessage = MessageProperties.get('validate.fingerprintsMatched');
                $timeout(function () {
                    $scope.fingerPrintScanProcessMessage = undefined;
                }, 1000);
            }, function error(reason, status) {
                console.error(reason, status);
                $scope.fingerPrintScanProcessMessage = reason;
                $timeout(function () {
                    $scope.fingerPrintScanProcessMessage = undefined;
                    $scope.qualityMessage = undefined;
                }, 1000);
            });
        })
    }]);
});