'use strict';

define(function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('UserUserGroupInfoChangeDlgCtrl',
        ['$scope','$element','$rootScope','API','Const','MakeGroupTree','ModifiedFieldExtraction',
        function ($scope, $element, $rootScope, API, Const, MakeGroupTree, ModifiedFieldExtraction) {

        $scope.safeApply = function (fn) {
            var phase = this.$root.$$phase;
            if (phase == '$apply' || phase == '$digest') {
                if (fn && (typeof(fn) === 'function')) {
                    fn();
                }
            } else {
                this.$apply(fn);
            }
        };

        var origin_data = '';
        var group_id = $scope.user_groups_data.id;
        if (angular.isDefined($scope.user_groups_data.UserGroup)) {
            group_id = $scope.user_groups_data.UserGroup.id;
        }
        console.info($scope.selectTreeItem);
        API.get('user_groups/' + group_id).then(function (data) {
            $scope.safeApply(function () {
                origin_data = angular.toJson(data);

                var user = {};
                user.start_datetime = data.UserGroup.start_datetime;
                user.expiry_datetime = data.UserGroup.expiry_datetime;

                if (angular.isDefined(data.UserGroup.start_datetime)) {
                    var start_datetime = data.UserGroup.start_datetime.slice(0, 10).split('-');
                    data.UserGroup.start_date = start_datetime.join('/');
                    user.start_date = start_datetime.join('/');
                }
                if (angular.isDefined(data.UserGroup.expiry_datetime)) {
                    var expiry_datetime = data.UserGroup.expiry_datetime.slice(0, 10).split('-');
                    data.UserGroup.expiry_date = expiry_datetime.join('/');
                    user.expiry_date = expiry_datetime.join('/');
                }

                if (angular.isUndefined(data.UserGroup.sync_device_groups)) {
                    data.UserGroup.sync_device_groups = [];
                }
                if (angular.isUndefined(data.UserGroup.sync_devices)) {
                    data.UserGroup.sync_devices = [];
                }

                $scope.user = user;
                $scope.userGroup = data.UserGroup;
                console.log($scope.userGroup.sync_device_groups);

                $scope.collectCheckedDeviceItem(data.UserGroup.sync_devices);

                var item, i, cnt = -1;
                if (angular.isDefined($scope.userGroup.sync_devices)) {
                    for (i = 0; i < $scope.userGroup.sync_devices.length; i++) {
                        item = $scope.userGroup.sync_devices[i];
                        if (cnt < 0) {
                            $scope.devicesSelectString = item.name;
                        }
                        cnt++;
                    }
                }

                fnMakeSelectDevicesString(cnt);
            });
        });


        $rootScope.$on('getDate', function (e, m) {

            $scope.userGroup.start_datetime = m.start_datetime;
            $scope.userGroup.expiry_datetime = m.expiry_datetime;

            var user = {};
            if (angular.isDefined($scope.user)) {
                user = $scope.user;
            }
            user.start_date = m.startdate;
            user.expiry_date = m.enddate;
            user.start_datetime = m.start_datetime;
            user.expiry_datetime = m.expiry_datetime;
            $scope.user = user;
        });

        $scope.deviceGroupTreeData = [];
        $scope.deviceGroupTreeDataOpt = {
            treeName: 'deviceGroupTree',
            treeType: 'treeGrid',
//      treeType : 'treeTypeGrid',
            checkbox: true,
            formatter: function (node) {
                return node.name
            },
            onLoadSuccess: function (node, data) {
                var i,
                    item,
                    tree = $("#deviceGroupTree");

                if (angular.isDefined($scope.userGroup.sync_devices)) {
                    for (i = 0; i < $scope.userGroup.sync_devices.length; i++) {
                        item = $scope.userGroup.sync_devices[i];
                        node = tree.tree('find', item.id);
                        if (node != null && angular.isDefined(node))
                            tree.tree('check', node.target);
                    }
                }
                if (angular.isDefined($scope.userGroup.sync_device_groups)) {
                    for (i = 0; i < $scope.userGroup.sync_device_groups.length; i++) {
                        item = $scope.userGroup.sync_device_groups[i];
                        node = tree.tree('find', item.id);
                        if (node != null && angular.isDefined(node))
                            tree.tree('check', node.target);
                    }
                }

                $scope.collectCheckedDeviceItem($("#deviceGroupTree").tree('getChecked'));
            }
        };

        MakeGroupTree.getDeviceGroupTree().then(function (data) {
            $scope.deviceGroupTreeData = MakeGroupTree.getTreeData(data.DeviceGroup);
        }, function (reason, status) {

        });

        $scope.doLoadSelectDeviceGroupTreeInDLG = function ($event) {
            if ($scope.deviceGroupTreeData.length > 0) {
                $scope.synctoShowOK = !$scope.synctoShowOK;
                $scope.$broadcast('makeTree' + $scope.deviceGroupTreeDataOpt.treeName, $scope.deviceGroupTreeData);
            }
        };

        $scope.doInfoBatchEditOK = function () {
            $scope.userGroupInfoChangeDlg.url = '';
            $("#userGroupInfoChangeDlg").dialog('destroy');

            var userGroupParam = ModifiedFieldExtraction.get(angular.fromJson(origin_data), $scope.userGroup);

            var change_data = {};

            change_data.id = $scope.userGroup.id;
            change_data.sync_devices = $scope.userGroup.sync_devices;

//      console.log(angular.toJson(userGroupParam));
            API.put('user_groups/' + group_id, undefined, {'UserGroup': userGroupParam });
        };

        $scope.doInfoBatchEditCancel = function () {
            $scope.userGroupInfoChangeDlg.url = '';
            $("#userGroupInfoChangeDlg").dialog('destroy');
        };

        $scope.collectCheckedDeviceItem = function (data) {
            if (angular.isUndefined(data)) {
                data = $("#deviceGroupTree").tree('getChecked');
            }
            $scope.devicesSelectStringSubStr = '';
            var i, len = data.length, cnt = -1;
            for (i = 0; i < len; i++) {
                delete data[i]['target'];
                var item = data[i];
                if (cnt == -1 && item.isDevices == true) {
                    cnt++;
                    $scope.devicesSelectString = item.name;
                    $scope.userGroup.sync_devices.push({"id": item.id, "name": item.name});
                } else if (cnt >= 0 && item.isDevices == true) {
                    cnt++;
                    $scope.userGroup.sync_devices.push({"id": item.id, "name": item.name});
                } else {
                    $scope.userGroup.sync_device_groups.push({"id": item.id, "name": item.name});
                }
            }

            fnMakeSelectDevicesString(cnt);
        };

        function fnMakeSelectDevicesString(cnt) {
            if (cnt >= 0) {
                if ($scope.devicesSelectString.length > 16) {
                    $scope.devicesSelectStringSubStr = $scope.devicesSelectString.substr(0, 16) + '...';
                } else {
                    $scope.devicesSelectStringSubStr = $scope.devicesSelectString;
                }
            }

            if (cnt > 0) {
                $scope.devicesSelectStringSubStr += ' + ';
            }

            $scope.devicesSelectCount = cnt;
        }

        $scope.fnSelectBoxBlur = function (value, $event) {
            $scope[value] = false;
            $scope.collectCheckedDeviceItem($("#deviceGroupTree").tree('getChecked'));
        };

        $scope.fnSelectBoxFocus = function (value, $event) {
            value = true;
        }
    }]);
});