'use strict';

define(['modules/common/services/access-control-agent', 'modules/common/services/user-agent'], function () {
    var app = angular.module('biostarWebApp');
    app.register.controller('UserUserInfoBatchEditDlgCtrl',
        ['$scope','$document','API','Const','Util','UserAgent','AccessControlAgent','MessageProperties','MessageService',
        function ($scope, $document, API, Const, Util, UserAgent, AccessControlAgent, MessageProperties, MessageService) {

            var UserTreeData,
                AccessGroupData,
                options;

            $scope.userGroupEditYN = false;
            $scope.userInactiveEditYN = false;
            $scope.userPeriodEditYN = false;
            $scope.userAccessGroupEditYN = false;
            $scope.userPermissionEditYN = false;

            $scope.editAllUser = {
                "user_group_id": {
                    "id": undefined
                },
                "disabled" : "false",
                "start_datetime": undefined,
                "expiry_datetime": undefined,
                "access_groups": [],
                "permission": undefined
            };


            $scope.doEditUserGroup = function () {
                $scope.userGroupEditYN = !$scope.userGroupEditYN;

                if ($scope.userGroupEditYN) {
                    UserAgent.getUserGroupRecursiveData('inUserInfoBatchEdit').then(function success(data) {
                        $scope.UserTreeData = data;
                    });
                } else if (!$scope.userGroupEditYN) {
                    $scope.UserTreeData = undefined;
                    $scope.editAllUser.user_group_id = {};
                    $scope.editAllUser.user_group_id.id = undefined;
                }
            };

            $scope.doEditUserInactive = function () {
                $scope.userInactiveEditYN = !$scope.userInactiveEditYN;

                if ($scope.userGroupEditYN) {
                    UserAgent.getUserGroupRecursiveData('inUserInfoBatchEdit').then(function success(data) {
                        $scope.UserTreeData = data;
                    });
                } else if (!$scope.userGroupEditYN) {
                    $scope.UserTreeData = undefined;
                    $scope.editAllUser.user_group_id = {};
                    $scope.editAllUser.user_group_id.id = undefined;
                }
            };

            $scope.doEditUserPeriod = function () {
                $scope.userPeriodEditYN = !$scope.userPeriodEditYN;
                if (!$scope.userPeriodEditYN) {
                    $scope.editAllUser.start_datetime = undefined;
                    $scope.editAllUser.expiry_datetime = undefined;
                }
            };

            $scope.doEditAccessGroups = function () {
                $scope.userAccessGroupEditYN = !$scope.userAccessGroupEditYN;

                if ($scope.userAccessGroupEditYN) {
                    $scope.AccessGroupData = undefined;
                    if (AccessControlAgent.getAccessGroups().then) {
                        AccessControlAgent.getAccessGroups().then(function success(data) {
                            $scope.AccessGroupData = data.AccessGroupCollection.rows;
                        });
                    } else {
                        $scope.AccessGroupData = AccessControlAgent.getAccessGroups();
                    }
                } else if (!$scope.userAccessGroupEditYN) {
                    $scope.AccessGroupData = undefined;
                    $scope.editAllUser.access_groups = [];
                }
            };

            $scope.doEditPermission = function () {
                if($scope.SelectAllYN == true || $scope.checkItemArray.indexOf(Const.ADMINISTRATOR_DEFAULT_ID.toString()) > -1) {
                    MessageService.displayWarningMessage(MessageProperties.get('validate.adminPrivilegesCanNotBeEdited'));
                    return;
                }

                $scope.userPermissionEditYN = !$scope.userPermissionEditYN;

                if ($scope.userPermissionEditYN) {
                    API.get('permissions').then(function (data) {
                        $scope.PermissionData = data.PermissionCollection.rows;
                    });
                } else if (!$scope.userPermissionEditYN) {
                    $scope.PermissionData = undefined;
                }

            };

            $scope.doUserInfoBatchEdit = function () {
                if (!$scope.userGroupEditYN) {
                    delete $scope.editAllUser.user_group_id;
                    delete $scope.editAllUser.inherited;
                }
                if (!$scope.userInactiveEditYN) {
                    delete $scope.editAllUser.disabled;
                }
                if (!$scope.userPeriodEditYN) {
                    delete $scope.editAllUser.start_datetime;
                    delete $scope.editAllUser.expiry_datetime;
                }
                if (!$scope.userAccessGroupEditYN) {
                    delete $scope.editAllUser.access_groups;
                }
                if (!$scope.userPermissionEditYN) {
                    delete $scope.editAllUser.permission;
                }
                if (Object.keys($scope.editAllUser).length > 0) {
                   MessageService.displayConfirmMessage(MessageProperties.get('common.modifyAllSelectedUsers'), function (confirmYN) {
                        if (confirmYN) {
                            // $scope.checkItemArray 는 this Dlg 를 embed 하고 있는 UserController의 Scope 변수입니다.
                            var param = $scope.checkItemArray;
                            // $scope.SelectAllYN 는 this Dlg 를 embed 하고 있는 UserController의 Scope 변수입니다.
                            if ($scope.SelectAllYN) {
                                param = 'ALL';
                            }

                            UserAgent.putUsers({
                                "userIDs": param, "user": $scope.editAllUser, "query": $scope.userListQueryStrings
                            }).then(function success(data) {

                            }, function error(reason, status) {

                            }).finally(function() {
                                $scope.$emit('InitUserInfoBatchEditDlgUrl');
                            });
                        }
                    })
                } else {
                   MessageService.displayConfirmMessage(MessageProperties.get('confirm.noChangesContinue'), function (confirmYN) {
                        if (confirmYN) {
                            options = angular.element("#userInfoBatchEditDlg").dialog('options');
                            options.onClose();
                        }
                    });
                }

            };

            angular.element('#doUserInfoBatchEdit').on('click', function () {
                $scope.doUserInfoBatchEdit();
            });

            $scope.doInfoBatchEditCancel = function () {
                options = angular.element("#userInfoBatchEditDlg").dialog('options');
                options.onClose();
            };

            angular.element('#doInfoBatchEditCancel').on('click', function () {
                $scope.doInfoBatchEditCancel();
            });

            $document.on('scroll', function (event) {
                Util.debug(angular.element('#userInfoBatchEditDlg').offset().top);
                Util.debug(angular.element('#userInfoBatchEditDlg').offset().top);
            })

        }]);
});