'use strict';

define(function () {

    var app = angular.module('biostarWebApp');

    app.register.service('PrintOptionService', ['$rootScope', 'Const', 'MessageProperties', function ($rootScope, Const, MessageProperties) {

        var getReportColumnNameFunction;
        var queryObject;

        return {
            getQueryObject: function () {
                return queryObject;
            },
            setQueryObject: function (paramQueryObject) {
                queryObject = paramQueryObject;
            },
            getReportColumnNameFunction: function (gridColumnName) {
                return gridColumnName;
            },
            getReportColumnTypeFunction: function (paramGetReportColumnNameFunction) {
                return "string";
            },
            openPrintOptionPopupDlg: function () {
                var options = {};
                options.iconCls = 'icon-save';
                options.modal = true;
                options.shadow = false;
                options.border = false;
                options.title = MessageProperties.get("printOption.dialog.header");
                options.width = 800;
                options.height = 'auto';
//                options.top = 150;

                options.onClose = function () {
                    $rootScope.$apply(function () {
                        $rootScope.printOptionDialog.url = '';
                        angular.element('#printOptionPopupDlg').dialog('destroy');
                    });
                };

                angular.element("#printOptionPopupDlg").dialog(options);

                $rootScope.printOptionDialog = {};
                $rootScope.printOptionDialog.url = 'modules/common/print/printOption.html';
            },
            closeDialog: function () {
                $rootScope.printOptionDialog.url = '';
                angular.element('#printOptionPopupDlg').dialog('destroy');
            },
            buildGridQueryFunction: function (collectionName, paramObject) {
                queryObject = {
                    search_text: paramObject.query,
                    offset: paramObject.offset,
                    limit: paramObject.limit,
                    collection_name: collectionName,
                    object: "query"
                };
                if (paramObject.order_by != undefined) {
                    var tempArray = paramObject.order_by.split(":");
                    queryObject.orders = [];
                    queryObject.orders.push({
                        column: tempArray[0],
                        descending: tempArray[1]
                    });
                }
                if (paramObject.group_id) {
                    queryObject.conditions = [];
                    queryObject.conditions.push({column: 'group_id', operator: 'eq', values: [paramObject.group_id] });
                }

                return queryObject;
            }
        };
    }]);
});
